*********************************************************************
* assembler.i
*
* Copyright 1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* $Id: assembler.i,v 2.2 93/03/04 00:05:58 Kell Exp Locker: Kell $
*
* $Log:	assembler.i,v $
*Revision 2.2  93/03/04  00:05:58  Kell
*
*********************************************************************
	IFND	ASSEMBLER_I
ASSEMBLER_I SET	1	

	IFD	__G2	;Test for GenIm2 HiSoft Assembler
**************************************************
	include "HiSoftPath.i"

* Until right before shipping, we will save time with these
	OPT	O2+,O1-,OW1-,OW2-,OW3-,OW4-,OW5-

* O+ = enable optimise everything, else use O- for no optimising
* O1+ = enable short branch optimisation (O1- disables)
* O2+ = enable addressing optimisation (O2- disables)
* OW1- = disable short branch optim. warning message??
* OW2- = disable addressing optim. warning message??
* OW3- = disable warning message?
* OW4- = disable warning message?
* OW5- = disable warning message?

**************************************************
	ENDC	;IFD GenIm2

_AbsExecBase	equ	4

	IFND    TRUE
TRUE	EQU	1
	ENDC
	
	IFND    FALSE
FALSE	EQU	0
	ENDC
	
	IFND    NULL
NULL	EQU	0
	ENDC

	IFD	CAPE	;Test for C.A.P.E. 68K Assembler
	 include "Assembler.CAPE.i"
	ENDC

	ENDC	;ASSEMBER_I
