/* This is the Preliminary Keying script 
   for RenderFX */
/* Update to allow Key out 3/29/96 */
/* Updated to help previews key out 4/5/96 */

/* 4/23/97 */
/* Updated for Correct Timing with Output Effect */
/* Allow Key Pages without Luminence Keyer */     
/* Allow Fadeout at end of effect */

OPTIONS RESULTS
TOASTERLIB="ToasterARexx.port"

call remlib('PROJECT_REXX_PORT')
call addlib('PROJECT_REXX_PORT',0)

IF POS(TOASTERLIB , SHOW('Libraries')) = 0 THEN
  IF ~ADDLIB(TOASTERLIB , 0) THEN x=Bummer(" Please start your Toaster.")

call Switcher(TOSW)

if exists("ENV:OZ-PanicStop") then address command "delete ENV:OZ-PanicStop QUIET"

rx startfilereq("Output File Name")
exit=1
do while exit=1
   filename1=queryfilereq()
   if filename1=0 then 
      call quit
    else NOOP
      if filename1~="" then exit=0
      else NOOP
      address command "c:wait 1"
      end
      call req_close()

position1 = lastpos(':',filename1)
position2 = lastpos(':',filename1,position1-1)

if position2 ~= 0 then do
   filename1 = right(filename1,length(filename1)-position2)
end

fpatht=filename1
patht=''
filenamet=''
lenfpt=length(fpatht)
if lenfpt>1 then do
   lastpt=lastpos('/',fpatht,lenfpt)
   if (lastpt~=0) then do
      if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
      patht=left(fpatht,lastpt-1)
      end
   else if lastpt=0 then do
      lastpt=lastpos(':',fpatht,lenfpt)
      if (lastpt~=0) then do
         if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
         patht=left(fpatht,lastpt)
         end
      end
   if patht~='' then do
      call pragma('D',patht)
      patht=pragma('D','RAM:')
      end
call req_close()

if (patht='') then do
   call req_tell('RenderFX cancelled','    You need to select a drive/folder','       from bottom of Flyer window')
   call quit()
   end

if (filenamet='') then do
   call req_tell('RenderFX cancelled','   You need to type in a filename')
   call quit()
   end

if (right(patht,1)~="/") & (right(patht,1)~=":") then
   patht=patht||"/"

filename1=patht||filenamet

croutoncount = croutonsinproject()
if (croutoncount > 4) then
   croutoncount = 4

call SET_VIEW(4)

if (croutoncount = 2) then do
   OPEN(myfile,"env:Keying.txt",'Write')     
   WRITELN(myfile,filename1||",3");

   croutonpick(0)

   p_type=croutontype()
   p_tn=1
   if (p_type="FRAM")|(p_type="STIL")|(p_type="MAIN")|(p_type="KEYF") then do
      if (p_type="FRAM")|(p_type="KEYF") then p_tn=3
         else if (p_type="STIL") then p_tn=2
         else if (p_type="MAIN") then p_tn=4
      end

   if (p_tn > 2) then do 
      Call Switcher(M001)
      Call Switcher(PDV2)
      Call Switcher(FMLD,croutonname())
      Call Switcher(WAIT,1)
      end

   WRITELN(myfile,croutonname()||","||p_tn||","||croutongettag(ClipStartField)/2||","||croutongettag(Duration)/2);

   count5 = croutongettag(Duration)/2

   croutonpick(1)

   WRITELN(myfile,croutonname()||",5,2,1");

   WRITELN(myfile,"Rendering Keypages  ,0 "); 

   WRITELN(myfile,count5);

   WRITELN(myfile,"2");

   WRITELN(myfile,"0,99");

   WRITELN(myfile,count5||",99");

   CLOSE(myfile)

   croutonpick(1)

   value = REQ_TELL("Start Render or Preview","Press Continue to Render Key","Press Cancel to See a Preview","    Before Rendering")

   if (value = 0) then do
      address command "prowave:previewfx env:keying.txt"
      value = REQ_TELL("Render Previewed Key??? ","Press Continue to Render Key","Press Cancel to Exit RenderFX")
      end

   if (value = 1) then do
      address command "prowave:RenderFX env:Keying.txt"
      call MAKEICON(filename1,count5/2) 
      end

   end

if (croutoncount > 2) then do 
   Type = 1
   Level = 40
   default = 10
   result = REQ_BUTTONS("Key Color",default,"BLACK","WHITE")
   if (result = "10") then
      Type = 1
   else
      Type = 2

   result = REQ_NUMBER("Enter Level",40,0,257)

   Level = result

   croutoncount = croutonsinproject()
   if (croutoncount > 4) then
      croutoncount = 4

   OPEN(myfile,"env:Keying.txt",'Write')     
   WRITELN(myfile,filename1||",3");

   croutonpick(0)

   p_type=croutontype()
   p_tn=1
   if (p_type="FRAM")|(p_type="STIL")|(p_type="MAIN")|(p_type="KEYF") then do
      if (p_type="FRAM")|(p_type="KEYF") then p_tn=3
         else if (p_type="STIL") then p_tn=2
         else if (p_type="MAIN") then p_tn=4
   end

   if (p_tn > 2) then do 
      Call Switcher(M001)
      Call Switcher(PDV2)
      Call Switcher(FMLD,croutonname())
      Call Switcher(WAIT,1)
   end

   WRITELN(myfile,croutonname()||","||p_tn||","||croutongettag(ClipStartField)/2||","||croutongettag(Duration)/2);

   count5 = croutongettag(Duration)/2

   croutonpick(2)
   n_type=croutontype()
   n_tn=1
   if (n_type="FRAM")|(n_type="STIL")|(n_type="MAIN")|(n_type="KEYF") then do
      if (n_type="FRAM")|(n_type="KEYF") then n_tn=3
         else if (n_type="STIL") then n_tn=2
         else if (n_type="MAIN") then n_tn=4
   end

   if (n_tn>2) then do
      Call Switcher(M001)
      Call Switcher(PDV1)
      Call Switcher(FMLD,croutonname())
      Call Switcher(WAIT,1)
   end

   count2 = croutongettag(Duration)

   WRITELN(myfile,croutonname()||","||n_tn||","||croutongettag(ClipStartField)/2||","||croutongettag(Duration)/2);

   croutonpick(1)

   count = croutongettag(numfields)/2

   count3 = 0 

   if (croutoncount = 4) then do
      croutonpick(3)
      count3 = croutongettag(numfields)/2
      OPEN(myfile2,"env:Keying2.txt",'Write')     
      WRITELN(myfile2,filename1||",3");
      croutonpick(0)
      WRITELN(myfile2,croutonname()||","||p_tn||","||croutongettag(ClipStartField)/2+count5-count3||","||count3);
      croutonpick(2)
      WRITELN(myfile2,croutonname()||","||n_tn||","||croutongettag(ClipStartField)/2+count5-count3||","||count3);
      WRITELN(myfile2,"  KEYING Video, 0");
      WRITELN(myfile2,count3)
      WRITELN(myfile2,"2");
      WRITELN(myfile2,"0,0");
      WRITELN(myfile2,count3||",100");
      WRITELN(myfile2,"SWIT,1,6,"||Type||","||Level||",1");
      CLOSE(myfile2)
      end

   WRITELN(myfile,"  KEYING Video, 0");
   WRITELN(myfile,count5-count3)
   WRITELN(myfile,"3");
   WRITELN(myfile,"0,0");
   WRITELN(myfile,count||",100");
   WRITELN(myfile, count5-count-count3||",100");
   WRITELN(myfile,"SWIT,1,6,"||Type||","||Level||",1");
   CLOSE(myfile)

   croutonpick(1)

   call Switcher(DOEN)

   value = REQ_TELL("Start Render or Preview","Press Continue to Render Key","Press Cancel to See a Preview","    Before Rendering")

   if (value = 0) then do
      address command "prowave:previewfx env:keying.txt"
      if (croutoncount = 4 ) then do
         croutonpick(3)
         call Switcher(DOEN) 
         address command "prowave:previewfx env:keying2.txt"
         call Switcher(TAKE)
         end
      value = REQ_TELL("Render Previewed Key??? ","Press Continue to Render Key","Press Cancel to Exit RenderFX")
      end

   if (value = 1) then do
      croutonpick(1)
      call Switcher(DOEN) 
      address command "prowave:RenderFX env:Keying.txt"
      if (croutoncount = 4 ) then do
         croutonpick(3)
         call Switcher(DOEN) 
         address command "prowave:renderfx env:keying2.txt"
         end
      call MAKEICON(filename1,count5/2) 
      end
   end

call SET_VIEW(2)

end
