if (res==FERR_OKAY) 
   {
   res = GetFieldClock(&theclock);
		printf("Started at clock %lx (asked for %lx)\n",theclock,clock);
		for (;;) {
			if (WaitForChar(handle,30)) {
				key = getchar();
				if (key=='a') {
					Action.Flags ^= (CAF_AUDIOL | CAF_AUDIOR);		/* Toggle audio */
					printf("Audio turned %ls\n",(Action.Flags & (CAF_AUDIOL | CAF_AUDIOR))?"on":"off");
					res = ChangeAudio(&Action);
					getchar();
				}
				else if (key=='u') {
					if (Volume < 0xC000)
					{
						Volume += 0x4000;
						printf("Audio vol= %ld\n",Volume);

						Action.VolAttack = 60;
						Action.VolSust1 = Action.VolSust2 = Volume;
						res = ChangeAudio(&Action);
					}
					getchar();
				}
				else if (key=='d') {
					if (Volume >= 0x4000)
					{
						Volume -= 0x4000;
						printf("Audio vol= %ld\n",Volume);

						Action.VolAttack = 60;
						Action.VolSust1 = Action.VolSust2 = Volume;
						res = ChangeAudio(&Action);
					}
					getchar();
				}
				else {
					res = AbortAction(&Action);		// This aborts just my action
//					res = AbortAction(NULL);			// Does a global (panic) abort

					printf("Aborted\n");
					break;
				}
//				printf(".\n");
			}
			res = CheckAction(&Action);
			if (res != FERR_BUSY) {
				printf("Complete\n");
				break;
			}
		}
	}

	printf("Last frame played = %ld\n",Action.LastFieldDone>>2);

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Okay\n");
