/*********************************************************************\
*
* SCSIreset - Reset all SCSI channels
*
* $Id: SCSIreset.c,v 1.0 1995/05/05 15:50:18 Flick Exp $
*
* $Log: SCSIreset.c,v $
*Revision 1.0  1995/05/05  15:50:18  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	04/05/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit;
	ULONG	res;

	if ((argc!=2)||(argv[1][0]=='?')) {
		printf("Usage: %ls <board>\n",argv[0]);
		return(20);
	}

	GetArg(argv[1],&unit,0,3,"Board number");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = SCSIreset(unit);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("SCSI reset okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}
