/*********************************************************************\
*
* VoidAllHeads - Kill all A/B heads
*
* $Id: VoidAllHeads.c,v 1.2 1995/08/31 16:41:18 Flick Exp $
*
* $Log: VoidAllHeads.c,v $
*Revision 1.2  1995/08/31  16:41:18  Flick
*Now does a graceful, then nasty cleanup -- removed use of printf for compactness
*
*Revision 1.1  1995/08/25  15:31:09  Flick
*Simplified in case we need to release this puppy to public
*
*Revision 1.0  1995/05/05  15:53:50  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/25/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void SimplePrint(char *msg);
//void GetArg(char *arg,int *var,int lo,int hi,char *label);
//void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label);

struct Library *FlyerBase;

main(int argc,char **argv)
{
	int	unit=0;
	ULONG	res;
	char	temp[10];

//	if ((argc!=2)||(argv[1][0]=='?')) {
//		printf("Usage: %ls <board>\n",argv[0]);
//		return(20);
//	}
//
//	GetArg(argv[1],&unit,0,3,"Board number");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0)
	{
		SimplePrint("Open flyer.library failed\n");
		exit(20);
	}

	SimplePrint("Cleaning up...\n");

	// Do graceful cleanup
	res = StartHeadList(unit);
	res = EndHeadList(unit,1);

	// Okay, get serious now and do massive cleanup
	if (res == FERR_OKAY)
		res = VoidCardHeads(unit);

	if (res)
	{
//		printf("Error %ld - %ls\n",res,Error2String(res));
		SimplePrint("Error ");
		stci_d(temp,res);
		SimplePrint(temp);
		SimplePrint(" - ");
		SimplePrint(Error2String(res));
		SimplePrint("\n");
	}
	else
		SimplePrint("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}


void SimplePrint(char *msg)
{
	Write(Output(),msg,strlen(msg));
}

//void GetArg(char *arg,int *var,int lo,int hi,char *label)
//{
//	stch_i(arg,var);
//	if ((*var < lo)||(*var > hi)) {
//		printf("Error: %ls is out of range\n",label);
//		exit(20);
//	}
//}
//
//
//void GetLongArg(char *arg,ULONG *var,ULONG lo,ULONG hi,char *label)
//{
//	stch_l(arg,(long *)var);
//	if ((*var < lo)||(*var > hi)) {
//		printf("Error: %ls is out of range\n",label);
//		exit(20);
//	}
//}
