/* $Id: envelope.c,v 2.1 1996/11/18 18:38:34 Holt Exp $
* $Log: envelope.c,v $
*Revision 2.1  1996/11/18  18:38:34  Holt
*no real changes, I'm not really using this file right now.
*it was suposed to have the envelope panel code in here but...
*
*Revision 2.0  1996/10/24  16:50:35  Holt
*FirstCheckIn
*
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <intuition/sghooks.h>
#include <graphics/gfxmacros.h>
#include <graphics/gfxbase.h>
#include <graphics/text.h>

#include <edit.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <time.h>
#include <editwindow.h>
#include <project.h>
#include <gadgets.h>
#include <prophelp.h>
#include <grazer.h>
#include <editswit.h>
#include <crouton_all.h>
#include <request.h>
#include <tags.h>
#include <panel.h>
#include <flyer.h>
#include <RawKeyCodes.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/diskfont.h>

#define SERDEBUG	1
#include <serialdebug.h>


#ifndef PROTO_PASS
#include <proto.h>
#else
#include "edit:proto/envelope.p"
#endif



/*********************************************
*
* Allocate and init Envelope Type Gadget
*
*********************************************/
struct AudEnvDisp *NewEnvGad(	struct RastPort *RP,
									 	struct RastPort *DBRP,
									 	UWORD X,
									 	UWORD Y,
										UWORD W,
										UWORD H,
										ULONG GADID)
{
	struct AudEnvDisp *aev;

	// allocate the Envelope structure

	if (aev = AllocMem(sizeof(struct AudEnvDisp),MEMF_PUBLIC|MEMF_CLEAR))
	{

		// init the Envelope structure
		aev->X=X;
		aev->Y=Y;
		aev->W=W;
		aev->H=H;
		aev->InPoint=0;
		aev->OutPoint=0;
		aev->MinVal=0;
		aev->MaxVal=0;
		aev->HScale=0;
		aev->VScale=0;
		aev->KeyCount=0;
		aev->RP=RP;
		aev->DRP=DBRP;
		aev->DBM=DBRP->BitMap;
		aev->SELECTED_KEY=NULL;

		NewList(&aev->AEDKeys);
	
		// init the Envelope Gadget structure
		aev->EnvDispGadget.NextGadget=NULL;
		aev->EnvDispGadget.LeftEdge=X-2;
		aev->EnvDispGadget.TopEdge=Y-2;
		aev->EnvDispGadget.Width=W+6;
		aev->EnvDispGadget.Height=H+5;
		aev->EnvDispGadget.Flags=GFLG_GADGHNONE;
		aev->EnvDispGadget.Activation=RELVERIFY|GACT_IMMEDIATE; //|GACT_FOLLOWMOUSE;
		aev->EnvDispGadget.GadgetType=BOOLGADGET;
		aev->EnvDispGadget.GadgetRender=NULL;
		aev->EnvDispGadget.GadgetText=NULL;
		aev->EnvDispGadget.MutualExclude=NULL;
		aev->EnvDispGadget.SpecialInfo=NULL;
		aev->EnvDispGadget.GadgetID=GADID;
		aev->EnvDispGadget.UserData=NULL;
		return(aev);
	}
	else
		return(NULL);

}



/*************************************************************
*
* TagtoKL - Make Key list from AudEnv16 struct.
*
*************************************************************/
void	TagtoKL(struct AudEnvDisp *aev,struct AudioEnv *AEtag)
{
	struct AEDKey *NewAEDNode;
	UWORD	 i;


	if(AEtag->Keysused==0)
	{
		if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
		{
			AddTail(&aev->AEDKeys,NewAEDNode);	
			//DUMPHEXIL("&aev.AEDKeys=",(LONG)&aev.AEDKeys,"  ");
			//DUMPHEXIL("NewAEDNode=",(LONG)NewAEDNode,"\\");
			NewAEDNode->Time = aev->InPoint;
			NewAEDNode->Scaled_Time = 0;
			NewAEDNode->Value = 32000;
			NewAEDNode->Scaled_Val = NewAEDNode->Value/1307;
			NewAEDNode->Act = AEDKey_act;
			NewAEDNode->Att = TimeLocked;
		}

		if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
		{
			AddTail(&aev->AEDKeys,NewAEDNode);	
			//DUMPHEXIL("&aev.AEDKeys=",(LONG)&aev.AEDKeys,"  ");
			//DUMPHEXIL("NewAEDNode=",(LONG)NewAEDNode,"\\");
			NewAEDNode->Time = aev->OutPoint;
			NewAEDNode->Scaled_Time = 0;
			NewAEDNode->Value = 32000;
			NewAEDNode->Scaled_Val = NewAEDNode->Value/1307;
			NewAEDNode->Act = AEDKey_act;
			NewAEDNode->Att = TimeLocked;
		}
	}
	else
	{
		for(i=0;i<AEtag->Keysused;i++)
		{
			if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
			{
				AddTail(&aev->AEDKeys,NewAEDNode);
				NewAEDNode->Time = ((AEtag->AEKeys[i].GoTime+AEtag->AEKeys[i].NumOfFlds)/2);
				NewAEDNode->Scaled_Time = 0;
				NewAEDNode->Value = 0xffff-AEtag->AEKeys[i].VOL1;
				NewAEDNode->Scaled_Val = NewAEDNode->Value/1307;
				NewAEDNode->Act = AEDKey_act;
				NewAEDNode->Att = Deleteable;					
			}
		}	
		NewAEDNode=aev->AEDKeys.mlh_TailPred;
		NewAEDNode->Att = TimeLocked;					
		
		NewAEDNode=aev->AEDKeys.mlh_Head;
		NewAEDNode->Att = TimeLocked;					
	}
}



/*************************************************************
*
* KLtoTag - Make AudEnv16-Tag from a key list.
*
*************************************************************/
void	KLtoTag(struct AudEnvDisp *aev,struct AudioEnv *AEtag)
{
	struct AEDKey *AEDNode;
	struct MinList *AEDHead;
	ULONG	 curr_time;
	int i=-1;
	struct AEKey *CurrKey;


	AEDHead = &aev->AEDKeys;	

	curr_time=aev->InPoint;
	DUMPUDECL("CurrTime",curr_time,"\\");
	

	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{
		i++;
		CurrKey=&AEtag->AEKeys[i];

		CurrKey->Flags=0x0666;
		CurrKey->GoTime=curr_time*2;
		CurrKey->NumOfFlds=(AEDNode->Time-curr_time)*2;
		DUMPUDECL("Durr of ramp",CurrKey->NumOfFlds,"\\");
		
		CurrKey->VOL1=0xffff-AEDNode->Value;
		CurrKey->VOL2=0xffff-AEDNode->Value;
		CurrKey->PAN1=-32768;
		CurrKey->PAN2=32767;
		
		curr_time=AEDNode->Time;
		if(curr_time==aev->InPoint)
			curr_time += 2;

	}
	AEtag->Keysused = i+1;
	AEtag->Flags 	=	1;
}




/*************************************************
*
*
*	SetTimeBounds -- Sets Panel Line PropStart/End
*
*
*************************************************/
void	SetTimeBounds(struct AudEnvDisp *aev,
						  struct PanelLine *PTime)
{
	
	struct AEDKey *prev,*next;



	if(aev->SELECTED_KEY)
	{	
		if(aev->SELECTED_KEY->Att&0x01)
		{
			DUMPMSG	("Got key its timelocked");
			PTime->PropStart=aev->SELECTED_KEY->Time;
			PTime->PropEnd=aev->SELECTED_KEY->Time;
		}	
		else
		{
			next=aev->SELECTED_KEY->mln_Succ;
			prev=aev->SELECTED_KEY->mln_Pred;

			DUMPMSG	("Got key, not timelocked");
			PTime->PropStart=prev->Time+4;
			PTime->PropEnd=next->Time-4;
		}
	}
}



/*************************************************
*
*
* AdjKeyValStr -- 
*
*
*************************************************/
void	AdjKeyValStr(struct AudEnvDisp *aev,
						 struct AEDKey *SelNode,
						 struct PanelLine *PNum,
						 struct Window *Window)
{

	*PNum->Param=(100-(SelNode->Value/655));
	UpdatePanStr(PNum,Window);
	DUMPMSG	("In adjkeyval after updatestring");

}


/*************************************************
*
*
* AdjKeyTimeStr -- 
*
*
*************************************************/
void	AdjKeyTimeStr(struct AudEnvDisp *aev,
						  struct AEDKey *SelNode,
						  struct PanelLine *PTime,
						  struct Window *Window)
{
	*PTime->Param=SelNode->Time;
	UpdatePanStr(PTime,Window);
	DUMPMSG	("In adjkeyTime after updatestring");

}




/**************************************************
*
* SelectEnvKey -- Select the envlope key closest to
*						where user clicked, or none(NULL)
*
**************************************************/
struct AudEnvDisp  *SelectEnvKey(struct AudEnvDisp *aev,
											UWORD	X, UWORD Y, 
											struct PanelLine *PTime)
{
	struct MinList	*AEDHead;
	struct AEDKey	*AEDNode,*SelNode=NULL;
	UWORD Selabs_off=1000,abs_off=1000;	
	

	X -= aev->X; 
	Y -= aev->Y;	

	//DUMPHEXIW("In SelectEnvKey\\X= ",(UWORD)X,"\\");
	//DUMPHEXIW("Y= ",(UWORD)Y,"\\");

	AEDHead=&aev->AEDKeys;
	
	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{
		abs_off=(abs((AEDNode->Scaled_Time-aev->MinVal)-X)+abs(AEDNode->Scaled_Val-Y));
		//DUMPHEXIW("abs_off= ",(UWORD)abs_off,"\\");
		if(abs_off<=12)
		{	
			if(SelNode)
			{
				if(abs_off<Selabs_off)
				{	
					SelNode=AEDNode;
					Selabs_off=abs_off;
				}
			}
			else
			{	
				SelNode=AEDNode;
				Selabs_off=abs_off;
			}
		}
	}

	if(SelNode)
	{
		for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
		{
			if(AEDNode->Act!=AEDKey_Inact)
				AEDNode->Act=AEDKey_act;
		}		
		SelNode->Act=AEDKey_sel;
		RedrawAudioevn(aev);

	}
	aev->SELECTED_KEY=SelNode;
	SetTimeBounds(aev,PTime);
	return(SelNode);
}




/**************************************************************
*
* SelectNextEnvKey -- Select the Next key to the one selected
*
**************************************************************/
struct AudEnvDisp  *SelectNextEnvKey(struct AudEnvDisp *aev,
												 struct PanelLine *PTime)
{
	struct MinList	*AEDHead;
	struct AEDKey	*AEDNode,*SelNode=NULL;

	AEDHead=&aev->AEDKeys;
	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{
		if(AEDNode->Act==AEDKey_sel)
		{
			AEDNode->Act=AEDKey_act;
			SelNode = AEDNode->mln_Succ;
			SelNode->Act=AEDKey_sel;

		}
	}		
	RedrawAudioevn(aev);
	aev->SELECTED_KEY=SelNode;
	//SetPTimeLimits(aev,PTime);
	SetTimeBounds(aev,PTime);
	return(SelNode);
}	




/**************************************************************
*
* SelectPrevEnvKey -- Select the prev key to the one selected
*
**************************************************************/
struct AudEnvDisp  *SelectPrevEnvKey(struct AudEnvDisp *aev,
												 struct PanelLine *PTime)
{
	struct MinList	*AEDHead;
	struct AEDKey	*AEDNode,*SelNode=NULL;

	AEDHead=&aev->AEDKeys;
	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{

		if(AEDNode->Act==AEDKey_sel)
		{
			AEDNode->Act=AEDKey_act;
			SelNode = AEDNode->mln_Pred;
			SelNode->Act=AEDKey_sel;

		}

	}		
	RedrawAudioevn(aev);
	aev->SELECTED_KEY=SelNode;
	//SetPTimeLimits(aev,PTime);
	SetTimeBounds(aev,PTime);
	return(SelNode);
}



/******************************************************
*
*	DeleteEnvKey --
*
*
******************************************************/
void	DeleteEnvKey(struct AudEnvDisp *aev,
						 struct AEDKey *AEDNode,
 						 struct Window *Window,
						 struct PanelLine *PTime,
						 struct PanelLine *PNum)

{
	struct AEDKey *BNode;

	if(AEDNode -> Att & 0x02)
	{
		BNode = SelectPrevEnvKey(aev,PTime);
		Remove(AEDNode);
		FreeMem(AEDNode,sizeof(struct AEDKey));	
		RedrawAudioevn(aev);
		AdjKeyTimeStr(aev,BNode,PTime,Window);
		AdjKeyValStr(aev,BNode,PNum,Window);
	}
}


/******************************************************
*
* Timematch - See if any nodes fall on this time code.
*
*
******************************************************/
BOOL	Timematch(struct AudEnvDisp *aev,ULONG TIME)
{
	struct MinList *AEDHead;
	struct AEDKey  *AEDNode;
	BOOL	Match=FALSE;


	AEDHead=&aev->AEDKeys;
	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{
		if(AEDNode->Time==TIME)
			Match=TRUE;
	}		
	return(Match);
}





/******************************************************
*
* CreateEnvKey	-- 
*				  		
*
******************************************************/
void	CreateEnvKey(struct AudEnvDisp *aev,
						 struct Window *Window,
				 		 struct IntuiMessage *IntuiMsg,
						 struct PanelLine *PTime,
						 struct PanelLine *PNum)

{
	struct MinList *AEDHead;
	struct AEDKey  *NewAEDNode, *AEDNode, *SN_Hi, *SN_Low;
	UWORD  MX,MY;
	ULONG	 NewTime;

	MX=IntuiMsg->MouseX-aev->X;

	if(IntuiMsg->MouseY<aev->Y)
		MY=0;
	else 
	{
		if(IntuiMsg->MouseY>(aev->Y+aev->H-10))
			MY=50;
		else 
			MY=IntuiMsg->MouseY-aev->Y+2;
	}	
	NewTime=((((MX+aev->MinVal)*aev->HScale)/256)/4)*4;
	
	AEDHead = &aev->AEDKeys;
	AEDNode = AEDHead->mlh_TailPred;
	

	if((MX<(aev->X+aev->W))&
		(NewTime<AEDNode->Time)&
		(!Timematch(aev,NewTime)))
	{	
		if(NewAEDNode=AllocMem(sizeof(struct AEDKey),MEMF_PUBLIC|MEMF_CLEAR))
		{
			NewAEDNode->Time = NewTime;
			NewAEDNode->Scaled_Time = MX+aev->MinVal;
			NewAEDNode->Value = MY*1310;
			NewAEDNode->Scaled_Val = MY;
			NewAEDNode->Act = AEDKey_act;
			NewAEDNode->Att = Deleteable;
		}

		SN_Hi = AEDHead->mlh_Head;

		SN_Low = SN_Hi;
		SN_Hi = SN_Hi->mln_Succ;

		while(NewAEDNode->Time>SN_Hi->Time)
		{
			SN_Low = SN_Hi;
			SN_Hi = SN_Hi->mln_Succ;
		}
	
		Insert(AEDHead,NewAEDNode,SN_Low);
	
		if(aev->SELECTED_KEY)
		{
			aev->SELECTED_KEY->Act = AEDKey_act;
		}
		NewAEDNode->Act=AEDKey_sel;
		aev->SELECTED_KEY=NewAEDNode;

		//SelectEnvKey(aev,IntuiMsg->MouseX,IntuiMsg->MouseY,PTime);

		RedrawAudioevn(aev);
		AdjKeyTimeStr(aev,NewAEDNode,PTime,Window);
		AdjKeyValStr(aev,NewAEDNode,PNum,Window);
		SetTimeBounds(aev,PTime);

	}
}



#define	XAcc	16*32
#define	YAcc	16*32
/******************************************************
*
* AdjKeyValue 	--	Make changes on key values based on 
*				  		mouse input.
*
******************************************************/
void	AdjKeyValue(struct AudEnvDisp *aev,
				 struct AEDKey *SelNode,
				 struct IntuiMessage *IntuiMsg)
{
	LONG	SCRATCH;


	SCRATCH = SelNode->Value;
	SCRATCH += (IntuiMsg->MouseY*YAcc);
	if(SCRATCH<0)
		SCRATCH=0;
	if(SCRATCH>65535) 
		SCRATCH=65535;
		
	SelNode->Value = (UWORD)SCRATCH;
	
	SelNode->Scaled_Val = SelNode->Value/1307;
	
	DUMPHEXIW("SelNode->Value ",(UWORD)SelNode->Value,"\\");
}


/**************************************************
*
* AdjKeyTime -- Make changes on key values based on 
*				 	 mouse input.
*
**************************************************/
void	AdjKeyTime(struct AudEnvDisp *aev,
				 struct AEDKey *SelNode,
				 struct IntuiMessage *IntuiMsg)
{
	LONG	SCRATCH;
	LONG	mmy;
	ULONG	HI_BOUND,LO_BOUND,CURTIME;
	struct AEDKey *prev,*next;

	next=SelNode->mln_Succ;
	prev=SelNode->mln_Pred;
	
	HI_BOUND=next->Time;
	LO_BOUND=prev->Time;

	mmy=IntuiMsg->MouseX;

	SCRATCH = SelNode->Time;

	SCRATCH += mmy*4;
	
	CURTIME=(((ULONG)SCRATCH)/4)*4;

	if(CURTIME<=LO_BOUND)
		CURTIME=LO_BOUND+4;

	if(CURTIME>=HI_BOUND)
		CURTIME=HI_BOUND-4;
	
	SelNode->Time = (ULONG)CURTIME;
	
	SelNode->Scaled_Time = (SelNode->Time*256)/aev->HScale;
	
	DUMPHEXIL("SelNode->Time ",(ULONG)SelNode->Time,"\\");

}



/**************************************************
*
* HandleKeyDrag --  Handle Envelope Key Draging
*
*
**************************************************/
void HandleKeyDrag(struct AudEnvDisp *aev,
						 struct Window *Window,
						 struct IntuiMessage *IntuiMsg,
						 struct AEDKey *SelNode,
						 UBYTE  RButton, 
						 struct PanelLine *PTime,
						 struct PanelLine *PNum)
{
	BOOL mouseup=FALSE;
	UWORD	MX,MY;
	UBYTE KeyAtt;

	MX=IntuiMsg->MouseX;
	MY=IntuiMsg->MouseY;

	ReplyMsg((struct Message *)IntuiMsg);		//Orignal GadgetDown/RButton msg.
	SoftSpriteOff();
	ReportMouse(1,Window);
	ModifyIDCMP(Window,WinFlags|IDCMP_DELTAMOVE);
	KeyAtt=SelNode->Att;


	if(SelNode)
	{	
		AdjKeyTimeStr(aev,SelNode,PTime,Window);
		AdjKeyValStr(aev,SelNode,PNum,Window);
	}
	while(!mouseup)
	{
		WaitPort(Window->UserPort);
		while (IntuiMsg = (struct IntuiMessage *)GetMsg(Window->UserPort)) 
		{
			//DUMPHEXIL("Got IntuiMsg Class: ",IntuiMsg->Class," \\");

			switch(IntuiMsg->Class)
			{
			case IDCMP_GADGETUP:
				mouseup=TRUE;
				break;

			case IDCMP_MOUSEMOVE:
				if(SelNode)
				{
					if(RButton)
					{
						if(!(KeyAtt & 0x01))  //TimeLocked
						{
							AdjKeyTime(aev,SelNode,IntuiMsg);
							RedrawAudioevn(aev);
							AdjKeyTimeStr(aev,SelNode,PTime,Window);
						}
					}
					else
					{
						//DUMPHEXIW("MouseX= ",IntuiMsg->MouseX,"\\");
						//DUMPHEXIW("MouseY= ",IntuiMsg->MouseY,"\\");
						AdjKeyValue(aev,SelNode,IntuiMsg);	
						RedrawAudioevn(aev);
						AdjKeyValStr(aev,SelNode,PNum,Window);
					}
				}
				break;

			case IDCMP_MOUSEBUTTONS:
				if(IntuiMsg->Code==MENUUP)
					mouseup=TRUE;
				else
					if(IntuiMsg->Code==SELECTUP)
						mouseup=TRUE;
				break;

			}
			ReplyMsg((struct Message *)IntuiMsg);
			if(mouseup) break;		
		}
	}
	ReportMouse(0,Window);
	ModifyIDCMP(Window,WinFlags);
	ESparams2.Data1 = MX+Window->LeftEdge;
	ESparams2.Data2 = MY+Window->TopEdge;
	SendSwitcherReply(ES_MoveSprite,&ESparams2);
	SoftSpriteOn();
}




/**************************************************
*
* HandleEnvGad --  Handle Envelope Type Gadget
*
* 
* STATUS={KEY_DRAG,KEY_CREATE,KEY_DELETE}
*
*
*
**************************************************/
void HandleEnvGad(struct AudEnvDisp *aev,
						struct Window *Window,
						struct IntuiMessage *IntuiMsg,
						UBYTE	STATUS, 
						struct PanelLine *PTime,
						struct PanelLine *PNum)

{
	if(IntuiMsg->Code==MENUDOWN)
	{
		if(STATUS==KEY_DRAG)
				HandleKeyDrag(aev,Window,IntuiMsg,
								  SelectEnvKey(aev,IntuiMsg->MouseX,IntuiMsg->MouseY,PTime),
								  1,PTime,PNum);		
	}
	else
	{
		switch(STATUS)
		{
			case	KEY_CREATE:
				CreateEnvKey(aev,Window,IntuiMsg,PTime,PNum);
				break;
			case	KEY_DRAG:
				HandleKeyDrag(aev,Window,IntuiMsg,
								  SelectEnvKey(aev,IntuiMsg->MouseX,IntuiMsg->MouseY,PTime),		
								  0,PTime,PNum);		

				break;
			case	KEY_DELETE:
				DeleteEnvKey(aev,
								 SelectEnvKey(aev,IntuiMsg->MouseX,IntuiMsg->MouseY,PTime),
								 Window,PTime,PNum);
				break;
		}
	
	}
}



/***********************************************************
*
* ScaleEnvelope
*
*	Scaling_Factor=width of super-envelope
***********************************************************/
void ScaleEnvelope(struct AudEnvDisp *aev,ULONG Scaling_Factor)
{
	struct AEDKey *AEDNode,*AEDNode2;
	struct MinList *AEDHead;
	ULONG	 Total_Time;

	aev->SuperEnvWidth=Scaling_Factor;
	AEDHead = &aev->AEDKeys;	
	AEDNode = AEDHead->mlh_Head;
	AEDNode2 = AEDHead->mlh_TailPred;

	Total_Time = AEDNode2->Time-AEDNode->Time;
	aev->HScale = (Total_Time*256)/Scaling_Factor;
	
	aev->MinVal = (AEDNode->Time*256)/aev->HScale;
	aev->MaxVal = (AEDNode2->Time*256)/aev->HScale;

	for(AEDNode=AEDHead->mlh_Head;AEDNode->mln_Succ;AEDNode=AEDNode->mln_Succ)
	{
		AEDNode->Scaled_Time = (AEDNode->Time*256)/aev->HScale;
	}

}	


/*************************************************************************
*
*	SetKeyInPLTime
*
*************************************************************************/
void	SetKeyInPLTime(struct AudEnvDisp *aev,
						   struct PanelLine *PLine)
{
	struct AEDKey *SelNode;
	ULONG	Temp;

	SelNode=aev->SELECTED_KEY;
	if(SelNode)
	{
		Temp= *PLine->Param;
		if(Temp>PLine->PropEnd)
		{
			*PLine->Param=PLine->PropEnd-4;
			Temp= *PLine->Param;
			AdjKeyTimeStr(aev,aev->SELECTED_KEY,PLine,aev->PWindow);
		}
		else	
		{
			if(Temp<PLine->PropStart)
			{
				*PLine->Param=PLine->PropStart+4;
				Temp= *PLine->Param;
				AdjKeyTimeStr(aev,aev->SELECTED_KEY,PLine,aev->PWindow);
			}
		}

		DUMPHEXIL("Time PLine->Param=",(ULONG)*PLine->Param,"\\");

		SelNode->Time=Temp;
		SelNode->Scaled_Time=(SelNode->Time*256)/aev->HScale;
	}
}



/*************************************************************************
*
*	SetKeyInPLValue
*
*************************************************************************/
void	SetKeyInPLValue(struct AudEnvDisp *aev,
							 struct PanelLine *PLine)
{
struct AEDKey *SelNode;

	UWORD Temp; 

	SelNode=aev->SELECTED_KEY;
	if(SelNode)
	{
		Temp = *PLine->Param;
		DUMPHEXIW("Value PLine->Param=",(UWORD)Temp,"\\");
		SelNode->Value = (100-Temp)*655;
		SelNode->Scaled_Val = SelNode->Value/1307;
	}
}


