/* This is the OverlayFX script */
/* August 21, 1997 - Fixed the Arexx Bug */

/* August 22, 1997 - Add Auto Insert Feature */
/* August 25, 1997 - Add Undo Features */

OPTIONS RESULTS
TOASTERLIB="ToasterARexx.port"

call remlib('PROJECT_REXX_PORT')
call addlib('PROJECT_REXX_PORT',0)

IF POS(TOASTERLIB , SHOW('Libraries')) = 0 THEN
  IF ~ADDLIB(TOASTERLIB , 0) THEN x=Bummer(" Please start your Toaster.")

if exists("ENV:OZ-PanicStop") then address command "delete ENV:OZ-PanicStop QUIET"

fpath="" 	/* Path for saving to a selected location (not auto-save) */
orig=0	/* 1=Write to original file location  0=new selected path */

count = croutonsinproject()

mycount. = 0

testing = 0

next = 1
selected = 0
do while next < count+1
   row = trunc(next/8)
   col = next - (row*8)
   row = row + 1
   selected = selected + croutonselected(row,col)
   if croutonselected(row,col) = 1 then do
      mycount.testing = next-1
      testing = testing + 1
   end
   next = next + 1
end

myeffect = mycount.0

call SET_VIEW(4)

call croutonpick(myeffect)

fields = croutongettag(numfields)/2
myduration = croutongettag(Duration)/2

/* This is the new line of code */

if croutongettag(LoopAnims) = 0 then do
   myduration = fields
end

delay = croutongettag(Delay)/2
  
OPEN(myfile,"ram:OverlayFX.txt",'Write')     
croutonpick(myeffect-1)

p_type=croutontype()
p_tn=1
if (p_type="FRAM")|(p_type="STIL")|(p_type="MAIN")|(p_type="KEYF") then do
   if (p_type="FRAM")|(p_type="KEYF") then p_tn=3
      else if (p_type="STIL") then p_tn=2
      else if (p_type="MAIN") then p_tn=4
   end

if (p_tn > 2) then do 
   Call Switcher(M001)
   Call Switcher(PDV2)
   Call Switcher(FMLD,croutonname())
   Call Switcher(WAIT,1)
   end

call DoItNow

call croutonpick(myeffect-1)

WRITELN(myfile,filename1||",3");
WRITELN(myfile,croutonname()||","||p_tn||","||croutongettag(ClipStartField)/2+delay||","||myduration||",0,"||fields);
CLOSE(myfile)
croutonpick(myeffect)

Switcher(DOEN)

address command "prowave:OverlayFX ram:OverlayFX.txt"  

if ~exists(filename1) then 
   do
   call remlib('PROJECT_REXX_PORT')
   call remlib('ToasterARexx.port')
   exit
   end   

value = REQ_TELL("Add Audio to Clip?","Press Continue to Add Audio ","Press Cancel for no Audio")
if (value = 1) then do
   OPEN(myfile,"env:keyaudio.txt",'Write')     
   WRITELN(myfile,filename1||"A,");
   WRITELN(myfile,filename1||",0");
   croutonpick(myeffect-1)
   WRITELN(myfile,croutonname()||","||croutongettag(ClipStartField)/2+delay);
   CLOSE(myfile);
   address command  "prowave:keysupport env:keyaudio.txt"  
   address command "delete "||filename1
   address command "delete "||filename1||".prowave"
   address command "rename "||filename1||"A "||filename1
   end 

call MAKEICON(filename1,fields) 

call SET_VIEW(2)

/* Lets make the undo file */

fpath = filename1

if lastpos('/',fpath,length(fpath)-1)~=0 then do
   filenam2=right(fpath,(length(fpath)-lastpos('/',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos('/',fpath,length(fpath))-1))
   end
else do
   filenam2=right(fpath,(length(fpath)-lastpos(':',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos(':',fpath,length(fpath))))
   end

undofilename = "prowave:undofx/"||filenam2||".undo"

SAY undofilename

OPEN(myfile,undofilename,'WRITE')

WRITELN(myfile,"1");

croutonpick(myeffect)

WRITELN(myfile,croutonname())     

myfcount = croutongettag(FCountMode)

WRITELN(myfile,myfcount)

if (myfcount = 2) then
   WRITELN(myfile,fields*2)

WRITELN(myfile,myduration*2)

WRITELN(myfile,delay*2)

croutonpick(myeffect-1)

WRITELN(myfile,croutongettag(Duration))

WRITELN(myfile,croutongettag(AudioDuration))

CLOSE(myfile)

/* Lets Replace it in the Project */
croutonpick(myeffect-1)

filename2 = croutonname()

startval = croutongettag(ClipStartField)

call croutonpick(myeffect) 

call croutonload(filename2,INSERT)

call croutonpick(myeffect)

call croutonload(filename1,INSERT)

call croutonpick(myeffect) 

call croutondelete() 

call croutonpick(myeffect-1) 

call croutonsettag(Duration,delay*2)

if (value = 1) then
   croutonsettag(AudioDuration,delay*2)

call croutonpick(myeffect) 
call croutonsettag(ClipStartField,0) 
fxlength = croutongettag(recfields)
call croutonsettag(Duration,fxlength)

if (value = 1) then do 
   croutonsettag(AudioStart,0)
   croutonsettag(AudioDuration,fxlength)
   end

call croutonpick(myeffect+1) 

call croutonsettag(ClipStartField,startval+delay*2+fxlength) 
call croutonsettag(Duration,croutongettag(Duration)-delay*2-fxlength)

call croutonsettag(AudioStart,startval+delay*2+fxlength) 
call croutonsettag(AudioDuration,croutongettag(AudioDuration)-delay*2-fxlength)

call remlib('ToasterARexx.port')
call remlib('PROJECT_REXX_PORT')

exit


DoItNow:
/* Create file name here */

croutonpick(myeffect-1)

p_name = croutonname()

croutonpick(myeffect)

n_name = croutonname()

if lastpos('/',p_name,length(p_name)-1)~=0 then do
   filenam3=right(p_name,(length(p_name)-lastpos('/', p_name, length(p_name)-1)))
   newpath=left(p_name,(lastpos('/',p_name,length(p_name))-1))
   end
else do
   filenam3=right(p_name,(length(p_name)-lastpos(':', p_name, length(p_name)-1)))
   newpath=left(p_name,(lastpos(':',p_name,length(p_name))))
   end
call pragma("D",newpath)
newpath=pragma("D","RAM:")

if (right(newpath,1)~="/") & (right(newpath,1)~=":") then
   newpath=newpath||"/"
sm_name=left(filenam3,3)||"z.rfx"

if ((p_tn=1)|(p_tn=2)) & (orig=1) then 
   newfile=newpath||sm_name
else do
   if fpath="" then call savewhere()
   newfile=fpath||sm_name
   end

counter=0
found=0
do while found=0
   counter=counter+1
   if counter<10 then ct="00"||counter
   else if counter<100 then ct="0"||counter
   else ct=counter   
   if ~exists(newfile||ct) then found=1
   end

filename1=newfile||ct

return

SaveWhere:
call startfilereq("Select Flyer drive below to save clip to","FA0:","(No Filename needed)")

exit=1
do while exit=1
  fpath=queryfilereq()
  if fpath=0 then call quit()
  if fpath~="" then exit=0
  else address command "c:wait 1"
end

if lastpos('/',fpath,length(fpath)-1)~=0 then do
   filenam2=right(fpath,(length(fpath)-lastpos('/',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos('/',fpath,length(fpath))-1))
   end
else do
   filenam2=right(fpath,(length(fpath)-lastpos(':',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos(':',fpath,length(fpath))))
   end

call pragma("D",path2)
fpath=pragma("D","RAM:")

if (right(fpath,1)~="/") & (right(fpath,1)~=":") then
   fpath=fpath||"/"
return

