/* This is the Preliminary UndoFX script for RenderFX */

/* Updated August 25, 1997 */
 
OPTIONS RESULTS
TOASTERLIB="ToasterARexx.port"

call remlib('PROJECT_REXX_PORT')
call addlib('PROJECT_REXX_PORT',0)

IF POS(TOASTERLIB , SHOW('Libraries')) = 0 THEN
  IF ~ADDLIB(TOASTERLIB , 0) THEN x=Bummer(" Please start your Toaster.")

call Switcher(TOSW)

if exists("ENV:OZ-PanicStop") then address command "delete ENV:OZ-PanicStop QUIET"

count = croutonsinproject()

mycount. = 0

testing = 0

next = 1
selected = 0
do while next < count+1
   row = trunc(next/8)
   col = next - (row*8)
   row = row + 1
   selected = selected + croutonselected(row,col)
   if croutonselected(row,col) = 1 then do
      mycount.testing = next-1
      testing = testing + 1
   end
   next = next + 1
end

myeffect = mycount.0

/* Lets Replace it in the Project */
croutonpick(myeffect) 

fpath = croutonname()

if lastpos('/',fpath,length(fpath)-1)~=0 then do
   filenam2=right(fpath,(length(fpath)-lastpos('/',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos('/',fpath,length(fpath))-1))
   end
else do
   filenam2=right(fpath,(length(fpath)-lastpos(':',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos(':',fpath,length(fpath))))
   end

filename1 = "prowave:undofx/"||filenam2||".undo"

OPEN(myfile,filename1,'Read')     

UndoType = READLN(myfile)

if (UndoType = 0) then do
   effectname = READLN(myfile)
   call croutonload(effectname,INSERT)
   croutonpick(myeffect)
   call croutondelete()
   croutonpick(myeffect)

   myfcount = READLN(myfile)
   call croutonsettag(FCountMode,myfcount)

   if (myfcount = 2) then do
      myfields = READLN(myfile)
      croutonsettag(numfields,myfields)
      end

   undovideo1 = READLN(myfile)
   undoaudio1 = READLN(myfile)
   call croutonpick(myeffect-1)
   call croutonsettag(Duration,undovideo1)
   call croutonsettag(AudioDuration,undoaudio1)
   call croutonpick(myeffect+1)
   undostart2 = READLN(myfile)
   undolength2 = READLN(myfile)
   call croutonsettag(ClipStartField,undostart2)
   call croutonsettag(Duration,undolength2)
   undostart2 = READLN(myfile)
   undolength2 = READLN(myfile)
   call croutonsettag(AudioStart,undostart2)
   call croutonsettag(AudioDuration,undolength2)
   end

if (UndoType = 1) then do
   effectname = READLN(myfile)
   call croutonload(effectname,INSERT)
   croutonpick(myeffect)
   call croutondelete()
   croutonpick(myeffect+1)
   call croutondelete()
   croutonpick(myeffect)

   myfcount = READLN(myfile)
   call croutonsettag(FCountMode,myfcount)

   if (myfcount = 2) then do
      myfields = READLN(myfile)
      croutonsettag(numfields,myfields)
      end

   myduration = READLN(myfile)
   mydelay = READLN(myfile)

   call croutonsettag(Duration,myduration)
   call croutonsettag(Delay,mydelay)

   undovideo = READLN(myfile)
   undoaudio = READLN(myfile)
   call croutonpick(myeffect-1)
   call croutonsettag(Duration,undovideo)
   call croutonsettag(AudioDuration,undoaudio)
   end

Close(myfile)


call remlib('PROJECT_REXX_PORT')
call remlib('ToasterARexx.port')

exit

