.MODULE Correlation;
 
{
        Correlate Routine
 
        Calling Parameters
                I1 --> Data Memory Buffer               L1 = 0
                I2 --> Length of Data Buffer            L2 = 0
                I5 --> Program Memory Buffer            L5 = 0
                I6 --> Program Memory Result Buffer     L6 = 0
                M0,M4,M5,M6 = 1         
                M2 = -1
                L0,L4 = 0
                SE = scale value
                CNTR = output buffer length

        Return Values
                Result Buffer Filled
 
        Altered Registers
                I0,I1,I2,I4,I5,I6,MX0,MY0,MR,SR

        Computation Time
                Output Length * (Input Length + 8 - ((Output Length-1)/2)) + 2
}
 
.ENTRY          correlate;
 
correlate:      DO corr_loop UNTIL CE;
                   I0=I1;
                   I4=I5;
                   CNTR=I2;
                   MR=0, MY0=PM(I4,M4), MX0=DM(I0,M0);
                   DO data_loop UNTIL CE;
data_loop:            MR=MR+MX0*MY0(SS),MY0=PM(I4,M4),MX0=DM(I0,M0);
                   MY0=PM(I5,M5), SR=LSHIFT MR1 (HI);
                   MX0=DM(I2,M2), SR=SR OR LSHIFT MR0 (LO);
corr_loop:         PM(I6,M6)=SR1;
                RTS;
.ENDMOD;

