
.MODULE Triple_Precision_Add;

{
        Triple-Precision Addition
                Z = X + Y

        Calling Parameters
                I0 --> Buffer for X             L0 = 0
                I1 --> Buffer for Y             L1 = 0
                I2 --> Storage Buffer for Z     L2 = 0
                M0 = 1

        Return Values
                Z Buffer is filled

        Altered Registers
                I0, I1, I2, AR, AX0, AY0

        Computation Time
                10 cycles

}

.ENTRY  tpa;

tpa:    AX0=DM(I0,M0);                          {Fetch LSWs}
        AY0=DM(I1,M0);
        AX0=DM(I0,M0), AR=AX0+AY0;              {Add LSWs}
        AY0=DM(I1,M0);
        DM(I2,M0)=AR, AR=AX0+AY0+C;             {Save LSW, add middle words}
        AX0=DM(I0,M0);                          {Fetch MSWs}
        AY0=DM(I1,M0);
        DM(I2,M0)=AR, AR=AX0+AY0+C;             {Add MSWs}
        DM(I2,M0)=AR;                           {Save MSW}
        RTS;

.ENDMOD;
