.MODULE floating_point_subtract;

{
        Floating-Point Subtraction
                z = x - y

        Calling Parameters
                AX0 = Exponent of x
                AX1 = Fraction of x
                AY0 = Exponent of y
                AY1 = Fraction of y

        Return Values
                AR = Exponent of z
                SR1 = Fraction of z

        Altered Registers
                AX0,AY1,AY0,AF,AR,SI,SE,SR 

        Computation Time
                11 cycles

}

.ENTRY  fps;

fps:    AF=AX0-AY0;                                 {Is Ex > Ey?}
        IF GT JUMP shifty;                          {Yes, shift y}
        SI=AX1, AR=PASS AF;                         {No, shift x}
        SE=AR;
        SR=ASHIFT SI (HI);
        AR=SR1-AY1;                                 {Subtract fractions}
        JUMP subt;
shifty: SI=AY1, AR=-AF;
        SE=AR;
        SR=ASHIFT SI (HI);
        AY1=SR1;
        AY0=AX0, AR=AX1-AY1;                        {Subtract fractions}
subt:   SE=EXP AR (HIX);
        AX0=SE, SR=NORM AR (HI);                    {Normalize}
        AR=AX0+AY0;                                 {Compute exponent}
        RTS;

.ENDMOD;

