.MODULE/ABS=4       dif_fft_main;

.CONST                   N=1024,N_x_2=2048;      {Const. for 1024 points}
.CONST                   N_div_2=512,log2N=10;
.VAR/DM/RAM              inplacedata[N_x_2];     
.VAR/DM/RAM              real_results[N];        
.VAR/DM/RAM              imag_results[N];   
.VAR/PM/ROM/CIRC         twid_imag[N_div_2];     
.VAR/PM/ROM/CIRC         twid_real[N_div_2];     

.VAR/DM/RAM              groups,node_space,bflys_per_group,blk_exponent;

.INIT   inplacedata: <inplacedata.dat>;
.INIT   twid_imag:   <twid_ima.dat>;
.INIT   twid_real:   <twid_rea.dat>;     
.INIT   groups: 1;      
.INIT   node_space: N;  
.INIT   bflys_per_group: N_div_2;       
.INIT   blk_exponent: 0;        

.GLOBAL twid_real, twid_imag;
.GLOBAL inplacedata;
.GLOBAL groups,bflys_per_group,node_space,blk_exponent;

.EXTERNAL fft_start, unscramble;

        CALL fft_start;
        CALL unscramble;        
        TRAP;
.ENDMOD;
