#include	<adsp2101.h>

void flagin(void)
{

/* drop into native code and use flag test assembly instructions */
#pragma inline
	    if not fi jump sawflagin;	{if no flag, just get out}
	    jump flagin__end_;		{restore stack, then rts}

sawflagin:  if not fi jump sawflagin;	{wait here until flag is released}

            {
               Flagin detected...
               Place user code here to service flag event.
            }

	    jump flagin__end_;		{restore stack, then rts}
#pragma inline
/* switch back to C source */

}

/*
 * Note: the label to "flagin__end_" is provided by the compilier
 * automatically, and since it does the run-time stack restore
 * for us, its easier to just go there than to duplicate code.
 */
