#include	<adsp2101.h>
#include	<signal.h>
#include	<stdlib.h>

extern int	inc1, inc2, inc3, rad1, rad2, rad3, timer_count, modifier;
#define 	max_angle 45
#define		max_rad 43

/* macro to reverse motion of display */
#define toggle (modifier = modifier * -1);

int get_random(int highest, int lowest)
{
    /* return a random number within the bounds specified */
    int hugerand = 0;

    while ((hugerand > highest) || (hugerand < lowest))
	hugerand = rand() >> 8;
    return hugerand;
}


interrupt2_routine()
{
    /* randomize all parameters and clear the timer interrupt count */
    inc1 = get_random(max_angle, 1);
    inc2 = get_random(max_angle, 1);
    inc3 = get_random(max_angle, 1);
    rad1 = get_random(max_rad, 20);
    rad2 = get_random(max_rad, 20);
    rad3 = 127 - (rad1 + rad2);
    timer_count = 0;
}

timer_interrupt()
{
    /* bump selected parameters to make cool looking display */
    rad3 = rad3 + modifier;
    if ((rad3 > 2 * max_rad) || (rad3 < -2 * max_rad))
    {
	toggle;

        /* randomize for new display every other repeat cycle... */
    	timer_count++;
	if (timer_count >= 2)
	    raise(SIGINT2);
    }
    if (rad3 >= 0)
        rad2 = 127 - (rad1 + rad3);
    if (rad3 < 0)
        rad2 = 127 - (rad1 - rad3);
}
