{-------ADSP-2101 Data Memory Test
        DSP Applications
        617 - 461 - 3672
                            ---------}
.module dmtest;
.var/dm/abs=0x3800	dmram[10{0x3ff}];

{init data memory to 0x00}
dminit:	i0 = ^dmram;
	m0 = 0;
	M1 = 1;
	M2 = -1;
	L0 = %dmram;
	ax0 = 0x00;
	cntr = 10 {0x3ff};
	do zloop1 until ce;
zloop1:	   dm(i0,m1) = ax0;

{Test 1: Data memory stuck bit test		}
{	 Pass: AX0 = 0	AX1 = 0			}
{	 Fail: AX0 = 1, AX1 = failed dm address	}
dmtst1:	cntr = 10 {0x3ff};
	ax0 = 0xAAAA;
	ay0 = 0x5555;
	do sbit until ce;
	   dm(i0,m0) = ax0;
	   ay1 = dm(i0,m0);
	   dm(i0,m0) = ay0;
           ax1 = dm(i0,m0);
	   ar = ax0 -ay1;
	   if ne jump dmtst1_fail;
	   ar = ay0 - ax1;
	   if ne jump dmtst1_fail;
sbit:	   modify(i0,m1);
	ax0 = 0;
	ax1 = 0;
	jump dmtst2;

dmtst1_fail:
	pop cntr;
	pop pc;
	pop loop;
	ax1 = i0;
	ax0 = 0x01;
	jump end;

{Test 2: Address line short test   		}
{	 Pass: AX0 = 0	AX1 = 0			}
{	 Fail: AX0 = 2, AX1 = failed dm address	}
dmtst2:	{zero dm}
	ax0 = 0x00;
	cntr = 10 {0x3ff};
	do zloop2 until ce;
zloop2:	   dm(i0,m1) = ax0;

strt_test:
	ar = 0;
	ax0 = 0xffff;
	cntr = 10 {0x3ff};
	do atst1 until ce;
	   dm(i0,m1) = ax0;
	   cntr = 10 - 1; {0x3ff}
	   ay0 = dm(i0,m1);
	   do atst2 until ce;
atst2:		ar = ar + ay0, ay0 = dm(i0,m1);
	   modify(i0,m2);
	   ar = pass ar;
	   if ne jump dmtst2_fail;
	   ar = 0;
atst1:	   dm(i0,m1) = ar;
	ax0 = 0;
	ax1 = 0;
	jump dmtst3;
	
dmtst2_fail:
	pop cntr;
	pop pc;
	pop loop;
	ax1 = i0;
	ax0 = 0x02;
	jump end;
dmtst3: jump end;

end:	rts;

.endmod;

