********************************************************************
* $EditSwit.i$
*
* Copyright (c)1993 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
* $Id: EditSwit.i,v 2.70 1995/03/15 18:48:20 CACHELIN4000 Exp $
*
* $Log: EditSwit.i,v $
*Revision 2.70  1995/03/15  18:48:20  CACHELIN4000
*Add ES_RecordAppend
*
*Revision 2.69  1995/03/07  15:45:44  CACHELIN4000
*add FastDrive config bitdef
*
*Revision 2.68  1995/03/02  12:35:53  pfrench
*Added switcher un-used rawkey handling code
*
*Revision 2.67  1995/02/17  16:10:55  Kell
*New fields on LocateFile and FoundFile (was SaveFile)
*
*Revision 2.66  1995/02/17  13:21:36  Kell
**** empty log message ***
*
*Revision 2.65  1995/02/12  05:05:17  Kell
*New Prefs bits defined for External VID3/4 & New record videosources defined for External VID3/4.
*
*Revision 2.64  1995/02/10  15:24:48  Kell
**** empty log message ***
*
*Revision 2.63  1995/01/25  13:03:22  Kell
*New TBCO & TBCC hacks defined
*
*Revision 2.62  1995/01/24  12:12:57  Kell
*New defines for ES_Pause and Cutting Room features.  TBC hacks defined.
*
*Revision 2.61  1995/01/23  15:41:07  Kell
*New definition for ES_Hack.  Now uses Data1 for Type vs twhk_Type
*
*Revision 2.60  1994/12/31  06:33:37  Kell
**** empty log message ***
*
*Revision 2.59  1994/12/30  02:39:16  Kell
*Removed ES_FlyerVolumes
*
*Revision 2.58  1994/12/17  04:59:00  Kell
**** empty log message ***
*
*Revision 2.57  1994/11/30  22:41:24  Kell
*New SavePrefs command.
*
*Revision 2.56  1994/11/23  16:37:58  Kell
*New ES_UnSavable & ES_NewFieldCount defined.
*
*Revision 2.55  1994/11/04  03:26:22  Kell
*added LoadedSlices ES command
*
*Revision 2.54  1994/10/31  15:55:05  Kell
*New READCALIB flag on the Tweek panel.
*
*Revision 2.53  1994/10/28  14:13:46  Kell
*Added more Tweek structure fields (Pedestal, Shift, etc.)
*
*Revision 2.52  1994/10/25  08:11:56  Kell
*Added new flags to the RenderCallBack structure for Video FineTune.
*
*Revision 2.51  1994/10/21  17:01:29  Kell
*New ES_Get & SetPrefs commands, along with SystemPrefs structure
*
*Revision 2.50  1994/10/21  13:01:45  Kell
*Added ES_SystemSetup
*
*Revision 2.49  1994/10/15  01:30:38  Kell
*Added ES_FlyerVolumes
*
*Revision 2.48  1994/10/07  23:40:02  Kell
*Defind Hack stucture and flags for tweeking
*
*Revision 2.47  1994/10/06  20:22:59  Kell
*Added TweakHack structure.
*
*Revision 2.46  1994/10/04  23:39:31  Kell
*Added ES_Hack for all kinds of Hacking possibilities.
*
*Revision 2.45  1994/09/30  21:08:17  Kell
*New ES commands for Making/Appending clip icons, getting clip info
*
*Revision 2.44  1994/09/29  15:32:33  Kell
*Added ES commands for Clip Heads & making clip icons.
*
*Revision 2.43  1994/09/28  22:00:39  Kell
*New ES_FlyerDefrag
*
*Revision 2.42  1994/09/27  09:07:51  Kell
*New ES_CheckRecord command
*
*Revision 2.41  1994/09/27  08:11:57  Kell
*Added SVHS setting to the possible record sources.
*
*Revision 2.40  1994/09/27  04:47:16  Kell
*Now ES_Stop is used for play/record or sequencing.
*ES commands CommpressionMode, RecordSource added.
*Various EQUs for setting up Record.
*
*Revision 2.39  1994/09/23  17:03:43  Kell
*Added ES_FlyerDriveInfo command
*
*Revision 2.38  1994/09/13  21:20:08  Kell
*New ES_ commands for talking to our slices.
*
*Revision 2.37  1994/09/13  05:58:41  Kell
*Changes to RenderCallBack function.
*I mean structure (not function).
*
*Revision 2.36  1994/09/08  19:28:29  Kell
*New ES_TagSize, GetTable and PutTable commands.
*
*Revision 2.35  1994/09/05  20:14:57  Kell
*Added more fields to define Shuttle Speed
*
*Revision 2.34  1994/09/05  18:22:35  Kell
**** empty log message ***
*
*Revision 2.33  1994/09/05  18:20:26  Kell
*New ES_Jump and ES_ApplyTags commands
*Added shuttle speed/direction information to the RenderCallBack struct.
*
*Revision 2.32  1994/09/02  16:19:23  Kell
*Added ES_PanelOpen/Close commands
*
*Revision 2.31  1994/09/02  08:40:42  Kell
*Added MouseX/Y fields to the RenderCallBack structure.
*
*
********************************************************************
	IFND EDIT_SWIT_I
EDIT_SWIT_I SET 1

;	IFND EXEC_TYPES_I
;	INCLUDE "exec/types.i"
;	ENDC
;	INCLUDE "exec/ports.i"

*	FG_Extra1
CR_Overlap	equ	0
CR_VidEvent	equ	1
CR_Other	equ	2

EditCookie	equ	$666

MAX_ESPARAMS	equ	8

*-------------------------------------------------------
	STRUCTURE ESMessage,MN_SIZE
	WORD ES_Cookie		;$666
	WORD ES_Type
	LONG ES_Reply	;Usually returns a useful number, pointer, or error number
	APTR ES_Error	;->some type off Error structure

	LONG ES_Data1
	LONG ES_Data2
	LONG ES_Data3
	LONG ES_Data4
	LONG ES_Data5
	LONG ES_Data6
	LONG ES_Data7
	LONG ES_Data8	;actually any number of LONGs is allowed
	LABEL ES_SIZEOF ;so, look at MN_LENGTH for total length

*-------------------------------------------------------
	STRUCTURE RenderCallBack,0
	APTR	RCB_Function
	APTR	RCB_FG
	ULONG	RCB_Frame
	ULONG	RCB_Min
	ULONG	RCB_Max
	ULONG	RCB_Flags	;bit 31 = initial FF/REW direction (1=reverse)
				;bit 30 = clear if FF/REW, set if Shuttle
	APTR	RCB_Window
	APTR	RCB_Gadget
	WORD	RCB_MouseY	;initially same as sc_MouseY
	WORD	RCB_MouseX	;initially same as sc_MouseX

* Velocity = RCB_VelocityNumerator/RCB_VelocityDenominator
	WORD	RCB_VelocityNumerator
	UWORD	RCB_VelocityDenominator

	LABEL	 RCB_SIZEOF

	BITDEF	DHD,DHD_PLAY_REV,31  	; initial shuttle direction (1=reverse)
	BITDEF	DHD,DHD_SHUTTLE_MODE,30 ; clear if FF/REW Jog, set if Shuttle
	BITDEF	DHD,INPOINT,29		; set if moving inpoint
	BITDEF	DHD,OUTPOINT,28		; set if moving outpoint
	BITDEF	DHD,VIDEOSLIDER,27	; set if moving video slider
	BITDEF	DHD,AUDIOSLIDER,26  	; set if moving audio slider

*-------------------------------------------------------
HACK_TWEAK  	EQU 	'TWEK'  	;TWEK  first hack type
HACK_TBCwrite  	EQU 	'TBCW'
HACK_TBCread  	EQU 	'TBCR'
HACK_TBCopen  	EQU 	'TBCO'
HACK_TBCclose  	EQU 	'TBCC'

	STRUCTURE TweakHack,0
	 ULONG		twhk_Flags
	 ULONG		twhk_Position	; -910 -> 910
	 ULONG		twhk_Clock	; 0 -> 3
	 ULONG		twhk_Coarse	; 0 -> 15
	 ULONG		twhk_Fine	; 0 -> 7
	 ULONG		twhk_Luma	;
	 ULONG		twhk_Hue	;
	 ULONG		twhk_Pedestal	; 0 -> 255
	 ULONG		twhk_Shift	; 0 -> 1
   LABEL	twhk_SIZEOF

;twhk_Flags bits
HKB_PLAY_A	EQU 	0
HKB_PLAY_B	EQU 	1
HKB_RECORD_A	EQU 	2
HKB_RECORD_B	EQU 	3
HKB_TESTREC	EQU 	4
HKB_READCALIB	EQU	5


HKF_PLAY_A	EQU 	1
HKF_PLAY_B	EQU 	2
HKF_RECORD_A	EQU 	4
HKF_RECORD_B	EQU 	8
HKF_TESTREC	EQU 	16
HKF_READCALIB	EQU	32

*-------------------------------------------------------
	STRUCTURE SystemPrefs,0
		UBYTE	spref_Termination
		UBYTE	spref_GPI	;0=off, 1=positive, 2=negative
		UBYTE	spref_Flags1
		UBYTE	spref_Flags2
	LABEL	spref_SIZEOF

* Flags1 bits
	BITDEF	sp,PrvwOLay,0		;set if Preview Overlay is on, else 3 monitor setup
	BITDEF	sp,FlyerVID3,1		;set if Toaster VID3 is connected to Flyer, else it's External
	BITDEF	sp,FlyerVID4,2		;set if Toaster VID4 is connected to Flyer, else it's External
	BITDEF	sp,FastDrive,3		;set if extra fast drives are present, fast recording enabled

* Termination Setting:
	BITDEF	sp,Terminate4,0		;set if Video 4 input is terminated
	BITDEF	sp,Terminate3,1		;set if Video 3 input is terminated
	BITDEF	sp,Terminate2,2		;set if Video 2 input is terminated
	BITDEF	sp,Terminate1,3		;set if Video 1 input is terminated

*-------------------------------------------------------
* This will record the currently selected VideoSource & AudioSources, using
* the current compression mode.  See ES_CompressionMode, ES_RecordSource

*+ NOTE!!! This struct is now part of the ES command structure (starting at Data1)
*+       STRUCTURE FlyerRecord,0
*+	APTR	FLY_Name		;->path/name
*+	ULONG	FLY_Fields	;length of record, 0=wait for abort
*+
*+* The following functions are ignored if NULL.
*+* They are used to start and stop record frame accurately.
*+* So record start and stop could be controled by GPI, input SMPTE time,
*+* Time of Day, Keyboard or Mouse input, etc.
*+* Start and stop will take affect on start of the next color frame (field 1).
*+	ULONG	FLY_StartFunction ;Will not start until StartFunct returns
*+	ULONG	FLY_StopFunction  ;Will not stop until Stop function returns
*+	ULONG	FLY_Flags	  ;see below
*+       LABEL	FLY_SIZEOF

*** FLY_Flags ***
	BITDEF	FLY,APPEND,0		;For appending to existing clips
	BITDEF	FLY,SERIAL1,1		;Include Serial port1 data
	BITDEF	FLY,SERIAL2,2		;Include Serial port2 data

*-------------------------------------------------------
* Values used by ES_RecordSource(VideoSource,,,)
FLY_VideoSource_NONE		EQU	0	;Show black, don't record video
FLY_VideoSource_NTSC		EQU	1	;Requires Flyer TBC
FLY_VideoSource_SVHS		EQU	2	;Requires Flyer TBC
FLY_VideoSource_VID1		EQU	3
FLY_VideoSource_VID2		EQU	4
FLY_VideoSource_Main		EQU	5
FLY_VideoSource_Preview		EQU	6
FLY_VideoSource_VID3		EQU	7
FLY_VideoSource_VID4		EQU	8

*-------------------------------------------------------
* Values used by ES_CompressionMode
* I don't know what modes we'll support, so I just made up some names!!!
FLY_CompressionMode_D2			EQU 0
FLY_CompressionMode_BetaCam		EQU 1
FLY_CompressionMode_SVHS		EQU 2
FLY_CompressionMode_VHS			EQU 3
FLY_CompressionMode_BroadCast		EQU 4
FLY_CompressionMode_Industrial		EQU 5
FLY_CompressionMode_ThreeQuarter 	EQU 6
FLY_CompressionMode_High8		EQU 7
FLY_CompressionMode_PreviewQuality	EQU 8

*-------------------------------------
* Flags used by ES_LocateFile & ES_FoundFile
StringGadget	equ	1		;set if you want a string gadget (for save)


*****************************************************************
* See edit/inc/editswit.h for more commants.  Or switcher/src/pecomm.a

* ESMessage.Type
ES_DUMMY 	equ	0
ES_STARTUP	equ	1	; Data1->TB_Screen, Data2=NULL, Data3->TB_Window, Data4->table of pointers to FG lists
ES_RENDER_EDIT	equ	2	; tells Editor to (re)render its windows
				; Data1: TRUE means open windows if not open (and refresh)
				;        FALSE means close windows (no refresh before close)
				; (WINDOWOPENFLAG, ScreenDepth)  ;ONLY SENT TO EDITOR, NEVER TO SWITCHER!

ES_RENDER_SWIT	equ	3	; tells Switcher to (re)render, Data1: same ES_RENDER_EDIT

ES_ClearProject equ	4	; Clear a given project list

ES_PanelOpen	equ 	5	; Called when control panel is opened. USED TO BE SETRMOFF

ES_GETPLIST	equ	6	; asks switcher for project list pointers, reply will be pointer to table of pointers to FG lists
				; This info is also supplied by the ES_STARTUP message!!!

ES_FreeCrouton	equ	7	; asks switcher to unload crouton from memory
ES_LoadCrouton	equ	8	; asks switcher to load crouton data1 is pointer
				; to disk file name.

ES_DuplicateCrouton	equ	9	; make a duplicate of the crouton. Data1 is a pointer
				; to the crouton to duplicate

ES_LoadProject	equ	10	; Data1 is filename Data2 is mode
ES_SaveProject	equ	11	; Data1 is filename or Null for current file
ES_NewProject	equ	12	; Data1 is filename of new file

ES_Select	equ	13	; Data1 is FG to get FGC_SELECTQ
ES_Auto		equ	14	; Data1 is FG to get FGC_AUTO
ES_StartSeq	equ	15	;
ES_Stop		equ	16	; used to stop playing/recording clips & sequencing

ES_QUIT 	equ	17	; Tells the Editor to quit = F8

ES_GetValue	equ	18	; Gets value out of taglist
ES_PutValue	equ	19	; Puts value into taglist
ES_FGcommand	equ	20	; Sends a specific FGC command to crouton
ES_PanelClose	equ	21	; Called when control panel is closed. Was ES_HiliteCrouton

ES_Record	equ	22	; (->name, fields, ->StartFunct, ->StopFunct, Flags)
ES_Pause	equ	23	; (PauseFlag)
ES_Jog		equ	24	; (RenderCallBack)
ES_Shuttle	equ	25	; (RenderCallBack)

ES_InitRecord	equ	26
ES_InitPlay	equ	27
ES_Main2Blank	equ	28

ES_GUImode	equ	29	; Project/Switcher, Project/Files etc.
ES_SelectDefault equ	30	; Select internal default effect (fade)
ES_Jump		equ	31	; (FG,field)
ES_ApplyTags	equ	32	; (FGsource,FGdestination)

ES_TagSize	equ	33	; (FG, TagID)
ES_GetTable	equ	34	; (FG, ->Table, TableSize, TagID)
ES_PutTable	equ	35	; (FG, ->Table, TableSize, TagID)

ES_LightWave	equ	36	; (FGC_Command)
ES_ToasterPaint equ	37	; (FGC_Command)
ES_ToasterCG	equ	38	; (FGC_Command)
ES_ChromaFX	equ	39	; (FGC_Command)

ES_FlyerDriveInfo equ	40	; (->volumename, ->FlyerVolInfo or NULL)
ES_RecordSource	  equ	41	; (VideoSource)
ES_CompressionMode equ	42	; (mode)
ES_CheckRecord	equ	43	; (), returns FERR_..., 0 if recording finished OK

ES_DefragFlyer	 equ	44	; (->volumename)
ES_StartHeadList equ	45	; ()
ES_MakeClipHead  equ	46	; (->name,VidStart,VidFields,AudStart,AudFields)
ES_EndHeadList   equ	47	; ()

ES_MakeClipIcon	 equ	48	; (->name,->crud,crudsize,field)
ES_FlyerClipInfo equ	49	; (->clipname, ->ClipInfo or NULL)
ES_AppendIcon	 equ	50	; (->name)
ES_Hack		 equ	51	; ('Name',->HackStructure)

ES_BuildVolumeTable equ	52	; () returns ->table of Flyer Volumes & Type

ES_GetPrefs	 equ	53	; (->SystemPrefs Structure) fill in current values
ES_SetPrefs	 equ	54	; (->SystemPrefs Structure)
ES_LoadedSlices	 equ	55	; () returns Slice Mask (see tags.i for bits)

ES_UnSavable	 equ	56	;(FG, TagID)	;marks Tag item so it doesn't get saved in the project
ES_NewFieldCount equ    57	;(FG)	;This needs to be called if a Current FXs speed or duration has changed.
ES_SavePrefs	 equ	58	;() saves an HS file. Returns ERROR. Though we usually ignore errors!

ES_StartClipCutList equ	59 	;(->filename, DestructFlag)
ES_AddClipCut  	    equ 60	;(->filename, StartField, NumFields, VidAudFlags)
ES_EndClipCutList   equ	61	;(DoItFlag)
ES_AudioControl	    equ 62	;(->FlyAudCtrl, operationFlags)
ES_ChangeAudio	    equ 63	;(->FG)  Use this to modify the currently playing clip
ES_LocateFile	    equ 64	;(Type,->Name,flags,->textarray,mode)
ES_FoundFile        equ 65	;(Type,->Name,flags,->textarray,mode)
ES_SwitcherRAWKEY   equ 66	;(Code,Qualifier)
ES_RecordAppend   	equ 67	; (->name, fields )

*-------------------------------------------

* ESMessage.Reply
ES_ERR_NONE		equ	0
ES_ERR_GENERIC		equ	1	; unable to complete requested action

	ENDC ; EDIT_SWIT_I
