
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/exec.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library		*FlyerBase;

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: Aussie Audio Tool 1.00";

struct FlyAudCtrl Flyaudio;

main(int argc,char **argv)
{
unsigned temp;

if (argc < 2) 
   {
   printf("%s <command> <Left> <Right> \n",argv[0]);
   printf("0 = Read Levels \n");
   printf("1 = Set Gain \n");
   printf("Copyright 1999, Bill Evans \n");
   return(0);
   }

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0)
   {
   printf("Open flyer.library failed\n");
   return;
   }

temp = atoi(argv[1]);

if (temp == 0)
   {
   FlyerAudioCtrl(0,&Flyaudio,FACOF_SENSE8);
   printf("%d %d \n",Flyaudio.LeftSense, Flyaudio.RightSense);
   }
if (temp == 1)
   {
   Flyaudio.LeftGain = atoi(argv[2]);
   Flyaudio.RightGain = atoi(argv[3]);
   FlyerAudioCtrl(0,&Flyaudio,FACOF_SETGAIN);
   }

CloseLibrary(FlyerBase);
return(0);
}

