
#include "arexx.h"
#include "arexxsyslib.h"

#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction  Action;

void PlayVideo(UWORD, char *,UWORD); 

void AppendVid(char *, int);

char pathname[3][100];

FILE *input_file;

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: RenderFX 2.02 ";

main(int argc,char **argv)
{
UBYTE QualModes[] = {
   0x00,    // Standard
   0x03,    // Extended
   0x00,    // Audio-only (yuck!)
   0x10};   // HQ5

ULONG res;
int bill;

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return(20);
   }

res = FlyerInputSel(0,FI_ToasterMain,FS_ToasterMain);

res = PlayMode(0); 

bill = atoi(argv[1]);

res = VideoCompressModes(0,bill,4,0);
Delay(10);         // Allow a few fields of mode-settling

res = RecordMode(0);
Delay(1);


AppendVid(argv[2],8); 

CloseLibrary(FlyerBase);
}

void AppendVid(char *outpath, int count)
{

ULONG res;
int fields;

fields = count;

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.SCSIdrive = 0;
FlyVol.Path = outpath;

Action.Volume = &FlyVol;
Action.ReturnTime = RT_STOPPED;

Action.Channel = 0;

/* These flags are currently ignored */
Action.Flags = CAF_VIDEO | CAF_AUDIOL | CAF_AUDIOR;

Action.VidFieldCount = Action.AudFieldCount = fields;

Action.VolSust1 = 0xFFFF;     // Unimportant
Action.VolSust2 = 0xFFFF;     // "
Action.VidStartField = 0;     // "

res = AppendFields(&Action);
if (res) 
   {
   printf("This is superwidget \n");
   printf("\nError %ld - %ls\n",res,Error2String(res));
   }
}

