*********************************************************************
* eflib.i
*
* Copyright 1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* $Id: eflib.i,v 2.23 94/02/07 15:55:45 Kell Exp $
*
* $Log:	eflib.i,v $
*Revision 2.23  94/02/07  15:55:45  Kell
*Various changes to support the new 4.0 croutons & projects.
*
*********************************************************************
	IFND	EFXLIB_I
EFXLIB_I	SET	1

	
* EffectLibrary
	IFND	RECT_I
	include	"rect.i"
	ENDC
	IFND	KEYLOGIC_I
	include "keylogic.i"
	ENDC

	include "exec/libraries.i"

*----------------------------------
CALLEF	MACRO	;OffsetName
	jsr	_LVO\1(a4)
	ENDM
*----------------------------------

* Only allow 9 rectangles horizontally
SDXNUM	SET	9
WDXNUM	SET	9

NUMTV_SCALE	SET	14	;total # of variables (dynamic & static) / scale
NUMTV_PIXELIZE	SET	4
NUMTV_WIPE1	SET	8	
NUMTV_TELH1	SET	3	
NUMTV_TELH2	SET	6
NUMTV_TELH3	SET	3	

* used by 4.0 ANIM/ILBM Effects
NUMTV_Fader	SET	1
NUMTV_LumKey	SET	1
NUMTV_TBarTime	SET	1
NUMTV_BMposition SET	4

************************************************************************

	LIBINIT	LIB_BASE
	  LIBDEF _LVOoooo_oo_o_O
	  LIBDEF _LVOXXXX_oo_o_O
	  LIBDEF _LVOoooo_oo_X_O
	  LIBDEF _LVOXXXX_oo_X_O	
	  LIBDEF _LVOoooo_FF_o_O
	  LIBDEF _LVOXXXX_FF_o_O
	  LIBDEF _LVOoooo_FF_X_O
	  LIBDEF _LVOXXXX_FF_X_O	
	  LIBDEF _LVOoooo_Fo_o_O
	  LIBDEF _LVOoooo_oF_o_O	
	  LIBDEF _LVOXXXX_dd_X_A_O
	  LIBDEF _LVOoooo_dd_X_A_O
	  LIBDEF _LVOXXXX_dd_o_A_O	
	  LIBDEF _LVOXXXX_dd_X_P_O
	  LIBDEF _LVOoooo_dd_X_P_O
	  LIBDEF _LVOXXXX_dd_o_P_O	
	  LIBDEF _LVOXXXX_dd_X_N_O
	  LIBDEF _LVOoooo_dd_X_N_O
	  LIBDEF _LVOXXXX_dd_o_N_O
	  LIBDEF _LVOXXXX_DD_X_O
	  LIBDEF _LVOoooo_DD_X_O
	  LIBDEF _LVOXXXX_DD_o_O
	  LIBDEF _LVOoooo_oo_o_M
	  LIBDEF _LVOXXXX_oo_o_M
	  LIBDEF _LVOoooo_oo_X_M
	  LIBDEF _LVOXXXX_oo_X_M	
	  LIBDEF _LVOoooo_FF_o_M
	  LIBDEF _LVOXXXX_FF_o_M
	  LIBDEF _LVOoooo_FF_X_M
	  LIBDEF _LVOXXXX_FF_X_M	
	  LIBDEF _LVOoooo_Fo_o_M
	  LIBDEF _LVOoooo_oF_o_M	
	  LIBDEF _LVOXXXX_dd_X_A_M
	  LIBDEF _LVOoooo_dd_X_A_M
	  LIBDEF _LVOXXXX_dd_o_A_M	
	  LIBDEF _LVOXXXX_dd_X_P_M
	  LIBDEF _LVOoooo_dd_X_P_M
	  LIBDEF _LVOXXXX_dd_o_P_M	
	  LIBDEF _LVOXXXX_dd_X_N_M
	  LIBDEF _LVOoooo_dd_X_N_M
	  LIBDEF _LVOXXXX_dd_o_N_M
	  LIBDEF _LVOXXXX_DD_X_M
	  LIBDEF _LVOoooo_DD_X_M
	  LIBDEF _LVOXXXX_DD_o_M     
	  LIBDEF _LVOoooo_oo_o_P
	  LIBDEF _LVOXXXX_oo_o_P
	  LIBDEF _LVOoooo_oo_X_P
	  LIBDEF _LVOXXXX_oo_X_P	
	  LIBDEF _LVOoooo_FF_o_P
	  LIBDEF _LVOXXXX_FF_o_P
	  LIBDEF _LVOoooo_FF_X_P
	  LIBDEF _LVOXXXX_FF_X_P	
	  LIBDEF _LVOoooo_Fo_o_P
	  LIBDEF _LVOoooo_oF_o_P	
	  LIBDEF _LVOXXXX_dd_X_A_P
	  LIBDEF _LVOoooo_dd_X_A_P
	  LIBDEF _LVOXXXX_dd_o_A_P	
	  LIBDEF _LVOXXXX_dd_X_N_P
	  LIBDEF _LVOoooo_dd_X_N_P
	  LIBDEF _LVOXXXX_dd_o_N_P
	  LIBDEF _LVOXXXX_DD_X_P
	  LIBDEF _LVOoooo_DD_X_P
	  LIBDEF _LVOXXXX_DD_o_P     
	  LIBDEF _LVOxxxx_FF_x_O
	  LIBDEF _LVOxxxx_FF_x_M

	  LIBDEF _LVOHandleDVE2TBar
	  LIBDEF _LVOHandleDVE2Auto
	  LIBDEF _LVOChangeIS
	  LIBDEF _LVOProcessFreezeThaw
	  LIBDEF _LVOProcessTake
	  LIBDEF _LVOProcessEffect
	  LIBDEF _LVOProcessDuring
	  LIBDEF _LVOHandleSwitcher1TBar
	  LIBDEF _LVOHandleSwitcher1Auto
;;	  LIBDEF _LVODVEDDLogic
	  LIBDEF _LVODelayedLinearMotion
	  LIBDEF _LVOTileY
	  LIBDEF _LVOTileX
	  LIBDEF _LVOMidTransFadeLogic
	  LIBDEF _LVOHandleWipe1TBar
	  LIBDEF _LVOHandleWipe1Auto
;;	  LIBDEF _LVOSwitcherABLogic
;;	  LIBDEF _LVODVEOffABLogic
;;	  LIBDEF _LVODVEOnABLogic
	  LIBDEF _LVOHandleDVE1TBar
	  LIBDEF _LVOHandleDVE1Auto
	  LIBDEF _LVOInitDynamic
	  LIBDEF _LVOScaleCalc
	  LIBDEF _LVOScaleXOut
	  LIBDEF _LVOScaleYOut
	  LIBDEF _LVOScaleXIn
	  LIBDEF _LVOScaleYIn
	  LIBDEF _LVOFillByteBuff
	  LIBDEF _LVOLinearMotion
	  LIBDEF _LVOAccelMotion
	  LIBDEF _LVOHarmonicMotion
	  LIBDEF _LVOTimeVariablesCalc
	  LIBDEF _LVOMosaicX
	  LIBDEF _LVOMosaicY
	  LIBDEF _LVOHorizontalLine
	  LIBDEF _LVOMultRealByReal
	  LIBDEF _LVOMultRealByFract
	  LIBDEF _LVOMultRealByInt
	  LIBDEF _LVODivideReal
	  LIBDEF _LVOWipe1Calc
	  LIBDEF _LVODVE1HorEdges2CompBmList
	  LIBDEF _LVOWipe1HorEdges2CompBmList
	  LIBDEF _LVOEventListMotion
	  LIBDEF _LVOSegmentListMotion
	  LIBDEF _LVOChangeClips
	  LIBDEF _LVOStashStates

	LIBDEF	_LVOoooo_fF_o_O
	LIBDEF	_LVOXXXX_fF_o_O
	LIBDEF	_LVOoooo_fF_X_O
	LIBDEF	_LVOXXXX_fF_X_O	
	LIBDEF	_LVOoooo_fF_o_M
	LIBDEF	_LVOXXXX_fF_o_M
	LIBDEF	_LVOoooo_fF_X_M
	LIBDEF	_LVOXXXX_fF_X_M	
	LIBDEF	_LVOoooo_fF_o_P
	LIBDEF	_LVOXXXX_fF_o_P
	LIBDEF	_LVOoooo_fF_X_P
	LIBDEF	_LVOXXXX_fF_X_P	

	LIBDEF	_LVOProcessUnTake
	LIBDEF	_LVOProcessPosition
	LIBDEF	_LVOIsMatteShown

	LIBDEF	_LVOSearchDynamic

	LIBDEF  _LVODeltaLinearMotion
	LIBDEF  _LVODeltaAccelMotion	
	LIBDEF  _LVODeltaDeaccelMotion
	LIBDEF  _LVODeltaSCurveMotion	
	LIBDEF  _LVODeltaBigAccelMotion	
	LIBDEF  _LVODeltaBigDeaccelMotion
	LIBDEF  _LVODeltaRandomMotion
	LIBDEF  _LVODeltaCyclicMotion
	LIBDEF  _LVODeltaConstantMotion
	LIBDEF  _LVOMultiDeltaMotion
	LIBDEF  _LVOMultiSumMotion
	LIBDEF  _LVOMultiSegmentMotion

	LIBDEF  _LVOStdCroutonHandler

* New functions go here

EF_NEGSIZE EQU (-COUNT_LIB)-6+4  ;size of fuction area, including LONG at bottom.

	STRUCTURE	EF,LIB_SIZE
* This stuff is no longer embedded!!!!!!
		APTR	EF_VariableResults	;NEW for 4.0	
		APTR	EF_TimeVariables	;NEW for 4.0
		APTR	EF_EffectsTable		;NEW for 4.0
		APTR	EF_EffectsLogic		;NEW for 4.0	 

		WORD	EF_DestXMin
		WORD	EF_DestXMax

		WORD	EF_TakeFlag	
		WORD	EF_MonoFlag
		WORD	EF_ColorOrBW	;value put into TB after next transition

		WORD	EF_OldTBar	;-1 if start of effect
		WORD	EF_OldStage	;tbar logic stage from before	
		WORD	EF_BorderState	;border data type in lines 252/253

* Values of EF_BorderState
BorderTrashed	set	-1	;fix border on REMOVE
BorderStandard	set	0	;standard border in use
BorderLinearLUT	set	1	;Linear LUT data in border
* BorderGadation set 	2	;Special Gradated border

		WORD	EF_NotDigital	;flag no digital source for TDE effect		
*--------
		APTR	EF_TriMarkedEFX
		APTR	EF_TriMarkedLUT
		APTR	EF_TriMarkedFade
		
		WORD	EF_TValFade	;global fade in/out amount

		BYTE	EF_Flags1
		BYTE	EF_Flags2

EFFLAGS1_LOCKCLIP_BIT	EQU	0	;don't change Clip or NOKEYINVERT in ProcessDuring
EFFLAGS1_LOCKCLIP_MASK	EQU	1
EFFLAGS1_DISPLAYTRASHED EQU	2	;flags a redo display before ProcessEffect does ServerAVEI
EFFLAGS1_NODOTBAR 	EQU	3	;prevents ProcessEffect from using a DoTBar call in PEtbar
EFFLAGS1_MATTETRASHED	  EQU	4	;Need to restore matte after effect
EFFLAGS1_TEMPORARYSPRITE1 EQU	5	;Set if using a temporary sprite (i.e. sprite from ANIM bitmap)
					;After an effect, the system will kill this from TB_CurrentSprite1

		LONG	EF_TimeStop	;stop Autos at this point

		LONG	EF_CurrentEffectsTable	;Used by InitDynamic()

		WORD	EF_SavedMatte	;matte to restore after effects
		WORD	EF_OldTBarTime		

		LONG	EF_OverrideProcessDuring
		LONG	EF_FieldReinstall

		APTR	EF_PreProcessDuring

		LONG	EF_Spare5
		LONG	EF_Spare6
		LONG	EF_Spare7
		LONG	EF_Spare8
		LONG	EF_Spare9
		LONG	EF_SpareA
		LONG	EF_SpareB
		LONG	EF_SpareC
		LONG	EF_SpareD
		LONG	EF_SpareE
		LONG	EF_SpareF

* Newer data goes here

	LABEL	EF_POSSIZE

******************************************************************
* This used to be the embedded EF_EffectsLogic structure!!!

	STRUCTURE	TheEffectsLogic,0		
		APTR	TEL_TSEab
		APTR	TEL_TDEon
		APTR	TEL_TDEoff
		APTR	TEL_TSEwipe
		APTR	TEL_TDEtoTDE	
		APTR	TEL_TDtoBtoTD
		APTR	TEL_DTrailsOW
		APTR	TEL_TStoMtoTS
		APTR	TEL_DTrailsOffOn
		APTR	TEL_TDEtemp		
	
* some may not be done yet
		APTR	TEL_TSEwipe2	;EF_ATrails
		APTR	TEL_EncoderAlpha
		APTR	TEL_LutColorFilter
		APTR	TEL_LutColorTBar
		APTR	TEL_LutMonoFilter
		APTR	TEL_LutMonoTBar	

;;		APTR	TEL_TDEonFlashFreeze
;;		APTR	TEL_TDtoBtoTDFlashFreeze	
		APTR	TEL_QuafAlphaOn
		APTR	TEL_QuafAlphaOff

		APTR	TEL_TDEfx
		APTR	TEL_TSEfx
		APTR	TEL_Encoder
		APTR	TEL_LatchAencoderB
		APTR	TEL_LatchBencoderA
		
		APTR	TEL_TSEtemp
		APTR	TEL_TSEwipeTemp

		APTR	TEL_LatchBmatteA
		APTR	TEL_LatchAmatteB

		APTR	TEL_QuafAlphaTemp

		APTR	TEL_LatchTDEonEncoderA
		APTR	TEL_LatchTDEonEncoderB
		APTR	TEL_LatchTDEoffEncoderA
		APTR	TEL_LatchTDEoffEncoderB
	LABEL	TEL_SIZEOF

***************************************************
* This used to be the embedded EF_EffectsTable structure!
* The ET_ constants that are found in the Crouton Data are used as
* offsets into this Look Up Table.  This table keeps track of where
* the "TimeVariables" structure and "Results" structures are located
* for each type of Effect Data.

	STRUCTURE	TheEffectsTable,0
		STRUCT	TEF_DVE1X,8*SDXNUM
		STRUCT	TEF_DVE1Y,8
		STRUCT	TEF_PixelizeX,8
		STRUCT	TEF_PixelizeY,8
		STRUCT	TEF_Wipe1X,8*WDXNUM
		STRUCT	TEF_Wipe1Y,8
		STRUCT  TEF_TELH1,8
		STRUCT  TEF_TELH2,8
		STRUCT  TEF_TELH3,8

* used by 4.0 ANIM/ILBM Effects
		STRUCT	TEF_Fader,8
		STRUCT	TEF_LumKey,8
		STRUCT	TEF_TBarTime,8
		STRUCT	TEF_BMposition,8

	LABEL	TEF_SIZEOF

***************************************************
* This used to be the embedded at the start of EFXBASE!
* These are the structures that contain the results via algorithmic equations.

	STRUCTURE	TheVariableResults,0
		STRUCT	TVR_ScaleDataX,SD_SIZEOF*SDXNUM
		STRUCT	TVR_ScaleDataY,SD_SIZEOF

		STRUCT	TVR_PixelizeDataX,PD_SIZEOF
		STRUCT	TVR_PixelizeDataY,PD_SIZEOF
		
		STRUCT	TVR_Wipe1DataX,W1D_SIZEOF*WDXNUM
		STRUCT	TVR_Wipe1DataY,W1D_SIZEOF

		STRUCT	TVR_ToasterELH1,TELH1_SIZEOF
		STRUCT	TVR_ToasterELH2,TELH2_SIZEOF
		STRUCT	TVR_ToasterELH3,TELH3_SIZEOF

* used by 4.0 ANIM/ILBM Effects
		STRUCT	TVR_Fader,FDRD_SIZEOF
		STRUCT	TVR_LumKey,LKAD_SIZEOF
		STRUCT	TVR_TBarTime,TBTD_SIZEOF
		STRUCT	TVR_BMposition,BMPD_SIZEOF

	LABEL	TVR_SIZEOF

***************************************************
* This used to be the embedded near the start of EFXBASE!

	STRUCTURE	TheTimeVariables,0
		LABEL	TTV_TimeVarsScale
		STRUCT	TTV_TimeVarsScaleX,(NUMTV_SCALE*12+4)*SDXNUM
		STRUCT	TTV_TimeVarsScaleY,NUMTV_SCALE*12
		STRUCT	TTV_TVSEND,4		

		LABEL	TTV_TimeVarsPixelize
		STRUCT	TTV_TimeVarsPixelizeX,NUMTV_PIXELIZE*12
		STRUCT	TTV_TVPXEND,4		
		STRUCT	TTV_TimeVarsPixelizeY,NUMTV_PIXELIZE*12
		STRUCT	TTV_TVPYEND,4		

		LABEL	TTV_TimeVarsWipe1
		STRUCT	TTV_TimeVarsWipe1X,(NUMTV_WIPE1*12+4)*WDXNUM
		STRUCT	TTV_TimeVarsWipe1Y,NUMTV_WIPE1*12
		STRUCT	TTV_TVWEND,4		
		
		STRUCT	TTV_TimeVarsTELH1,NUMTV_TELH1*12
		STRUCT	TTV_TVTELH1END,4		

		STRUCT	TTV_TimeVarsTELH2,NUMTV_TELH2*12
		STRUCT	TTV_TVTELH2END,4		

		STRUCT	TTV_TimeVarsTELH3,NUMTV_TELH3*12
		STRUCT	TTV_TVTELH3END,4		

* used by 4.0 ANIM/ILBM Effects
		STRUCT	TTV_TimeVarsFader,NUMTV_Fader*12
		STRUCT	TTV_FaderEND,4		

		STRUCT	TTV_TimeVarsLumKey,NUMTV_LumKey*12
		STRUCT	TTV_LumKeyEND,4		

		STRUCT	TTV_TimeVarsTBarTime,NUMTV_TBarTime*12
		STRUCT	TTV_TBarTimeEND,4		

		STRUCT	TTV_TimeVarsBMposition,NUMTV_BMposition*12
		STRUCT	TTV_BMpositionEND,4		

	LABEL	TTV_SIZEOF

***************************************************
* The ET_ constants that are found in the Crouton Data are used as
* offsets into the EffectsTable LUT.
ET_RUN		EQU	0	;end of data, for now
ET_DVE1X1	EQU	1
ET_DVE1X2	EQU	2
ET_DVE1X3	EQU	3
ET_DVE1X4	EQU	4
ET_DVE1X5	EQU	5
ET_DVE1X6	EQU	6
ET_DVE1X7	EQU	7
ET_DVE1X8	EQU	8
ET_DVE1X9	EQU	9
ET_DVE1Y	EQU	10
ET_PixelizeX	EQU	11
ET_PixelizeY	EQU	12
ET_Wipe1X1	EQU	13
ET_Wipe1X2	EQU	14
ET_Wipe1X3	EQU	15
ET_Wipe1X4	EQU	16
ET_Wipe1X5	EQU	17
ET_Wipe1X6	EQU	18
ET_Wipe1X7	EQU	19
ET_Wipe1X8	EQU	20
ET_Wipe1X9	EQU	21
ET_Wipe1Y	EQU	22
ET_TELH1	EQU	23
ET_TELH2	EQU	24
ET_TELH3	EQU	25

* used by 4.0 ANIM/ILBM Effects
ET_Fader	EQU	26
ET_LumKey	EQU	27
ET_TBarTime	EQU	28
ET_BMposition	EQU	29

*-----------------------------
* Time Variable types 
TVT_END		EQU	0
TVT_IGNORE	EQU	1
TVT_CONST	EQU	2
TVT_LINEAR	EQU	3
TVT_ACCEL	EQU	4
TVT_HARMON	EQU	5
TVT_DELAYLIN	EQU	6	;linear constrained between time limits
TVT_EVENTS	EQU	7	;list of time/positions
TVT_SEGMENTS	EQU	8	;list of Delayed linear line segments = linear interp. between events

* These simple equations only 1 or just a few parameters!!!
TVT_DELTALINEAR	    EQU	9	;from 0, linearly changes to result "x"
TVT_DELTAACCEL	    EQU	10	;from 0, accelerates to result "x"
TVT_DELTADEACCEL    EQU	11	;from 0, deaccelerates to result "x"
TVT_DELTASCURVE	    EQU	12	;from 0, harmonically accelerates then deaccelerates to result "x"
TVT_DELTABIGACCEL   EQU	13	;from 0, lots of acceleration to result "x"
TVT_DELTABIGDEACCEL EQU	14	;from 0, lots of deacceleration to result "x"
TVT_DELTARANDOM	    EQU	15	;from 0, random value between 0 and "x", inclusive
TVT_DELTACYCLIC	    EQU 16	;from 0, cycle harmonically for "n" number of cycles
TVT_DELTACONST	    EQU 17	;a sined long fraction constant
TVT_MULTIDELTA	    EQU 18	;from initial x, does various motion types sequentially.
TVT_MULTISUM	    EQU 19	;adds various motion types together
TVT_MULTISEGMENT    EQU 20	;easy list of points vs time

* Future motion routines
;;TVT_RANDOM	 EQU		;small period (adjustable?) random range (for block dissolves????)
;;TVT_SPLINE		;yea right!!  Maybe I could use the 3 point curve equation
;;A way of adding the results from a group of equations??? Watch out for Roundoff!

	ENDC	;EFXLIB_I
