
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

FILE *infile, *outfile, *infile2, *input_file;

/* Special Note AnimFX offset is 0x260 */
/* Other Offset is 0x198 */

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: WIPEC 1.0 ";

int thirtycount = 0;
char thirty[30];
int ones = 0;
int twos = 0;
int threes = 0;

main(int argc, char **argv)
{
char c, destination[100], inpath[150], outpath[150];
unsigned char c1, c2, c3, c4;
int i = 0, j = 0,k, VidQual;
ULONG l,m;
char buff5[256];
char *tokenpt;

if ((argc!=2)||(argv[1][0]=='?')) 
   {
   printf("WIPEC version 1.0\n");
   printf("Copyright Bill Evans 1998 \n");
   printf("Usage: %ls <Filename> \n",argv[0]);
   return(20);
   }

input_file = fopen(argv[1],"r");
if (input_file == NULL)
   {
   printf("%s :No such file found\n",argv[1]); 
   return(20);
   }

fgets(buff5,255,input_file);
tokenpt = strtok(buff5,",");
strncpy(outpath,tokenpt,149);

fgets(buff5,255,input_file);
tokenpt = strtok(buff5,",");
strncpy(inpath,tokenpt,149);

fclose(input_file);

infile = fopen(inpath,"rb");
if (infile == 0)
   {
   printf("Error: File %s not found\n",inpath);
   exit(1);
   }
fclose(infile);

infile = fopen(inpath,"rb");
infile2 = fopen("prowave:exit.3","rb");
outfile = fopen(outpath,"wb");

for (i=0;i<0x814;i++)
   {
   c = fgetc(infile2);
   fprintf(outfile,"%c",c);
   }

for (i=0;i<4;i++)
   {
   c = fgetc(infile);
   fprintf(outfile,"%c",c);
   }

c1 = fgetc(infile);
c2 = fgetc(infile);
c3 = fgetc(infile);
c4 = fgetc(infile);

fprintf(outfile,"%c",c1);
fprintf(outfile,"%c",c2);
fprintf(outfile,"%c",c3);
fprintf(outfile,"%c",c4);

m = c1*16777216+c2*65536;

m = m + c3*256+c4;

for (l=0;l<m-8;l++)
   {
   c = fgetc(infile);
   fprintf(outfile,"%c",c);
   }

fclose(infile);
fclose(infile2);
fclose(outfile);
}


