/**************************************************************************
**
**                               error message lib
**
**
**
**
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "rfx_common.h"
#include "err_lib.h"


/*- global variables -*/
char   err_msg_buf[1025];
int    err_msg_buf_size = 1024;
int    err_display_level  = DEBUG_MSG;



/****************************************************************************
**
** void  log_message( int level, char *message)
**
** DESC:
**  logs a message to stdout if it at or above a threshold level
**
**
** INPUTS:
**
** OUTPUTS:
**
** RETURNS:
**
** ERRORS:
**
** GLOBALS:
**
**
** CALLS:
**
** NOTES:
**
**
** HISTORY:
**
**     DATE         By     Revision     Note
**
**
****************************************************************************/
void  log_message( int level, char *message)
{

    if (level >= err_display_level)
    {
        printf("%s\n", message);
    }

}








/*--- Spare Template ---*/


/****************************************************************************
**
**
** DESC:
**
**
** INPUTS:
**
** OUTPUTS:
**
** RETURNS:
**
** ERRORS:
**
** GLOBALS:
**
**
** CALLS:
**
** NOTES:
**
**
** HISTORY:
**
**     DATE         By     Revision     Note
**
**
****************************************************************************/



