/* This is the Mixer Script */
/* 9/29/96 */
/* 2/13/96 Added Support for Updated MixAudio 1.01 */

call remlib('PROJECT_REXX_PORT')
call addlib('PROJECT_REXX_PORT',0)

if exists("ENV:OZ-PanicStop") then address command "delete ENV:OZ-PanicStop QUIET"

OPEN(myfile,"ram:Prowave.txt",'Write')     

mycount. = 0

rx startfilereq("Output File Name")
exit=1
do while exit=1
   filename1=queryfilereq()
   if filename1=0 then 
      call quit
    else NOOP
      if filename1~="" then exit=0
      else NOOP
      address command "c:wait 1"
      end

fpatht=filename1
patht=''
filenamet=''
lenfpt=length(fpatht)
if lenfpt>1 then do
   lastpt=lastpos('/',fpatht,lenfpt)
   if (lastpt~=0) then do
      if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
      patht=left(fpatht,lastpt-1)
      end
   else if lastpt=0 then do
      lastpt=lastpos(':',fpatht,lenfpt)
      if (lastpt~=0) then do
         if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
         patht=left(fpatht,lastpt)
         end
      end
   if patht~='' then do
      call pragma('D',patht)
      patht=pragma('D','RAM:')
      end

call req_close()

if (patht='') then do
   call req_tell('MixAudio cancelled','    You need to select a drive/folder','       from bottom of Flyer window')
   call quit()
   end

if (filenamet='') then do
   call req_tell('MixAudio cancelled','   You need to type in a filename')
   call quit()
   end

if (right(patht,1)~="/") & (right(patht,1)~=":") then
   patht=patht||"/"

filename1=patht||filenamet

if exists(filename1) then do
   test=req_tell('That file already exists','  Select Continue to overwrite file')
   if test=0 then call quit()
   address command 'delete 'filename1' QUIET'
   if exists(filename1||'.i') then address command 'delete 'filename1'.i QUIET'
   end

WRITELN(myfile,filename1||",");

count = croutonsinproject()

SAY count

testing = 0

next = 1
selected = 0
do while next < count+1
   row = trunc(next/8)
   col = next - (row*8)
   row = row + 1
   selected = selected + croutonselected(row,col)
   if croutonselected(row,col) = 1 then do
      mycount.testing = next-1
      testing = testing + 1
   end
   SAY row||" "||col||" "||selected
   next = next + 1
end

SAY "This is Selected "||selected

if selected > 1 then do 
   WRITELN(myfile,selected);
   SAY "We are lost "
   next = 0
   do while next < selected
     call croutonpick(mycount.next)
     WRITELN(myfile,croutonname()||","||croutongettag(AudioStart)/2||","||croutongettag(AudioDuration)/2||","||croutontime()/2||","||croutongettag(AUDIOON)||","||croutongettag(AUDIOVOLUME1)||","||croutongettag(AUDIOVOLUME2)||","||croutongettag(AudioPan1)||","||croutongettag(AudioPan2)||","||croutongettag(AudioAttack)||","||croutongettag(AudioDecay));
   next = next + 1
   end
end

Say "This is count "||count

next = 0
if selected < 2 then do
   WRITELN(myfile,count);
   do while next < count
      call croutonpick(next)
      SAY "This is next "||next
      WRITELN(myfile,croutonname()||","||croutongettag(AudioStart)/2||","||croutongettag(AudioDuration)/2||","||croutontime()/2||","||croutongettag(AUDIOON)||","||croutongettag(AUDIOVOLUME1)||","||croutongettag(AUDIOVOLUME2)||","||croutongettag(AudioPan1)||","||croutongettag(AudioPan2)||","||croutongettag(AudioAttack)||","||croutongettag(AudioDecay));
      next = next + 1              
   end
end

CLOSE(myfile)

call req_open("Mixing Audio... Please Wait.", "Left-Amiga Delete to abort Operation")

address command  "prowave:mixaudio >CON: ram:prowave.txt"

call req_close()

call remlib('PROJECT_REXX_PORT')

