
#include <exec/types.h>
#include <exec/memory.h>
#include <libraries/dos.h>
#include <libraries/iffparse.h>

#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/iffparse_protos.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef LATTICE
int CXBRK(void) { return(0); }  /* Disable Lattice CTRL/C handling */
int chkabort(void) { return(0); }  /* really */
#endif

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: StealAudio 1.6";

UBYTE usage[] = "Usage: StealAudio Effect Audiofile";

/* proto for our function */
void PrintTopChunk (struct IFFHandle *);

int getdata(char *ptr, int nbytes, FILE *IN);
void error(char *msg, int code);

void main(int argc, char **argv)
{
FILE *Infile;
BPTR Outfile;
UWORD temp;
UWORD notthere;
ULONG temp2, temp3;
ULONG i;
char temp4;
ULONG test = 0x464F524D;

Infile = fopen (argv[1], "rb");
if (!Infile)
   {
   puts ("Input File open failed.");
   exit(5);
   }

Outfile = Open(argv[2], MODE_NEWFILE);
if (!Outfile)
   {
   puts("Output File open failed.");
   exit(5);
   }

/* 46 4F 52 4D */

getdata((char *)&temp,2,Infile);
notthere = 0;

while (notthere == 0)
   {
   while (temp != 0x464F)
      getdata((char *)&temp,2,Infile);
   getdata((char *)&temp,2,Infile);
   getdata((char *)&temp2,4,Infile);
   getdata((char *)&temp3,4,Infile);
   if (temp3 == 0x38535658)
      {
      notthere = 1;
      }
   }

if (notthere == 1)
   {
   Write(Outfile,(char *)&test,4);
   Write(Outfile,(char *)&temp2,4);
   Write(Outfile,(char *)&temp3,4);
   for (i=0;i<temp2;i++)
      {
      getdata((char *)&temp4,1,Infile);
      Write(Outfile,(char *)&temp4,1);
      }
   }

fclose (Infile);

Close (Outfile);

exit (0);
}

int getdata(char *ptr, int nbytes, FILE *IN)
{
int count;

for (count = 0; count < nbytes; count++) 
   {
   *(ptr+count) = getc(IN);
   if (ferror(IN))
      error("error reading from file",0);
   }

return(0);
}

void error(char *msg, int code)
{
printf("\nError code %4i \n",code);
printf("%s",msg);
exit(code);
}
