/* This is the OverlayFX script */
/* by bill evans, with a touch from Aussie */

OPTIONS RESULTS
TOASTERLIB="ToasterARexx.port"

call remlib('PROJECT_REXX_PORT')
call addlib('PROJECT_REXX_PORT',0)

IF POS(TOASTERLIB , SHOW('Libraries')) = 0 THEN
  IF ~ADDLIB(TOASTERLIB , 0) THEN x=Bummer(" Please start your Toaster.")

if exists("ENV:OZ-PanicStop") then address command "delete ENV:OZ-PanicStop QUIET"

project_end=croutonsinproject()-1
if project_end<1 then call quithelp()
call croutonpick(0)
if croutontype()~='CLIP' then call quithelp()
/*
call croutonpick(1)
name=upper(croutonname())
test=index(name,'/OVERLAYS/')
if test=0 then call quithelp()
*/

call set_view(2)
call req_open('OverlayFX by Prowave')
rx startfilereq("Select OUTPUT video Drive below, then type Output Name",'FA0:')

exit=1
do while exit=1
   filename1=queryfilereq()
   if filename1=0 then call quit()
    else NOOP
   if filename1~="" then exit=0
    else NOOP
   address command "c:wait 1"
   end
call req_error(' OverlayFX running')

/*
position1 = lastpos(':',filename1)
position2 = lastpos(':',filename1,position1-1)

if position2 ~= 0 then do
   filename1 = right(filename1,length(filename1)-position2)
end
*/

fpatht=filename1
patht=''
filenamet=''
lenfpt=length(fpatht)
if lenfpt>1 then do
   lastpt=lastpos('/',fpatht,lenfpt)
   if (lastpt~=0) then do
      if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
      patht=left(fpatht,lastpt-1)
      end
   else if lastpt=0 then do
      lastpt=lastpos(':',fpatht,lenfpt)
      if (lastpt~=0) then do
         if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
         patht=left(fpatht,lastpt)
         end
      end
   if patht~='' then do
      call pragma('D',patht)
      patht=pragma('D','RAM:')
      end
call req_close()

if (patht='') then do
   call req_tell('OverlayFX cancelled','    You need to select a drive/folder','       from bottom of Flyer window')
   call quit()
   end

if (filenamet='') then do
   call req_tell('OverlayFX cancelled','   You need to type in a filename')
   call quit()
   end

if (right(patht,1)~="/") & (right(patht,1)~=":") then
   patht=patht||"/"

filename1=patht||filenamet

if exists(filename1) then do
   test=req_tell('That file already exists','  Select Continue to overwrite file')
   if test=0 then call quit()
   address command 'delete 'filename1' QUIET'
   if exists(filename1||'.i') then address command 'delete 'filename1'.i QUIET'
   end


call croutonpick(1)

fields = croutongettag(numfields)/2
duration = croutongettag(Duration)/2



/* This is the new line of code */

if croutongettag(LoopAnims) = 0 then do
   duration = fields
end

delay = croutongettag(Delay)/2
  
OPEN(myfile,"ram:OverlayFX.txt",'Write')     
croutonpick(0)
WRITELN(myfile,filename1||",3");
WRITELN(myfile,croutonname()||",1,"||croutongettag(ClipStartField)/2+delay||","||duration||",0,"||fields);
CLOSE(myfile)
croutonpick(1)
address command "prowave:markfx "||croutonname() 
address command "prowave:OverlayFX ram:OverlayFX.txt"  
call PanicStop()
call req_open('Creating icon')

call MAKEICON(filename1,duration) 
call req_close()
call set_view(4)
call set_view(2)
call req_error(' OverlayFX all done')
call remlib('PROJECT_REXX_PORT')
exit

quit:
call req_close()
call req_error(' OverlayFX cancelled')
call remlib('PROJECT_REXX_PORT')
exit


PanicStop:
if exists("ENV:OZ-PanicStop") then do
   address command "delete ENV:OZ-PanicStop QUIET"
   call req_tell('Abort Key Detected','   OverlayFX has been canceled')
   call set_view(4)
   call set_view(2)
   call quit()
   end
return

quithelp:
call req_close()
call req_open('OverlayFX','To use: Place a video clip and an Overlay effect at the START of',' the project screen. Set their timing.  Then run OverlayFX ')
call req_tell('OverlayFX cancelled')
call quit()
return
