#ifndef NEWTEK_SWAP_H
#define NEWTEK_SWAP_H
/*
 * $Id: swap.h 5.3 1995/08/02 17:00:06 pfrench Exp $
 *
 * $Source: n:/rcs/include/newtek/swap.h $
 *
 * $Log: swap.h $
 * Revision 5.3  1995/08/02 17:00:06  pfrench
 * Moved directories around.
 * Revision 5.2  1995/04/02 20:42:04  pfrench
 * Cleaned up swap stuff, now that I've got structure packing working
 * correctly.  Much simpler operations now.
 * Revision 5.1  1995/04/02 18:15:00  pfrench
 * Convert word in-place macro a little wierd
 * Revision 5.0  1995/04/02 03:16:44  pfrench
 * Initial revision
 */

#ifndef PROOF_LIB_H
#include <proof/proof_lib.h>
#endif

ULONG swap_long( ULONG x );
void swap_longa( ULONG *x );
UWORD swap_word( UWORD x );
void swap_worda( UWORD *x );

/* INTEGER FORMAT CONVERSION MACROS (ICK HACK POOP)            */
/* *********************************************************** */
/* Direct Conversion */
#define TO_LONG(x)		swap_long(x)
#define TO_WORD(x)		swap_word(x)
#define TO_LONGA(px)	swap_long(*(px))
#define TO_WORDA(px)	swap_word(*(px))

/* Convert in-place */
#define CONV_LONG(x)	x = TO_LONG(x)
#define CONV_WORD(x)	x = TO_WORD(x)
#define CONV_LONGA(px)	swap_longa(px)
#define CONV_WORDA(px)	swap_worda(px)

#endif /* NEWTEK_SWAP_H */
