#ifndef PROOF_MSGPORT_H
#define PROOF_MSGPORT_H
/*
 * $Id: msgport.h 5.4 1995/10/10 17:33:58 pfrench Exp $
 *
 * $Source: n:/rcs/include/proof/msgport.h $
 *
 * $Log: msgport.h $
 * Revision 5.4  1995/10/10 17:33:58  pfrench
 * Removed mutex, will use proof_Forbid()/proof_Permit()
 * Revision 5.3  1995/10/10 16:50:54  pfrench
 * Moved msgport functions to proof
 * Revision 5.2  1995/04/02 20:19:38  pfrench
 * Added doio function, it is dangerous to call
 * Revision 5.1  1995/03/31 00:23:20  pfrench
 * Just added prototypes for link usage.
 * Revision 5.0  1995/03/30 18:54:38  pfrench
 * Initial revision
 */

#ifndef PROOF_LIB_H
#include "proof_lib.h"
#endif

struct MessagePort
{
	struct Node			 mp_Node;		/* Node is long aligned under NT */
	APTR				 mp_event;		/* Event to set on PutMsg */
	struct List			 mp_MsgList;	/* Messages coming in */
};

struct Message
{
	struct Node			 mn_Node;
	struct MessagePort	*mn_ReplyPort;	/* Port to send message back to */
	unsigned long		 mn_Length;		/* Total Message Length, in bytes */
};

#endif /* PROOF_MSGPORT_H */
