#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;

struct FlyerVolume	FlyVol, FlyVol2;
struct ClipAction	Action, Action2;

UBYTE Buffer[SAMPLESPERLINE];

main(int argc,char **argv)
{
int	board=0,i,line,modes,fieldnum;

ULONG	field,res,err;
UBYTE	*buff,qualmode;

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0)
   {
   printf("Open flyer.library failed\n");
   return;
   }

for (i=0;i<768;i++)
   {
   Buffer[i] = 71;
   }

field = 0;

FlyVol.Board = board;
FlyVol.Flags = 0;
FlyVol.Path = argv[1];			// Volume & name of clip

Action.Volume = &FlyVol;		// Link structures together

modes = FWF_NEW;

FlyVol2.Board = board;
FlyVol2.Path = argv[2];
FlyVol2.Flags = 0;			// We'll specify volume in name, not drive number

fieldnum = 0;

Action2.Volume = &FlyVol2;

qualmode = 0;		// Best mode

Action2.ReturnTime = RT_STOPPED;
Action.ReturnTime = RT_STOPPED;

for (field=0;field<4;field++)
   {
//   res = OpenReadField(&Action,field,0);  // Open field in clip for reading
   res = EasyOpenWriteField(&Action2,0,modes | FWF_APPEND,qualmode);
      if (res)
	 {
	 printf("\nError %ld - %ls\n",res,Error2String(res));
	 break;
	 }
   modes = 0;

   for (line=21;line<=260;line++)
      {
      Action.ReturnTime = RT_STOPPED;
      Action2.ReturnTime = RT_STOPPED;

      printf("Lets Read ");
//      res = FlyerReadLine(&Action,Buffer);			// Read D2 data into my buffer
//      if (res)
//	 {
//	 printf("\nError %ld - %ls\n",res,Error2String(res));
//	 break;
//	 }
      printf("Lets Read ");

      buff = Buffer;

      res = FlyerWriteLine(&Action2,buff);
      if (res)
	 {
	 printf("\nError %ld - %ls\n",res,Error2String(res));
	 break;
	 }
      printf ("This is field %d and line %d \n",field,line);
      
      }
   Action.ReturnTime = RT_STOPPED;
//   err = CloseField(&Action);									// Close field, done now
//   if (err)
//      printf("\nClose Error %ld - %ls\n",err,Error2String(err));
   Action2.ReturnTime = RT_STOPPED;
   err = CloseField(&Action2);
   if (err)
      printf("\nClose Error %ld - %ls\n",err,Error2String(err));
   }

Delay(5);
CloseLibrary(FlyerBase);

return(0);
}

