
/* arexx.h */

#ifndef AREXX_H_INCLUDED
#define AREXX_H_INCLUDED

#include<exec/types.h>
#include<exec/memory.h>
#include<exec/nodes.h>
#include<exec/libraries.h>
#include<exec/ports.h>


/* note:  INCLUDES_2 should be DEFINEd by users who wish to use
 * Commodore's official header files for 2.0
 */

#if defined( INCLUDES_2 ) /* Use 2.0 includes */
   #include <clib/exec_protos.h>
   #include <clib/dos_protos.h>

   extern struct MsgPort *CreatePort (UBYTE *name, ULONG pri);

   /* here you have to insert the pragma files you've built for
    * for your compiler from Commodor's 2.0 .fd files
    */

#elif defined( LATTICE ) || defined ( __SASC)   /* SAS/C */

   #include <proto/exec.h>
   #include <proto/dos.h>
#endif

#ifndef NULLCHAR
#define NULLCHAR  '\0'
#endif

#endif  /* AREXX_H_INCLUDED */

