 
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

struct Library *DosBase;

struct Library *FlyerBase;

FILE *bill;

WORD testbuff[256];

BPTR handle;

struct mystuff
   {
   char name[32];
   unsigned long start;
   unsigned long length;
   };

struct mystuff __far goodfiles[500];

struct mystuff __far erasedfiles[500];

unsigned long calldog(unsigned long, char *fileit);

void printall(UWORD, UWORD);

void sortgood(UWORD);

void sorterased(UWORD,UWORD);

void fixroot(UWORD);

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: Undelete 0.80";

ULONG  OUTFILE3;  
struct FlyerVolume FlyVol1, FlyVol2, FlyVol3;
UWORD BlkBuff[256];
UWORD ROOTBuf[256];

main(int argc,char **argv)
{
ULONG	res;
UWORD i,j, k, l, m,temp;
unsigned long cooldouble, cooldouble2;

if ((argc != 3) || (argv[1][0] == '?'))
   {
   printf("FlyerUndelete Version 0.60 \n");
   printf("Copyright Prowave 1997\n");
   printf("Incorrect arguements \n");
   printf("%s volume testvolume\n",argv[0]);
   exit(0);
   }

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   exit(0);
   }

FlyVol1.Board = 0;
FlyVol1.Flags = 0;
FlyVol1.Path = argv[2];

res = MakeFlyerFile(&FlyVol1,2,&OUTFILE3);

FlyVol2.Board = 0;
FlyVol2.Flags = 0;
FlyVol2.Path = argv[1];

res = CopyData(&FlyVol2,&FlyVol1,0,1,OUTFILE3+1);

handle = Open(argv[2],MODE_OLDFILE);

if (!handle) 
   {
   printf("Did not write clip successfully\n");
   goto ending;
   }

Read(handle,BlkBuff,512);

Read(handle,ROOTBuf,512);

Close(handle);

temp = ROOTBuf[31];

j = 0;

k = 0;

m = 0;

printf("This is temp %d \n",temp);

for (i=1;i<temp;i++)
   {
   printf("This is i %d \n",i);
   res = CopyData(&FlyVol2,&FlyVol1,i,1,OUTFILE3);

   handle = Open(argv[2],MODE_OLDFILE);
   if (!handle) 
      {
      printf("Did not write clip successfully\n");
      goto ending;
      }
   
   Read(handle,BlkBuff,512);

   Close(handle);

   if ((BlkBuff[0] == 0x4649) && (BlkBuff[1] == 0x4C45))
      {
      l = 6;
      while ((BlkBuff[l] != 0) && (l<38))
         {      
         goodfiles[j].name[(l-6)*2] = BlkBuff[l]>>8;
         goodfiles[j].name[(l-6)*2+1] = BlkBuff[l]&0x00FF;
         l++;
         }

      cooldouble = BlkBuff[51];
      cooldouble2 = BlkBuff[52];
      cooldouble = cooldouble & 0x0000FFFF;
      cooldouble2 = cooldouble2 & 0x0000FFFF;
      cooldouble = (cooldouble*65536) + cooldouble2;

      cooldouble2 = calldog(cooldouble,argv[2]);

      goodfiles[j].start = cooldouble;
      goodfiles[j].length = cooldouble2;

      k = 0;
      j++;
      }

   if ((BlkBuff[0] == 0x4649) && (BlkBuff[1] == 0x4C45))
      {
      l = 6;
      while ((BlkBuff[l] != 0) && (l<38))
         {      
         goodfiles[j].name[(l-6)*2] = BlkBuff[l]>>8;
         goodfiles[j].name[(l-6)*2+1] = BlkBuff[l]&0x00FF;
         l++;
         }

      cooldouble = BlkBuff[51];
      cooldouble2 = BlkBuff[52];
      cooldouble = cooldouble & 0x0000FFFF;
      cooldouble2 = cooldouble2 & 0x0000FFFF;
      cooldouble = (cooldouble*65536) + cooldouble2;

      cooldouble2 = calldog(cooldouble,argv[2]);

      goodfiles[j].start = cooldouble;
      goodfiles[j].length = cooldouble2;

      k = 0;
      j++;
      }

   if ((BlkBuff[0] == 0) && (BlkBuff[1] == 0))
      {
      if ((BlkBuff[6] == 0) && (BlkBuff[7] == 0))
         k++;
      else
         {
         /* Its a File */
         if (BlkBuff[38] == 1)
            {
            k = 0;
            l = 6;
            while ((BlkBuff[l] != 0) && (l<38))
               {      
               erasedfiles[m].name[(l-6)*2] = BlkBuff[l]>>8;
               erasedfiles[m].name[(l-6)*2+1] = BlkBuff[l]&0x00FF;
               l++;
               }
            m++;
            }
         else 
            /* Its a directory */
            if (BlkBuff[38] == 2)
            {
            k = 0;
            l = 6;
            while ((BlkBuff[l] != 0) && (l<38))
               {      
               erasedfiles[m].name[(l-6)*2] = BlkBuff[l]>>8;
               erasedfiles[m].name[(l-6)*2+1] = BlkBuff[l]&0x00FF;
               l++;
               }
            printf("Restored Directory: %x %s\n",i,erasedfiles[m].name);
            BlkBuff[0] = 0x4644;
            BlkBuff[1] = 0x4952;

            fixroot(i);

            handle = Open(argv[2],MODE_OLDFILE);
            if (!handle) 
               {
               printf("Did not write clip successfully\n");
               goto ending;
               }

            Write(handle,BlkBuff,512);

            Write(handle,ROOTBuf,512);

            Close(handle);

            res = CopyData(&FlyVol1,&FlyVol2,OUTFILE3,1,i);
                      
            m++;
            }

         }
      }

   }


ending:

printall(j,m);

res = CopyData(&FlyVol1,&FlyVol2,OUTFILE3+1,1,0);

CloseLibrary(FlyerBase);

return(0);
}


void fixroot(UWORD addon)
{
UWORD i;

for (i=54;i<256;i+=2)
   {
   if ((ROOTBuf[i] == 0) && (ROOTBuf[i+1] == 0x0152))
      {
//      ROOTBuf[i+4] = 0;
//      ROOTBuf[i+5] = addon;
      ROOTBuf[i] = 0;
      ROOTBuf[i+1] = addon;
      i = 256;
      }
   }
}

unsigned long calldog(unsigned long auburn,char *fileit)
{
ULONG	res;
unsigned long cool1, cool2, returnval;

res = CopyData(&FlyVol2,&FlyVol1,auburn,1,OUTFILE3);
handle = Open(fileit,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   }
   
Read(handle,BlkBuff,512);

Close(handle);

returnval = 0;

if ((BlkBuff[0] == 0x434C) && (BlkBuff[1] == 0x4950))
   {
   cool1 = BlkBuff[2];
   cool1 = cool1 & 0x0000FFFF;
   cool2 = BlkBuff[3];
   cool2 = cool2 & 0x0000FFFF;
   returnval = cool1*65536+cool2;
   }

return(returnval);
}

void printall(UWORD j,UWORD m)
{
UWORD i, temp;
ULONG res;
char myfile[100];
char myfile2[100];

printf("This is the good files \n");

sortgood(j);

for (i=0;i<j;i++)
   {
   printf("%d %s %ld %ld \n",i,goodfiles[i].name,goodfiles[i].start,goodfiles[i].length); 
   }

printf("This is the deleted files \n");

sorterased(j,m);

FlyVol3.Board = 0;
FlyVol3.Flags = 0;

printf("This is the value of m %d\n",m);

for (i=0;i<m;i++)
   {
   if (erasedfiles[i].length != 0)
      {
      printf("%d *** %s %lx %lx \n",i,erasedfiles[i].name,erasedfiles[i].start,erasedfiles[i].length); 
      strcpy(myfile,FlyVol2.Path); 
      strcat(myfile,erasedfiles[i].name);
      sprintf(myfile2,".%d",i);
      strcat(myfile,myfile2);
      FlyVol3.Path = myfile;
      res = MakeFlyerFile(&FlyVol3,erasedfiles[i].length,&OUTFILE3);
      if (OUTFILE3 == erasedfiles[i].start)
         {
         printf("We have restored the file \n");
         } 
      else
         {
         printf("Didn't Work %lx %lx \n",OUTFILE3, erasedfiles[i].start);
         }
      }
   }
}

void sortgood(UWORD count)
{
UWORD i,j,k;

ULONG one, two;

char bill[100];

for (i=0;i<count-1;i++)
   {
   for (j=0;j<count-1;j++)
      {
      if (goodfiles[j].start > goodfiles[j+1].start)
         {
         one = goodfiles[j].start;
         two = goodfiles[j].length;
         for (k=0;k<100;k++)
            bill[k] = goodfiles[j].name[k];
         goodfiles[j].start = goodfiles[j+1].start;
         goodfiles[j].length = goodfiles[j+1].length;
         for (k=0;k<100;k++)
            goodfiles[j].name[k] = goodfiles[j+1].name[k];
         goodfiles[j+1].start = one;
         goodfiles[j+1].length = two;
         for (k=0;k<100;k++)
            goodfiles[j+1].name[k] = bill[k];
         }
      }   
   }
}

void sorterased(UWORD count1, UWORD count2)
{
UWORD i,j,k;
ULONG one, two;
char bill[100];

for (i=0;i<count2;i++)
   printf("%d %s %lx %lx \n",i,erasedfiles[i].name,erasedfiles[i].start,erasedfiles[i].length); 

for (i=0;i<count2-1;i++)
   {
   for (j=0;j<count2-1;j++)
      {
      if (erasedfiles[j].start > erasedfiles[j+1].start)
         {
         one = erasedfiles[j].start;
         two = erasedfiles[j].length;
         for (k=0;k<100;k++)
            bill[k] = erasedfiles[j].name[k];
         erasedfiles[j].start = erasedfiles[j+1].start;
         erasedfiles[j].length = erasedfiles[j+1].length;
         for (k=0;k<100;k++)
            erasedfiles[j].name[k] = erasedfiles[j+1].name[k];
         erasedfiles[j+1].start = one;
         erasedfiles[j+1].length = two;
         for (k=0;k<100;k++)
            erasedfiles[j+1].name[k] = bill[k];
         }
      }   
   }

for (i=0;i<count2;i++)
   {
   if (erasedfiles[i].length != 0)
      {
      for (j = 0;j<count1;j++)
         {
         if (erasedfiles[i].start == goodfiles[j].start)
            erasedfiles[i].length = 0;
         }   
      }
   }

}

