***********************************************************************
*
* FlyerProc assembly subroutines
*
* $Id: FlyerProc2.asm,v 1.0 1995/08/31 15:49:12 Flick Exp $
*
* $Log: FlyerProc2.asm,v $
*Revision 1.0  1995/08/31  15:49:12  Flick
*FirstCheckIn
*
*
* Copyright (c) 1995 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	08/24/95		Marty	created
***********************************************************************

	include	"exec/types.i"
	include	"exec/nodes.i"
	include	"libraries/dosextens.i"

	include "asmsupp.i"
	include "macros.i"

	include	"Flyer.i"

	XDEF	_InvertField

	section	text,code

;BORDERCOLOR	EQU	71	;Use black for border pixels


_InvertField	;(a0 = srcfield, a1 = destfield)
	movem.l	d1-d5/a0-a1,-(sp)

	move.w	#TOASTERLINES-1,d5
.dolines
;	move.b	#80,d1	        ;Black on left border
	move.b	1(a0),d1	;Phantom border pixel = 2nd in from left
	move.b	(a0)+,d2	;Preload first pixel to process

	move.w	#SAMPLESPERLINE-1-1,d4		;Do 1 short of a full line
.dopixels
	move.b	(a0)+,d3	;Get 'next' pixel
	add.b	d3,d1		;(d1 = 'prev' pixel)
	sub.b	d2,d1		;New pixel = prev+next-current
	move.b	d1,(a1)+	;Place in output buffer

	move.b	d2,d1		;Shift pixels for next time
	move.b	d3,d2
	dbf	d4,.dopixels	;Do rest of line

;	move.b	#BORDERCOLOR,d3	;Black on right border
	move.b	-2(a0),d3	;Phantom border pixel = 2nd in from right
	add.b	d3,d1
	sub.b	d2,d1		;New pixel = prev+next-current
	move.b	d1,(a1)+	;Place in output buffer (final pixel for line)

	dbf	d5,.dolines	;Do rest of field

	movem.l	(sp)+,d1-d5/a0-a1
	rts

	END

