
/* function prototypes */

/* 1 */
void	main(void);
void	Suicide(struct FSbase *FS);
void	DiskChanges(struct FSbase *FS);
void	ExamineObject_(struct FSbase *FS);
void	ExamineFH_(struct FSbase *FS);
int	ExamineLock(struct FSbase *,BPTR,struct FileInfoBlock *);
void	ExamineNext_(struct FSbase *FS);
int	FillInInfo(struct FSbase *,ULONG,UWORD,struct FileInfoBlock *);
void	LocateObject_(struct FSbase *FS);
BPTR	Locate(struct FSbase *FS,BPTR lock,BSTR,int);
void	FreeLock_(struct FSbase *FS);
void	Parent_(struct FSbase *FS);
void	ParentFH_(struct FSbase *FS);
void	CurrentVolume_(struct FSbase *FS);
void	Timer_(struct FSbase *FS);
void	Flush_(struct FSbase *FS);
void	CopyDir_(struct FSbase *FS);
void	CopyDirFH_(struct FSbase *FS);
void	Info_(struct FSbase *FS);
void	DiskInfo_(struct FSbase *FS);
void	DiskInfoSub(struct FSbase *,BPTR);
void	MoreCache_(struct FSbase *FS);
void	Inhibit_(struct FSbase *FS);
void	ProtLocker_(struct FSbase *FS);
void	RenameDisk_(struct FSbase *FS);
void	SetProtect_(struct FSbase *FS);
void	SetComment_(struct FSbase *FS);
void	SetDate_(struct FSbase *FS);
void	DeleteObject_(struct FSbase *FS);
void	RenameObject_(struct FSbase *FS);
void	CreateDir_(struct FSbase *FS);
void	Truncate_(struct FSbase *FS);
void	IsFileSystem_(struct FSbase *FS);
void	SameLock_(struct FSbase *FS);
void	Format_(struct FSbase *FS);
void	Notify_(struct FSbase *FS);
void	MakeLink_(struct FSbase *FS);
void	Records_(struct FSbase *FS);
void	ChangeMode_(struct FSbase *FS);
void	Open_(struct FSbase *FS);
void	Close_(struct FSbase *FS);
void	Seek_(struct FSbase *FS);
void	RW_(struct FSbase *FS);
void	AbortWithNewError(struct FSbase *,LONG);
void	AbortWithError(struct FSbase *FS);
ULONG	PublicID(struct FSbase *);
int	GetOSversion(void);
void	BSTRtoCSTR(BSTR bname,char *cname);
LONG	Flyer2AmigaErr(int error);
void	ReturnFlyerError(struct FSbase *FS,int error);

/* 2 */
void	BSTR2Terminal(char *);
BPTR	DuplicateLock(struct FSbase *,BPTR);
void	RingMeBack(struct FSbase *,int);
int	GetParent(struct FSbase *,BPTR);
void	ReplyToDOS(struct FSbase *);
void	ReturnArgs(struct FSbase *,LONG,LONG);
void	GetMuchoStuffOnDrive(struct FSbase *);
ULONG	GrabArg(char *startup,char *keyword,ULONG dflt);
char	uppercase(char in);
void	Cleanup(struct FSbase *);
struct  DeviceList	*MakeVolume(char *);
void	DeleteVolume(BPTR);
void	UndoVolume(struct FSbase *FS);
BPTR	*GetDevListPtr(void);
int	GetVolumeInfo(struct FSbase *);
void	SetLogicalInfo(struct FSbase *);
LONG	CompareBSTRs(char *,char *,BYTE);
int	Bytes2Blocks(ULONG);
void	DiskInOut(struct FSbase *FS,int);
void	GetDateStamp(struct FSbase *FS,struct DateStamp *stamp);

/* 3 */
BPTR	RequestLock(struct FSbase *,ULONG,int,ULONG);
int	RemoveLock(struct FSbase *,BPTR);
int	GetLocksInfo(struct FSbase *,BPTR,ULONG *,ULONG *);
ULONG	Lock2Grip(BPTR);
int	MakeRequest(struct FSbase *FS,struct IntuiText *,int rw);
ULONG	DuplicateVolumeError(struct FSbase *FS,struct DeviceList *vol);
ULONG	ReadWriteError(struct FSbase *FS,BYTE);
struct Library *OpenFlyer(struct FSbase *FS);
void	CloseFlyer(struct FSbase *FS);
int	GetDiskState(struct FSbase *FS);
int	CheckName(struct FSbase *FS,char *name);


/* asm */
struct DosPacket *Wait4Packet(struct Process *process,struct MsgPort *msgport);
void __asm Dispatch(register __a0 struct FSbase *FS,
									register __d0 void (*fp)());
void __asm Abort(register __a0 struct FSbase *FS);
void __asm FastCopy(register __a0 APTR from,register __a1 APTR to,
	register __d0 UWORD count);

void kprintf(char *, ... );
