***********************************************************************
*
* Flyer FileSystem - Interfaces AmigaDOS to the Flyer card(s)
*		Module 3 - Misc support functions
*
* $Id: FlyerFS5.asm,v 1.2 95/09/08 10:32:54 Flick Exp $
*
* $Log:	FlyerFS5.asm,v $
*Revision 1.2  95/09/08  10:32:54  Flick
*Removed the dispatch/abort mechanism
*
*Revision 1.1  1995/05/08  10:04:01  Flick
*Changed assembler.i to asmsupp.i
*
*Revision 1.0  1995/05/05  15:49:45  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	02/22/94		Marty	created
***********************************************************************

	include	"exec/types.i"
	include	"exec/nodes.i"
	include	"libraries/dosextens.i"

	include "asmsupp.i"
	include "macros.i"

;	XDEF	_Wait4Packet
;	XDEF	_Dispatch
;	XDEF	_Abort
;	XDEF	_FastCopy

	section	text,code


;_Wait4Packet:	;(Process,MsgPort)
;	move.l	a6,-(sp)
;	move.l	8(sp),a0
;	move.l	(_AbsExecBase).w,a6
;	move.l	pr_PktWait(a0),d0
;	bne.s	.CallFilter
;.TryAgain:
;	movea.l	12(sp),a0		;myMsgPort
;	XSYS	GetMsg			;Check for packet
;	tst.l	d0
;	bne.s	.Exit
;	move.l	#$100,d0		;Wait for packet signal
;	XSYS	Wait
;	bra.s	.TryAgain
;
;.CallFilter:
;	move.l	d0,a0			;Filter Routine address
;	move.l	12(sp),d0		;myMsgPort
;	jsr	(a0)		;Call Filter Routine (will get msg for me)
;.Exit:
;	move.l	(sp)+,a6
;;	movea.l	d0,a0
;;	move.l	LN_NAME(a0),d0
;	rts



;_Dispatch	;(a0=FSbase, d0=function address)
;	movem.l	d1-d7/a1-a6,-(sp)		;save all registers
;	move.l	sp,(a0)				;save SP location
;	move.l	a0,-(sp)			;Save, and provide as arg
;	move.l	d0,a0
;	jsr	(a0)				;execute function
;	move.l	(sp)+,a0
;	bra.s	Finis
;;_Abort		;(a0=FSbase)
;	move.l	(a0),sp				;restore stack ptr
;Finis
;	movem.l	(sp)+,d1-d7/a1-a6		;retrieve all registers
;	moveq.l	#0,d0
;	rts


;_FastCopy	;(a0 = from, a1 = to, d0 = count)
;	bra.s	.into
;.loop
;	move.b	(a0)+,(a1)+
;.into
;	dbf		d0,.loop
;	rts

	END
