/*********************************************************************\
*
* Sync - Display Flyer field counter
*
* $Id: Sync.c,v 1.0 1995/05/05 15:53:23 Flick Exp $
*
* $Log: Sync.c,v $
*Revision 1.0  1995/05/05  15:53:23  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	06/24/94		Marty		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;

main(int argc,char **argv)
{
	ULONG	res,clock;

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = GetFieldClock(&clock);
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else
		printf("Frame/Field Clock = %lx\n",clock);

	CloseLibrary(FlyerBase);

	return(0);
}
