/******************************************************************** 
*
*	CopyA2F -- Copy Amiga file to Flyer file.
*
*	$Id: copya2f.c,v 2.1 1997/03/26 16:39:37 Holt Exp $
*
*	$Log: copya2f.c,v $
*Revision 2.1  1997/03/26  16:39:37  Holt
*not really a very worthwhile tool
*
*Revision 2.0  1997/03/20  22:37:25  Holt
*FirstCheckIn
*
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
*********************************************************************/
#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <dos/datetime.h>
#include <intuition/intuition.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerFS.h"
#include "intfsprivate.h"

#define	FlyerBase	FlyerBase

struct FileInfoBlock fib;
struct DateTime	stamp;
struct DateStamp	now;
BPTR	Handle;
ULONG	*FileHD;
ULONG	*TestBuffer;
//APTR	GPOINTER;
ULONG	GPOINTER;
struct GRIP	*ItsGrip;

int i;

UBYTE Buffer[32];
char	TestPath[]			= "Flyerb0:";
//char	TestFile[]			= "flyerb0:testfolder/DTestFile";
char	TestFile[]			= "flyerb0:testfolder/NewTestFile";

APTR	WRBuffer;

struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;


UBYTE	ReadBuff[64];


void	DoFlyerFileThing(char *FlyerFile,struct ClipAction *Flyer_CA,
					struct FlyerVolume *FlyerVol)
{

	ULONG	res,GPOINTER,fileid;
	struct GRIP	*DFileGrip;

// This is model 3
	FlyerVol->Flags = 0;
	FlyerVol->SCSIdrive = 0;				
	Flyer_CA->Volume = FlyerVol;
	Flyer_CA->ReturnTime = RT_STOPPED;
	Flyer_CA->Grip = 0;

	printf("Test HS file access\n===================\n");

	FlyerVol->Path = FlyerFile;

	printf("Accessing file: %s\n",FlyerVol->Path);

	//Action.Access = FLYER_MODE_INPUT;				//Read from file
	//Action.Access = FLYER_MODE_UPDATE;			//Read/Write file
	Flyer_CA->Access = FLYER_MODE_OUTPUT;			//Newfile/Write file

	res = FlyerFileOpen(Flyer_CA);
	if (res==0) 
	{
		// file is open now so FileID"grip" is initinlised
		GPOINTER = (LONG)Flyer_CA->FileID;
		GPOINTER += 0x2C0000-2;
		printf("GPOINTER %lx \n",GPOINTER);
		DFileGrip = (struct GRIP *)GPOINTER;
		printf("ItsGrip Amiga address: %lx \n",DFileGrip);
		printf("grip magic %lx \n",DFileGrip->g_magic);	
		printf("Start block %lx \n",DFileGrip->g_startblk);	
		printf("Physlen low32 bits %lx \n",DFileGrip->g_physlen);	
		printf("Filelen low32 bits %lx \n",DFileGrip->g_filelen);
		
		fileid = Flyer_CA->FileID;

		res = FlyerFileExtend(FlyerVol,fileid,100);

		if (res)
			printf("File Error %ld\n",res);
		res = FlyerFileClose(FlyerVol,fileid);
		printf("Accessed %ls, grip = %lx\n",FlyerFile,fileid);
		FlyerFreeGrip(FlyerVol,fileid);
	}		
	
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else {
		printf("Okay\n");
	}
}


UBYTE	OpenWriteHSFile(char *FlyerFile,struct ClipAction *Flyer_CA,
					struct FlyerVolume *FlyerVol,ULONG FileSize)
{

	ULONG	res,GPOINTER,fileid;
	struct GRIP	*DFileGrip;

// This is model 3
	FlyerVol->Flags = 0;
	FlyerVol->SCSIdrive = 0;				
	Flyer_CA->Volume = FlyerVol;
	Flyer_CA->ReturnTime = RT_STOPPED;
	Flyer_CA->Grip = 0;

	printf("Test HS file access\n===================\n");

	FlyerVol->Path = FlyerFile;

	printf("Accessing file: %s\n",FlyerVol->Path);

	//Action.Access = FLYER_MODE_INPUT;				//Read from file
	//Action.Access = FLYER_MODE_UPDATE;			//Read/Write file
	Flyer_CA->Access = FLYER_MODE_OUTPUT;			//Newfile/Write file

	res = FlyerFileOpen(Flyer_CA);
	if (res==0) 
	{
		// file is open now so FileID"grip" is initinlised
		GPOINTER = (LONG)Flyer_CA->FileID;
		GPOINTER += 0x2C0000-2;
		printf("GPOINTER %lx \n",GPOINTER);
		DFileGrip = (struct GRIP *)GPOINTER;
		printf("ItsGrip Amiga address: %lx \n",DFileGrip);
		printf("grip magic %lx \n",DFileGrip->g_magic);	
		printf("Start block %lx \n",DFileGrip->g_startblk);	
		printf("Physlen low32 bits %lx \n",DFileGrip->g_physlen);	
		printf("Filelen low32 bits %lx \n",DFileGrip->g_filelen);
		
		fileid = Flyer_CA->FileID;

		res = FlyerFileExtend(FlyerVol,fileid,FileSize);

		if (res)
			printf("File Error %ld\n",res);
		res = FlyerFileClose(FlyerVol,fileid);
		printf("Accessed %ls, grip = %lx\n",FlyerFile,fileid);
		FlyerFreeGrip(FlyerVol,fileid);
	}		
	
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else {
		printf("Okay\n");
	}
}



main(int argc,char **argv)
{
	int	succ,test,drive,i;
	BPTR	lock,AFromFile;
	ULONG	grip,fileid,actual,res;
	char	DateBuff[20],TimeBuff[20];
	LONG	oldpos,act2,Amt;



	WRBuffer = AllocMem(512*96,MEMF_PUBLIC);	
	if (!(WRBuffer))
	{
		printf("Could not allocate amiga buffer\n");
		return(0);
	}

	if ((argc<2)||(argv[1][0]=='?')) {
		printf("Usage: %ls <AmigaFile> <Flyerfile> \n",argv[0]);
		return(20);
	}

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	//OpenWriteHSFile(&TestFile,&Action,&FlyVol,0xA00000);

	//DoFlyerFileThing(&TestFile,&Action,&FlyVol);



	if(AFromFile = Open(argv[1],MODE_OLDFILE))
	{
		oldpos = Seek(AFromFile,0,OFFSET_END);
		oldpos = Seek(AFromFile,0,OFFSET_BEGINNING);

		printf("Amiga file size: %lx \n",oldpos);
	
		Close(AFromFile);

	}

#if 0		
		FlyVol.Flags = 0;
		FlyVol.SCSIdrive = 0;				
		Action.Volume = &FlyVol;
		Action.ReturnTime = RT_STOPPED;
		Action.Grip = 0;

		printf("Test HS file access\n===================\n");

		FlyVol.Path = TestFile;

		printf("Accessing file: %s\n",FlyVol.Path);

		//Action.Access = FLYER_MODE_INPUT;				//Read from file
		//Action.Access = FLYER_MODE_UPDATE;			//Read/Write file
		Action.Access = FLYER_MODE_OUTPUT;				//Newfile/Write file

		res = FlyerFileOpen(&Action);
		if (res==0) 
		{
			// file is open now so FileID"grip" is initinlised
			GPOINTER = (LONG)Action.FileID;
			GPOINTER += 0x2C0000-2;
			printf("GPOINTER %lx \n",GPOINTER);
			ItsGrip = (struct GRIP *)GPOINTER;
			printf("ItsGrip Amiga address: %lx \n",ItsGrip);
			printf("grip magic %lx \n",ItsGrip->g_magic);	
			printf("Start block %lx \n",ItsGrip->g_startblk);	
			printf("Physlen low32 bits %lx \n",ItsGrip->g_physlen);	
			printf("Filelen low32 bits %lx \n",ItsGrip->g_filelen);	

			fileid = Action.FileID;
			FlyVol.Path = 0;

			res = FlyerFileExtend(&FlyVol,fileid,0xA00000);
			if (res)
				printf("Error writing file %ld\n",res);

			res = FlyerFileClose(&FlyVol,fileid);
			printf("Wrote %ls, grip = %lx\n",&TestFile,fileid);
			FlyerFreeGrip(&FlyVol,fileid);
		}		
	}
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else {
		printf("Okay\n");
	}
#endif



	if(WRBuffer)
		FreeMem(WRBuffer,512*96);	

	CloseLibrary(FlyerBase);

	return(0);
}




//		printf("Buffer %lx\n",WRBuffer);
//		for(i=0;i<22;i++)
//			res = FlyerFileHSRead(&FlyVol,fileid,ItsGrip->g_startblk,96,WRBuffer);	
//		printf("Buffer %lx\n",WRBuffer);
//		for(i=0;i<22;i++)
//			res = FlyerFileHSWrite(&FlyVol,fileid,ItsGrip->g_startblk,96,WRBuffer);	
