/*********************************************************************\
*
* Panic - Aborts all Flyer commands
*
* $Id: panic.c,v 1.1 1995/05/19 14:22:30 Flick Exp $
*
* $Log: panic.c,v $
*Revision 1.1  1995/05/19  14:22:30  Flick
*Made abort optional, always does reset
*
*Revision 1.0  1995/05/05  15:52:03  Flick
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	12/31/94		Marty	created
\*********************************************************************/

#include <exec/types.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "FlyerLib.h"
#include "Flyer.h"

struct Library *FlyerBase;


main(int argc,char **argv)
{
	FlyerBase = OpenLibrary("flyer.library",0);
	if (FlyerBase==0) {
		printf("Could not open Flyer\n");
		exit(10);
	}

	if (argc > 1) {
		AbortAction(0);			/* Kill everything */
		printf("Abort/reset\n");
	}
	else {
		ResetFlyer(0,0);			/* Just do reset */
		printf("Reset\n");
	}

	CloseLibrary(FlyerBase);
}
