/*********************************************************************\
*
* SendEKey - Test Sending Audio Envelope key to Flyer.
*
* $Id: sendekey.c,v 2.2 1996/07/16 13:00:41 Holt Exp $
*
* $Log: sendekey.c,v $
*Revision 2.2  1996/07/16  13:00:41  Holt
**** empty log message ***
*
*Revision 2.1  1996/06/25  17:18:39  Holt
**** empty log message ***
*
*Revision 2.0  1996/06/18  12:53:18  Holt
*FirstCheckIn
*
*
* Copyright (c) 1994 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
*	06/18/96		David		Created
\*********************************************************************/

#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct Library *FlyerBase;

main(int argc,char **argv)
{
	ULONG	res;
	int	temp;
	struct AudioEKey *AEK;

	if (argc!=8) {
		printf("Usage: %ls <Time> <Duration> <Flags> <Volumn1> <Volumn2> <Pan1> <Pan2>\n",
				 argv[0]);
		return(20);
	}


	AEK->ETime = strtoul(argv[1],0,0);
	AEK->EDurr = strtoul(argv[2],0,0);
	//stcd_i(argv[2],&temp);
	//AEK->EDurr = temp;
	stcd_i(argv[3],&temp);
	AEK->EFlags = temp;
	stcd_i(argv[4],&temp);
	AEK->EVol1 = temp;
	stcd_i(argv[5],&temp);
	AEK->EVol2 = temp;
	stcd_i(argv[6],&temp);
	AEK->EPan1 = temp;
	stcd_i(argv[7],&temp);
	AEK->EPan2 = temp;

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	res = 0;

	printf("Time=%ld Dur=%ld flags=%ld vol1=%ld vol2=%ld pan1=%ld pan2=%ld \n",
			AEK->ETime,AEK->EDurr,AEK->EFlags,AEK->EVol1,AEK->EVol2,AEK->EPan1,
			AEK->EPan2);

	res = AddAudEKey(AEK);


#if 0
	if (res==0)
		res = ();
#endif
	if (res)
		printf("Error - %ls\n",Error2String(res));
	else
		printf("Okay\n");

	CloseLibrary(FlyerBase);

	return(0);
}

