/******************************************************************** 
*
*	SpeedRacer -- Flyer file xfer speed tester.
*
*	$Id: speedracer.c,v 2.4 1997/05/14 11:44:35 Holt Exp $
*
*	$Log: speedracer.c,v $
*Revision 2.4  1997/05/14  11:44:35  Holt
**** empty log message ***
*
*Revision 2.3  1997/04/18  16:56:16  Holt
*I think I've got the hs file stuff done...
*
*Revision 2.2  1997/03/26  16:41:56  Holt
*lots more test gunck
*
*Revision 2.0  1997/02/17  12:34:46  Holt
*FirstCheckIn
*
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved.
*
*********************************************************************/
#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <dos/datetime.h>
#include <intuition/intuition.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerFS.h"
#include "intfsprivate.h"





#define	FlyerBase	FlyerBase


#define 	WRBuffer_Size	0x100000


void GetArg(char *arg,int *var,int lo,int hi,char *label);

struct FileInfoBlock fib;
struct DateTime	stamp;
struct DateStamp	now;
BPTR	*Handle,*TestFileHD;
ULONG	*FileHD;
ULONG	*TestBuffer;
//APTR	GPOINTER;
ULONG	GPOINTER;
struct GRIP	*ItsGrip;

int i;

UBYTE Buffer[32];
char	TestPath[]			= "Flyerb2:";
char	TestPathFile[] 	= "SpeedRacer";
char	PathFile[]			= "Flyerb2:SpeedRacer";
char	DirName[]			= ":";
//char	TestFile[]			= "flyerb2:testfolder/DTestFile";
char	TestFile[]			= "flyerc0:speedtest001";
//char	TestFile[]			= "ram:NewTestFile";
//char	WRBuff[512*10]		= "Go Speed racer, Go!";	

char TestString[512] 		= "This is a test of the emergency broadcast system";

APTR	WRBuffer;



struct Library *FlyerBase;
struct FlyerVolume FlyVol;
struct ClipAction	 Action;


UBYTE	ReadBuff[64];

UBYTE TestOutBuff[16] = "David was here.";

#if 1
void HexDumpStr(char *DB_Str,int len)
{	
	int i=0,id=0;

	char DB_byte;
	
	for(id=0;id<len;id++)	
	{
		printf("%04x   %02X%02X%02X%02X   %02X%02X%02X%02X   %02X%02X%02X%02X   %02X%02X%02X%02X \n",
			i,(UBYTE)DB_Str[i],(UBYTE)DB_Str[i+1],(UBYTE)DB_Str[i+2],(UBYTE)DB_Str[i+3],
			  (UBYTE)DB_Str[i+4],(UBYTE)DB_Str[i+5],(UBYTE)DB_Str[i+6],(UBYTE)DB_Str[i+7],
			  (UBYTE)DB_Str[i+8],(UBYTE)DB_Str[i+9],(UBYTE)DB_Str[i+10],(UBYTE)DB_Str[i+11],
			  (UBYTE)DB_Str[i+12],(UBYTE)DB_Str[i+13],(UBYTE)DB_Str[i+14],(UBYTE)DB_Str[i+15]);
		i+=16;
	}
}
#endif

#if 0
void HexDumpStr(char *DB_Str,int len)
{	
	int i=0,id=0;

	char DB_byte;
	
	printf("\n");
	for(id=0;id<len;id++)	
	{
		printf("%4x   %x  \n",i,(UBYTE)DB_Str[i]);
		i+=1;
	}
	printf("\n");
}
#endif





main(int argc,char **argv)
{
	int	succ,test,drive,i;
	BPTR	lock;
	ULONG	grip,fileid,actual,res;
	char	DateBuff[20],TimeBuff[20];
	LONG	oldpos,act2,Amt;




	WRBuffer = AllocMem(WRBuffer_Size,MEMF_PUBLIC);	
	if (!(WRBuffer))
	{
		printf("Could not allocate amiga buffer\n");
		return(0);
	}





//	if ((argc<4)||(argv[1][0]=='?')) {
//		printf("Usage: %ls  \n",argv[0]);
//		return(20);
//	}

	//GetArg(argv[1],&test,0,99,"Test code");

	if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) {
		printf("Open flyer.library failed\n");
		return;
	}

	GetArg(argv[1],&Amt,0,10000000,"Extend Amt");

#if 1
	/* Allocate some test memory */
	if (TestBuffer = AllocMem(1000000,MEMF_PUBLIC))
	{	
		/* Create a file using Amiga DOS */
 		//if (FileHD = Open(&TestFile,MODE_NEWFILE))
 		if (FileHD = Open(&TestFile,MODE_OLDFILE))
		{
			for(i=1;i<=100;i++)
			{	
				//if(!Write(FileHD,TestBuffer,1952*512))
				//	break;
				//printf("Bytes written: %d \n",Write(FileHD,TestBuffer,1000000));


				if(!Read(FileHD,TestBuffer,1952*512))
						break;
				


			}
			Close(FileHD);
		}
		else
			printf("Error. Could not allocate buffer.\n");
	
		FreeMem(TestBuffer,1000000);
	}
	else
		printf("Error. Could not allocate buffer.\n");
#endif





#if 0
	FlyVol.Flags = FVF_USENUMS;
	FlyVol.Path = DirName;
	FlyVol.SCSIdrive = 22;				//Drive number 9 flyerba:
	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;
	Action.Grip = 0;


	printf("Test Create file\n");
	FlyVol.Path = DirName;
	Action.Grip = 0;
	res = FlyerLocate(&Action);
	printf("After FlyerLocate\n");
	if (res==0) 
	{
	grip = Action.Grip;
		printf("Located %ls, grip = %lx\n",&DirName,grip);
		FlyVol.Path = TestFile;
		Action.Access = FLYER_MODE_OUTPUT;
		res = FlyerFileOpen(&Action);
		if (res==0) 
		{
			fileid = Action.FileID;
			FlyVol.Path = 0;
			res = FlyerFileWrite(&FlyVol,fileid,
				sizeof(TestString),TestString,&actual);
			if (res)
				printf("Error writing file %ld\n",res);
			res = FlyerFileClose(&FlyVol,fileid);
			printf("Wrote %ls, grip = %lx\n",&TestFile,fileid);
			FlyerFreeGrip(&FlyVol,fileid);
		}
		FlyerFreeGrip(&FlyVol,grip);
	}

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else {
		printf("Okay\n");
	}
#endif

		

// This is the one that works Model 1
#if 0
	FlyVol.Flags = 0;
//	FlyVol.Path = TestPath;
	FlyVol.SCSIdrive = 0;				
	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;
	Action.Grip = 0;

	printf("Test HS file access\n===================\n");
	FlyVol.Path = TestPath;
	Action.Grip = 0;
	res = FlyerLocate(&Action);
	printf("After FlyerLocate\n");
	if (res==0) 
	{
		grip = Action.Grip;

		printf("Located %ls = %lx\n",&DirName,grip);
		FlyVol.Path = TestFile;
		//Action.Access = FLYER_MODE_INPUT;
		Action.Access = FLYER_MODE_UPDATE;
		//Action.Access = FLYER_MODE_OUTPUT;
		res = FlyerFileOpen(&Action);
		if (res==0) 
		{
			// file is open now so FileID"grip" is initinlised
			GPOINTER = (LONG)Action.FileID;
			GPOINTER += 0x2C0000-2;
			printf("GPOINTER %lx \n",GPOINTER);
			ItsGrip = (struct GRIP *)GPOINTER;
			printf("ItsGrip Amiga address: %lx \n",ItsGrip);
			printf("grip magic %lx \n",ItsGrip->g_magic);	
			printf("Start block %lx \n",ItsGrip->g_startblk);	
			printf("Physlen low32 bits %lx \n",ItsGrip->g_physlen);	
			printf("Filelen low32 bits %lx \n",ItsGrip->g_filelen);	


			fileid = Action.FileID;
			FlyVol.Path = 0;

//			printf("Buffer %lx\n",WRBuffer);

			for(i=0;i<22;i++)
				res = FlyerFileHSRead(&FlyVol,fileid,ItsGrip->g_startblk,96,WRBuffer);	


//			printf("Buffer %lx\n",WRBuffer);
//			for(i=0;i<22;i++)
//				res = FlyerFileHSWrite(&FlyVol,fileid,ItsGrip->g_startblk,96,WRBuffer);	
			


//			res = FlyerFileWrite(&FlyVol,fileid,
//				sizeof(TestString),TestString,&actual);

//			res = FlyerFileExtend(&FlyVol,fileid,Amt);


			if (res)
				printf("Error writing file %ld\n",res);
			res = FlyerFileClose(&FlyVol,fileid);
			printf("Wrote %ls, grip = %lx\n",&TestFile,fileid);
			FlyerFreeGrip(&FlyVol,fileid);
		}
		FlyerFreeGrip(&FlyVol,grip);
	}

	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else {
		printf("Okay\n");
	}

#endif



// This is model 2
#if 0
	FlyVol.Flags = 0;
	FlyVol.SCSIdrive = 0;				
	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;
	Action.Grip = 0;

	printf("Test HS file access\n===================\n");
	grip = Action.Grip;

	printf("Located %ls = %lx\n",&DirName,grip);
	FlyVol.Path = TestFile;
	//Action.Access = FLYER_MODE_INPUT;
	Action.Access = FLYER_MODE_UPDATE;
	//Action.Access = FLYER_MODE_OUTPUT;
	res = FlyerFileOpen(&Action);
	if (res==0) 
	{
		// file is open now so FileID"grip" is initinlised
		GPOINTER = (LONG)Action.FileID;
		GPOINTER += 0x2C0000-2;
		printf("GPOINTER %lx \n",GPOINTER);
		ItsGrip = (struct GRIP *)GPOINTER;
		printf("ItsGrip Amiga address: %lx \n",ItsGrip);
		printf("grip magic %lx \n",ItsGrip->g_magic);	
		printf("Start block %lx \n",ItsGrip->g_startblk);	
		printf("Physlen low32 bits %lx \n",ItsGrip->g_physlen);	
		printf("Filelen low32 bits %lx \n",ItsGrip->g_filelen);	


		fileid = Action.FileID;
		FlyVol.Path = 0;

//		printf("Buffer %lx\n",WRBuffer);

		for(i=0;i<22;i++)
			res = FlyerFileHSRead(&FlyVol,fileid,ItsGrip->g_startblk,96,WRBuffer);	

//		printf("Buffer %lx\n",WRBuffer);
//		for(i=0;i<22;i++)
//			res = FlyerFileHSWrite(&FlyVol,fileid,ItsGrip->g_startblk,96,WRBuffer);	
			


//		res = FlyerFileWrite(&FlyVol,fileid,
//						sizeof(TestString),TestString,&actual);

//		res = FlyerFileExtend(&FlyVol,fileid,Amt);

		if (res)
			printf("Error writing file %ld\n",res);
		res = FlyerFileClose(&FlyVol,fileid);
		printf("Wrote %ls, grip = %lx\n",&TestFile,fileid);
		FlyerFreeGrip(&FlyVol,fileid);
	}		
	//FlyerFreeGrip(&FlyVol,grip); //old grip on device
	
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else {
		printf("Okay\n");
	}
#endif


	//OpenWriteHSFile(&TestFile,&Action,&FlyVol,0xA00000);


	//DoFlyerFileThing(&TestFile,&Action,&FlyVol);


// this is a test of the intergration of the HS code into the FlyerFS
#if	0
	
	if(TestFileHD=Open(&TestFile,MODE_OLDFILE))
	{
		printf("Opened File: %lx  \n",TestFileHD);


		Read(TestFileHD,WRBuffer,512*10);


		Close(TestFileHD);
	}
	else 
	{
		printf("Err: Unable to open file.\n");
	}
#endif	



	
// This is model 3
#if 0
	FlyVol.Flags = 0;
	FlyVol.SCSIdrive = 0;				
	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;
	Action.Grip = 0;

	printf("Test HS file access\n===================\n");

	FlyVol.Path = PathFile;

	printf("Accessing file: %s\n",FlyVol.Path);

	//Action.Access = FLYER_MODE_INPUT;				//Read from file
	Action.Access = FLYER_MODE_UPDATE;				//Read/Write file
	//Action.Access = FLYER_MODE_OUTPUT;			//Newfile/Write file

	res = FlyerFileOpen(&Action);
	if (res==0) 
	{
		// file is open now so FileID"grip" is initinlised

		//res = FlyerFileHSRead(&FlyVol,fileid,ItsGrip->g_startblk,96,WRBuffer);	

		GPOINTER = (LONG)Action.FileID;
		GPOINTER += 0x2C0000-2;
		printf("GPOINTER %lx \n",GPOINTER);
		ItsGrip = (struct GRIP *)GPOINTER;
		printf("ItsGrip Amiga address: %lx \n",ItsGrip);
		printf("grip magic %lx \n",ItsGrip->g_magic);	
		printf("Start block %lx \n",ItsGrip->g_startblk);	
		printf("Physlen low32 bits %lx \n",ItsGrip->g_physlen);	
		printf("Filelen low32 bits %lx \n",ItsGrip->g_filelen);	

		
		//FlyVol.Path = 0;
		fileid = Action.FileID;

//		printf("Buffer %lx\n",WRBuffer);

//		for(i=0;i<2;i++)

//		res = FlyerFileHSRead(&FlyVol,fileid,ItsGrip->g_startblk,1,WRBuffer);	
//		printf("buffer cont: %lx\n",(ULONG *)WRBuffer);


//		printf("CurPos low32 bits %lx \n",ItsGrip->g_curpos);	

//		printf("Buffer %lx\n",WRBuffer);
//		for(i=0;i<22;i++)
//			res = FlyerFileHSWrite(&FlyVol,fileid,ItsGrip->g_startblk,96,WRBuffer);	
			
//		for(i=0;i<13;i++)
//		{
//			res = FlyerFileWrite(&FlyVol,fileid,11,TestString,&actual);
//			printf("CurPos low32 bits %lx  res: %lx  actual: %lx TS: %s\n",ItsGrip->g_curpos,res,actual,TestString);	
//		}
//		res = FlyerFileExtend(&FlyVol,fileid,Amt);


		


		res = FlyerNewFileWrite(&FlyVol,fileid,11,TestString,&actual);
//		res = FlyerFileRead(&FlyVol,fileid,11,TestString,&actual);
//		res = FlyerNewFileRead(&FlyVol,fileid,11,TestString,&actual);


//		res =	FlyerFileRead(&FlyVol,fileid,512,TestString,&actual);
//		res =	FlyerNewFileRead(&FlyVol,fileid,512,TestString,&actual);
			

//		res = FlyerFileHSRead(&FlyVol,fileid,0x51a16,1,TestString);

//		res = FlyerFileExtend(&FlyVol,fileid,512);
		
//		res = FlyerFileHSWrite(&FlyVol,fileid,0x144b,1,TestString);
//		printf("res from FlyerFileHSWrite: %X\n",res);
		
//		HexDumpStr(TestString,16);
		
//		printf("\nactual %X\n\n",actual);


//		printf("CurPos low32 bits %lx \n",ItsGrip->g_curpos);	





		if (res)
			printf("File Error %ld\n",res);


		res = FlyerFileClose(&FlyVol,fileid);
		//printf("Wrote %ls, grip = %lx\n",&TestFile,fileid);
		FlyerFreeGrip(&FlyVol,fileid);
		

	}		
	
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else {
		printf("Okay\n");
	}
#endif


// Test for strange file problem
#if 0

 	if (FileHD = Open(&TestFile,MODE_NEWFILE))
	{

		for(i=0;i<100;i++)
		{
			Write(FileHD,&TestString,17);
			printf("the string %s \n",&TestString);		
		}

		Close(FileHD);
	}
	else
		printf("Error: Could not open file.\n");

#endif


#if 0
//	FlyVol.Flags = FVF_USENUMS;
	FlyVol.Flags = 0;
	FlyVol.Path = &TestPath;
	FlyVol.SCSIdrive = 9;
	Action.Volume = &FlyVol;
	Action.ReturnTime = RT_STOPPED;
	Action.Grip = 0;
#endif


#if 0
	/* Create file in sub-directory */
	printf("No Racer X, I'm going to be in the race....\n");

	FlyVol.Flags = FVF_USENUMS;
	FlyVol.Path = &TestPathFile;
	Action.Grip = 0;
	FlyVol.SCSIdrive = 9;

	Action.Access = FLYER_MODE_OUTPUT;

	res = FlyerFileOpen(&Action);
	printf("FileOpen\n");

	if (res==0) 
	{
		res = FlyerFileClose(&FlyVol,fileid);
		fileid = Action.FileID;
		FlyVol.Path = 0;
	}
	//FlyerFreeGrip(&FlyVol,fileid);
#endif


#if 0
	/* Open file */
	printf("I'm going to win the race... Go speed racer go!\n");
	FlyVol.Path = argv[3];
	Action.Grip = 0;
	res = FlyerLocate(&Action);
	if (res==0) {
		grip = Action.Grip;
		printf("Located %ls, grip = %lx\n",argv[3],grip);

		FlyVol.Path = argv[4];
		Action.Access = FLYER_MODE_INPUT;
		res = FlyerFileOpen(&Action);
		if (res==0) {
			fileid = Action.FileID;

			res = FlyerFileClose(&FlyVol,fileid);

			printf("Opened file %ls, id = %lx\n",argv[4],fileid);
			FlyerFreeGrip(&FlyVol,fileid);
		}
		FlyerFreeGrip(&FlyVol,grip);
	}
#endif



#if 0
	/* Dump first 32 bytes of file */
	printf("I'm not going to let the monstor truct win the race!\n");
	Handle = Open(argv[3],MODE_OLDFILE);
	if (Handle)
	{
		act2 = Read(Handle,ReadBuff,32);
		if (act2 == -1)
		{
			printf("Failed, error code = %ld,%ld\n",act2,IoErr());
		}
		else
		{
			printf("Actual = %ld\n",act2);
			for (i=0; i<act2; i++)
				printf("%02lx ",ReadBuff[i]);
		}
		Close(Handle);
	}
	else
		printf("Did not open successfully\n");
	res = 0;
#endif




	/* End of test cleanup and close */
#if 0
	if (res)
		printf("Error %ld - %ls\n",res,Error2String(res));
	else 
	{
		printf("Okay\n");
	}
#endif

	if(WRBuffer)
		FreeMem(WRBuffer,WRBuffer_Size);	

	CloseLibrary(FlyerBase);

	return(0);
}


void GetArg(char *arg,int *var,int lo,int hi,char *label)
{
	stch_i(arg,var);
	if ((*var < lo)||(*var > hi)) {
		printf("Error: %ls is out of range\n",label);
		exit(20);
	}
}

