/* This is the Preliminary Envelope script for RenderFX */
/* New Envelope Script with Added Enhancements */
/* Updated August 21, 1997 */
/* August 26, 1997 - Undo Code added */
 
OPTIONS RESULTS
TOASTERLIB="ToasterARexx.port"

call remlib('PROJECT_REXX_PORT')
call addlib('PROJECT_REXX_PORT',0)

IF POS(TOASTERLIB , SHOW('Libraries')) = 0 THEN
  IF ~ADDLIB(TOASTERLIB , 0) THEN x=Bummer(" Please start your Toaster.")

fpath="" 	/* Path for saving to a selected location (not auto-save) */
orig=0	/* 1=Write to original file location  0=new selected path */

call Switcher(TOSW)

if exists("ENV:OZ-PanicStop") then address command "delete ENV:OZ-PanicStop QUIET"

count = croutonsinproject()

mycount. = 0

testing = 0

next = 1
selected = 0
do while next < count+1
   row = trunc(next/8)
   col = next - (row*8)
   row = row + 1
   selected = selected + croutonselected(row,col)
   if croutonselected(row,col) = 1 then do
      mycount.testing = next-1
      testing = testing + 1
   end
   next = next + 1
end

OPEN(myfile,"env:envelope.txt",'Write')     

myeffect = mycount.0

call croutonpick(myeffect) 

effectlength = croutongettag(numfields)/2

testlength = effectlength%4

testlength = testlength*4

mydelta = 0
if (effectlength > testlength) then
   mydelta = 2

call switcher(DOEN) 

call switcher(TBAR,200)

billrev1 = Switcher(STAT,TBAR)

call switcher(TBAR,100)

billrev2 = Switcher(STAT,TBAR)

Switcher(TAKE)

if billrev1 = billrev2 then 
   billrev1 = 1
else
   billrev1 = 0

croutonpick(myeffect-1)

myreverse = 0

VidA = myeffect-1
VidB = myeffect+1

p_type=croutontype()
if (p_type = "CTRL") then do
   position1 = lastpos('/',croutonname())
   filename1 = upper(right(croutonname(),length(croutonname())-position1))
   if left(filename1,8)="OZFX-REV" then do
      myreverse = 1;
      croutonpick(myeffect+1)
      p_type=croutontype()
      VidA = myeffect+1
      VidB = myeffect-2
      end
   end

p_tn=1
if (p_type="FRAM")|(p_type="STIL")|(p_type="MAIN")|(p_type="KEYF") then do
   if (p_type="STIL") then p_tn=2
   if (p_type="FRAM") then p_tn=3
   if (p_type="MAIN") then p_tn=4
   if (p_type="KEYF") then p_tn=5
   end

if (p_tn > 2) then do 
   Call Switcher(M001)
   Call Switcher(PDV2)
   Call Switcher(FMLD,croutonname())
   Call Switcher(WAIT,1)
   end

call DoItNow

croutonpick(VidA)

WRITELN(myfile,filename1||",3,"||billrev1||","||myreverse);

length = croutongettag(recfields);

start = croutongettag(ClipStartField)+croutongettag(Duration)-4

start = start-effectlength

start = start-mydelta

if (p_tn == 2) then do
   length = 2
   start = 0
   end

if (start < 0) then do
   effectlength = effectlength + start   
   start = 0
   end
   
WRITELN(myfile,croutonname()||","||start||","||length||","||p_tn);

croutonpick(VidB)
n_type=croutontype()
n_tn=1
if (n_type="FRAM")|(n_type="STIL")|(n_type="MAIN")|(n_type="KEYF") then do
   if (n_type="STIL") then n_tn=2
   if (n_type="FRAM") then n_tn=3
   if (n_type="MAIN") then n_tn=4
   if (n_type="KEYF") then n_tn=5
   end

if (n_tn>2) then do
   Call Switcher(M001)
   Call Switcher(PDV1)
   Call Switcher(FMLD,croutonname())
   Call Switcher(WAIT,1)
end

Length2 = croutongettag(recfields)

start2 = croutongettag(ClipStartField)-effectlength+mydelta

if (n_tn == 2) then do
   Length2 = 2;
   start2 = 0;
   end 

if (start2 < 0) then do
   effectlength = effectlength + start2 
   start2 = 0 
   end

if (n_tn=5) then
   WRITELN(myfile,croutonname()||","||(myeffect+1)*2||",0,"||n_tn);
else 
   WRITELN(myfile,croutonname()||","||start2||","||Length2||","||n_tn);

WRITELN(myfile,effectlength*2);

CLOSE(myfile)

call Switcher(M003)

call croutonpick(myeffect) 

Switcher(DOEN)

call Switcher(TOWB)

address command "prowave:rfxx" 

if ~exists(filename1) then 
   do
   SAY "It works!!!!!"
   call remlib('PROJECT_REXX_PORT')
   call remlib('ToasterARexx.port')
   exit
   end   

call MAKEICON(filename1,fields) 

/* Lets Build the Undo File */

fpath = filename1

if lastpos('/',fpath,length(fpath)-1)~=0 then do
   filenam2=right(fpath,(length(fpath)-lastpos('/',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos('/',fpath,length(fpath))-1))
   end
else do
   filenam2=right(fpath,(length(fpath)-lastpos(':',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos(':',fpath,length(fpath))))
   end

undofilename = "prowave:undofx/"||filenam2||".undo"

SAY undofilename

OPEN(myfile,undofilename,'WRITE')

WRITELN(myfile,"0");

croutonpick(myeffect)

WRITELN(myfile,croutonname())     

myfcount = croutongettag(FCountMode)

WRITELN(myfile,myfcount)

if (myfcount = 2) then
   WRITELN(myfile,effectlength*2)

croutonpick(myeffect-1)

WRITELN(myfile,croutongettag(Duration))

WRITELN(myfile,croutongettag(AudioDuration))

croutonpick(myeffect+1)

WRITELN(myfile,croutongettag(ClipStartField))

WRITELN(myfile,croutongettag(Duration))

WRITELN(myfile,croutongettag(AudioStart))

WRITELN(myfile,croutongettag(AudioDuration))

CLOSE(myfile)

/* Lets Replace it in the Project */
croutonpick(myeffect) 

call croutonload(filename1,INSERT)

croutonpick(myeffect)

call croutondelete()

croutonpick(myeffect)

call croutonsettag(ClipStartField,0)

call croutonsettag(Duration,croutongettag(recfields))

croutonpick(myeffect-1)

if (myreverse = 1) then do
   croutonpick(myeffect-1)
   croutondelete() 
   croutonpick(myeffect-2)
   end

OPEN(myfile,"env:rfx_out.txt",'Read')     

coolstuff = READLN(myfile)

coolstuff = READLN(myfile)

position1 = lastpos(',',coolstuff)

position2 = lastpos(',',coolstuff,position1-1)

coolstuff2 = right(coolstuff,length(coolstuff)-position2)

position1 = lastpos(',',coolstuff2)

outval1 = left(coolstuff2,position1-1)-4

coolstuff = READLN(myfile)

position1 = lastpos(',',coolstuff)

position2 = lastpos(',',coolstuff,position1-1)

coolstuff2 = right(coolstuff,length(coolstuff)-position2)

position1 = lastpos(',',coolstuff2)

startval2 = left(coolstuff2,position1-1)

outval2 = right(coolstuff2,length(coolstuff2)-position1)

Close(myfile)

call croutonsettag(Duration,croutongettag(Duration)-outval2/2-4)

croutonpick(myeffect+1)

call croutonsettag(ClipStartField,startval2+outval2)

call croutonsettag(Duration,croutongettag(Duration)-outval2/2)

call remlib('PROJECT_REXX_PORT')
call remlib('ToasterARexx.port')

exit


DoItNow:
/* Create file name here */

croutonpick(VidA)

p_name = croutonname()

croutonpick(VidB)

n_name = croutonname()

if lastpos('/',p_name,length(p_name)-1)~=0 then do
   filenam3=right(p_name,(length(p_name)-lastpos('/', p_name, length(p_name)-1)))
   newpath=left(p_name,(lastpos('/',p_name,length(p_name))-1))
   end
else do
   filenam3=right(p_name,(length(p_name)-lastpos(':', p_name, length(p_name)-1)))
   newpath=left(p_name,(lastpos(':',p_name,length(p_name))))
   end
call pragma("D",newpath)
newpath=pragma("D","RAM:")

if (right(newpath,1)~="/") & (right(newpath,1)~=":") then
   newpath=newpath||"/"
sm_name=left(filenam3,3)||"z.rfx"

if ((p_tn=1)|(p_tn=2)) & (orig=1) then 
   newfile=newpath||sm_name
else do
   if fpath="" then call savewhere()
   newfile=fpath||sm_name
   end

counter=0
found=0
do while found=0
   counter=counter+1
   if counter<10 then ct="00"||counter
   else if counter<100 then ct="0"||counter
   else ct=counter   
   if ~exists(newfile||ct) then found=1
   end

filename1=newfile||ct

return

SaveWhere:
call startfilereq("Select Flyer drive below to save clip to","FA0:","(No Filename needed)")

exit=1
do while exit=1
  fpath=queryfilereq()
  if fpath=0 then call quit()
  if fpath~="" then exit=0
  else address command "c:wait 1"
end

if lastpos('/',fpath,length(fpath)-1)~=0 then do
   filenam2=right(fpath,(length(fpath)-lastpos('/',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos('/',fpath,length(fpath))-1))
   end
else do
   filenam2=right(fpath,(length(fpath)-lastpos(':',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos(':',fpath,length(fpath))))
   end

call pragma("D",path2)
fpath=pragma("D","RAM:")

if (right(fpath,1)~="/") & (right(fpath,1)~=":") then
   fpath=fpath||"/"
return

