/* This is the Preliminary Keying script 
   for RenderFX */
/* Update to allow Key out 3/29/96 */
/* Updated to help previews key out 4/5/96 */

/* 4/23/97 */
/* Updated for Correct Timing with Output Effect */
/* Allow Key Pages without Luminence Keyer */     

/* 7/01/97 */
/* Allow Fadein and Fadeout of Keypages */
/* Added Padding for front and back */
/* Add Reverse for Luminence Key Effects */ 
/* Add Audio Support */


OPTIONS RESULTS
TOASTERLIB="ToasterARexx.port"

call remlib('PROJECT_REXX_PORT')
call addlib('PROJECT_REXX_PORT',0)

IF POS(TOASTERLIB , SHOW('Libraries')) = 0 THEN
  IF ~ADDLIB(TOASTERLIB , 0) THEN x=Bummer(" Please start your Toaster.")

call Switcher(TOSW)

if exists("ENV:OZ-PanicStop") then address command "delete ENV:OZ-PanicStop QUIET"

rx startfilereq("Output File Name")
exit=1
do while exit=1
   filename1=queryfilereq()
   if filename1=0 then 
      call quit
    else NOOP
      if filename1~="" then exit=0
      else NOOP
      address command "c:wait 1"
      end
      call req_close()

position1 = lastpos(':',filename1)
position2 = lastpos(':',filename1,position1-1)

if position2 ~= 0 then do
   filename1 = right(filename1,length(filename1)-position2)
end

fpatht=filename1
patht=''
filenamet=''
lenfpt=length(fpatht)
if lenfpt>1 then do
   lastpt=lastpos('/',fpatht,lenfpt)
   if (lastpt~=0) then do
      if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
      patht=left(fpatht,lastpt-1)
      end
   else if lastpt=0 then do
      lastpt=lastpos(':',fpatht,lenfpt)
      if (lastpt~=0) then do
         if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
         patht=left(fpatht,lastpt)
         end
      end
   if patht~='' then do
      call pragma('D',patht)
      patht=pragma('D','RAM:')
      end
call req_close()

if (patht='') then do
   call req_tell('RenderFX cancelled','    You need to select a drive/folder','       from bottom of Flyer window')
   call quit()
   end

if (filenamet='') then do
   call req_tell('RenderFX cancelled','   You need to type in a filename')
   call quit()
   end

if (right(patht,1)~="/") & (right(patht,1)~=":") then
   patht=patht||"/"

filename1=patht||filenamet

croutoncount = croutonsinproject()
if (croutoncount > 4) then
   croutoncount = 4

call SET_VIEW(4)

f_want=req_time("Extra padding at start?",0)
if f_want="CANCEL" then call quit()
call req_close()
fm=substr(f_want,4,2)
fs=substr(f_want,7,2)
ff=substr(f_want,10,2)
padP=((fm*1800)+(fs*30)+ff)
padPhold=padP

call req_open("RenderFX tip","-------------","If you plan to layer another effect to the end of this one,","  then perhaps add extra padding here to cover the next effect.  ")

f_want=req_time("Extra padding at end?",0)
if f_want="CANCEL" then call quit()
call req_close()
fm=substr(f_want,4,2)
fs=substr(f_want,7,2)
ff=substr(f_want,10,2)
padN=((fm*1800)+(fs*30)+ff)
padNhold=padN


/* Lets do the Key Pages First */
if (croutoncount = 2) then do
   OPEN(myfile,"env:Keying.txt",'Write')     
   WRITELN(myfile,filename1||",3");

   croutonpick(0)

   p_type=croutontype()
   p_tn=1
   if (p_type="FRAM")|(p_type="STIL")|(p_type="MAIN")|(p_type="KEYF") then do
      if (p_type="FRAM")|(p_type="KEYF") then p_tn=3
         else if (p_type="STIL") then p_tn=2
         else if (p_type="MAIN") then p_tn=4
      end

   if (p_tn > 2) then do 
      Call Switcher(M001)
      Call Switcher(PDV2)
      Call Switcher(FMLD,croutonname())
      Call Switcher(WAIT,1)
      end

   f_want=req_time("Fade In Time",0)
   if f_want="CANCEL" then call quit()
   call req_close()
   fm=substr(f_want,4,2)
   fs=substr(f_want,7,2)
   ff=substr(f_want,10,2)
   infade=((fm*1800)+(fs*30)+ff)

   f_want=req_time("Fade Out Time",0)
   if f_want="CANCEL" then call quit()
   call req_close()
   fm=substr(f_want,4,2)
   fs=substr(f_want,7,2)
   ff=substr(f_want,10,2)
   outfade=((fm*1800)+(fs*30)+ff)

   count5 = croutongettag(Duration)/2+padP+padN

   WRITELN(myfile,croutonname()||","||p_tn||","||croutongettag(ClipStartField)/2-padP||","||count5);

   croutonpick(1)

   WRITELN(myfile,croutonname()||",5,2,1");

   WRITELN(myfile,"Rendering Keypages  ,0 "); 

   WRITELN(myfile,count5);

   mytot = 2

   if (infade > 0) then
      mytot = mytot + 2

   if (outfade > 0) then
      mytot = mytot + 2

   if (padP > 0) then 
      mytot = mytot + 2

   if (padN > 0) then
      mytot = mytot + 2

   WRITELN(myfile,mytot);

   cframe = 0

   if (padP > 0) then do
      WRITELN(myfile,"0,0")
      WRITELN(myfile,padP-2||",0");       
      cframe = padP
      end

   if (infade > 0) then do
      WRITELN(myfile,cframe||",1");
      WRITELN(myfile,cframe+infade-2||",99"); 
      cframe = cframe + infade
      end

   WRITELN(myfile,cframe||",99");
   WRITELN(myfile,count5-padP-outfade-2||",99");
   cframe = count5-padP-outfade

   if (outfade > 0) then do
      WRITELN(myfile,cframe||",99");
      WRITELN(myfile,cframe+outfade-2||",1"); 
      cframe = cframe + outfade
      end

   if (padP > 0) then do
      WRITELN(myfile,cframe||",0")
      WRITELN(myfile,count5||",0");       
      end

   CLOSE(myfile)

   croutonpick(1)

   value = REQ_TELL("Start Render or Preview","Press Continue to Render Key","Press Cancel to See a Preview","    Before Rendering")

   if (value = 0) then do
      address command "prowave:previewfx env:keying.txt"
      value = REQ_TELL("Render Previewed Key??? ","Press Continue to Render Key","Press Cancel to Exit RenderFX")
      end

   if (value = 1) then do
      address command "prowave:RenderFX env:Keying.txt"
      value = REQ_TELL("Add Audio to Clip?","Press Continue to Add Audio ","Press Cancel for no Audio")
      if (value = 1) then do
         OPEN(myfile,"env:keyaudio.txt",'Write')     
         WRITELN(myfile,filename1||"A,");
         WRITELN(myfile,filename1||",0");
         croutonpick(0)
         WRITELN(myfile,croutonname()||","||croutongettag(ClipStartField)/2-padP);
         CLOSE(myfile);
         address command  "prowave:keysupport env:keyaudio.txt"  
         address command "delete "||filename1
         address command "delete "||filename1||".prowave"
         address command "rename "||filename1||"A "||filename1
         end 
      call MAKEICON(filename1,count5) 
      end
   end

if (croutoncount > 2) then do 
   Type = 1
   Level = 40
   default = 10
   result = REQ_BUTTONS("Key Color",default,"BLACK","WHITE")
   if (result = "10") then
      Type = 1
   else
      Type = 2

   result = REQ_NUMBER("Enter Level",40,0,257)

   Level = result

   croutoncount = croutonsinproject()

   effect1 = 1
   effect2 = 3
   fx_rev1 = 0
   fx_rev2 = 0

   croutonpick(1)

   fx_type=croutontype()

   if fx_type = 'CTRL' then do
      fx_rev1 = 1
      effect1 = 2
      effect2 = 4
      end 
     
   if (croutoncount > effect1+2) then do
      croutonpick(effect1+2)

      fx_type=croutontype()

      if fx_type = 'CTRL' then do
         fx_rev2 = 1;
         effect2 = effect1+3;
         end
      end
   else
      croutoncount = 3;
     
   OPEN(myfile,"env:Keying.txt",'Write')     

   croutonpick(0)

   p_type=croutontype()
   p_tn=1
   if (p_type="FRAM")|(p_type="STIL")|(p_type="MAIN")|(p_type="KEYF") then do
      if (p_type="FRAM")|(p_type="KEYF") then p_tn=3
         else if (p_type="STIL") then p_tn=2
         else if (p_type="MAIN") then p_tn=4
   end

   if (p_tn > 2) then do 
      Call Switcher(M001)
      Call Switcher(PDV2)
      Call Switcher(FMLD,croutonname())
      Call Switcher(WAIT,1)
   end

   count5 = croutongettag(Duration)/2+padP

   croutonpick(effect1+1)
   n_type=croutontype()
   n_tn=1
   if (n_type="FRAM")|(n_type="STIL")|(n_type="MAIN")|(n_type="KEYF") then do
      if (n_type="FRAM")|(n_type="KEYF") then n_tn=3
         else if (n_type="STIL") then n_tn=2
         else if (n_type="MAIN") then n_tn=4
   end

   if (n_tn>2) then do
      Call Switcher(M001)
      Call Switcher(PDV1)
      Call Switcher(FMLD,croutonname())
      Call Switcher(WAIT,1)
   end

   Call Switcher(MDV1)

   count2 = croutongettag(Duration)

   croutonpick(effect1)

   count = croutongettag(numfields)/2

   count3 = 0 

   call croutonpick(effect1) 
   call switcher(DOEN) 
   call switcher(TBAR,200)

   billrev1 = Switcher(STAT,TBAR)

   call switcher(TBAR,100)

   billrev2 = Switcher(STAT,TBAR)

   Switcher(TAKE)

   if billrev1 = billrev2 then 
      billrev1 = 1
   else
      billrev1 = 0

   call croutonpick(effect2) 
   call switcher(DOEN) 
   call switcher(TBAR,200)

   bill2rev1 = Switcher(STAT,TBAR)

   call switcher(TBAR,100)

   bill2rev2 = Switcher(STAT,TBAR)

   Switcher(TAKE)

   if bill2rev1 = bill2rev2 then 
      bill2rev1 = 1
   else
      bill2rev1 = 0


   croutonpick(0)

   WRITELN(myfile,filename1||",3,"||billrev1);
   WRITELN(myfile,croutonname()||","||p_tn||","||(croutongettag(ClipStartField))/2-padP||","||count5);
   croutonpick(effect1+1)

   WRITELN(myfile,croutonname()||","||n_tn||","||croutongettag(ClipStartField)/2||","||croutongettag(Duration)/2+padP);

   if (croutoncount > 3) then do
      croutonpick(effect2)
      count3 = (croutongettag(numfields))/2+padN
      OPEN(myfile2,"env:Keying2.txt",'Write')     
      WRITELN(myfile2,filename1||",3,"||bill2rev1);
      croutonpick(0)
      WRITELN(myfile2,croutonname()||","||p_tn||","||croutongettag(ClipStartField)/2+count5-count3||","||count3);
      croutonpick(effect1+1)
      WRITELN(myfile2,croutonname()||","||n_tn||","||croutongettag(ClipStartField)/2+count5-count3||","||count3);
      WRITELN(myfile2,"  KEYING Video, 0");
      WRITELN(myfile2,count3)

      mytot = 2
      if (padN > 0) then
          mytot = 4
                 
      WRITELN(myfile2,mytot);

      if (fx_rev2 = 0) then do
         WRITELN(myfile2,"0,0");
         WRITELN(myfile2,count3-padN||",100");
         end

      if (fx_rev2 = 1) then do
         WRITELN(myfile2,"0,100");
         WRITELN(myfile2,count3-padN||",1");
         end

      if ((padN > 0)&(fx_rev2 = 1)) then do
         WRITELN(myfile2,count3-padN+2",1");
         WRITELN(myfile2,count3||",1");
         end

      if ((padN > 0)&(fx_rev2 = 0)) then do
         WRITELN(myfile2,count3-padN+2",100");
         WRITELN(myfile2,count3||",100");
         end


      WRITELN(myfile2,"SWIT,1,6,"||Type||","||Level||",1");
      CLOSE(myfile2)
      end

   WRITELN(myfile,"  KEYING Video, 0");
   WRITELN(myfile,count5-count3+padP)

   mytot = 3 
   if (padP > 0) then
      mytot = 5

   WRITELN(myfile,mytot);

   if ((padP > 0)&(fx_rev1 = 0)) then do
      WRITELN(myfile,"0,1");
      WRITELN(myfile,padP-2||",1");
      end

   if ((padP > 0)&(fx_rev1 = 1)) then do
      WRITELN(myfile,"0,99");
      WRITELN(myfile,padP-2||",99");
      end

   if (fx_rev1 = 0) then do
      WRITELN(myfile,padP",1");
      WRITELN(myfile,padP+count||",100");
      WRITELN(myfile, padP+count5-count3||",100");
      end

   if (fx_rev1 = 1) then do
      WRITELN(myfile,padP",100");
      WRITELN(myfile,padP+count||",0");
      WRITELN(myfile, padP+count5-count3||",0");
      end

   WRITELN(myfile,"SWIT,1,6,"||Type||","||Level||",1");
   CLOSE(myfile)

   croutonpick(effect1)

   call Switcher(DOEN)

   value = REQ_TELL("Start Render or Preview","Press Continue to Render Key","Press Cancel to See a Preview","    Before Rendering")

   if (value = 0) then do
      address command "prowave:previewfx env:keying.txt"
      if (croutoncount > 3 ) then do
         croutonpick(effect2)
         call Switcher(DOEN) 
         address command "prowave:previewfx env:keying2.txt"
         call Switcher(TAKE)
         end
      value = REQ_TELL("Render Previewed Key??? ","Press Continue to Render Key","Press Cancel to Exit RenderFX")
      end

   if (value = 1) then do
      croutonpick(effect1)
      call Switcher(DOEN) 
      address command "prowave:RenderFX env:Keying.txt"
      if (croutoncount > 3 ) then do
         croutonpick(effect2)
         call Switcher(DOEN) 
         address command "prowave:renderfx env:keying2.txt"
         value = REQ_TELL("Add Audio to Clip?","Press Continue to Add Audio ","Press Cancel for no Audio")
         if (value = 1) then do
            OPEN(myfile,"env:keyaudio.txt",'Write')     
            WRITELN(myfile,filename1||"A,");
            WRITELN(myfile,filename1||",0");
            croutonpick(0)
            WRITELN(myfile,croutonname()||","||croutongettag(ClipStartField)/2-padP);
            CLOSE(myfile);
            address command  "prowave:keysupport env:keyaudio.txt"  
            address command "delete "||filename1 
            address command "delete "||filename1||".prowave" 
            address command "rename "||filename1||"A "||filename1 
            end 
         end
      call MAKEICON(filename1,count5) 
      end
   end

call SET_VIEW(2)

end
