
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

FILE *outfile, *input_file, *input_file2;

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: MakeIcon 1.1 ";

unsigned stuff[0x128] = {
0x46,0x4f,0x52,0x4d,0x00,0x00,0x00,0x10,
0x20,0x50,0x55,0x53,0x49,0x4c,0x42,0x4d,
0x00,0x00,0x00,0x04,0x00,0x00,0x06,0x30,
0x46,0x4f,0x52,0x4d,0x00,0x00,0x00,0xf0,
0x43,0x72,0x55,0x44,0x54,0x59,0x50,0x45,
0x00,0x00,0x00,0x08,0x41,0x4e,0x49,0x4d,
0x00,0x00,0x00,0x00,0x4c,0x49,0x42,0x53,
0x00,0x00,0x00,0x18,0xff,0xff,0xfc,0xd0,
0x00,0x10,0x65,0x66,0x66,0x65,0x63,0x74,
0x73,0x2e,0x6c,0x69,0x62,0x72,0x61,0x72,
0x79,0x00,0x00,0x00,0x54,0x41,0x47,0x53,
0x00,0x00,0x00,0xb4,0x80,0x00,0x00,0x55,
0x00,0x00,0x00,0x01,0x80,0x00,0x00,0x56,
0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x57,
0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x58,
0x00,0x00,0x00,0x02,0x80,0x00,0x00,0x59,
0x00,0x00,0x00,0x01,0x80,0x00,0x00,0x89,
0xe4,0x00,0x00,0x00,0x80,0x00,0x00,0x8a,
0x94,0x00,0x00,0x00,0x80,0x00,0x00,0x04,
0x00,0x00,0x00,0x01,0x80,0x00,0x00,0x39,
0x00,0x00,0x00,0x01,0x80,0x00,0x00,0x38,
0x00,0x00,0x00,0x01,0x80,0x00,0x00,0x0d,
0x00,0x00,0x00,0x01,0x80,0x00,0x00,0x23,
0x00,0x00,0x00,0x01,0x80,0x00,0x00,0x22,
0x00,0x00,0x00,0x07,0x80,0x00,0x00,0x07,
0x00,0x00,0x00,0x01,0x10,0x00,0x00,0x1b,
0x00,0x00,0x00,0x38,0x00,0x01,0x00,0x00,
0x00,0x00,0x00,0x04,0x8f,0xff,0x0f,0xff,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x90,0x00,0x00,0x00,0x10,0x00,
0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x00,
0x46,0x4f,0x52,0x4d,0x00,0x00,0x00,0x10,
0x20,0x50,0x55,0x53,0x43,0x72,0x55,0x44,
0x00,0x00,0x00,0x04,0x00,0x00,0x00,0xf0};


main(int argc, char **argv)
{
unsigned char c, c1;
int i, j;
ULONG size;

if ((argc!=4)||(argv[1][0]=='?')) 
   {
   printf("MakeIcon version 1.1\n");
   printf("Copyright Bill Evans 1998 \n");
   printf("Usage: %ls <New Icon Picture> <Effect> <Icon Created> \n",argv[0]);
   return(20);
   }

input_file = fopen(argv[1],"rb");
if (input_file == NULL)
   {
   printf("%s :No such file found\n",argv[1]); 
   return(20);
   }

outfile = fopen(argv[3],"wb");

for (i=0;i<6;i++)
   {
   c = fgetc(input_file);
   fprintf(outfile,"%c",c);
   }

c = fgetc(input_file);
fprintf(outfile,"%c",c);

c1 = fgetc(input_file);
fprintf(outfile,"%c",c1);

size = 256*c + c1;

for (i=0;i<size;i++)
   {
   c = fgetc(input_file);
   fprintf(outfile,"%c",c);
   }

for (i=0;i<0x18;i++)
   {
   c = fgetc(input_file);
   fprintf(outfile,"%c",c);
   }

for (i=0;i<6;i++)
   {
   c = fgetc(input_file);
   fprintf(outfile,"%c",c);
   }

c = fgetc(input_file);
fprintf(outfile,"%c",c);
c1 = fgetc(input_file);
fprintf(outfile,"%c",c1);

size = 256*c + c1;

for (i=0;i<size;i++)
   {
   c = fgetc(input_file);
   fprintf(outfile,"%c",c);
   }

input_file2 = fopen(argv[2],"rb");

j = 0;
while((!feof(input_file2)) && (j==0))
   {
   c = fgetc(input_file2);
   if (c == 'P')
      {
      fgetc(input_file2);
      if (c == 'U')
         {
         fgetc(input_file2);
         if (c == 'S')
            {
            fgetc(input_file2);
            if (c == 'I')
               {
               fgetc(input_file2);
               if (c == 'L')
                  {
                  fgetc(input_file2);
                  if (c == 'B')
                     {
                     fgetc(input_file2);
                     if (c == 'M')
                        {
                        j = 1;
                        }
                     }
                  }   
               }
            }
         }
      }
   }

if (j == 1)
   {
   for (i=0;i<16;i++)
      fprintf(outfile,"%c",stuff[i]);

   while(!feof(input_file2))
      {
      c = fgetc(input_file2);
      fprintf(outfile,"%c",c);
      }
   }   

fclose(input_file);
fclose(input_file2);
fclose(outfile);
}


