 
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

struct Library *DosBase;

struct Library *FlyerBase;

FILE *bill;

WORD testbuff[256];

BPTR handle;

struct mystuff
   {
   char name[32];
   unsigned long fileblock;
   unsigned long start;
   unsigned long length;
   };

struct mystuff __far goodfiles[500];

struct mystuff __far erasedfiles[500];

unsigned long calldog(unsigned long, char *fileit);

void printall(UWORD, UWORD);

void sortgood(UWORD);

void sorterased(UWORD,UWORD);

void fixroot(UWORD);

/* 2.0 Version string for c:Version to find */
UBYTE vers[] = "\0$VER: Undelete 0.90";

ULONG  OUTFILE3;  
struct FlyerVolume FlyVol1, FlyVol2, FlyVol3;
UWORD BlkBuff[256];
UWORD ROOTBuf[256];

/* MAIN FUNCTION */

main(int argc,char **argv)
{
ULONG	res;
UWORD i,j, k, l, m,temp;
unsigned long cooldouble, cooldouble2;

if ((argc != 3) || (argv[1][0] == '?'))
   {
   printf("FlyerUndelete Version 0.90 \n");
   printf("Copyright Bill Evans 1998\n");
   printf("Incorrect arguements \n");
   printf("%s volume testvolume:filename\n",argv[0]);
   exit(0);
   }

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   exit(0);
   }

FlyVol1.Board = 0;
FlyVol1.Flags = 0;
FlyVol1.Path = argv[2];

res = MakeFlyerFile(&FlyVol1,2,&OUTFILE3);

FlyVol2.Board = 0;
FlyVol2.Flags = 0;
FlyVol2.Path = argv[1];

res = CopyData(&FlyVol2,&FlyVol1,0,1,OUTFILE3+1);

handle = Open(argv[2],MODE_OLDFILE);

if (!handle) 
   {
   printf("Did not write clip successfully\n");
   goto ending;
   }

Read(handle,BlkBuff,512);

Read(handle,ROOTBuf,512);

Close(handle);

temp = ROOTBuf[31];

j = 0;

k = 0;

m = 0;

printf("This is temp %d \n",temp);

for (i=1;i<temp;i++)
   {
   printf("This is i %d \n",i);
   res = CopyData(&FlyVol2,&FlyVol1,i,1,OUTFILE3);

   handle = Open(argv[2],MODE_OLDFILE);
   if (!handle) 
      {
      printf("Did not write clip successfully\n");
      goto ending;
      }
   
   Read(handle,BlkBuff,512);

   Close(handle);

   if ((BlkBuff[0] == 0x4649) && (BlkBuff[1] == 0x4C45))
      {
      l = 6;
      while ((BlkBuff[l] != 0) && (l<38))
         {      
         goodfiles[j].name[(l-6)*2] = BlkBuff[l]>>8;
         goodfiles[j].name[(l-6)*2+1] = BlkBuff[l]&0x00FF;
         l++;
         }

      cooldouble = BlkBuff[51];
      cooldouble2 = BlkBuff[52];
      cooldouble = cooldouble & 0x0000FFFF;
      cooldouble2 = cooldouble2 & 0x0000FFFF;
      cooldouble = (cooldouble*65536) + cooldouble2;

      cooldouble2 = calldog(cooldouble,argv[2]);

      goodfiles[j].start = cooldouble;
      goodfiles[j].length = cooldouble2;

      k = 0;
      j++;
      }

   if ((BlkBuff[0] == 0x4649) && (BlkBuff[1] == 0x4C45))
      {
      l = 6;
      while ((BlkBuff[l] != 0) && (l<38))
         {      
         goodfiles[j].name[(l-6)*2] = BlkBuff[l]>>8;
         goodfiles[j].name[(l-6)*2+1] = BlkBuff[l]&0x00FF;
         l++;
         }

      cooldouble = BlkBuff[51];
      cooldouble2 = BlkBuff[52];
      cooldouble = cooldouble & 0x0000FFFF;
      cooldouble2 = cooldouble2 & 0x0000FFFF;
      cooldouble = (cooldouble*65536) + cooldouble2;

      cooldouble2 = calldog(cooldouble,argv[2]);

      goodfiles[j].start = cooldouble;
      goodfiles[j].length = cooldouble2;

      k = 0;
      j++;
      }

   if ((BlkBuff[0] == 0) && (BlkBuff[1] == 0))
      {
      if ((BlkBuff[6] == 0) && (BlkBuff[7] == 0))
         k++;
      else
         {
         /* Its a File */
         if (BlkBuff[38] == 1)
            {
            k = 0;
            l = 6;
            while ((BlkBuff[l] != 0) && (l<38))
               {      
               erasedfiles[m].name[(l-6)*2] = BlkBuff[l]>>8;
               erasedfiles[m].name[(l-6)*2+1] = BlkBuff[l]&0x00FF;
               l++;
               }
            cooldouble = BlkBuff[51];
            cooldouble2 = BlkBuff[52];
            cooldouble = cooldouble & 0x0000FFFF;
            cooldouble2 = cooldouble2 & 0x0000FFFF;
            cooldouble = (cooldouble*65536) + cooldouble2;

            cooldouble2 = calldog(cooldouble,argv[2]);

            erasedfiles[m].start = cooldouble;
            erasedfiles[m].length = cooldouble2;
            erasedfiles[m].fileblock = i;
            m++;
            }
         else 
            /* Its a directory */
            if (BlkBuff[38] == 2)
            {
            k = 0;
            l = 6;
            while ((BlkBuff[l] != 0) && (l<38))
               {      
               erasedfiles[m].name[(l-6)*2] = BlkBuff[l]>>8;
               erasedfiles[m].name[(l-6)*2+1] = BlkBuff[l]&0x00FF;
               l++;
               }
            printf("Restored Directory: %x %s\n",i,erasedfiles[m].name);
            BlkBuff[0] = 0x4644;
            BlkBuff[1] = 0x4952;

//            fixroot(i);

            handle = Open(argv[2],MODE_OLDFILE);
            if (!handle) 
               {
               printf("Did not write clip successfully\n");
               goto ending;
               }

            Write(handle,BlkBuff,512);

            Write(handle,ROOTBuf,512);

            Close(handle);

            res = CopyData(&FlyVol1,&FlyVol2,OUTFILE3,1,i);
                      
            m++;
            }

         }
      }

   }


ending:

printall(j,m);

res = CopyData(&FlyVol1,&FlyVol2,OUTFILE3+1,1,0);

CloseLibrary(FlyerBase);

return(0);
}


/* Fixes Root to Put files Back into Play */

void fixroot(UWORD addon)
{
UWORD i;

if ((ROOTBuf[156] == 0) && (ROOTBuf[157] == 0))
   {
   ROOTBuf[156] = 0;
   ROOTBuf[157] = addon;
   i = 256;
   }
  
}

/* Copys Data to new drive */

unsigned long calldog(unsigned long auburn,char *fileit)
{
ULONG	res;
unsigned long cool1, cool2, returnval;

res = CopyData(&FlyVol2,&FlyVol1,auburn,1,OUTFILE3);

handle = Open(fileit,MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   }
   
Read(handle,BlkBuff,512);

Close(handle);

returnval = 0;

if ((BlkBuff[0] == 0x434C) && (BlkBuff[1] == 0x4950))
   {
   cool1 = BlkBuff[2];
   cool1 = cool1 & 0x0000FFFF;
   cool2 = BlkBuff[3];
   cool2 = cool2 & 0x0000FFFF;
   returnval = cool1*65536+cool2;
   }

return(returnval);
}

/* Prints Out Results and Allows Undeletion */

void printall(UWORD j,UWORD m)
{
UWORD i, temp;
ULONG res;
char myfile[100];
char myfile2[100];

printf("This is the good files \n");

sortgood(j);

for (i=0;i<j;i++)
   {
   printf("%d %s %ld %ld \n",i,goodfiles[i].name,goodfiles[i].start,goodfiles[i].length); 
   }

printf("This is the deleted files \n");

sorterased(j,m);

FlyVol3.Board = 0;
FlyVol3.Flags = 0;

printf("This is the value of m %d\n",m);

for (i=0;i<m;i++)
   {
   if (erasedfiles[i].length != 0)
      {
      
      printf("We are inside \n");

      fixroot(erasedfiles[i].fileblock);
// Fix File Ptr

// Copy File Ptr Back
      res = CopyData(&FlyVol2,&FlyVol1,erasedfiles[i].fileblock,1,OUTFILE3);

      handle = Open(FlyVol1.Path,MODE_OLDFILE);
      if (!handle) 
         {
         printf("Did not write clip successfully\n");
//         goto ending;
         }
   
      Read(handle,BlkBuff,512);

      Close(handle);

      BlkBuff[0] = 0x4649;
      BlkBuff[1] = 0x4C45;
      BlkBuff[6] = 0x5072;
      BlkBuff[7] = 0x6F77;
      BlkBuff[8] = 0x6176;
      BlkBuff[9] = 0x6555;
      BlkBuff[10] = 0x6E64;
      BlkBuff[11] = 0x656C;
      BlkBuff[12] = 0x6574;
      BlkBuff[13] = 0x6546;
      BlkBuff[14] = 0x696C;
      BlkBuff[15] = 0x6500;
      BlkBuff[16] = 0;
      BlkBuff[17] = 0;
      BlkBuff[18] = 0;
      BlkBuff[19] = 0;
      BlkBuff[20] = 0;
      BlkBuff[21] = 0; 

       handle = Open(FlyVol1.Path,MODE_OLDFILE);
       if (!handle) 
               {
               printf("Did not write clip successfully\n");
//               goto ending;
               }

            Write(handle,BlkBuff,512);

            Write(handle,ROOTBuf,512);

            Close(handle);





// Copy File Ptr Back
      res = CopyData(&FlyVol1,&FlyVol2,OUTFILE3,1,erasedfiles[i].fileblock);

// Copy Root Back
      res = CopyData(&FlyVol2,&FlyVol1,OUTFILE3+1,1,0);
      rename(FlyVol2.Path||"ProwaveUndeleteFile",FlyVol2.Path||erasedfiles[i].name);
      }
   }
}

/* Sorted Good Files */
void sortgood(UWORD count)
{
UWORD i,j,k;

ULONG one, two;

char bill[100];

for (i=0;i<count-1;i++)
   {
   for (j=0;j<count-1;j++)
      {
      if (goodfiles[j].start > goodfiles[j+1].start)
         {
         one = goodfiles[j].start;
         two = goodfiles[j].length;
         for (k=0;k<100;k++)
            bill[k] = goodfiles[j].name[k];
         goodfiles[j].start = goodfiles[j+1].start;
         goodfiles[j].length = goodfiles[j+1].length;
         for (k=0;k<100;k++)
            goodfiles[j].name[k] = goodfiles[j+1].name[k];
         goodfiles[j+1].start = one;
         goodfiles[j+1].length = two;
         for (k=0;k<100;k++)
            goodfiles[j+1].name[k] = bill[k];
         }
      }   
   }
}

/* Sort Erased Files */

void sorterased(UWORD count1, UWORD count2)
{
UWORD i,j,k;
ULONG one, two;
char bill[100];

for (i=0;i<count2;i++)
   printf("%d %s %lx %lx \n",i,erasedfiles[i].name,erasedfiles[i].start,erasedfiles[i].length); 

for (i=0;i<count2-1;i++)
   {
   for (j=0;j<count2-1;j++)
      {
      if (erasedfiles[j].start > erasedfiles[j+1].start)
         {
         one = erasedfiles[j].start;
         two = erasedfiles[j].length;
         for (k=0;k<100;k++)
            bill[k] = erasedfiles[j].name[k];
         erasedfiles[j].start = erasedfiles[j+1].start;
         erasedfiles[j].length = erasedfiles[j+1].length;
         for (k=0;k<100;k++)
            erasedfiles[j].name[k] = erasedfiles[j+1].name[k];
         erasedfiles[j+1].start = one;
         erasedfiles[j+1].length = two;
         for (k=0;k<100;k++)
            erasedfiles[j+1].name[k] = bill[k];
         }
      }   
   }



for (i=0;i<count2;i++)
   {
   printf("What is going on ??   %d %ld \n",i, erasedfiles[i].length);      
   if (erasedfiles[i].length != 0)
      {
      for (j = 0;j<count1;j++)
         {
         if (erasedfiles[i].start == goodfiles[j].start)
            erasedfiles[i].length = 0;
         }   
      }
   }
}

