
.MODULE Double_Precision_Subtract;

{
        Double-Precision Subtraction
                Z = X - Y

        Calling Parameters
                AX0 = LSW of X
                AX1 = MSW of X
                AY0 = LSW of Y
                AY1 = MSW of Y

        Return Values
                SR0 = LSW of Z
                SR1 = MSW of Z

        Altered Registers
                AR, SR

        Computation Time
                4 cycles

}

.ENTRY  dps;

dps:    AR=AX0-AY0;                            {Subtract LSWs}
        SR0=AR, AR=AX1-AY1+C-1;                {Subtract MSWs}
        SR1=AR;
        RTS;

.ENDMOD;


