.MODULE Integer_DPM;

{
        Integer Double-Precision Multiplication
                Z = X * Y

        Calling Parameters
                I0 --> Z Buffer                         L0 = 0
                M0 = 1
                MX0 = LSW of X
                MX1 = MSW of X
                MY0 = LSW of Y
                MY1 = MSW of Y
                SE = -1

        Return Values
                Z Buffer Filled

        Altered Registers
                I0, MR, SR

        Computation Time
                14 cycles

}

.ENTRY  idpm;

idpm:   MR=MX0*MY0(UU);                                 {Compute LSW}
        MR0=MR1, SR=LSHIFT MR0(LO);                     {Shift LSW right 1 bit}
        MR1=MR2, SR=SR OR LSHIFT MR1(HI);               {before saving}
        DM(I0,M0)=SR0, MR=MR+MX1*MY0(SU);
        MR=MR+MX0*MY1(US);
        MR0=MR1, SR=LSHIFT MR0(LO);
        MR1=MR2, SR=SR OR LSHIFT MR1(HI);
        DM(I0,M0)=SR0, MR=MR+MX1*MY1(SS);
        SR=LSHIFT MR0(LO);
        SR=SR OR LSHIFT MR1(HI);
        SR=SR OR LSHIFT MR2 BY 15(HI);
        DM(I0,M0)=SR0;
        DM(I0,M0)=SR1;                                 {Save MSW after shifting}
        RTS;

.ENDMOD;


