.MODULE Unsigned_SP_Divide;

{
        Unsigned Single-Precision Divide

        Calling Parameters
                AF = MSW of dividend
                AY0 = LSW of dividend
                AX0 = 16-bit divisor

        Return Values
                AY0 = 16-bit result

        Altered Registers
                AY0, AF

        Computation Time
                18 cycles

}


.ENTRY  sdivq;

sdivq:  ASTAT=0;                           {Clear AQ bit of ASTAT}
        DIVQ AX0;                          {Compute 16 quotient bits}
        DIVQ AX0; DIVQ AX0; DIVQ AX0;
        DIVQ AX0; DIVQ AX0; DIVQ AX0;
        DIVQ AX0; DIVQ AX0; DIVQ AX0;
        DIVQ AX0; DIVQ AX0; DIVQ AX0;
        DIVQ AX0; DIVQ AX0; DIVQ AX0;
        RTS;

.ENDMOD;

