.MODULE Signed_SP_Divide;

{
        Signed Single-Precision Divide

        Calling Parameters
                AF = MSW of dividend
                AY0 = LSW of dividend
                AX0 = 16-bit divisor

        Return Values
                AY0 = 16-bit result

        Altered Registers
                AY0, AF

        Computation Time
                17 cycles

}

.ENTRY  sdivs;

sdivs:  DIVS AF,AX0;    			{Compute sign bit}
        DIVQ AX0; DIVQ AX0; DIVQ AX0;   	{Compute 15 quotient bits}
        DIVQ AX0; DIVQ AX0; DIVQ AX0;
        DIVQ AX0; DIVQ AX0; DIVQ AX0;
        DIVQ AX0; DIVQ AX0; DIVQ AX0;
        DIVQ AX0; DIVQ AX0; DIVQ AX0;
        RTS;

.ENDMOD;

