
.MODULE Triple_Precision_Subtract;

{
        Triple-Precision Subtraction
                Z = X - Y

        Calling Parameters
                I0 --> X Buffer                  L0 = 0
                I1 --> Y Buffer                  L1 = 0
                I2 --> Z Buffer                  L2 = 0
                M0 = 1


        Return Values
                Z Buffer is filled

        Altered Registers
                I0, I1, I2, AR, AX0, AY0

        Computation Time
                10 cycles

}

.ENTRY  tps;

tps:    AX0=DM(I0,M0);                           {Fetch LSWs}
        AY0=DM(I1,M0);
        AX0=DM(I0,M0), AR=AX0-AY0;               {Subtract LSWs}
        AY0=DM(I1,M0);
        DM(I2,M0)=AR, AR=AX0-AY0+C-1;            {Store LSW, fetch middle words}
        AX0=DM(I0,M0);                           {Fetch MSWs}
        AY0=DM(I1,M0);
        DM(I2,M0)=AR, AR=AX0-AY0+C-1;            {Subtract MSWs}
        DM(I2,M0)=AR;                            {Store MSW}
        RTS;

.ENDMOD;

