.MODULE/ABS=4       	dit_fft_main;   
.CONST          	N=1024, N_div_2=512;    {Const. for 1024 points}
.VAR/PM/RAM/CIRC        twid_real [N_div_2];
.VAR/PM/RAM/CIRC        twid_imag [N_div_2], padding [4];
.VAR/DM/RAM/ABS=0       inplacereal [N], inplaceimag [N];
.VAR/DM/RAM/ABS=H#1000  inputreal [N], inputimag [N];
.VAR/DM/RAM             groups, bflys_per_group,
                	node_space, blk_exponent;

.INIT   twid_real: <twid_real.dat>;
.INIT   twid_imag: <twid_imag.dat>;
.INIT   inputreal: <inputreal.dat>;
.INIT   inputimag: <inputimag.dat>;
.INIT   inplaceimag: <inputimag.dat>;
.INIT   groups: N_div_2;
.INIT   bflys_per_group: 1;
.INIT   node_space: 1;
.INIT   blk_exponent: 0;
.INIT   padding: 0,0,0,0;               {Zeros after twid_imag}

.GLOBAL twid_real, twid_imag;
.GLOBAL inplacereal, inplaceimag;
.GLOBAL inputreal, inputimag;
.GLOBAL groups, bflys_per_group, node_space, blk_exponent;

.EXTERNAL       scramble, fft_strt;

        	CALL scramble;          {subroutine calls}
        	CALL fft_strt;          
        	TRAP;                   {halt program}
.ENDMOD;
