 {_______________________________________________________________________
                            M4N1024.dsp                                          

 Calling shell for the 1024_pt FFT radix_4 with the built_in digit_reverse
        Linked with:
               *F4N1024.dsp ---->FFT routine


_________________________________________________________________________}

.MODULE/RAM/boot=0/ABS=0        main;
.CONST          N=1024;                 {number of samples to be FFT'd}
.CONST          Nx2=2048;
.VAR/DM         inplace[Nx2];           {inplace array contains original input}
                                        {and also hold intermediate results}
.VAR/DM/abs=0   output[Nx2];            {output array holds results in_order}
.INIT           inplace:<input.dat>;    {load inplace array  with data}
.GLOBAL         inplace,output;
.EXTERNAL       fft;                    {the  FFT routine}



 start:         SI=0;                   {these 3 lines reset the system }
                DM(0X3FFF)=SI;          {control register and the data }
                DM(0X3FFE)=SI;          {memory control register to allow}
                                        {zero wait state memory access}
                CALL fft;
TRAPPER:        JUMP TRAPPER;                                                 
.endmod;

