 {_______________________________________________________________________
                            m4s1024.dsp                                         

 Calling shell for the 1024_pt FFT radix_4 with the unscrambling routine
        *F4N1024.dsp ---->FFT routine
        *S41024.dsp----> descrabling routine

_________________________________________________________________________}

.MODULE/RAM/boot=0/ABS=0        main;
.CONST          N=1024;
.CONST          Nx2=2048;
.VAR/DM         inplace[Nx2];           {inplace array contains original input}
                                        {and also hold intermediate results}
.INIT           inplace:<input.dat>;    {load inplace array  with data}
.GLOBAL         inplace;
.EXTERNAL       fft,drev;               {the 2 routines used to perfortm FFT}



                JUMP start;             {this code is 2100/2101 compatible}
                RTI;                    {the 2101 initial pc value is 0,}
                RTI;                    {2100, however, has pc=4 as start add.}
                RTI;
start:          SI=0;                   {these 3 lines reset the system }
                DM(0X3FFF)=SI;          {control register and the data }
                DM(0X3FFE)=SI;          {memory control register to allow}
                                        {zero state memory access}
                CALL fft;
                CALL DREV;

TRAPPER:        JUMP TRAPPER;                                                 
.endmod;

