{
                COLUMN BLOCK FLOATING POINT ADJUST ROUTINE


}
.MODULE         column_bfp_adjust;
.EXTERNAL       realdata, blk_exponent;      {Begin declaration section}
.EXTERNAL       tempdata, rcolbase, icolbase;
.CONST          buffer_size = 64;
.ENTRY  col_bfp;
                
col_bfp:        AY0=CNTR;       {Check for last stage}
                AR=AY0-1;
                IF EQ RTS;      {If last stage, return}
                AY0=-2;
                AX0=SB;
                AR=AX0-AY0;      {Check for SB=-2}
        IF EQ RTS;               {IF SB=-2, no bit growth, return}

        I0=dm(rcolbase);        {I0=read pointer}
        I1=dm(rcolbase);        {I1=write pointer}
        M1 = buffer_size;
        AY0=-1;
        MY0=H#4000;              {Set MY0 to shift 1 bit right}
        AR=AX0-AY0,MX0=DM(I0,M1);       {Check if SB=-1; Get first sample}
        IF EQ JUMP strt_shift;  	{If SB=-1, shift block data 1 bit}
        AY0=-2; 			{Set AY0 for block exponent update}
        MY0=H#2000;     		{Set MY0 to shift 2 bits right}
strt_shift:CNTR=buffer_size - 1;      		{initialize loop counter}
        DO shift_loop UNTIL CE;         {Shift block of data}
           MR=MX0*MY0(RND),MX0=DM(I0,M1);  	{MR=shifted data,MX0=next value}
shift_loop:DM(I1,M1)=MR1;          		{Unshifted data=shifted data}
        MR=MX0*MY0(RND);
        DM(I1,M1)=MR1;        	{Shift last data word}
                                          {store last shifted sample}


        I0=dm(icolbase);         {I0=read pointer}
        I1=dm(icolbase);         {I1=write pointer}
        AY0=-1;
        MY0=H#4000;              {Set MY0 to shift 1 bit right}
        AR=AX0-AY0,MX0=DM(I0,M1);       {Check if SB=-1; Get first sample}
        IF EQ JUMP shift_start;  	{If SB=-1, shift block data 1 bit}
        AY0=-2; 			{Set AY0 for block exponent update}
        MY0=H#2000;     		{Set MY0 to shift 2 bits right}
shift_start:CNTR=buffer_size - 1;      		{initialize loop counter}
        DO shft_loop UNTIL CE;         {Shift block of data}
           MR=MX0*MY0(RND),MX0=DM(I0,M1);  	{MR=shifted data,MX0=next value}
shft_loop:DM(I1,M1)=MR1;          		{Unshifted data=shifted data}
        MR=MX0*MY0(RND);        	{Shift last data word}
        AY0=DM(blk_exponent);   	{Update block exponent and}
        DM(I1,M1)=MR1,AR=AY0-AX0;       {store last shifted sample}
        DM(blk_exponent)=AR;

        RTS;
.ENDMOD;

