.MODULE			ADSP2101_Runtime_Header;

.EXTERNAL   main_, ____top_of_ram, ____top_of_stack;
.EXTERNAL   __lib_setup_heap, __lib_setup_errno, __lib_setup_exit;
.EXTERNAL   __lib_setup_interrupts_2101;

.EXTERNAL   __lib_restart_vector;

.ENTRY	     __lib_code_start;

__lib_code_start:
	   IMASK=0;			{Disable all interrupts} 
	    L0=0;L1=0;L2=0;L3=0;	{All length registers }
	    L4=0;L5=0;L6=0;L7=0;	{ should be set to 0}
	    M0=0;M1=1;M2=0;M3=-1;	{Modify registers set }
	         M5=1;M6=0;M7=-1;	{ to various constants}
	    M4=^____top_of_stack;	{Frame pointer = top of stack}
	    I4=^____top_of_stack;	{Stack pointer = top of stack}
	    CALL __lib_setup_heap;
	    CALL __lib_setup_interrupts_2101;
	    CALL __lib_setup_errno;
	    CALL __lib_setup_exit;	
	    CALL main_;			{Begin C program}
__lib_code_hang:
	    JUMP __lib_code_hang;

.ENDMOD;
