
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <proto/dos.h>

#include "flyerlib.h"
#include "flyer.h"
#include "flyerClipFmt.h"

struct Library *FlyerBase;
struct FlyerVolume FlyVol;

WORD testbuff[256];

main(int argc,char **argv)
{
ULONG	res;
ULONG  OUTFILE;
ULONG count;
BPTR handle;
UWORD i;

if ((argc!=3)||(argv[1][0]=='?')) 
   {
   printf("FlyerFile Version 1.1\n");
   printf("Copyright Prowave 1997\n");
   printf("Usage: %ls <Filename> <size> \n",argv[0]);
   return(20);
   }

count = atoi(argv[2]);

printf("1 %s %d \n",argv[1],count);

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return;
   }

FlyVol.Board = 0;
FlyVol.Flags = 0;
FlyVol.Path = argv[1];

res = MakeFlyerFile(&FlyVol,count,&OUTFILE);

handle = Open(argv[1],MODE_OLDFILE);
if (!handle) 
   {
   printf("Did not write clip successfully\n");
   return(20);
   } 

for (i=0;i<256;i++)
   testbuff[i] = 0;

for (i=0;i<25;i++)
   {
   Write(handle,&testbuff,512); 
   }

Close(handle); 

CloseLibrary(FlyerBase);

return(0);
}

