	LIBINIT		; start of public function vectors of ToasterBase

*	FastGadget related functions.

	LIBDEF	_LVODrawFastGList
* void DrawFastGList( Count, Offset, FastGadget, Window, Req );
*                      D0     D1      A0          A1      A2

	LIBDEF	_LVOCompFastGList
* void CompFastGList( Count, Offset, FastGadget, Window, Req );
*                      D0     D1      A0          A1      A2

	LIBDEF	_LVOClearFastGList
* void ClearFastGList( Count, Offset, FastGadget, Window, Req );
*                       D0     D1      A0          A1      A2

	LIBDEF	_LVOSaveFastGList
* void SaveFastGList( Count, Offset, FastGadget, Window, Req, Buffer );
*                      D0     D1      A0          A1      A2   A3

	LIBDEF	_LVOLoadFastGList
* void LoadFastGList( Count, Offset, FastGadget, Window, Req, Buffer );
*                      D0     D1      A0          A1      A2   A3

	LIBDEF	_LVODigitFastG
* void DigitFastG( X, Y, DigitIndex, ImageTableIndex, FastGadget );
*                  D0 D1  D2          D3               A0

	LIBDEF	_LVOCompBoolSelect
* LONG CompBoolSelect( FastGadget, Window, Req );
*  D0                   A0          A1      A2

	LIBDEF	_LVOImageBoolSelect
* LONG ImageBoolSelect( FalseIndex, TrueIndex, FastGadget, Window, Req );
*  D0                    D0          D1         A0          A1      A2

	LIBDEF	_LVOHiLiteBoolSelect
* LONG HiLiteBoolSelect( FastGadget, Window, Req );
*  D0                     A0          A1      A2

	LIBDEF	_LVOMouseFastGList
* LONG MouseFastGList( Count, MouseX, MouseY, FastGadget, Req );
*  D0                   D0     D1      D2      A0          A1

	LIBDEF	_LVOLoadFastG
* LONG LoadFastG( FastGadgetStringName );
*  D0              A0

	LIBDEF	_LVOUnLoadFastG
* void UnLoadFastG( FastGadget );
*                    A0

	LIBDEF	_LVOAddFastGList
* LONG AddFastGList( Count, Position, FastGadgetSrc, FastGadgetDestBase );
*  D0                 D0     D1        A0             A1

	LIBDEF	_LVORemoveFastGList
* LONG RemoveFastGList( Count, FastGadgetSrc, FastGadgetDestBase );
*  D0                    D0     A0             A1

	LIBDEF	_LVOIndexFastG
* LONG IndexFastG( Index, FastGadgetListBase );
*  D0               D0     A0

	LIBDEF	_LVOIndexIDFastG
* LONG IndexIDFastG( IndexID, FastGadgetListBase );
*  D0                 D0       A0

	LIBDEF	_LVOAddressFastG
* LONG AddressFastG( FastGadget, FastGadgetListBase );
*  D0                 A0          A1

	LIBDEF	_LVOPutNewLocTB
* LONG PutNewLocTB( TBFastGadget );
*  D0                A0

	LIBDEF	_LVOInsertTB
* LONG InsertTB( IndexID );
*  D0             D0

	LIBDEF	_LVODeleteTB
* LONG DeleteTB( IndexID );
*  D0             D0

	LIBDEF	_LVOReadProjEntry
* LONG ReadProjEntry( FileHandle );
*  D0                  A0

	LIBDEF	_LVOWriteProjEntry
* LONG WriteProjEntry( FileHandle, TBFastGadget );
*  D0                   A0          A1

	LIBDEF	_LVOReadProject
* LONG ReadProject( ProjectNum );
*  D0                D0

	LIBDEF	_LVOReadDefaultProject
* LONG ReadDefaultProject();
*  D0

	LIBDEF	_LVOWriteProject
* LONG WriteProject( ProjectNum, CommentSTR );
*  D0                 D0          A0

	LIBDEF	_LVOReadCurrentProject
* LONG ReadCurrentProject();
*  D0

	LIBDEF	_LVOWriteCurrentProject
* LONG WriteCurrentProject( ProjectNum );
*  D0                        D0

	LIBDEF	_LVOInitFileBuffering
* void InitFileBuffering( Input, Output );
*                          A0     A1

	LIBDEF	_LVOBuffInput
* LONG BuffInput();
*  D0

	LIBDEF	_LVOBuffOutput
* LONG BuffOutput();
*  D0

	LIBDEF	_LVOBuffGetChar
* LONG BuffGetChar();
*  D0

	LIBDEF	_LVOBuffPutChar
* LONG BuffPutChar( Char );
*  D0                D0

	LIBDEF	_LVOBuffRead
* LONG BuffRead( Count, Buffer );
*  D0             D0     A0

	LIBDEF	_LVOBuffWrite
* LONG BuffWrite( Count, Buffer );
*  D0              D0     A0

	LIBDEF	_LVOUnLoadToolBox
* void UnLoadToolBox();

	LIBDEF	_LVORemoveTBFG
* void RemoveTBFG( TBFG);
*                   A0

	LIBDEF	_LVOPlaceTBFG
* void PlaceTBFG( TBFastGadget );
*                  A0

	LIBDEF	_LVORefreshFCString
* void RefreshFCString( FCFastGadget );
*                        A0

	LIBDEF	_LVOActivateFCString
* void ActivateFCString( FCFastGadget );
*                         A0

	LIBDEF	_LVOUpDateFC
* void UpDateFC():

*	SoftSprite related functions.

	LIBDEF	_LVOSoftSpriteOn
* void SoftSpriteOn();

	LIBDEF	_LVOSoftSpriteOff
* void SoftSpriteOff();

	LIBDEF	_LVOSoftSpriteBPLCON0On
* void SoftSpriteBPLCON0On();

	LIBDEF	_LVOSoftSpriteBPLCON0Off
* void SoftSpriteBPLCON0Off();

	LIBDEF	_LVOSoftSpriteAudioOn
* void SoftSpriteAudioOn();

	LIBDEF	_LVOSoftSpriteAudioOff
* void SoftSpriteAudioOff();

	LIBDEF	_LVOSoftSpriteVSynch
* void SoftSpriteVSynch( VBeamPos );
*                         D0

	LIBDEF	_LVOOpenSoftSprite
* LONG OpenSoftSprite( VBeamPos );
*  D0                   D0

	LIBDEF	_LVOCloseSoftSprite
* void SoftSpriteClose();

	LIBDEF	_LVOMoveSoftSpriteABS
* void MoveSoftSpriteABS( XCoord, YCoord );
*                          D0      D1

	LIBDEF	_LVOMoveSoftSpriteREL
* void MoveSoftSpriteREL( XOffset, YOffset );
*                          D0       D1

*	Miscellaneous and special interest related functions.

	IFD	NEEDED

	LIBDEF	_LVOSlope
* LONG Slope( DeltaX, DeltaY );
*  D0          D0      D1

	LIBDEF	_LVOSine
* LONG Sine( Position );
*  D0         D0

	ENDC

	LIBDEF	_LVOSelectButtonState
* void SelectButtonState();

	LIBDEF	_LVODeltaYMouse
* DeltaYResult NewYMouse DeltaYMouse( OldYMouse );
*  D0           D1                     D1

	LIBDEF	_LVODeltaXMouse
* DeltaXResult NewXMouse DeltaXMouse( OldXMouse );
*  D0           D1                     D1

	LIBDEF	_LVOMaskToIndex
* WORD MaskToIndex( Mask );
*  D0                D0

	LIBDEF	_LVOIndexToMask
* WORD IndexToMask( Index );
*  D0                D0

	LIBDEF	_LVOReDoDisplay
* void ReDoDisplay();

	LIBDEF	_LVOUpdateDisplay
* void UpdateDisplay();

	LIBDEF	_LVOClearToastDisplay
* void ClearToastDisplay();

	LIBDEF	_LVOClearToolBoxArea
* void ClearToolBoxArea();

	LIBDEF	_LVODiskDeviceList
* void DiskDeviceList( Container );
*                       A0

	LIBDEF	_LVOReValidate
* void ReValidate( Mask );
*                   D0

;;;;	LIBDEF	_LVODisplayMessageAndWait		; Addendum 4/26/90:
;;;;* void DisplayMessageAndWait( Message1, Message2 );	; - removed
;;;;*                              A0        A1

	LIBDEF	_LVOSwitcherAutoRequest
* LONG SwitcherAutoRequest( ControlFlag, ArrayPointer );
*  D0                        D0           A0

	LIBDEF	_LVODoSwitcherRequester
* LONG DoSwitcherRequester
*  D0  ( OKIDCMP, CancelIDCMP, Msg1, Msg2, OKMsg, CancelMsg );
*         D0       D1           A0    A1    A2     A3

	LIBDEF	_LVOEnableKeyRepeat
* void EnableKeyRepeat();

	LIBDEF	_LVODisableKeyRepeat
* void DisableKeyRepeat();

	LIBDEF	_LVOAutoRequestEnable
* void AutoRequestEnable();

	LIBDEF	_LVOAutoRequestDisable
* void AutoRequestDisable();

	LIBDEF	_LVOFloppyDiskInfo
* void FloppyDiskInfo();

	LIBDEF	_LVOFloppyDiskFormat
* LONG FloppyDiskFormat( Unit, ShowFlag, Name );
*  D0                     D0    D1        A0

	LIBDEF	_LVOFloppyInOut
* void FloppyInOut();

	LIBDEF	_LVOFloppyDiskTest
* LONG FloppyDiskTest():
*  D0

	LIBDEF	_LVORemFloppyDiskPort
* void RemFloppyDiskPort():

	LIBDEF	_LVOFloppyDiskChange
* LONG FloppyDiskChange():
*  D0

	LIBDEF	_LVOFloppyDiskQuery
* LONG FloppyDiskQuery():
*  D0

;;	LIBDEF	_LVOFindFileEntity
;;* LONG FindFileEntity( Value, Type, Count, DevPath, Container );
;;*  D0                   D0     D1    D2     A0       A1

	LIBDEF	_LVOBuildFileName
* LONG BuildFileName( Value, Type, Comment, Container );
*  D0                  D0     D1    A0       A1

	LIBDEF	_LVOBuildFSTable
* LONG BuildFSTable();
*  D0

	LIBDEF	_LVOBuildProjectTable
* LONG BuildProjectTable();
*  D0

	LIBDEF	_LVOLockEffects
* LONG LockEffects( Mode );
*  D0                D0

	LIBDEF	_LVOLockFS
* LONG LockFS();
*  D0

	LIBDEF	_LVOLockProject
* LONG LockProject();
*  D0

	LIBDEF	_LVOLockAuxLibs
* LONG LockAuxLibs();
*  D0

	LIBDEF	_LVOLockToasterFonts
* LONG LockToasterFonts( Mode );
*  D0                     D0

	LIBDEF	_LVOClearIDCMP
* void ClearIDCMP( IDCMPMsgPort );
*                   A0

	LIBDEF	_LVOSetLibVector
* LONG SetLibVector( Offset, Library, NewVector );
*  D0                 D0      A0       A1

*	String support.

	LIBDEF	_LVOIsaDigit
* LONG IsaDigit( Char );
*  D0             D0

	LIBDEF	_LVOToUpperCase
* LONG ToUpperCase( Char );
*  D0                D0

	LIBDEF	_LVOSTRcopy
* LONG STRcopy( STR1, STR2 );
*  D0            A0    A1

	LIBDEF	_LVOSTRNcopy
* LONG STRNcopy( Count, STR1, STR2 );
*  D0             D0     A0    A1

	LIBDEF	_LVOBSTRcmp
* LONG BSTRcmp( BSTR1, BSTR2 );
*  D0            A0     A1

	LIBDEF	_LVOSTRcmp
* LONG STRcmp( STR1, STR2 );
*  D0           A0    A1

	LIBDEF	_LVOSTRlen
* LONG STRlen( STR );
*  D0           A0

	LIBDEF	_LVOByteSubSet
* LONG ByteSubSet( Count, ByteSeq1, ByteSeq2 );
*  D0               D0     A0        A1

*	ToolBox FastGadget (croutons) support functions.

	LIBDEF	_LVOToolBoxFill
* void ToolBoxFill( TBFGListBase );
*                    A0

	LIBDEF	_LVODrawBorderBox
* void DrawBorderBox( X1, Y1, Width, Height );
*                     D0  D1   D2     D3

	LIBDEF	_LVODoHiLiteSelect
* LONG DoHiLiteSelect( FastGadget );
*  D0                   A0

	LIBDEF	_LVODoHiLiteSelectK
* LONG DoHiLiteSelectK( FastGadget );
*  D0                    A0

	LIBDEF	_LVODoHiLiteSelectQ
* LONG DoHiLiteSelectQ( FastGadget );
*  D0                    A0

	LIBDEF	_LVODoHiLiteRemove
* void DoHiLiteRemove( FastGadget );
*                       A0

	LIBDEF	_LVODoHiLiteRemoveQ
* void DoHiLiteRemoveQ( FastGadget );
*                        A0

	LIBDEF	_LVODoTBar
* LONG DoTBar( Handler );
*  D0           A0

	LIBDEF	_LVOCookAndServeOLay
	LIBDEF	_LVOCookAndServeMain
	LIBDEF	_LVOCookAndServePrvw
	LIBDEF	_LVOCookAndServeClipA
	LIBDEF	_LVOCookAndServeKeyButton
	LIBDEF	_LVOCookAndServeTake
	LIBDEF	_LVOCookAndServeFreeze

	LIBDEF	_LVOCookOLay
	LIBDEF	_LVOCookMain
	LIBDEF	_LVOCookPrvw
	LIBDEF	_LVOCookClipA
	LIBDEF	_LVOCookKeyButton
	LIBDEF	_LVOCookTake
	LIBDEF	_LVOCookFreeze

*	Internal library list handling functions.

	LIBDEF	_LVOOpenAuxLib
* LONG OpenAuxLib( LibraryName );
*  D0               A0

	LIBDEF	_LVOCloseAuxLib
* void CloseAuxLib( Library );
*                    A0

	LIBDEF	_LVORemoveAuxLib
* LONG RemoveAuxLib( Library );
*  D0                 A0

* SKELLS FUNCTIONS  ***********************************

;;	LIBDEF	_LVOInitSAWrite	
;;	LIBDEF	_LVOSetUpSAWrite
 	LIBDEF	_LVOInitDVECopList1
	LIBDEF	_LVOSetUpDVECopList1
	LIBDEF	_LVOInitDVEInterface1
	LIBDEF	_LVOSetUpDVEInterface1
	LIBDEF	_LVOInitToaster		;used by old InstallToaster
	LIBDEF	_LVOInitBytes2BmLUT
	LIBDEF	_LVODoLineWrite		
	LIBDEF	_LVOInitDVESprite1Buff
	LIBDEF	_LVOInitDVEBitMapBuff
;;	LIBDEF	_LVOHorizEdges2CompBmList


	 IFD	DYNAMICSPRITES
	LIBDEF	_LVOInitSprite0Live
	LIBDEF	_LVOInitSprite0Freeze
	LIBDEF	_LVOInitSprite1Linear
	LIBDEF	_LVOInitSprite0
	LIBDEF	_LVOInitSprite1
	LIBDEF	_LVOInitSpriteNull
	 ENDC	;DYNAMICSPRITES

 
	LIBDEF	_LVOBytes2Sprite1
	LIBDEF	_LVOFillSprite
	LIBDEF	_LVOCopySprite2Sprite
	LIBDEF	_LVOELH2Sprite0
	LIBDEF	_LVOELH2Sprite1
	LIBDEF	_LVOBytes2BitMaps
	LIBDEF	_LVOWait4Top
	LIBDEF	_LVOInstallField
	LIBDEF	_LVOInstallFieldAndWait
	LIBDEF	_LVOInstallFieldIorIII
	LIBDEF	_LVORestoreCopperList
	LIBDEF	_LVOSendELH2Toaster
	LIBDEF	_LVOGetFileLength
	LIBDEF	_LVOReadFile
	LIBDEF	_LVOInterruptsOff
	LIBDEF	_LVOInterruptsOn
	LIBDEF	_LVODMAoff
	LIBDEF	_LVODMAon
	LIBDEF	_LVOMemoryMapCopLists
	LIBDEF	_LVOMemoryMapPlanes
	LIBDEF	_LVOInitAVECopLists
	LIBDEF	_LVOInitAVEInterfaces
	LIBDEF	_LVOSetUpEntrySprites
	LIBDEF	_LVOSendSprites2Toaster
	LIBDEF	_LVOGetEPhase
	LIBDEF	_LVOSyncCPU2Video
	LIBDEF	_LVOGrabField
	LIBDEF	_LVOInitReadCopList
	LIBDEF	_LVOGrabbed2Planes
	LIBDEF	_LVOInstallFieldI
	LIBDEF	_LVOReinstallCurrentCopList
	LIBDEF	_LVOInitFieldWrite
	LIBDEF	_LVOSetUpFieldWrite
	LIBDEF	_LVOSetUpAVECopList
	LIBDEF	_LVOSetUpAVEInterface
	LIBDEF	_LVOFreezeThawDVE
	LIBDEF	_LVOInstallAVE
	LIBDEF	_LVOInstallAVEI
	LIBDEF	_LVOInitEFX
	LIBDEF	_LVOInitEFXChipMem
	LIBDEF	_LVOInitDVEFastMem
	LIBDEF	_LVOInitDVEChipMem
	LIBDEF	_LVOELH2Sprites

	LIBDEF	_LVOMask2AM
	LIBDEF	_LVOMask2BM
	LIBDEF	_LVOMask2IS
	LIBDEF	_LVOMask2PV
	LIBDEF	_LVOMask2LK

	LIBDEF	_LVOAM2Mask
	LIBDEF	_LVOBM2Mask
	LIBDEF	_LVOIS2Mask
	LIBDEF	_LVOPV2Mask
	LIBDEF	_LVOLK2Mask

	LIBDEF	_LVOSetUpELHEntrySprites

;;	LIBDEF	_LVOTransSwitcherABFreeze
;;	LIBDEF	_LVOTransSwitcherABTake
;;	LIBDEF	_LVOTransSwitcherABDuring
;;	LIBDEF	_LVOTransSwitcherABInit

;;	LIBDEF	_LVOTransDVEOnABInit
;;	LIBDEF	_LVOTransDVEOffABInit
;;	LIBDEF	_LVOTransDVEOnABTake
;;	LIBDEF	_LVOTransDVEOffABTake
;;	LIBDEF	_LVOTransDVEABDuring
;;	LIBDEF	_LVOTransDVEABFreeze

;;	LIBDEF	_LVOTransSwitcherABUnTake
;;	LIBDEF	_LVOTransDVEOnABUnTake
;;	LIBDEF	_LVOTransDVEOffABUnTake

	LIBDEF	_LVOUpdateTBar
	LIBDEF	_LVOShortOutFader

	LIBDEF	_LVOProcessLoadButton
	LIBDEF	_LVOProcessSaveButton

	LIBDEF	_LVOInstallAVEIdoELH
	LIBDEF	_LVOInstallAVEdoELH
	LIBDEF	_LVOInitWipeInterface1
	LIBDEF	_LVOSetUpWipeInterface1
	LIBDEF	_LVOInstallFieldIthruIV
	LIBDEF	_LVOELHList2Sprites
	LIBDEF	_LVOSendELHList2Toaster
	LIBDEF	_LVOSetSaveBank
	LIBDEF	_LVOSetLoadBank
	LIBDEF	_LVODoBlockWrite
	LIBDEF	_LVODoFieldWrite
	LIBDEF	_LVOBytes2Planes
	LIBDEF	_LVOWriteYIQBlock

 	LIBDEF	_LVOInitDVECopList2
	LIBDEF	_LVOSetUpDVECopList2
	LIBDEF	_LVOBytes2BitMapsDVE2

	LIBDEF	_LVODoTake
	LIBDEF	_LVOGray2Bank

	LIBDEF	_LVOReadCIAA_TOD
	LIBDEF	_LVOResetFrameBase
	LIBDEF	_LVOGetFrameBase
	LIBDEF	_LVOWaitFrameCount

	LIBDEF	_LVOEnableInput
	LIBDEF	_LVODisableInput

	LIBDEF	_LVOInitSafeWrite
	LIBDEF	_LVOOldDoSafeWrite
	LIBDEF	_LVOInitSimpleBMCopLists
	LIBDEF	_LVOSetUpSimpleBMCopList
	LIBDEF	_LVOInitReadScanLineBMs
	LIBDEF	_LVOReadScanLine

	LIBDEF	_LVOTestReadScanLine
	LIBDEF	_LVOCaliReadScanLine
	LIBDEF	_LVOAutoCalibrate
	LIBDEF	_LVOSetDigitalPhase	;was _LVOSetDAHue
	LIBDEF	_LVOSetPedestal
	LIBDEF	_LVOSetGain
	LIBDEF	_LVOGrab1Bank
	LIBDEF	_LVOWriteGrayPulse
	LIBDEF	_LVONoTransFreeze
	LIBDEF	_LVOTestAutoCal
	LIBDEF	_LVOSendBytes2Toaster

	LIBDEF	_LVOAllInterruptsOn
	LIBDEF	_LVOAllInterruptsOff

	LIBDEF	_LVOReadHardSets
	LIBDEF	_LVOWriteHardSets
	LIBDEF	_LVOLoadHardSets
	LIBDEF	_LVOSaveHardSets

	LIBDEF	_LVORestoreBorderColor

	LIBDEF	_LVOReDoAllButtonRows

	LIBDEF	_LVOMouseOn
	LIBDEF	_LVOMouseOff

	LIBDEF	_LVOFlashVideoOn
	LIBDEF	_LVOFlashVideoOff

	LIBDEF	_LVOWriteLineZero

	LIBDEF	_LVORestoreMatteColor	;was RestoreMattColor

	LIBDEF	_LVOCancelCG
	LIBDEF	_LVOUpdateClipA

	LIBDEF	_LVOFrameSave
	LIBDEF	_LVOFrameLoad

	LIBDEF	_LVOSMPTEbars

	LIBDEF	_LVOForceSoftSpriteOn

	LIBDEF	_LVOULongMultiply
	LIBDEF	_LVOCreateInterrupt
	LIBDEF	_LVODeleteInterrupt

	LIBDEF	_LVOULongDivide

	LIBDEF	_LVOGetFrameFreeCount

	LIBDEF	_LVOStringToUpper

	LIBDEF	_LVOInitRGB2YIQ
	LIBDEF	_LVORGB2YIQ
	LIBDEF	_LVOInitYIQ2Composite
	LIBDEF	_LVOYIQ2Composite
	LIBDEF	_LVODitherYIQ
	LIBDEF	_LVOSendRGBInit
	LIBDEF	_LVOSendRGBBeginRegion
	LIBDEF	_LVOSendRGBAddLine
	LIBDEF	_LVOSendRGBRegion
	LIBDEF	_LVOSendRGBCleanup

	LIBDEF	_LVOImageryOn
	LIBDEF	_LVOImageryOff

	LIBDEF	_LVOTestVid1Camera
	LIBDEF	_LVOTestMain2Vid4
	LIBDEF	_LVOAutoTerm
	LIBDEF	_LVOAutoHue
	LIBDEF	_LVOInitRead7QuadsBMs
	LIBDEF	_LVOSetExternalPhase
	LIBDEF	_LVOReadScatter
	LIBDEF	_LVOScatter2IQs
	LIBDEF	_LVOSquareRootUWORD
	LIBDEF	_LVOSquareRootULONG
	LIBDEF	_LVODeltaPhase

	LIBDEF	_LVOSendOutputGPI
	LIBDEF	_LVONewSwitcherRequester

	LIBDEF	_LVODisplayNormalSprite
	LIBDEF	_LVODisplayWaitSprite
	LIBDEF	_LVOGetDisplaySprite

	LIBDEF	_LVOTest68000Grab

	LIBDEF	_LVOOpenCommonRGB
	LIBDEF	_LVOCloseCommonRGB
	LIBDEF	_LVOKillCommonRGB
	LIBDEF	_LVOUnlockCommonRGB
	LIBDEF	_LVOLockCommonRGB

	LIBDEF	_LVOQueryFile
	LIBDEF	_LVOCloseQuery
	LIBDEF	_LVOLoadRGBPicture
	LIBDEF	_LVOSaveRGBPicture

	LIBDEF	_LVOSendRGBPicture

	LIBDEF	_LVOInstallAVEC
	LIBDEF	_LVOInstallAVECdoELH

	LIBDEF	_LVOSetBackGround

	LIBDEF	_LVORoundSigned
	LIBDEF	_LVORoundUnsigned
	LIBDEF	_LVOSingleRGB2YIQ
	LIBDEF	_LVOSendRGBAddComposite
	LIBDEF	_LVOByteFillMemory

	LIBDEF	_LVOStartSaveRGBPicture
	LIBDEF	_LVOStopSaveRGBPicture
	LIBDEF	_LVOAddRGBLine

	LIBDEF	_LVOAnimWipeCroutonEffect
	LIBDEF	_LVOAnimLoad
	LIBDEF	_LVOAnimUnload
	LIBDEF	_LVOAnimSetupForward
	LIBDEF	_LVOAnimPlayForward
	LIBDEF	_LVOAnimPlayReverse

	LIBDEF	_LVOStartLoadRGBPicture
	LIBDEF	_LVOStopLoadRGBPicture
	LIBDEF	_LVOLoadRGBLine
	LIBDEF	_LVOGrabRGBField

	LIBDEF	_LVOWritePlanes
	LIBDEF	_LVOWritePlanesBW
	LIBDEF	_LVOBumpLineCount
	LIBDEF	_LVOFindDebugHunk
	LIBDEF	_LVOGetChunkType

	LIBDEF	_LVODoSafeWrite
	LIBDEF	_LVOWait4Copper

	LIBDEF	_LVOSetUp2FI
	LIBDEF	_LVOInit2FI
	LIBDEF	_LVOInstall2FIdoELH
	LIBDEF	_LVOInstall2FI
	LIBDEF	_LVOInstallFieldIorII
	LIBDEF	_LVOInstallIKey
	LIBDEF	_LVOInstallIKeyDoELH

	LIBDEF	_LVOWait4Blit
	LIBDEF	_LVOAutoMatte

	LIBDEF	_LVOLUToff
	LIBDEF	_LVOAttachSprite0
	LIBDEF	_LVOAttachSprite1
	LIBDEF	_LVOAttachSprites
	LIBDEF	_LVOVBServer1

	LIBDEF	_LVOPadFile
	LIBDEF	_LVOPadFileL
	LIBDEF	_LVOCopyFileBytes

	LIBDEF	_LVOLoadSegment			;LoadSegment(filename)
	LIBDEF	_LVONLoadSegment		;NLoadSegment(filename,buffersize)
	LIBDEF	_LVOUnLoadSegment		;UnLoadSegment(segmentlist)


	LIBDEF	_LVOWriteBMLineBW
	LIBDEF	_LVOWriteBMLine
	LIBDEF	_LVOWriteLine

	LIBDEF	_LVOSetSaveYPosition
	LIBDEF	_LVOLockToasterELH

	LIBDEF	_LVODrawTriMark

	LIBDEF	_LVOLoadPictureData
	LIBDEF	_LVOFreeIFF24OrFS
	LIBDEF	_LVOLoadIFF24OrFS	; CommonRGB.a
	LIBDEF	_LVOAllocateBufferMem	; size,att

	LIBDEF	_LVOFrameLoadNew

	LIBDEF	_LVOOpenKbdState
	LIBDEF	_LVOCloseKbdState
	LIBDEF	_LVOGetKbdState	

	LIBDEF	_LVODoMouseXY
	LIBDEF	_LVOProgramChips
	LIBDEF	_LVOLoadPatches
	LIBDEF	_LVOSetPedestalCrude
	LIBDEF	_LVOSetGainCrude
	LIBDEF	_LVOAllocPlanes
	LIBDEF	_LVOFreePlanes
	LIBDEF	_LVOFieldSave
	LIBDEF	_LVONewProcessSaveButton

	LIBDEF	_LVOSendBytes2ToasterAVEI
	LIBDEF	_LVOWriteYIQBlockAVEI
	LIBDEF	_LVODoBlockWriteAVEI
	LIBDEF	_LVORestoreBorderAVEI

	LIBDEF	_LVODoTakeNoKey

	LIBDEF	_LVOFileCopy
	LIBDEF	_LVOCancelNonStdEfx
	LIBDEF	_LVOSelectStdEfx

	LIBDEF	_LVODisableInterrupts
	LIBDEF	_LVOEnableInterrupts

	LIBDEF	_LVOInitReadScanLine
	LIBDEF	_LVODoSyncWrite
	LIBDEF	_LVOSoft2HardColor
	
	LIBDEF	_LVOInstallToaster	;new sync write
	LIBDEF	_LVOInitToaster2	;used by new sync write
	LIBDEF	_LVOTestMain2EXT
	LIBDEF	_LVOTestRGBTermination
	LIBDEF	_LVOSoftSpriteOnScreen
	LIBDEF	_LVOSoftSpriteAudioOnScreen

	LIBDEF	_LVOSetupSSBM
	LIBDEF	_LVOInstallSBMdoELHlistNoWait
	LIBDEF	_LVOInstallSBMdoELHnoWait
	LIBDEF	_LVOInstallSBMnoWait
	LIBDEF	_LVOInstallSBMdoELHlist
	LIBDEF	_LVOInstallSBMdoELH
	LIBDEF	_LVOInstallSBM
	LIBDEF	_LVOInstallAVEIdoELHlist
	LIBDEF	_LVOInstallAVECdoELHlist
	LIBDEF	_LVOInstallAVEdoELHlist

	LIBDEF	_LVOPlayAnim
	LIBDEF	_LVOFreeAnim
	LIBDEF	_LVOLoadAnim

	LIBDEF	_LVOSendRGBExtInit
	LIBDEF	_LVODrawCroutonImage
	LIBDEF	_LVOCompCroutonImage
	LIBDEF	_LVOSendRGBExtBeginRegion

	LIBDEF	_LVOBufferedClose	;was _LVOBufferClose
	LIBDEF	_LVOBufferedWrite	;was _LVOBufferWrite
	LIBDEF	_LVOBufferedRead	;was _LVOBufferRead	
	LIBDEF	_LVOBufferedOpen	;was _LVOBufferOpen  

	LIBDEF	_LVOSetupSBMCopListAA

	LIBDEF	_LVOStartHamAnimSave
	LIBDEF	_LVOStopHamAnimSave
	LIBDEF	_LVOAddHamAnimFrame
	LIBDEF	_LVOGetPalette
	LIBDEF	_LVOPrepareHam
	LIBDEF	_LVOEncodeHam

	LIBDEF	_LVOGetFileLoadName
	LIBDEF	_LVOGetFileSaveName

	LIBDEF	_LVOInitFXAudioChannels
	LIBDEF	_LVOFreeFXAudioChannels
	LIBDEF	_LVOLoadFXAudio
	LIBDEF	_LVOFreeFXAudio
	LIBDEF	_LVOPlayFXAudio
	LIBDEF	_LVOAbortFXAudio

	LIBDEF	_LVODrawBorderBoxRP

	LIBDEF	_LVOAnimFXHandler

	LIBDEF	_LVOLockAnimPalette

	LIBDEF	_LVOForceDoTBar2Top
	LIBDEF	_LVOSetupAndInstallSSBM
	LIBDEF	_LVODVElutoff

	LIBDEF	_LVOUpdateSoundImage

	LIBDEF	_LVOSomeInterruptsOff
	LIBDEF	_LVOSomeInterruptsOn

	LIBDEF	_LVOWindowDoPopList

	LIBDEF	_LVOGetMouseXY	;SetFunctionable!
	LIBDEF	_LVOIsLMBdown	;SetFunctionable!
	LIBDEF	_LVOIsRMBdown	;SetFunctionable!

	LIBDEF	_LVOIsLMBup
	LIBDEF	_LVOIsRMBup

	LIBDEF	_LVOWait4LMBup
	LIBDEF	_LVOWait4LMBdown
	LIBDEF	_LVOWait4RMBup
	LIBDEF	_LVOWait4RMBdown	

	LIBDEF	_LVOInstallAVEnoWait
	LIBDEF	_LVOInstallAVECnoWait

	LIBDEF	_LVOLoadAnimHeader
	LIBDEF	_LVOStuffFCount

	LIBDEF	_LVOFGC_PutValueCommand
	LIBDEF	_LVOFGC_GetValueCommand
	LIBDEF	_LVOFGC_LoadTagsCommand
	LIBDEF	_LVOFGC_SaveTagsCommand
		
	LIBDEF	_LVOPutStructValue
	LIBDEF	_LVOGetStructValue
	LIBDEF	_LVOPutLongValue
	LIBDEF	_LVOGetLongValue

	LIBDEF	_LVOSearchLists4TagID
	LIBDEF	_LVOSearch4TagID
	LIBDEF	_LVOMoveTag2Value
	LIBDEF	_LVOMoveValue2Tag
		
	LIBDEF	_LVOFGC_NextCommand
	LIBDEF	_LVOFGC_ToPrvwCommand
	LIBDEF	_LVOFGC_ToMainCommand

	LIBDEF	_LVOBufferedSeek	;was _LVOBufferSeek

	LIBDEF	_LVOSearchLists4TagGetID
	LIBDEF	_LVOSearch4TagGetID
	LIBDEF	_LVOSearchLists4TagPutID
	LIBDEF	_LVOSearch4TagPutID
	LIBDEF	_LVOSearchFG4Struct

	LIBDEF	_LVOAlgoFXHandler
	LIBDEF	_LVOGetTagValue

	LIBDEF	_LVOReadBufferedByte
	LIBDEF	_LVOReadBufferedWord
	LIBDEF	_LVOReadBufferedLong

	LIBDEF	_LVOSeek2CrUDchunk
	LIBDEF	_LVOCloseCroutonFile
	LIBDEF	_LVOOpenCroutonFile

	LIBDEF	_LVOExamineCroutonIconFile
	LIBDEF	_LVOExamineCroutonDataFile
	LIBDEF	_LVOExamineCroutonDefaults

	LIBDEF	_LVOAllocIconBM
	LIBDEF	_LVOFreeIconBM

	LIBDEF	_LVOFGC_LoadCommand
	LIBDEF	_LVOFGC_RemoveCommand
	LIBDEF	_LVOFGC_AutoCommand
	LIBDEF	_LVOFGC_RemoveQCommand
	LIBDEF	_LVOFGC_UnloadCommand
	LIBDEF	_LVOFGC_SelectCommand
	LIBDEF	_LVOFGC_SelectQCommand
	LIBDEF	_LVOFGC_SelectKCommand

	LIBDEF	_LVONewReadProject
	LIBDEF	_LVONewReadDefaultProject
	LIBDEF	_LVONewUnloadToolbox
	LIBDEF	_LVONewWriteProject

	LIBDEF	_LVOMakeTagListsSaved
	LIBDEF	_LVOMakeTagListSaved
	LIBDEF	_LVOSendFGC2Crouton
	LIBDEF	_LVOFGC_BGCommand
	LIBDEF	_LVOLoadCroutonFile

	LIBDEF	_LVOWait4Time
	LIBDEF	_LVOFGC_TakeCommand

	LIBDEF	_LVOSignedLong2ASCII
	LIBDEF	_LVOSignedWord2ASCII
	LIBDEF	_LVOSignedByte2ASCII
	LIBDEF	_LVOLong2ASCII
	LIBDEF	_LVOWord2ASCII
	LIBDEF	_LVOByte2ASCII

	LIBDEF	_LVOContinueMessage
	LIBDEF	_LVORetryOrCancel

	LIBDEF	_LVOFGC_PbuttonCommand
	LIBDEF	_LVOFGC_MbuttonCommand
	LIBDEF	_LVOFGC_ObuttonCommand

	LIBDEF	_LVOStopSavePIconRGB
	LIBDEF	_LVOIcon_CopyPIC
	LIBDEF	_LVOIcon_CopyRGB
	LIBDEF	_LVOCopy2PIconRGB
	LIBDEF	_LVOCopy2PIcon	
	LIBDEF	_LVOPCON_Save        
	LIBDEF	_LVOIcon_CopySL
	LIBDEF	_LVOStartSavePIcon
	LIBDEF	_LVOStopSavePIcon
	LIBDEF	_LVOGrabIcon
	LIBDEF	_LVOMKPIcon
	LIBDEF	_LVOMKPIconRGB
	LIBDEF	_LVOSingleLineDecode_Icon
	LIBDEF	_LVOIcon_CopyLines

	LIBDEF	_LVOAddString2FGtags

	LIBDEF	_LVOStopSaveRGBPIcon644
	LIBDEF	_LVOStopSaveIcon644

	LIBDEF	_LVOPostErrorLater
	LIBDEF	_LVOPostErrorNow

	LIBDEF	_LVOAddValue2FGtags
	LIBDEF	_LVOFGC_UpdateTagCommand
	LIBDEF	_LVOFGC_TagInfoCommand

	LIBDEF	_LVOAppendIcon		;Error=AppendIcon(Name)
	LIBDEF	_LVOMakeIcon		;Error=MakeIcon(Name,BM,CRuD,CRuDsize)

	LIBDEF	_LVOLoadClipField	;Error=LoadClipField(BM,Name,Field#)
	LIBDEF	_LVOSaveClipField	;Error=SaveClipField(BM,Name,OpenMode)
	LIBDEF	_LVOExpandField		;void  ExpandField(BM,Field#)

	LIBDEF	_LVOAddTBMemHandler	; (struct Interrupt * in a0)
	LIBDEF	_LVORemTBMemHandler	; (struct Interrupt * in a0)

	LIBDEF	_LVOSetMatteColor	;BOOL=(color)

	LIBDEF	_LVOMakeClipIcon	;Error=MakeClipIcon(name,CRud,CrudSize,Field#)

	LIBDEF	_LVOAppendClipIcon	;Error=AppendClipIcon(FileName,TB)

	LIBDEF	_LVOIsEitherButtonDown

	LIBDEF	_LVOGetTheDefaultPath
	LIBDEF	_LVOFindTheFile

	LIBDEF	_LVOGetFirstDefaultPath
	LIBDEF	_LVOFlyer_GetVolumeInfo
	LIBDEF	_LVOFlyer_GetClipInfo
	LIBDEF	_LVOWait4TopNoDisable

* New Functions Go Here  *********************************

TB_NEGSIZ	EQU	(-COUNT_LIB)-6	; size of the function vectors in
