
#include <exec/types.h>
#include <exec/memory.h>
#include <string.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "flyerlib.h"
#include "flyer.h"

struct Library *FlyerBase;

main(int argc,char **argv)
{
int   vidchan;

printf("SetColorFrame version 1.00 \n");
printf("Copyright Prowave 1996\n");

if ((argc!=2)||(argv[1][0]=='?'))
   {
   printf("Usage: %ls <vidchan>\n",argv[0]);
   return(20);
   }

vidchan = atoi(argv[1]) - 3;

printf("Video Channel %d \n",vidchan);

if ((vidchan > 1) || (vidchan < 0))
   vidchan = 0; 

if ((FlyerBase = OpenLibrary(FLYERLIBNAME,0))==0) 
   {
   printf("Open flyer.library failed\n");
   return;
   }

StillMode(0,vidchan,MODE_FRAME);

CloseLibrary(FlyerBase);
return(0);
}
