*********************************************************************
* $Tags.i$
*
* Copyright (c)1992 NewTek, Inc.
* Confidental and Proprietary. All rights reserved. 
*
* $Id: tags.i,v 2.37 1995/09/12 14:02:15 Flick Exp $
*
* $Log: tags.i,v $
*Revision 2.37  1995/09/12  14:02:15  Flick
*Added TAG_ macros for new FX tags in data tables
*
*Revision 2.36  1995/07/27  16:29:51  Flick
*Added new FX tags for improved control over A/B sources
*
*Revision 2.35  1995/04/27  15:02:09  Flick
*Added new tag for scrolls ---> HoldFields
*
*Revision 2.34  1995/02/19  18:24:09  Kell
**** empty log message ***
*
*Revision 2.33  1995/02/16  17:10:43  Kell
**** empty log message ***
*
*Revision 2.32  1995/02/10  15:25:28  Kell
*New tags for smpte/delay/numfields time mode, and tags for ChromaFX
*
*Revision 2.31  1995/02/09  09:55:05  Kell
*Added Video/KeyedANIM, Main and FlyerStill
*
*Revision 2.30  1995/01/24  12:16:10  Kell
*New PACO defines that were missing.
*
*Revision 2.29  1995/01/03  20:29:02  Kell
**** empty log message ***
*
*Revision 2.28  1994/12/03  06:16:50  Kell
*New  TAG_PanelMode for novice/expert
*
*Revision 2.27  1994/11/30  01:35:02  Kell
*Removed Audio Head/Tail Start/Duration Tag items.  Not necessary.
*
*Revision 2.26  1994/11/18  08:57:42  Kell
*Changed TAG_Synchronous to TAG_Asynchronous.
*
*Revision 2.25  1994/11/17  18:46:41  Kell
*New  tags for Clip split audio, and Video clips w/ Effects during sequencing.
*New  tags for AREXX croutons.
*
*Revision 2.24  1994/11/04  16:36:26  Kell
**** empty log message ***
*
*Revision 2.23  1994/11/04  03:22:22  Kell
*added LoadedSlices TAG
*
*Revision 2.22  1994/10/13  18:00:03  Kell
*Removed Matte tag. Now used Encoder tag.
*
*Revision 2.21  1994/10/11  16:14:00  Kell
*Added Encoder tag item.
*
*Revision 2.20  1994/10/06  20:22:04  Kell
*Comments & Changed AFXT_Border_Custom to -1 to match values for Matte_Custom
*
*Revision 2.19  1994/10/05  05:55:42  Kell
*Now using both TAGCTLR_NEW and TAGCTRL_UNSAVED flags.
*
*Revision 2.18  1994/09/22  05:32:49  Kell
*New  tags for Fading in/out Keyed graphics.
*
*Revision 2.17  1994/09/12  18:22:12  Kell
*AudioOn bits defined.
*
*Revision 2.16  1994/08/27  06:59:10  Kell
*New  tag items.  Removed some old tag items.  New ERR! CrUD type.
*
*Revision 2.15  1994/08/04  01:10:36  Kell
*Changed FORM PUSS to PUS in CrUD macros.
*
*Revision 2.14  1994/08/03  06:44:03  Kell
*Added TAGID_OriginalLocation for remembering where content came from.
*Modifed the CrUD macros to support FORM PUS instead of CHUNK HEAD.
*
*Revision 2.13  1994/08/01  17:17:52  Kell
*Changed TAGID_Page to be a table of data.
*
*Revision 2.12  1994/07/13  20:42:04  Kell
**** empty log message ***
*
*Revision 2.11  94/03/31  13:10:10  Kell
**** empty log message ***
*
*Revision 2.10  94/03/19  11:58:27  Kell
*New  tags for Live video sources
*
*Revision 2.9  94/03/19  09:10:04  Kell
**** empty log message ***
*
*Revision 2.8  94/03/19  02:05:23  Kell
**** empty log message ***
*
*Revision 2.7  94/03/18  17:18:28  Kell
*New equates for shifting transitions with respect to in/out points
*
*Revision 2.6  94/03/18  09:23:20  Kell
*New  tags for DHD
*
*Revision 2.5  94/03/18  00:11:04  Kell
*Added new  tag items for Clips
*
*Revision 2.4  94/03/16  10:55:15  Kell
*New  tag items for Frame counts and various croutons and the Flier
*
*Revision 2.3  94/03/06  23:43:50  CACHELIN4000
*Enter CrUD_type values to match crouton.library
*
*Revision 2.2  94/03/06  16:39:32  Kell
*Fixes for Prxass assembler.
*
*Revision 2.1  94/02/17  12:36:49  Kell
**** empty log message ***
*
*Revision 2.0  94/02/07  15:58:52  Kell
*FirstCheckIn
*
*
*********************************************************************
	IFND	TAGS_I
TAGS_I	SET	1

	include "assembler.i"
	include "exec/types.i"
	include "eflib.i"
	include "croutons.i"

*****************************************************************
	IFND	_PHXASS_	;These IFNDs fail under the Phxass assembler!

	IFND    TRUE
TRUE	EQU	1
	ENDC
	
	IFND    FALSE
FALSE	EQU	0
	ENDC
	
	IFND    NULL
NULL	EQU	0
	ENDC
	
	ENDC

*****************************************************************
* Our tag lists are unlike Amiga TAG Lists. We don't limit the DATA
* to a LONG, but can use any even data size. We typically us a UWORD
* ID, unlike the Amiga which uses a LONG (our upper WORD contains flags).
* Though we can use any string (padded to even length) as a unique
* identifier.  This identifier string can indicate hierarchy if needed.
* The actual items data may be immediately included, or may "point"
* (via unique identifier) to another tag item.  Our tag lists never
* actually contain real pointers, which makes these lists suitable
* in file formats.

	STRUCTURE	TAG_,0
	      	LABEL	TAG_THEEND ;A NULL LONG if end of Tag List
	
		WORD	TAG_CTRL   ;Various control flags
		UWORD	TAG_ID	   ;unlike Amiga Tags which use a LONG
	        LABEL   TAG_DATA   ;A LONG	

	     	ULONG   TAG_EXTDATASIZE	;even size of add on data
		LABEL	TAG_EXTDATA	;= start of add on data

* Unique name assigned to this Tag Item = ID Hierarchy.
;;		UWORD	TAG_NAMESIZE		;even length
;;		STRUCT	TAG_NAME,TAG_NAMESIZE

* Unique name assigned to some external Tag Item.
* This is used as a variable name.
;;		UWORD	TAG_VARNAMESIZE		;even length
;;		STRUCT	TAG_VARNAME,TAG_VARNAMESIZE

;;		LABEL	TAG_VALUE	;= some immediate data

	LABEL	TAG_SIZEOF

*****************************************************************
* Bits in the TAG_CTRL WORD

TAGCTRL_LONG	EQU	15	;When set = LONG type TAG data at TAG_DATA.
				;When clear = extended tag data, starting
				;at TAG_EXTDATA, of size TAG_EXTDATASIZE.
				
* If the above bit is clear, one or more of the following bits is always set.
TAGCTRL_NAME	EQU	14	;When set = extended tag name, starting
				;at TAG_NAME, of size TAG_NAMESIZE.
				;When clear = no tag name given.

TAGCTRL_VARNAME	EQU	13	;When set = variable tag name, starting
				;at TAG_VARNAME, of size TAG_VARNAMESIZE.
				;When clear = no tag variable name given.

TAGCTRL_VALUE	EQU	12	;When set = immediate value, starting
				;at TAG_VALUE, of size
				;TAG_EXTDATASIZE-TAG_NAMESIZE-TAG_VARNAMESIZE
				;When clear = no immediate value is given.
*----------

TAGCTRL_VARIABLE EQU	11	;When set = this is a variable pointing
				;to some other tag item. 
				;Only the TAG_VARNAME is used. The TAG_VALUE
				;will be ignored.
				;When clear = this is an immediate value.
				;Only the TAG_VALUE is used. The TAG_VARNAME
				;will be ignored.

TAGCTRL_UNSAVED	EQU	10	;When set this item has been changed, edited,
				;or is a new item in the list.
				;This flag is cleared after an object is
				;Loaded off of Disk (or created).  Project
				;loading, or Control Panel editing, or
				;AREXX, etc., will set this bit.  Then only
				;flaged tag items will be saved during
				;project saving.

TAGCTRL_DISABLE	EQU	9	;Normally Clear. Only set when a source
				;tag item needs to indicated to disable the
				;corresponding destination tag item. The
				;destinations ID will be marked TAGID_IGNORE.

TAGCTRL_NEW  	EQU	8	;This bit is also used in source lists when
				;we find items that currently don't exist
				;in a destination list.  This way, we can
				;allocate one new node that contains all
				;new items when applying this to the destination.

*----------------------------------------

TAGID_IGNORE	EQU	0	;A zero in the TAGID will cause the item
				;to be ignored.  This space can be used in
				;the future when other Tag items are
				;defined.
*-----------
TAG_END		MACRO
	dc.l	0
123456789$:
    ENDM

*-----------
TAG_START	MACRO
12345678$:
	ENDOFLIST		;->next node (none)
	dc.l	123456789$-12345678$	;size of this node
	dcb.b	TLN_SIZEOF+12345678$-*,0
    ENDM
*-----------

* This is for compatibility. I now recommend TAG_END!!!!
*  ENDOFLIST should be at the end of every TagList.
ENDOFLIST	MACRO
	dc.l	0
	ENDM	

*****************************************************************
* This defines the LONG TagIDs.
* The AFXT_ stuff is for support of old dc.l tag id names used in old ButtLogs

DEFTAGID	MACRO			;name
TAGID_\1    EQU     SOFFSET!(1<<(TAGCTRL_LONG+16))
AFXT_\1	    EQU	    TAGID_\1
SOFFSET     SET     SOFFSET+1
		ENDM

*****************************************************************
* This defines the STRUCT TagIDs.
* The AFXT_ stuff is for support of old dc.l tag id names used in old ButtLogs

DEFTABLEID	MACRO			;name
TAGID_\1    EQU     SOFFSET!(1<<(TAGCTRL_VALUE+16))
AFXT_\1	    EQU	    TAGID_\1
SOFFSET     SET     SOFFSET+1
		ENDM

	IFD	CRAP
*****************************************************************
* Used to define hardcoded LONG Tags
* NOTE!!! DON'T USE THIS MACRO ANYMORE!!
*  BUT INSTEAD USE THE INDIVIDUAL TAG ITEM MACROS
TAGLONG MACRO			;value, "name" (don't include AFXT_ or TAGID_)
	 dc.w	1<<TAGCTRL_LONG
	 dc.w	TAGID_\2
	 dc.l	\1
	ENDM

*****************************************************************
* Used to define hardcoded STRUCT Tags
* NOTE!!! DON'T USE THIS MACRO ANYMORE!!
*  BUT INSTEAD USE THE INDIVIDUAL TABLE ITEM MACROS
TAGSTRUCT MACRO		;name
	 dc.w	1<<TAGCTRL_VALUE
	 dc.w	TAGID_\1
	 dc.l	.SOFFSET-*-4

* followed by even DCs for all fields in the STRUCT
	ENDM

*------------
TAGSTRUCTEND	MACRO
.SOFFSET
	ENDM

	ENDC



*******************************************************************
*******************************************************************
*****************************************************************
* All the  TAG items that may be found in croutons.
* This defines the TagIDs.

  STRUCTURE CroutonTags,1	;start at 1 for TagIDs because 0 marks end of list
	DEFTAGID	Version		;default UWORD = AFXT_Ver_3

AFXT_Ver_2		EQU	2
AFXT_Ver_3		EQU	3

	DEFTAGID	Revision		;default UWORD = AFXT_Rev_First

AFXT_Rev_First		EQU	0

* FALSE implies NonAAeffect is TRUE
	DEFTAGID	AAeffect			;Default = TRUE

* FALSE implies AAeffect is TRUE
	DEFTAGID	NonAAeffect		;Default = FALSE

	DEFTAGID	KillInterfaceNonAA		;Default = TRUE
	DEFTAGID	KillInterfaceAA		;Default = TRUE

	DEFTAGID	ButtonELHlogic		;Default UWORD = AFXT_Logic_Encoder

AFXT_Logic_Custom		EQU	0	;Crouton supplies ButtonELH logic
						;Requires CustomButtonELHlogic 

*------------------------------------------------------
* Internal Standard Button/ELH logics

* non-digital, non-lumkey. New Source on B side. e.g.
* If any alpha or latching is involved, please use TSEwipe or TSEwipe2.
* e.g. Smooth Fade
AFXT_Logic_TSEab		EQU	1

* Digital push on. Supports LumKey. New source on B side.  e.g. Push to "R"ight
AFXT_Logic_TDEon		EQU	2

* Digital pull off. Supports LumKey. New source on B side.  e.g. Pull to "R"ight
AFXT_Logic_TDEoff		EQU	3

* DIB Alpha wipe.  Non-lumkey.  New source on B side.  e.g. Wipe to "R"ight
* See TSEwipe2 logic.
AFXT_Logic_TSEwipe		EQU	4

* Synonymous to TSEwipe.  Used when Latch FX require the Encoder
* to be selected on the B side of the fader. 
* DO NOT USE THIS!!!!!!
;;;AFXT_Logic_TSEencoderB		EQU	4

* Full screen Digital Main switches to new full screen Digital main
* halfway through transition.  Supports LumKey.  Foreground sources on B side
* Supports LumKey. Foreground sources on B side when LumKeying.
* e.g. Sqz.TRLS to "C"enter
AFXT_Logic_TDEtoTDE		EQU	5

* Digital pull off to reveal matte.  Then digital push on of new source.
* Supports LumKey.  Overlay sources (matte during 1st half, new source
* during 2nd half) on B side.	e.g. Sqz.BKG to "C"enter
AFXT_Logic_TDtoBtoTD		EQU	6

* Digital trails push on.  Supports LumKey. New source on B side.
* No shipping effects use this logic.  We've prefered DTrailsOffOn logic.
AFXT_Logic_DTrailsOW		EQU	7

* non-digital, non-alpha/key, non-latch.  Switcher effect transitions to
* matte.  Then half way through, transitions to a new source.
* Overlay sources (matte during 1st half, new source during 2nd half)
* on B side. e.g. Cross Fade 3
AFXT_Logic_TStoMtoTS		EQU	8

* Full screen digital trails.  Switchers to new source half way through.
* Supports LumKey. Foreground sources on B side when LumKeying.
* e.g. Sqz.TRLS to "C"enter
AFXT_Logic_DTrailsOffOn		EQU	9

* Digital source flys on and off over the top of background video.
* Supports LumKey.  Digital source on B side.
* No pre 3.0 shipping effects have used this logic.
AFXT_Logic_TDEtemp		EQU	10

* DIB Alpha wipe.  Non-lumkey.  New source on A side.
* Because TSEwipe works with FadeIn/Out, it is prefered over TSEwipe2.
* e.g. Pos Wipe Out
AFXT_Logic_TSEwipe2		EQU	11

* Synonymous to TSEwipe2.  Used when Latch FX require the Encoder
* to be selected on the A side of the fader. 
* DO NOT USE THIS!!!!!!
;;;AFXT_Logic_TSEencoderA		EQU	11

* Encoded graphics is keyed over background. There is no Take.
* Does not support LumKey. Encoder is on B side.
AFXT_Logic_EncoderAlpha		EQU	12	

* The following logic is used by ChromaFX croutons.  It is unlikely
* that any of these lut logics will be useful in other effects croutons.
AFXT_Logic_LutColorFilter	EQU	13
AFXT_Logic_LutColorTBar		EQU	14
AFXT_Logic_LutMonoFilter	EQU	15
AFXT_Logic_LutMonoTBar		EQU	16	

* Digital push on with "Quaf" transparent drop shadows. Supports LumKey.
* New source on A side. Not used until VT 3.0.
AFXT_Logic_QuafAlphaOn		EQU	17

* Digital push off with "Quaf" transparent drop shadows. Supports LumKey.
* New source on A side. Not used until VT 3.0.
AFXT_Logic_QuafAlphaOff		EQU	18

* Full screen Digital effect of Main (vs transition).  There is no Take.
* Supports LumKey. Foreground sources on B side when LumKeying.
* Not used until VT 3.0
AFXT_Logic_TDEfx		EQU	19

* Non-digital, non-alpha/key, non-latch.  "Brain dead logic"
* Not probably useful for Effects or Transitions.
* Used by AdjDHue, AdjEHue, AdjPed, AdjGain manual adjustment croutons.
AFXT_Logic_TSEfx		EQU	20

* Full screen Encoded graphics. May work with Alpha. There is no Take.
* Supports LumKey. Encoder is on B side when LumKeying.
AFXT_Logic_Encoder		EQU	21	

* Use Latching on the AM side of the fader. The ENCODER/MATTE is on the
* BM side of the fader.
AFXT_Logic_LatchAencoderB	EQU	22

* Use Latching on the BM side of the fader. The ENCODER/MATTE is on the
* AM side of the fader.
AFXT_Logic_LatchBencoderA	EQU	23

* Same as TSEab except there isn't a take at the TBar's bottom.
AFXT_Logic_TSEtemp		EQU	24	

* Same as TSEwipe except there isn't a take at the TBar's bottom.
AFXT_Logic_TSEwipeTemp		EQU	25

* Use Latching on the AM side of the fader. MATTE is on the
* BM side of the fader.
AFXT_Logic_LatchBmatteA		EQU	26

* Use Latching on the BM side of the fader. MATTE is on the
* AM side of the fader.
AFXT_Logic_LatchAmatteB		EQU	27

* Digital source flys on and off over the top of background video,
* with "Quaf" transparent drop shadows. Supports LumKey.
* New source on A side. Not used until VT 3.0.
* No pre 3.0 shipping effects have used this logic.
AFXT_Logic_QuafAlphaTemp	EQU	28

* Digital push on. Does not supports LumKey
* Latches digital source and new source both on B side of fader.
* Encoder is forced into the A side of fader.
AFXT_Logic_LatchTDEonEncoderA	EQU	29

* Digital push on. Does not supports LumKey
* Latches digital source and new source both on A side of fader.
* Encoder is forced into the B side of fader.
AFXT_Logic_LatchTDEonEncoderB	EQU	30

* Digital push off. Does not supports LumKey
* Latches digital source and new source both on B side of fader.
* Encoder is forced into the A side of fader.
AFXT_Logic_LatchTDEoffEncoderA	EQU	31

* Digital push off. Does not supports LumKey
* Latches digital source and new source both on A side of fader.
* Encoder is forced into the B side of fader.
AFXT_Logic_LatchTDEoffEncoderB	EQU	32

*------------------------------------------------------

	DEFTABLEID	CustomButtonELHlogic	;->Custom ButtonELH logic
						;Implies AFXT_Logic_Custom
						;Default = EF_Encoder(a4)

* ANIMs may be present in the 1st, 2nd, 3rd .... OverLay hunks.
* On AUTO or TBar they will be executed in this same order.  The number
* of loop times is given by the AnimControl table.
* If the anim is external, this is the number of external files.
	DEFTAGID	NumberOfAnims		;Default = AFXT_OneAnim 

AFXT_NoAnim		EQU	0	
AFXT_OneAnim		EQU	1

* The ASL file requester may be used to indicate a load file
	DEFTAGID	RequestFileName		;Default = FALSE

* Pointer to a null terminated table of string pointers.
	DEFTABLEID	AnimFiles			;Default = NULL

	DEFTAGID	Frames			;Default = FALSE = Fields

	DEFTAGID	FieldSync			;Default = FALSE

* Some algrithmic effect may allow user specified speeds.
	DEFTAGID	VariableSpeeds		;Default = FALSE

* on ANIMs that will play either way, we may force a direction
	DEFTAGID	ForcePlayForward		;Default = FALSE
	DEFTAGID	ForcePlayReverse		;Default = FALSE

* This loops all anims until haulted by user input.

	DEFTAGID	LoopAnims			;Default = FALSE
TAGID_LoopILBM	 EQU	TAGID_LoopAnims			;Default = FALSE

* Pointer to table of loop times.  See STRUCTURE AnimControl
* Each anim may play once, multiple times, or forever.  Each anim may
* or maynot complete when interrupted by optional user input.
* This structure over rides the LoopAnims flag.
	DEFTABLEID	AnimControl		;Default = NULL
	
* Audio samples begin in the hunk following the ANIM data (if any).
* Or the audio samples may be external files.
* Stereo Audio is stored with the left channel first, then the right.
* Audio for the fastest ANIM speed is stored first, then Medium,
* the for the Slow speed.
* ACTUALLY, WE DON'T PROBABLY CARE IF IT'S STEREO OR MONAURAL.
* THE LOADER WILL HANDLE THE DETAILS.  WE ASSUME A STEREO SAMPLES IS
* STILL JUST ONE CHUNK OF DATA, LOADED AS A UNIT.

	DEFTAGID	AudioFastSamples	;Default = AFXT_NoAudioFast
AFXT_NoAudioFast	EQU	0
AFXT_MonoAudioFast	EQU	1
AFXT_StereoAudioFast	EQU	2
AFXT_AudioFast		EQU	-1	;unknown if monaural of stereo

	DEFTAGID	AudioMediumSamples	;Default = AFXT_NoAudioMedium
AFXT_NoAudioMedium	EQU	0
AFXT_MonoAudioMedium	EQU	1
AFXT_StereoAudioMedium	EQU	2
AFXT_AudioMedium	EQU	-1	;unknown if monaural of stereo

	DEFTAGID	AudioSlowSamples	;Default = AFXT_NoAudioSlow
AFXT_NoAudioSlow	EQU	0
AFXT_MonoAudioSlow	EQU	1
AFXT_StereoAudioSlow	EQU	2
AFXT_AudioSlow		EQU	-1	;unknown if monaural of stereo

* Pointer to a null terminated table of string pointers.
	DEFTABLEID	AudioFiles			;Default = NULL

* For each ANIM speed, when each sample should play, sample speed, volume,
* fade in/out, audio looping etc.  See STRUCTURE AudioControl
	DEFTABLEID	AudioControl		;Default = NULL

* A table of pause times may be supplied.  See STRUCTURE PauseTimes
	DEFTABLEID	PauseTimes			;Default = NULL

* A table of dynamic LatchColors may be supplied.  See STRUCTURE LatchColors
	DEFTABLEID	LatchColors		;Default = NULL

* A table of dynamic TransparentColors may be supplied.  See STRUCTURE TransparentColors
	DEFTABLEID	TransparentColors		;Default = NULL

* A table of RGB colors may be supplied.  See STRUCTURE PaletteColors
	DEFTABLEID	PaletteColors		;Default = NULL

* These were never implemented as separate equations.  Instead
* we have an Equations structure that contains multiple equations.
* Dynamic Scrolling and Cropping algrithmic equations
*	DEFTAGID	SourceX			;Default = NULL
*	DEFTAGID	SourceY			;Default = NULL
*	DEFTAGID	SourceWidth		;Default = NULL			
*	DEFTAGID	SourceHeight		;Default = NULL
*	DEFTAGID	DestinationX		;Default = NULL
*	DEFTAGID	DestinationY		;Default = NULL

* Points to a table of Algorithmic Equations.  Used for the
* fader, lumkey, and superbitmap scrolling and color cycling.

* A scrollable BitMap uses a special super bitmap ILBM.
* The upper 1/2 of the planes are shifted 32 pixels to the right.
* Typically the center of the bitmap should be centered on the Amiga display
* at the start or end of a transition (though this is adjustable).
	DEFTABLEID	Equations		;Default = NULL

	DEFTAGID	Encoder			;Defaults to FALSE.  Replaces old TAG_Matte TRUE
	DEFTAGID	VerticalScroll		;Default = NULL			

	DEFTAGID	ReverseTime		;Default = FALSE
	DEFTAGID	ReverseButtLog		;Default UWORD = AFXT_Logic_Encoder
	DEFTABLEID	ReverseCustomButtLog	;->Reverse Custom ButtonELH logic
						;Implies AFXT_Logic_Custom
						;Default = EF_Encoder(a4)

	DEFTAGID	KeyMode			;Default = AFXT_Key_Overlay70ns

AFXT_Key_Digital280ns	EQU 0	;QUAF
AFXT_Key_QUAF		EQU 0

AFXT_Key_Overlay70ns	EQU 1	;PixelSw				
AFXT_Key_PixelSw	EQU 1

AFXT_Key_QUAFalpha	EQU 2	;DG
AFXT_Key_2Level70ns	EQU 2	;DG
AFXT_Key_DG		EQU 2

AFXT_Key_LumKey70ns	EQU 3	;LumKey
AFXT_Key_LumKey		EQU 3

AFXT_Key_16Level70ns	EQU 4	;DIGBR
AFXT_Key_DIGBR		EQU 4	;TYPEO !!!!! Use DIBGR!!!
AFXT_Key_DIBGR		EQU 4

AFXT_Key_4Level70ns	EQU 5	;DIB
AFXT_Key_DIB		EQU 5

AFXT_Key_256Level280ns	EQU 6	;DRGquad
AFXT_Key_DRGquad	EQU 6

AFXT_Key_Fader		EQU 7	;CD
AFXT_Key_CD		EQU 7	;QUAF

* See ForceDefaultMatte.
	DEFTAGID	MatteColor		;Default = AFXT_Matte_Current

AFXT_Matte_Current	EQU	0
AFXT_Matte_Custom	EQU	-1	;PRIVATE FLAG!! Use CustomMatteColor instead
					
AFXT_Matte_Black	EQU	1
AFXT_Matte_White	EQU	2
AFXT_Matte_Red		EQU	3
AFXT_Matte_Green	EQU	4
AFXT_Matte_Blue		EQU	5
AFXT_Matte_Yellow	EQU	6
AFXT_Matte_Magenta	EQU	7
AFXT_Matte_Cyan		EQU	8
AFXT_Matte_Snow		EQU	9

*-------------------------------------------------------------
* If (ForceDefaultMatte = FALSE) and (MatteColor <> 0)
*   then there are user settable Effect Colors.
*   The user may select Matte colors 1 thru 9 = Black - Snow
*   And if (CustomMatteColor <> 0)
*          then they can also select -1 for the default Custom Color
*
* NOTE: In the actual CrUD TAGS it isn't important to set MatteColor to
*       -1 when using CustomMatteColors. Because the crouton will
*       automatically set these Tags when the crouton is loaded.
*
*-----------------------
* If (AlgoFXborder = TRUE) and (BorderColor <> 0)
*   then there are user settable Border Colors
*   The user may select 1-8 = black thru cyan
*   And if (CustomBorderColor <> 0)
*          then they can also select -1 for the default Custom Border
*
* NOTE: In the actual CrUD TAGS it isn't important to set AlgoFXBorder 
*       to TRUE when using a BorderColor or CustomBorderColor.
*       And it isn't important to set BorderColor to -1 when using
*       CustomMatteColors. Because the crouton will automatically set these
*       Tags when the crouton is loaded.
*-------------------------------------------------------------

* MatteColor is over ridden by CustomMatteColor
* CustomMatteColor implies MatteColor=Matte_Custom

	DEFTAGID	CustomMatteColor ;Default = Black = $000.
					 ; Custom nibble values for MA/MB/MP			
				 	 ; When Matte color = -1 this color is used.

	DEFTAGID	BorderColor		;Default = AFXT_Border_Current

AFXT_Border_Current	EQU	0
AFXT_Border_Custom	EQU	-1	;PRIVATE FLAG!! Use CustomBorderColor instead

AFXT_Border_Black	EQU	1
AFXT_Border_White	EQU	2
AFXT_Border_Red		EQU	3
AFXT_Border_Green	EQU	4
AFXT_Border_Blue	EQU	5
AFXT_Border_Yellow	EQU	6
AFXT_Border_Magenta	EQU	7
AFXT_Border_Cyan	EQU	8

	DEFTAGID	CustomBorderColor		;Default YIQ = $470000

* You may generate line numbers algrithmically
* I quess we might need a different equation for every row of the display!!
* See STRUCTURE LineNumbers
	DEFTABLEID	LineNumbers		;Default = NULL

	DEFTAGID	LineNumberPlane		;Default = AFXT_LineNumber_None

AFXT_LineNumber_None	EQU	0
AFXT_LineNumber_Plane1	EQU	1	
AFXT_LineNumber_Plane2	EQU	2	
AFXT_LineNumber_Plane3	EQU	3	
AFXT_LineNumber_Plane4	EQU	4	
AFXT_LineNumber_Plane5	EQU	5	
AFXT_LineNumber_Plane6	EQU	6	
AFXT_LineNumber_Plane7	EQU	7	
AFXT_LineNumber_Plane8	EQU	8	
AFXT_LineNumber_Plane9	EQU	9	
AFXT_LineNumber_Plane10	EQU	10	
AFXT_LineNumber_Plane11	EQU	11	
AFXT_LineNumber_Plane12	EQU	12	
AFXT_LineNumber_Plane13	EQU	13	

	DEFTAGID	ForceFreeze4		;Default = FALSE
	DEFTAGID	ForceFreeze8		;Default = FALSE
	DEFTAGID	ForceLive			;Default = FALSE

	DEFTAGID 	ForceLumKeyOn		;Default = FALSE
	DEFTAGID 	ForceLumKeyOff		;Default = FALSE
	DEFTAGID 	ForceLumKeyOnBlack		;Default = FALSE
	DEFTAGID 	ForceLumKeyOnWhite		;Default = FALSE

* Set this flag if it is a bad choice for a default effect after
* the CG, LW etc, are deselected.  See ToastBase's SelectStdEfx(). 
	DEFTAGID	BadDefaultFX		;Default = FALSE

* Stillstores may be pre-loaded.  See STRUCTURE LoadPictures
	DEFTABLEID	LoadPictures		;Default = NULL

* This was never used.  Instead use Equations!
* Algorithmic equations for fader and Clip
**	DEFTAGID	FaderLevel			;Default = NULL
**	DEFTAGID	ClipLevel			;Default = NULL

* These Fades are used by Keyed Stills (we have separate Audio fade tags)
	DEFTAGID	FadeInDuration			;Default = NULL
	DEFTAGID	FadeOutDuration			;Default = NULL

* Toaster Control Bits, These are Constant throughout effect.
	DEFTAGID	DigitalFX			;Default = FALSE

	DEFTAGID	TimeMode		;Default = 0
TIMEMODE_NUMFIELDS 	EQU	0	;from start of recorded clip
TIMEMODE_DELAY 		EQU	1	;delay from Video Inpoint   
;;TIMEMODE_SMPTE 		EQU	2	;NOT USED Use NumFields if no SMPTE

	DEFTAGID	LUT			;Default = FALSE

	DEFTAGID	DigitalPairs		;Default = FALSE

	DEFTAGID	LatchAM			;Default = FALSE
	DEFTAGID	LatchBM			;Default = FALSE
	DEFTAGID	LatchIS			;Default = FALSE
	
	DEFTAGID	HonorPreviewOverLay	;Default = FALSE

* This flag will prevent the user from selecting new matte colors for
* Latch type effects.  It will always use the effects default color (if any)
	DEFTAGID	ForceDefaultMatte		;Default = FALSE

* The following THREE items are for Amiga Audio for FX.
* Don't confuse these with Flyer Audio tags!
	DEFTAGID	TurnAudioFilterOff		;Default = FALSE. Turns off the audio filter
	DEFTAGID	AudioStartField		;Default = 0
	DEFTAGID	NumAudioFields		;Default = length of ANIM = -1

AFXT_Audio_LengthOfAnim EQU -1
	DEFTAGID	ISandClipPause		;Default = FALSE

	DEFTAGID	Interlaced			;Default = FALSE
	DEFTAGID	FirstFieldNTSCII		;Default = FALSE

	DEFTAGID	BounceILBM			;Default = FALSE, implies LoopILBM

	DEFTABLEID	LatchRanges		;Default = NULL
	DEFTABLEID	LatchList			;Default = NULL

	DEFTABLEID	TransparentRanges		;Default = NULL

	DEFTABLEID	TransparentList		;Default = NULL

* Don't set this flag if using TransparentColors/Ranges/List
	DEFTAGID	Color0Transparent		;Default = FALSE

	DEFTAGID	AbortIfSlow		;Default = FALSE
	DEFTAGID	NumSkipFieldsAtEnd		;Default = 0
	DEFTAGID	TBarDoesAuto		;Default = FALSE	

	DEFTAGID	DoNotStompSprite		;Default = FALSE

* NOT YET IMPLEMENTED!!!!!!
	DEFTAGID	AbortLoopAtEnd		;Default = FALSE

* Implies NonAAEffect.  Remapping only applies to AAeffects
* running on a non-AA machine.  These modes are normally derived from
* the DigitalFX, LatchAM/BM/IS, and KeyMode tag items. But, if this
* tag item is last, it may force the remap to a particular mode. 
	DEFTAGID	NonAAremap			;Default = AFXT_Remap_Encoder
AFXT_Remap_Encoder 	EQU	0
AFXT_Remap_Digital	EQU	1
AFXT_Remap_DIB		EQU	2
AFXT_Remap_DIBGR	EQU	4
AFXT_Remap_Latch	EQU	8
AFXT_Remap_DIBlatch	EQU	10
AFXT_Remap_DIBGRlatch	EQU	12

	DEFTAGID	100PercentWhiteMatte	;Default = FALSE

* This flag is set when MatteColor, CustomMatteColor or 100PercetWhiteMatte
* are used.  When clear, any changes to the Effect Color row are ignored.
	DEFTAGID	UseEffectColor		;Default = FALSE

	DEFTAGID	LoopCount	;for LoopILBMs and LoopANIMs, 0=forever

*------------------------------------------------------
	
	DEFTAGID	CroutonType	;Used by Control croutons to indicate type of control crouton.

CROUTONTYPE_WHITESPACE	EQU	0	;Nop
CROUTONTYPE_ENDOFROW	EQU	1	;same as white space but always causes a new row
CROUTONTYPE_STOP	EQU	2
CROUTONTYPE_RESTART	EQU	3	;loop back to sequence start (from where sequence origianally began)
CROUTONTYPE_WAIT4GPI	EQU	4
CROUTONTYPE_WAIT4LMB		EQU	5	;Left mouse button down
CROUTONTYPE_WAIT4RMB		EQU	6	;Right mouse button down (NOT SUPPORTED BECAUSE THIS USUALLY ABORTS SEQUENCE)
CROUTONTYPE_WAIT4ANYBUTTON	EQU	7	;Either mouse button down (NOT SUPPORTED BECAUSE RMB USUALLY ABORTS SEQUENCE)
CROUTONTYPE_WAIT4ANYKEY		EQU	8	;Any keyboard press
CROUTONTYPE_WAIT4ANYSERIAL	EQU	9	;any serial character input
CROUTONTYPE_WAIT4TIME		EQU	10	;wait for real world time (use Amiga realtime clock)

	DEFTAGID	TimeLine	;2 eg video, overlay, transition, audio1, audio2 ...

	DEFTAGID	IndexID	   	;3 FGS_IndexID, mirrors old FG_IndexID
					;Always mirrors FG_IndexID

	DEFTAGID	FCountMode	;4 OLD FGS_FCountMode lower 2 bits
					; denotes what FCount mode is active
					; The low order two bits should
					; be looked at.
					; 3=slow, 0=med, 1=fast, 2=variable
	
	DEFTAGID	VariableFCount  ;5 OLD FGS_FCountMode upper 14 bits
					; 0=variable not supported

	DEFTAGID	SlowFCount	;6 OLD FGS_SlowFCount lower byte
					; FCount for slow mode

	DEFTAGID	MedFCount	;7 OLD FGS_MedFCount lower byte
					; FCount for medium mode

	DEFTAGID	FastFCount	;8 OLD FGS_FastFCount lower byte
					; FCount for fast mode

	DEFTAGID	VariableFCount68000  ;9	; 0=variable not supported
 
	DEFTAGID	SlowFCount68000	     ;10 OLD FGS_SlowFCount upper byte
					     ; FCount for slow mode

	DEFTAGID	MedFCount68000	     ;11 OLD FGS_MedFCount upper byte
					     ; FCount for medium mode

	DEFTAGID	FastFCount68000	     ;12 OLD FGS_FastFCount upper byte
					     ; FCount for fast mode

	DEFTAGID	NumFields	;13  Number of fields for crouton.
					; This value is based on other user
					; setable speed/time related parameters
					; This only relates to the effects time,
					; or a default effects time (default Fade?).
					; We use this for Scroll HOLD time.

	DEFTAGID	StartTime	;14 Fraction between 0 and $ffff, shifts	
					; non-video time starts with respect
					; to video time cut points.
					; e.g. if 0, transition starts at
					; the end of the current clips out
					; point. If $ffff transition ends at
					; the current clips out point				
	
	DEFTABLEID	DescriptorList	;Text list of descriptive words used
					;as database for indexing / searching.	
					;Each item in null terminated.
					;The list is terminated with a null.

	DEFTABLEID	AboutList	;Text containing authors name,
					;commany, copyright, date etc.
					;Each line is null terminated
					;The list is terminated with a null.
					;The 1st line usually contains...
					;$VER: ProgramName Version.revision
					;This works with AmigaDos Version cmd.

	DEFTABLEID	CommentList	;Text containing comment(s) about
					;the Crouton.  The first line is
					;usually a 80 char. description.
					;This may be followed with any
					;amount of "Help" text/docs.
					;Each line is null terminated
					;The list is terminated with a null.
	DEFTAGID	AlgoFXtype	;Type type of Algorithmic Effect.
					;These effects don't require ILBMs/ANIMs
ALGT_StdDigitalFX	EQU	0
ALGT_StdWipeFX		EQU	1
ALGT_StdSwitcherFX	EQU	2

	DEFTAGID	AlgoFXborder	;Flag for Digital FX that have borders.
					;If TRUE the Setup screens Effect
					;Color determines the DVEs border color.
		
	DEFTAGID	NumFramesSlow		;Valid after FGC_LOAD
	DEFTAGID	NumFramesMedium		;Valid after FGC_LOAD
	DEFTAGID	NumFramesFast		;Valid after FGC_LOAD
	DEFTAGID	NumFramesVariable	;Valid after FGC_LOAD

* CG pages
	DEFTABLEID	Page	;contains all info to re-edit the page
	DEFTAGID	Speed	;for scroll/crawl

* Sequence controls
	DEFTAGID	Delay
Delay_Early	EQU	(-$7fff)	;transition ends at end of clip
Delay_Middle	EQU	0		;transition centered on end of clip
Delay_Late	EQU	($7fff)		;transition starts at end of clip
* On Audio clips, and Keyed video Delay is used as a start time with respect
* to the previous video event.

	DEFTAGID	Duration	;Used by FrameStores, Clip, VideoSources
					;Also used for overall Scrawl duration,
					;including hold=HoldFields and FadeOutDuration.
	
* Flyer video/audio clips
	DEFTAGID	AudioAttack	;used to be RecStartPoint
	DEFTAGID	AudioDecay	;used to be RecEndPoint
	DEFTAGID	RecFields	;Flyer unedited clip #fields

*------------------
	DEFTAGID	AudioOn		;Flags to indicate what channels were
					;recorded w/Audio, and enabled.
AUDB_Channel1Recorded	EQU	0
AUDB_Channel2Recorded	EQU	1
AUDB_Channel1Enabled	EQU	2
AUDB_Channel2Enabled	EQU	3
*------------------

	DEFTAGID	AudioStart	;used to be ClipStartPoint
	DEFTAGID	AudioDuration	;used to be ClipEndPoint
	DEFTAGID	ClipStartField	;# fields from Record Start
					;Use above with TAG_Duration to get end field#

	DEFTAGID	FadeInVideo	;vs CutInVideo. BOOL used with FRAMEs and CLIPs

	DEFTAGID	MaxDuration	;Used for user adjustable FX & VideoSource durations
					;This limits users from adjusting Fades to 10 years.

	DEFTAGID	VideoSource	;force to a particular value. This is a Mask
					;that relates to TB_PrvwSec on FGC_SELECT.
	
SOURCE_NOCHANGE	EQU	0		;Use current (may be used to Force Live DVE)
SOURCE_VIDEO1	EQU	(1<<0)
SOURCE_VIDEO2	EQU	(1<<1)
SOURCE_VIDEO3	EQU	(1<<2)		;current 3, may be Flyer
SOURCE_VIDEO4	EQU	(1<<3)		;current 4, may be Flyer
SOURCE_DV1	EQU	(1<<4)		;Or both DV1 and DV2 for Live
SOURCE_DV2	EQU	(1<<5)
SOURCE_MATTE	EQU	(1<<6)

SOURCE_EXTERNAL	EQU	(1<<15)		;"+" this with VID3/4 to force External VID3/4 vs Current VID3/4
	
*---------
	DEFTAGID	LoadedSlices	 ;bit mask of loaded Slices

* LoadedSlices Bits
SLICE_SETUP	EQU	0	;=Switcher Prefs, ignored because its always loaded
SLICE_CHROMAFX	EQU	1
SLICE_PAINT	EQU	2
SLICE_CG	EQU	3
SLICE_LIGHTWAVE	EQU	4
SLICE_HARDWARE	EQU	5	;ignored because its always loaded

*---------
	DEFTABLEID	OriginalLocation ;Path+Name where content was when
					 ;it was initally drug into a project

	DEFTAGID	AudioVolume1	;The sustain volume of left rec. channel	
	DEFTAGID	AudioVolume2	;The sustain volume of right rec. channel
	DEFTAGID	AudioPan1	;Amount of pan of left rec. channel	
	DEFTAGID	AudioPan2	;Amount of pan of right rec. channel

	DEFTAGID	PanelMode	
* PanelMode Values
PANELMODE_NOVICE	EQU	0
PANELMODE_EXPERT	EQU	1

	DEFTAGID	ColorMode	;Used by ChromaFX
COLORMODE_BW		EQU	0
COLORMODE_COLOR		EQU	1
 
	DEFTAGID	CycleMode	;Used by ChromaFX 
CYCLEMODE_OFF		EQU	0
CYCLEMODE_UP		EQU	1
CYCLEMODE_DOWN		EQU	2
CYCLEMODE_BOUNCE	EQU	3

	DEFTAGID	DataMode	;Used by ChromaFX 
DATAMODE_TBAR		EQU	0
DATAMODE_FILTER		EQU	1

* The following 2 items are only used for Sequencing
	DEFTAGID	AdjustedVideoStart	;includes FX overlap at start or end of clip
	DEFTAGID	AdjustedVideoDuration	;includes FX overlap at start or end of clip

	DEFTAGID	Asynchronous	;Used with AREXX scripts and sequencing.
					;=FALSE if AREXX doesn't return until
					;the AREXX script is finished.						
					;Defaults to FALSE = synchronous.

	DEFTABLEID	CommandLine	;Text string containing a command
					;with optional parameters.

	DEFTABLEID	SMPTEtime	;SMPTEinfo structure

	DEFTAGID	TBarPosition	;Used by ChromaFX & other non-transitional FX

	DEFTAGID	HoldFields	;For scrolls

	DEFTAGID	TakeOffset	;32-bit fraction -- take position in FX
	DEFTAGID	ASourceLen	;32-bit fraction -- A video source length in FX
	DEFTAGID	BSourceLen	;32-bit fraction -- B video source length in FX

* NEW TAG DEFINITIONS GO HERE!!!!

**************************************************************************
**************************************************************************
**************************************************************************

TAG_Version   MACRO    ;value
   dc.l   TAGID_Version,(\1)
  ENDM

TAG_Revision   MACRO    ;value
   dc.l   TAGID_Revision,(\1)
  ENDM

TAG_AAeffect   MACRO    ;value
   dc.l   TAGID_AAeffect,(\1)
  ENDM

TAG_NonAAeffect   MACRO    ;value
   dc.l   TAGID_NonAAeffect,(\1)
  ENDM

TAG_KillInterfaceNonAA   MACRO    ;value
   dc.l   TAGID_KillInterfaceNonAA,(\1)
  ENDM

TAG_KillInterfaceAA   MACRO    ;value
   dc.l   TAGID_KillInterfaceAA,(\1)
  ENDM

TAG_ButtonELHlogic   MACRO    ;value
   dc.l   TAGID_ButtonELHlogic,(\1)
  ENDM

TAG_NumberOfAnims   MACRO    ;value
   dc.l   TAGID_NumberOfAnims,(\1)
  ENDM

TAG_RequestFileName   MACRO    ;value
   dc.l   TAGID_RequestFileName,(\1)
  ENDM

TAG_Frames   MACRO    ;value
   dc.l   TAGID_Frames,(\1)
  ENDM

TAG_FieldSync   MACRO   ;value
   dc.l   TAGID_FieldSync,(\1)
  ENDM

TAG_VariableSpeeds   MACRO   ;value
   dc.l   TAGID_VariableSpeeds,(\1)
  ENDM

TAG_ForcePlayForward   MACRO   ;value
   dc.l   TAGID_ForcePlayForward,(\1)
  ENDM

TAG_ForcePlayReverse   MACRO   ;value
   dc.l   TAGID_ForcePlayReverse,(\1)
  ENDM

TAG_LoopAnims   MACRO   ;value
   dc.l   TAGID_LoopAnims,(\1)
  ENDM

TAG_LoopILBM	MACRO	;value
   dc.l   TAGID_LoopILBM,(\1)
  ENDM

TAG_AudioFastSamples   MACRO   ;value
   dc.l   TAGID_AudioFastSamples,(\1)
  ENDM

TAG_AudioMediumSamples   MACRO   ;value
   dc.l   TAGID_AudioMediumSamples,(\1)
  ENDM

TAG_AudioSlowSamples   MACRO   ;value
   dc.l   TAGID_AudioSlowSamples,(\1)
  ENDM

TAG_VerticalScroll   MACRO   ;value
   dc.l   TAGID_VerticalScroll,(\1)
  ENDM

TAG_ReverseTime   MACRO   ;value
   dc.l   TAGID_ReverseTime,(\1)
  ENDM

TAG_ReverseButtLog   MACRO   ;value
   dc.l   TAGID_ReverseButtLog,(\1)
  ENDM

TAG_KeyMode   MACRO   ;value
   dc.l   TAGID_KeyMode,(\1)
  ENDM

TAG_MatteColor   MACRO   ;value
   dc.l   TAGID_MatteColor,(\1)
  ENDM

TAG_CustomMatteColor   MACRO   ;value
   dc.l   TAGID_CustomMatteColor,(\1)
  ENDM

TAG_BorderColor   MACRO   ;value
   dc.l   TAGID_BorderColor,(\1)
  ENDM

TAG_CustomBorderColor   MACRO   ;value
   dc.l   TAGID_CustomBorderColor,(\1)
  ENDM

TAG_LineNumberPlane   MACRO   ;value
   dc.l   TAGID_LineNumberPlane,(\1)
  ENDM

TAG_ForceFreeze4   MACRO   ;value
   dc.l   TAGID_ForceFreeze4,(\1)
  ENDM

TAG_ForceFreeze8   MACRO   ;value
   dc.l   TAGID_ForceFreeze8,(\1)
  ENDM

TAG_ForceLive   MACRO   ;value
   dc.l   TAGID_ForceLive,(\1)
  ENDM

TAG_ForceLumKeyOn   MACRO   ;value
   dc.l   TAGID_ForceLumKeyOn,(\1)
  ENDM

TAG_ForceLumKeyOff   MACRO   ;value
   dc.l   TAGID_ForceLumKeyOff,(\1)
  ENDM

TAG_ForceLumKeyOnBlack   MACRO   ;value
   dc.l   TAGID_ForceLumKeyOnBlack,(\1)
  ENDM

TAG_ForceLumKeyOnWhite   MACRO   ;value
   dc.l   TAGID_ForceLumKeyOnWhite,(\1)
  ENDM

TAG_BadDefaultFX   MACRO   ;value
   dc.l   TAGID_BadDefaultFX,(\1)
  ENDM

TAG_DigitalFX   MACRO   ;value
   dc.l   TAGID_DigitalFX,(\1)
  ENDM

TAG_LUT   MACRO   ;value
   dc.l   TAGID_LUT,(\1)
  ENDM

TAG_DigitalPairs   MACRO   ;value
   dc.l   TAGID_DigitalPairs,(\1)
  ENDM

TAG_LatchAM   MACRO   ;value
   dc.l   TAGID_LatchAM,(\1)
  ENDM

TAG_LatchBM   MACRO   ;value
   dc.l   TAGID_LatchBM,(\1)
  ENDM

TAG_LatchIS   MACRO   ;value
   dc.l   TAGID_LatchIS,(\1)
  ENDM

TAG_HonorPreviewOverLay   MACRO   ;value
   dc.l   TAGID_HonorPreviewOverLay,(\1)
  ENDM

TAG_ForceDefaultMatte   MACRO   ;value
   dc.l   TAGID_ForceDefaultMatte,(\1)
  ENDM

TAG_TurnAudioFilterOff   MACRO   ;value
   dc.l   TAGID_TurnAudioFilterOff,(\1)
  ENDM

TAG_AudioStartField   MACRO   ;value
   dc.l   TAGID_AudioStartField,(\1)
  ENDM

TAG_NumAudioFields   MACRO   ;value
   dc.l   TAGID_NumAudioFields,(\1)
  ENDM

TAG_ISandClipPause   MACRO   ;value
   dc.l   TAGID_ISandClipPause,(\1)
  ENDM

TAG_Interlaced   MACRO   ;value
   dc.l   TAGID_Interlaced,(\1)
  ENDM

TAG_FirstFieldNTSCII   MACRO   ;value
   dc.l   TAGID_FirstFieldNTSCII,(\1)
  ENDM

TAG_BounceILBM   MACRO   ;value
   dc.l   TAGID_BounceILBM,(\1)
  ENDM

TAG_Color0Transparent   MACRO   ;value
   dc.l   TAGID_Color0Transparent,(\1)
  ENDM

TAG_AbortIfSlow   MACRO   ;value
   dc.l   TAGID_AbortIfSlow,(\1)
  ENDM

TAG_NumSkipFieldsAtEnd   MACRO   ;value
   dc.l   TAGID_NumSkipFieldsAtEnd,(\1)
  ENDM

TAG_TBarDoesAuto   MACRO   ;value
   dc.l   TAGID_TBarDoesAuto,(\1)
  ENDM

TAG_DoNotStompSprite   MACRO   ;value
   dc.l   TAGID_DoNotStompSprite,(\1)
  ENDM

TAG_AbortLoopAtEnd   MACRO   ;value
   dc.l   TAGID_AbortLoopAtEnd,(\1)
  ENDM

TAG_NonAAremap   MACRO   ;value
   dc.l   TAGID_NonAAremap,(\1)
  ENDM

TAG_100PercentWhiteMatte   MACRO   ;value
   dc.l   TAGID_100PercentWhiteMatte,(\1)
  ENDM

TAG_UseEffectColor   MACRO   ;value
   dc.l   TAGID_UseEffectColor,(\1)
  ENDM

TAG_LoopCount   MACRO   ;value
   dc.l   TAGID_LoopCount,(\1)
  ENDM

TAG_CroutonType   MACRO   ;value
   dc.l   TAGID_CroutonType,(\1)
  ENDM

TAG_TimeLine   MACRO   ;value
   dc.l   TAGID_TimeLine,(\1)
  ENDM

TAG_IndexID   MACRO   ;value
   dc.l   TAGID_IndexID,(\1)
  ENDM

TAG_FCountMode   MACRO   ;value
   dc.l   TAGID_FCountMode,(\1)
  ENDM

TAG_VariableFCount   MACRO   ;value
   dc.l   TAGID_VariableFCount,(\1)
  ENDM

TAG_SlowFCount   MACRO   ;value
   dc.l   TAGID_SlowFCount,(\1)
  ENDM

TAG_MedFCount   MACRO   ;value
   dc.l   TAGID_MedFCount,(\1)
  ENDM

TAG_FastFCount   MACRO   ;value
   dc.l   TAGID_FastFCount,(\1)
  ENDM

TAG_VariableFCount68000   MACRO   ;value
   dc.l   TAGID_VariableFCount68000,(\1)
  ENDM

TAG_SlowFCount68000   MACRO   ;value
   dc.l   TAGID_SlowFCount68000,(\1)
  ENDM

TAG_MedFCount68000   MACRO   ;value
   dc.l   TAGID_MedFCount68000,(\1)
  ENDM

TAG_FastFCount68000   MACRO   ;value
   dc.l   TAGID_FastFCount68000,(\1)
  ENDM

TAG_NumFields   MACRO   ;value
   dc.l   TAGID_NumFields,(\1)
  ENDM

TAG_StartTime   MACRO   ;value
   dc.l   TAGID_StartTime,(\1)
  ENDM

TAG_AlgoFXtype   MACRO   ;value
   dc.l   TAGID_AlgoFXtype,(\1)
  ENDM

TAG_AlgoFXborder   MACRO   ;value
   dc.l   TAGID_AlgoFXborder,(\1)
  ENDM

TAG_NumFramesSlow   MACRO   ;value
   dc.l   TAGID_NumFramesSlow,(\1)
  ENDM

TAG_NumFramesMedium   MACRO   ;value
   dc.l   TAGID_NumFramesMedium,(\1)
  ENDM

TAG_NumFramesFast   MACRO   ;value
   dc.l   TAGID_NumFramesFast,(\1)
  ENDM

TAG_NumFramesVariable   MACRO   ;value
   dc.l   TAGID_NumFramesVariable,(\1)
  ENDM

TAG_Speed   MACRO   ;value
   dc.l   TAGID_Speed,(\1)
  ENDM

TAG_Delay   MACRO   ;value
   dc.l   TAGID_Delay,(\1)
  ENDM

TAG_Duration   MACRO   ;value
   dc.l   TAGID_Duration,(\1)
  ENDM

TAG_RecFields   MACRO   ;value
   dc.l   TAGID_RecFields,(\1)
  ENDM

TAG_ClipStartField   MACRO   ;value
   dc.l   TAGID_ClipStartField,(\1)
  ENDM

TAG_FadeInVideo   MACRO   ;value
   dc.l   TAGID_FadeInVideo,(\1)
  ENDM

TAG_MaxDuration   MACRO   ;value
   dc.l   TAGID_MaxDuration,(\1)
  ENDM

TAG_VideoSource   MACRO   ;value
   dc.l   TAGID_VideoSource,(\1)
  ENDM

TAG_AudioAttack   MACRO   ;value
   dc.l   TAGID_AudioAttack,(\1)
  ENDM

TAG_AudioDecay   MACRO   ;value
   dc.l   TAGID_AudioDecay,(\1)
  ENDM

TAG_AudioOn   MACRO   ;value
   dc.l   TAGID_AudioOn,(\1)
  ENDM

TAG_AudioStart   MACRO   ;value
   dc.l   TAGID_AudioStart,(\1)
  ENDM

TAG_AudioDuration   MACRO   ;value
   dc.l   TAGID_AudioDuration,(\1)
  ENDM

TAG_AudioVolume1   MACRO   ;value
   dc.l   TAGID_AudioVolume1,(\1)
  ENDM

TAG_AudioVolume2   MACRO   ;value
   dc.l   TAGID_AudioVolume2,(\1)
  ENDM

TAG_AudioPan1   MACRO   ;value
   dc.l   TAGID_AudioPan1,(\1)
  ENDM

TAG_AudioPan2   MACRO   ;value
   dc.l   TAGID_AudioPan2,(\1)
  ENDM

TAG_LoadedSlices   MACRO   ;value
   dc.l   TAGID_LoadedSlices,(\1)
  ENDM

TAG_Encoder   MACRO   ;value
   dc.l   TAGID_Encoder,(\1)
  ENDM

TAG_AdjustedVideoStart   MACRO   ;value
   dc.l   TAGID_AdjustedVideoStart,(\1)
  ENDM

TAG_AdjustedVideoDuration   MACRO   ;value
   dc.l   TAGID_AdjustedVideoDuration,(\1)
  ENDM

TAG_Asynchronous   MACRO   ;value
   dc.l   TAGID_Asynchronous,(\1)
  ENDM

TAG_TimeMode   MACRO   ;value
   dc.l   TAGID_TimeMode,(\1)
  ENDM

TAG_ColorMode   MACRO   ;value
   dc.l   TAGID_ColorMode,(\1)
  ENDM

TAG_CycleMode   MACRO   ;value
   dc.l   TAGID_CycleMode,(\1)
  ENDM

TAG_DataMode   MACRO   ;value
   dc.l   TAGID_DataMode,(\1)
  ENDM

TAG_TBarPosition   MACRO   ;value
   dc.l   TAGID_TBarPosition,(\1)
  ENDM

TAG_TakeOffset   MACRO   ;value
   dc.l   TAGID_TakeOffset,(\1)
  ENDM

TAG_ASourceLen   MACRO   ;value
   dc.l   TAGID_ASourceLen,(\1)
  ENDM

TAG_BSourceLen   MACRO   ;value
   dc.l   TAGID_BSourceLen,(\1)
  ENDM


* NEW TAG NON-TABLE DEFINITIONS GO HERE!!!!

***************************************************************************
*
* The following TABLE items are always followed with a TABLE_END MACRO!!!
*
* No Table may include any absolute address labels, only local $ lables.
*
***************************************************************************

TABLE_CustomButtonELHlogic   MACRO
   dc.l   TAGID_CustomButtonELHlogic
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_AnimFiles   MACRO   
   dc.l   TAGID_AnimFiles
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_AnimControl   MACRO   
   dc.l   TAGID_AnimControl
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_AudioFiles   MACRO   
   dc.l   TAGID_AudioFiles
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_AudioControl   MACRO   
   dc.l   TAGID_AudioControl
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_PauseTimes   MACRO   
   dc.l   TAGID_PauseTimes
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_LatchColors   MACRO   
   dc.l   TAGID_LatchColors
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_TransparentColors   MACRO   
   dc.l   TAGID_TransparentColors
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_PaletteColors   MACRO   
   dc.l   TAGID_PaletteColors
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_Equations   MACRO   
   dc.l   TAGID_Equations
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_ReverseCustomButtLog   MACRO   
   dc.l   TAGID_ReverseCustomButtLog
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_LineNumbers   MACRO   
   dc.l   TAGID_LineNumbers
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_LoadPictures   MACRO   
   dc.l   TAGID_LoadPictures
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_LatchRanges   MACRO   
   dc.l   TAGID_LatchRanges
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_LatchList   MACRO   
   dc.l   TAGID_LatchList
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_TransparentRanges   MACRO   
   dc.l   TAGID_TransparentRanges
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_TransparentList   MACRO   
   dc.l   TAGID_TransparentList
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_DescriptorList   MACRO   
   dc.l   TAGID_DescriptorList
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_AboutList   MACRO   
   dc.l   TAGID_AboutList
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_CommentList   MACRO   
   dc.l   TAGID_CommentList
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_Page   MACRO   
   dc.l   TAGID_Page
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_OriginalLocation   MACRO   
   dc.l   TAGID_OriginalLocation
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_CommandLine   MACRO   
   dc.l   TAGID_CommandLine
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

TABLE_SMPTEtime   MACRO   
   dc.l   TAGID_SMPTEtime
A\@: dc.l  666$-A\@-4
* the table goes here
  ENDM

* NEW TAG TABLE DEFINITIONS GO HERE!!!!

****************************************************************

TABLE_END   MACRO   ;value
	CNOP	0,2
666$:
	ENDM


**************************************************************************
	STRUCTURE	TYPECHUNK,0
	  ULONG	TYPECHUNK_Type
	  ULONG	TYPECHUNK_Version
	LABEL	TYPECHUNK_SIZEOF

*-------------------------------
	STRUCTURE	HEADCHUNK,0
	  APTR	HEADCHUNK_FORMCrUD	;->FORM CrUD
	  APTR	HEADCHUNK_FORMILBM	;->icon
* new fields go here
	  APTR	HEADCHUNK_ChunkHEAD	;->HEAD chunk
	LABEL	HEADCHUNK_SIZEOF

**************************************************************************
**************************************************************************
**************************************************************************
* See the various CrUD_ types below.
* The version is only related to crouton version (not the switcher version)
*
* NOTE: 'CrUD' = Crouton User Data

CrUD_START	MACRO	;Type, version

CrUD_FORMSTART:
	dc.l	'FORM'
	dc.l	CrUD_FORMEND-CrUD_CrUDCHUNK	;form length
CrUD_CrUDCHUNK:
	dc.l	'CrUD'

*--
	dc.l	'TYPE'	
	dc.l	CrUD_TYPECHUNKEND-CrUD_TYPECHUNK ;TYPE chunk length

CrUD_TYPECHUNK:
	dc.l	(\1)	;type name
	dc.l	(\2)	;version		
CrUD_TYPEEND:
	
* This allows us to add fields if necessary, and recompile
;;;	dcb.b	TYPECHUNK_SIZEOF+CrUD_TYPECHUNK-CrUD_TYPECHUNKEND,0

CrUD_TYPECHUNKEND
*--
	dc.l	'LIBS'	
	dc.l	CrUD_TAGSCHUNK-CrUD_ENTRYOFFSET	;chunk length
		
CrUD_ENTRYOFFSET:
	dc.l	_LVOStdCroutonHandler		;Entry Offset
	dc.w	CrUD_ENDOFLIBLIST-CrUD_ENTRYLIB	;string length	
CrUD_ENTRYLIB:
	dc.b	'effects.library',0		;Entry Library
	CNOP	0,2	;for all lib strings to word lengths

* other librarys may go here, i.e. ChromaFX.library, for auto open.
CrUD_ENDOFLIBLIST:
	dc.w	0	;end of library list

*--
CrUD_TAGSCHUNK:
	dc.l	'TAGS'
	dc.l	CrUD_FORMEND-CrUD_TAGSSTART

CrUD_TAGSSTART:
	ENDM

**********************************************
* NOTE: ' PUS' = Parse Upward Search

CrUD_END	MACRO

	TAG_END		;end of tag list
	CNOP	0,4	;This forces the FORM to a LONG word size!!

CrUD_FORMEND:

	dc.l	'FORM',16,' PUS','CrUD',4,CrUD_FORMEND-CrUD_CrUDCHUNK

	END

	ENDM

*----------------------------------------------
CrUD_4_0		EQU	0

*----------------------------------------------
* I DON'T THINK THESE EQUs ARE REQUIRED ANY MORE!!!!!!
* PLEASE DO NOT USE THEM!!!!!

CrUD_NoIcon		EQU	0
CrUD_BWIcon		EQU	1580	;3 planes, 8 color CMAP
CrUD_ColorIcon		EQU	3248	;6 planes, 64 color CMAP

**************************************************************************
**************************************************************************
**************************************************************************
* For a given field number F, it's time ranges from
* (65536*F)/N rounded down, to ((65536*(F+1))/N)-1 rounded down. 
*-------------------------------
* (65536*F)/N
FIELDSTART	MACRO	;Field# (0-(N-1)), AnimSize (N)
	dc.w	((\1<<16)/\2)		
	ENDM
*-------------------------------
* ((65536*(F+1))/N)-1
FIELDEND	MACRO	;Field# (0-(N-1)), AnimSize (N)
	dc.w	((((\1+1)<<16)/\2)-1)		
	ENDM

************************************************************
* NOTE! LatchRanges may be easier to use!!
   STRUCTURE LatchColors,0
	BYTE	LACO_Source
	UBYTE	LACO_Color	;0-255 color number
	UWORD	LACO_StartTime	;inclusive
	UWORD	LACO_EndTime	;inclusive

;;	BYTE	LACO_Source
;;	UBYTE	LACO_Color	;0-255
;;	UWORD	LACO_StartTime
;;	UWORD	LACO_EndTime
;;	etc.

;;	WORD	LACO_Source+LACO_Color ;= LACO_End = 0
	
   LABEL	LACO_SIZEOF

LACO_Vid1		EQU	-1
LACO_Vid2		EQU	-2
LACO_Vid3		EQU	-3
LACO_Vid4		EQU	-4	
LACO_Bank0		EQU	-5
LACO_Bank1		EQU	-6	
LACO_EncoderMatte	EQU	-7
LACO_Monochrome		EQU	-8

LACO_CurrentMain	EQU	1
LACO_CurrentPreview	EQU	2
LACO_CurrentOverLay	EQU	3

LACO_InitialMain	EQU	4
LACO_InitialPreview	EQU	5
LACO_InitialOverLay	EQU	6

LACO_LoadBank		EQU 	7 ;use what ever bank a picture may have loaded into.

LACO_End	EQU	0

LatchColors_END	MACRO
	dc.w	LACO_End
	ENDM

************************************************************
   STRUCTURE LatchRanges,0
	WORD	LARA_Source
	UBYTE	LARA_StartColor	;0-255 color number
	UBYTE	LARA_NumColors

;;	WORD	LARA_Source
;;	UBYTE	LARA_StartColor	;0-255 color number
;;	UBYTE	LARA_NumColors
;;	etc.

;;	WORD	LARA_Source	;= LARA_End = 0
	
   LABEL	LARA_SIZEOF

* These equates are the same as the LatchColors equates.
LARA_Vid1		EQU	-1
LARA_Vid2		EQU	-2
LARA_Vid3		EQU	-3
LARA_Vid4		EQU	-4	
LARA_Bank0		EQU	-5
LARA_Bank1		EQU	-6	
LARA_EncoderMatte	EQU	-7
LARA_Monochrome		EQU	-8

LARA_CurrentMain	EQU	1
LARA_CurrentPreview	EQU	2
LARA_CurrentOverLay	EQU	3

LARA_InitialMain	EQU	4
LARA_InitialPreview	EQU	5
LARA_InitialOverLay	EQU	6

LARA_LoadBank		EQU 	7 ;use what ever bank a picture may have loaded into.

LARA_End	EQU	0

LatchRanges_END	MACRO
	dc.w	LARA_End
	ENDM

************************************************************
   STRUCTURE LatchList,0
	WORD	LALI_Source
	WORD	LALI_Color	;0-255 color number

;;	WORD	LALI_Color	;0-255 color number
;;	etc.
;;	WORD	LALI_Color	;= LALI_End = -1

;;	WORD	LALI_Source
;;	WORD	LALI_Color	;0-255 color number

;;	WORD	LALI_Color	;0-255 color number
;;	etc.
;;	WORD	LALI_Color	;= LALI_ColorEnd = -1
;;	etc.

;;	WORD	LALI_Source	;= LALI_End = 0

   LABEL	LALI_SIZEOF

* These equates are the same as the LatchColors equates
LALI_Vid1		EQU	-1
LALI_Vid2		EQU	-2
LALI_Vid3		EQU	-3
LALI_Vid4		EQU	-4	
LALI_Bank0		EQU	-5
LALI_Bank1		EQU	-6	
LALI_EncoderMatte	EQU	-7
LALI_Monochrome		EQU	-8

LALI_CurrentMain	EQU	1
LALI_CurrentPreview	EQU	2
LALI_CurrentOverLay	EQU	3

LALI_InitialMain	EQU	4
LALI_InitialPreview	EQU	5
LALI_InitialOverLay	EQU	6

LALI_LoadBank		EQU 	7 ;use what ever bank a picture may have loaded into.

LALI_ColorEnd	EQU	-1
LALI_End	EQU	0

LatchList_ColorEND	MACRO
	dc.w	LALI_ColorEnd
	ENDM

LatchList_END	MACRO
	dc.w	LALI_End
	ENDM

************************************************************
   STRUCTURE TransparentRanges,0
	UBYTE	TRRA_StartColor	;0-255 color number
	UBYTE	TRRA_NumColors

;;	UBYTE	TRRA_StartColor	;0-255 color number
;;	UBYTE	TRRA_NumColors
;;	etc.

;;	WORD	TRRA_StartColor+TRRA_NumColors	;= TRRA_End = 0
	
   LABEL	TRRA_SIZEOF

TRRA_End	EQU	0

TransparentRanges_END	MACRO
	dc.w	TRRA_End
		ENDM

************************************************************
   STRUCTURE TransparentList,0
	WORD	TRLI_Color	;0-255 color number

;;	WORD	TRLI_Color	;0-255 color number
;;	etc.

;;	WORD	TRLI_Color	;= TRLI_End = -1

   LABEL	TRLI_SIZEOF

TRLI_End	EQU	-1

TransparentList_END	MACRO
	dc.w	TRLI_End
		ENDM

************************************************************
* This structure is used on effects that can run on AA machines.
   STRUCTURE PaletteColors,0
	UWORD	PACO_NumberOfPalettes
	WORD	PACO_ColorsBetweenPalettes	;number of colors between palettes (may be negative to move other direction)
						;1 for moving pointer. -1 moving pointer from top palette towards bottom. 

	UWORD	PACO_StartingColorNumber	;Ususally 0
	UWORD	PACO_NumberOfColors		;Maximum of 240

	ULONG	PACO_Mask0
	ULONG	PACO_Mask1
	ULONG	PACO_Mask2
	ULONG	PACO_Mask3

	STRUCT	PACO_pad,16

	LONG	PACO_FRGB	;Flags, R, G, B, Flags, r, g, b
;;	LONG	PACO_FRGB	;Flags, R, G, B, Flags, r, g, b
;;	etc.

**************** CONSTANTS FOR EFFECTS THAT CAN RUN ON AA MACHINES
* Mask values. Combinations may be ORed (or Added) together.
* Colors 240 thru 255 may only contain Noncontrol bits used
* by Transparent & the Encoder.

PACO_Mask_DIB		EQU	($0003)
PACO_Mask_DIBGR		EQU	($0223)
PACO_Mask_Transparent	EQU	(1<<31)
PACO_Mask_Latch		EQU	($80000604)
PACO_Mask_Warp		EQU	($0110)		;For DigitalFX
PACO_Mask_Noncontrol	EQU	($0fff08c8)
PACO_Mask_Replace	EQU	($8fff0fff)
PACO_Mask_Nochange	EQU	(0)

PACO_Mask_Sprite	EQU	($0737)	;not really needed, this is
					;automatically handled for
					;colors 240-255
*----------------------
* Various Mask possiblities.
PACO_Transparent	EQU	(1<<31)	;Overlay Genlock transparent color
PACO_UseMask0		EQU	(0<<28)	;not necessary = default
PACO_UseMask1		EQU	(1<<28)
PACO_UseMask2		EQU	(2<<28)
PACO_UseMask3		EQU	(3<<28)

* Various Latch possibilities
PACO_Vid1		EQU	((LACO_Vid1<<12)&$f000)
PACO_Vid2		EQU	((LACO_Vid2<<12)&$f000)		
PACO_Vid3		EQU	((LACO_Vid3<<12)&$f000)		
PACO_Vid4		EQU	((LACO_Vid4<<12)&$f000)		
PACO_Bank0		EQU	((LACO_Bank0<<12)&$f000)		
PACO_Bank1		EQU	((LACO_Bank1<<12)&$f000)		
PACO_EncoderMatte	EQU	((LACO_EncoderMatte<<12)&$f000)	
PACO_Monochrome		EQU	((LACO_Monochrome<<12)&$f000)		

PACO_CurrentMain	EQU	(LACO_CurrentMain<<12)	
PACO_CurrentPreview	EQU	(LACO_CurrentPreview<<12)	
PACO_CurrentOverLay	EQU	(LACO_CurrentOverLay<<12)	

PACO_InitialMain	EQU	(LACO_InitialMain<<12)	
PACO_InitialPreview	EQU	(LACO_InitialPreview<<12)	
PACO_InitialOverLay	EQU	(LACO_InitialOverLay<<12)	

PACO_LoadBank		EQU	(LACO_LoadBank<<12)	;some bank that was just loaded		
					;colors 240-255

*----------------------

* Various DIB possibilities
PACO_DIB0		EQU	$000
PACO_DIB1		EQU	$001
PACO_DIB2		EQU	$002
PACO_DIB3		EQU	$003

* Various DIBGR possibilities
PACO_DIBGR0		EQU	$000
PACO_DIBGR1		EQU	$200
PACO_DIBGR2		EQU	$020
PACO_DIBGR3		EQU	$220
PACO_DIBGR4		EQU	$001
PACO_DIBGR5		EQU	$201
PACO_DIBGR6		EQU	$021
PACO_DIBGR7		EQU	$221
PACO_DIBGR8		EQU	$002
PACO_DIBGR9		EQU	$202
PACO_DIBGRa		EQU	$022
PACO_DIBGRb		EQU	$222
PACO_DIBGRc		EQU	$003
PACO_DIBGRd		EQU	$203
PACO_DIBGRe		EQU	$023
PACO_DIBGRf		EQU	$223

* Various digital Warp possibilities
PACO_Warp0		EQU	$110
PACO_Warp1		EQU	$010
PACO_Warp2		EQU	$100
PACO_Warp3		EQU	$000

* Various Sprite possibilities.  NOT Needed, it's automatically handled!
					;red grn blue
PACO_Sprite0		EQU	$000	;000 000 000 ; b1/g0 b0/r0 g1/b2 r1/r2
PACO_Sprite1		EQU	$600	;110 000 000 ;  msb               lsb
PACO_Sprite2		EQU	$024	;000 010 100 ;
PACO_Sprite3		EQU	$624	;110 010 100 ;
PACO_Sprite4		EQU	$101	;001 000 001 ;
PACO_Sprite5		EQU	$701	;111 000 001 ;
PACO_Sprite6		EQU	$125	;001 010 101 ;
PACO_Sprite7		EQU	$725	;111 010 101 ;
PACO_Sprite8		EQU	$012	;000 001 010 ;
PACO_Sprite9		EQU	$612	;110 001 010 ;
PACO_SpriteA		EQU	$036	;000 011 110 ;
PACO_SpriteB		EQU	$636	;110 011 110 ;
PACO_SpriteC		EQU	$113	;001 001 011 ;
PACO_SpriteD		EQU	$713	;111 001 011 ;
PACO_SpriteE		EQU	$137	;001 011 111 ;
PACO_SpriteF		EQU	$737	;111 011 111 ;

* User interface overlay levels for AA machine (not used by FX)
PACO_UIO0 EQU $000
PACO_UIO1 EQU $200
PACO_UIO2 EQU $020
PACO_UIO3 EQU $220

**************** CONSTANTS FOR EFFECTS THAT RUN ONLY ON NON-AA MACHINES
* This structure is used on effects that are only non-AA
   STRUCTURE PaletteColorsNonAA,0
	UWORD	PACO_NonAA_NumberOfPalettes
	UWORD	PACO_NonAA_ColorsBetweenPalettes	;number of colors between palettes
							;1 for moving pointer.

	UWORD	PACO_NonAA_StartingColorNumber	;Ususally 0
	UWORD	PACO_NonAA_NumberOfColors	;Maximum of 240

	WORD	PACO_NonAA_FRGB	;Flags, R, G, B, Flags, r, g, b
;;	WORD	PACO_NonAA_FRGB	;Flags, R, G, B, Flags, r, g, b
;;	etc.

* You should use the same Latch possibilities as for AA effects.
* Colors 17-31 must be avoided!!!

* Mask of DIB & DIBGR bits on Non AA machine
PACO_NonAA_Mask_DIB	EQU	($009)
PACO_NonAA_Mask_DIBGR	EQU	($889)

* Why did I use $2 for unused registers????
* Various DIB possibilities
PACO_NonAA_DIB0		EQU	$226
PACO_NonAA_DIB1		EQU	$228
PACO_NonAA_DIB2		EQU	$227
PACO_NonAA_DIB3		EQU	$229

* Various DIBGR possibilities
PACO_NonAA_DIBGR0	EQU	$776
PACO_NonAA_DIBGR1	EQU	$876
PACO_NonAA_DIBGR2	EQU	$786
PACO_NonAA_DIBGR3	EQU	$886
PACO_NonAA_DIBGR4	EQU	$778
PACO_NonAA_DIBGR5	EQU	$878
PACO_NonAA_DIBGR6	EQU	$788
PACO_NonAA_DIBGR7	EQU	$888
PACO_NonAA_DIBGR8	EQU	$777
PACO_NonAA_DIBGR9	EQU	$877
PACO_NonAA_DIBGRa	EQU	$787
PACO_NonAA_DIBGRb	EQU	$887
PACO_NonAA_DIBGRc	EQU	$779
PACO_NonAA_DIBGRd	EQU	$879
PACO_NonAA_DIBGRe	EQU	$789
PACO_NonAA_DIBGRf	EQU	$889

* Why did I use $2 for unused registers????
* Various digital Warp possibilities
PACO_NonAA_Warp0	EQU	$226
PACO_NonAA_Warp1	EQU	$228
PACO_NonAA_Warp2	EQU	$227
PACO_NonAA_Warp3	EQU	$229

* User interface overlay levels for AA machine (not used by FX)
PACO_NonAA_UIO0 	EQU 	$000
PACO_NonAA_UIO1 	EQU 	$800
PACO_NonAA_UIO2 	EQU 	$080
PACO_NonAA_UIO3 	EQU 	$880

*******************************************************************
*******************************************************************
*******************************************************************
* Not yet implemented!!!!!
* STRUCTURE AnimControl

* Not yet implemented!!!!!
* STRUCTURE AudioControl

* Not yet implemented!!!!!
* STRUCTURE LoadPictures

* Not yet implemented!!!!!
* STRUCTURE LineNumbers

************************************************************
* NOT IMPLEMENTED!!!! USE PaletteColors Instead!!!!
   STRUCTURE AlgoPaletteColors,0
	WORD	APCO_Color		;0-255 color number
	WORD	APCO_RedEquation  	;see TVT equations
;;	DCs for an equation for Red
	WORD	APCO_GreenEquation  	;see TVT equations
;;	DCs for an equation for Green
	WORD	APCO_BlueEquation  	;see TVT equations
;;	DCs for an equation for Blue

;;	WORD	APCO_Color		;0-255 color number
;;	WORD	APCO_RedEquation  	;see TVT equations
;;	DCs for an equation for Red
;;	WORD	APCO_GreenEquation  	;see TVT equations
;;	DCs for an equation for Green
;;	WORD	APCO_BlueEquation  	;see TVT equations
;;	DCs for an equation for Blue

;;	WORD	APCO_Color	;= APCO_End = -1
	
   LABEL	APCO_SIZEOF

APCO_End	EQU	(-1)

AlgoPaletteColors_END	MACRO
	dc.w	APCO_End
		ENDM

************************************************************
* NOT YET IMPLEMENTED!!!!
* If an ANIM has N fields, and the field numbers are counted from zero,
* then the pause fields will be at (PauseTime*N)/65536 rounded down.
* See the FIELDSTART macros.
* AFTX_PauseTimes points to this structure.

   STRUCTURE PauseTimes,0
	UWORD	PATI_NumPauseTimes	;number of UWORDs in below array

* an array of UWORDs
;;	UWORD	PATI_Time	;0-$ffff
;;	UWORD	PATI_Time	;0-$ffff
;;	UWORD	PATI_Time	;0-$ffff
;;	etc.

   LABEL	PATI_SIZEOF

************************************************************
* THIS IS NOT IMPLEMENTED!  USE TransparentRanges instead!!!
* AFTX_TransparentColors points to this structure
* On AA machines, these colors get bit 31 of their RGB color set.
* Use the FIELDSTART & FIELDEND macros.

   STRUCTURE TransparentColors,0

	WORD	TRCO_Color	;0-255 color number
	UWORD	TRCO_StartTime
	UWORD	TRCO_EndTime

;;	WORD	TRCO_Color	;0-255
;;	UWORD	TRCO_StartTime
;;	UWORD	TRCO_EndTime
;;   	etc.

;;	WORD	TRCO_Color	;= TRCO_End = -1

   LABEL	TRCO_SIZEOF

TRCO_End	EQU	(-1)

TransparentColors_END	MACRO
	dc.w	TRCO_End
	ENDM

*******************************************************************
*******************************************************************
*******************************************************************
GETREALVALUEDENOM MACRO

	IFC	'','\0'
REALVALUE_DENOM SET	1
	   MEXIT
	ENDC

	IFC	'W','\0'
REALVALUE_DENOM SET	1
	   MEXIT
	ENDC

	IFC	'0','\0'
REALVALUE_DENOM SET	10
	   MEXIT
	ENDC

	IFC	'00','\0'
REALVALUE_DENOM SET	100
	   MEXIT
	ENDC

	IFC	'000','\0'
REALVALUE_DENOM SET	1000
	   MEXIT
	ENDC

	IFC	'0000','\0'
REALVALUE_DENOM SET	10000
	   MEXIT
	ENDC

	IFC	'00000','\0'
REALVALUE_DENOM SET	100000
	   MEXIT
	ENDC

REALVALUE_DENOM SET	1000000

    ENDM

*-------------------------------------------
REALVALUENEGATIVE MACRO
	   dc.l	(((\1)-1)<<16)+($10000-(REALVALUEDENOM*$10000/REALVALUE_DENOM))
	ENDM

*-------------------------------------------
REALVALUE	MACRO	;whole,fraction
	IFC	'','\0'
	GETREALVALUEDENOM
	ENDC

	IFNC	'','\0'
	GETREALVALUEDENOM.\0
	ENDC

REALVALUEDENOM SET	0	
	 IFNC	'','\2'
REALVALUEDENOM SET	\2
	 ENDC	

	 IFLT \1
	  REALVALUENEGATIVE \1 
	  MEXIT
	 ENDC

* Only these formats work for -0,fraction !!!!
	 IFC '\1','-0'
	  REALVALUENEGATIVE \1 
	  MEXIT
	 ENDC

	 IFC '\1','-(0)'
	  REALVALUENEGATIVE \1 
	  MEXIT
	 ENDC

	 IFC '\1','(-0)'
	  REALVALUENEGATIVE \1 
	  MEXIT
	 ENDC

	   dc.l	((\1)<<16)+(REALVALUEDENOM*$10000/REALVALUE_DENOM)
        ENDM

*----------
WORDVALUE	MACRO
	dc.w	/1
	ENDM

*----------
LONGVALUE	MACRO
	dc.l	/1
	ENDM

*******************************************************************
*******************************************************************
*******************************************************************
FADER_VALUE	MACRO	; 0 <= CD value <= 255
	DC.W	ET_Fader
	ENDM

FADER_END	MACRO
	dc.w	TVT_END
	ENDM

FADERMAX	EQU	255

*---- EXAMPLE of FADER_VALUE

;; FADER_VALUE MACRO

;; ....VALUE MACRO	;Faders CD value

;; FADER_END	MACRO

*------------------------------------------------------------
LUMKEY_VALUE	MACRO	; 0 <= LKA value <= 255
	DC.W	ET_LumKey
	ENDM

LUMKEY_END	MACRO
	dc.w	TVT_END
	ENDM

LUMKEYMAX	EQU	255

*---- EXAMPLE of LUMKEY_VALUE

;; LUMKEY_VALUE MACRO

;; ....VALUE MACRO	;LumKey LKA value

;; LUMKEY_END	MACRO

*------------------------------------------------------------
TBAR_VALUE	MACRO	; 0 <= transformed TBar time <= $ffff
	DC.W	ET_TBarTime
	ENDM

TBAR_END	MACRO
	dc.w	TVT_END
	ENDM

;;MaxTBarTime	EQU	$7fffffff, = REALVALUE.00000 32767,99999

TBARMAXWHOLE	EQU	32767
TBARMAXFRACT	EQU	99999
	
*---- EXAMPLE of TBAR_VALUE

;; TBAR_VALUE MACRO

;; ....VALUE MACRO   ;0 <= Transformed TBar Time <= TBARMAXWHOLE,TBARMAXFRACT

;; TBAR_END	MACRO

*------------------------------------------------------------
POSITION_VALUES	MACRO	;inital x,y and delta x,y values
	DC.W	ET_BMposition
	ENDM

POSITION_END	MACRO
	dc.w	TVT_END
	ENDM

*---- EXAMPLE of POSITION_VALUES

;; POSITON_VALUES MACRO

;; ....VALUE MACRO	;X origin centered in display at start

;; ....VALUE MACRO	;Y origin centered in display at start

;; ....VALUE MACRO	;delta X movement

;; ....VALUE MACRO	;delta Y movement

;; POSITION_END	MACRO

*******************************************************************
*******************************************************************
*******************************************************************
CONSTANT_VALUE	MACRO	;Delta Amount = +/- whole,fraction
	IFNC	'','\2'
	 dc.w	TVT_DELTACONST

	 IFC	'','\0'
	  REALVALUE	\1,\2
	  MEXIT
	 ENDC

	 REALVALUE.\0	\1,\2
	 MEXIT
	ENDC
	 dc.w	TVT_CONST
	 dc.w	\1
	ENDM
	
LINEAR_VALUE	MACRO	;Delta Amount = +/- whole,fraction
	dc.w	TVT_DELTALINEAR
	 IFC	'','\0'
	  REALVALUE	\1,\2
	  MEXIT
	 ENDC

	 REALVALUE.\0	\1,\2
	ENDM
	
ACCEL_VALUE	MACRO	;Delta Amount = +/- whole,fraction
	dc.w	TVT_DELTAACCEL
	REALVALUE	\1,\2
	ENDM
	
DEACCEL_VALUE	MACRO	;Delta Amount = +/- whole,fraction
	dc.w	TVT_DELTADEACCEL
	REALVALUE	\1,\2
	ENDM
	
BIGACCEL_VALUE	MACRO	;Delta Amount = +/- whole,fraction
	dc.w	TVT_DELTABIGACCEL
	REALVALUE	\1,\2
	ENDM
	
BIGDEACCEL_VALUE	MACRO	;Delta Amount = +/- whole,fraction
	dc.w	TVT_DELTABIGDEACCEL
	REALVALUE	\1,\2
	ENDM
	
SCURVE_VALUE	MACRO	;Delta Amount = +/- whole,fraction
	dc.w	TVT_DELTASCURVE
	REALVALUE	\1,\2
	ENDM
	
RANDOM_VALUE	MACRO	;Delta Amount = +/- whole,fraction
	dc.w	TVT_DELTARANDOM
	REALVALUE	\1,\2
	ENDM
	
*---------------------------------
CYCLIC_VALUE	MACRO
	dc.w	TVT_DELTACYCLIC
	ENDM

CYCLIC_INITAMP	MACRO	;+/- whole,fraction
	REALVALUE	\1,\2
	ENDM

CYCLIC_DELTAAMP	 MACRO	;+/- whole,fraction
	REALVALUE	\1,\2
	ENDM

CYCLIC_INITPHASE MACRO	;+/- whole,fraction     ;1.0 =360 degrees
	REALVALUE	\1,\2
	ENDM

CYCLIC_DELTAPHASE  MACRO ;+/- whole,fraction	;1.0 =360 degrees
	REALVALUE	\1,\2
	ENDM

CYCLIC_DELTAFREQ   MACRO ;+/- whole,fraction	;0 = constant frequency
	REALVALUE	\1,\2
	ENDM


*****************************************
MULTISUMMED_VALUE 	MACRO
	dc.w	TVT_MULTISUM
	ENDM

MULTISUMMED_END MACRO
	dc.w	0
	ENDM

*---- EXAMPLE of MULTISUMMED

;; MULTISUMMED_VALUE MACRO

;; First ...._VALUE macro goes here.

;; Second ...._VALUE macro goes here.

;; etc.

;; Last ...._VALUE macro goes here.

;; MULTISUMMED_END MACRO


*****************************************
MAXSEGMENTEDTIME	EQU	($ffff)

MULTISEGMENTED_VALUE 	MACRO
	dc.w	TVT_MULTISEGMENT
	ENDM

MULTISEGMENTED_STARTCOORD	MACRO	;start value = +/- whole,fraction
	REALVALUE	\1,\2
	ENDM

MULTISEGMENTED_ENDCOORD	MACRO	;end value = +/- whole,fraction
	REALVALUE	\1,\2
	ENDM

MULTISEGMENTED_TIME MACRO	;from 0-MAXSEGMENTEDTIME
	dc.w	\1	
	ENDM

MULTISEGMENTED_END MACRO
	dc.w	0
	ENDM

*---- EXAMPLE of MULTISEGMENTED

;; MULTISEGMENTED_VALUE MACRO

;; First MULTISEGMENTED_STARTCOORD macro goes here = this segment start at time 0

;; First MULTISEGMENTED_ENDCOORD macro goes here

;; First MULTISEGMENTED_TIME macro goes here = time to start next segment

;; Second MULTISEGMENTED_STARTCOORD macro goes here

;; Second MULTISEGMENTED_ENDCOORD macro goes here
	
;; etc.

;; Last MULTISEGMENTED_TIME macro goes here = time to start last segment

;; Last MULTISEGMENTED_STARTCOORD macro goes here

;; Last MULTISEGMENTED_ENDCOORD macro goes here

;; MULTISEGMENTED_END MACRO


*****************************************
MAXCONNECTEDTIME	EQU	($ffff)


MULTICONNECTED_VALUE MACRO
	dc.w	TVT_MULTIDELTA
	ENDM

MULTICONNECTED_TIME MACRO	;from 0-MAXCONNECTEDTIME
	dc.w	\1	
	ENDM

MULTICONNECTED_END MACRO
	dc.w	0
	ENDM

*---- EXAMPLE of MULTICONNECTED

;; MULTICONNECTED_VALUE MACRO

;; First ...._VALUE macro goes here. This equation always starts at time 0.	

;; First MULTICONNECTED_TIME macro goes here = time to start next equation

;; Second ...._VALUE macro goes here

;; Second MULTICONNECTED_TIME macro goes here = time to start next equation
	
;; etc.

;; Last MULTICONNECTED_TIME macro goes here = time to start last equation

;; Last ...._VALUE macro goes here

;; MULTICONNECTED_END MACRO


*****************************************

EQUATIONS_END	MACRO
	dc.w	ET_RUN
	ENDM

**************************************************************************
**************************************************************************
**************************************************************************
Proj_START	MACRO
	DC.b	4,'RAM:',0
	DC.b	0,16,0,0	;If ChromaFX croutons exist,
				;then ChromaFX should be indicated.

	dc.b	$00		;upper byte of Matte MA	(not on word boundry)
	dc.b	$00		;Black Matte, MB & MP

	dc.b	0		;upper byte of Border color (not on word boundry)
	dc.b	2		;Red border color
	dcb.b	16-4,0

IndexID	set	0
	ENDM

*************************************************************
Proj_END MACRO
	dc.l	0
	ENDM

*************************************************************
BlankEntry	MACRO
	IFND	IndexID
IndexID	SET	0
	ENDC
IndexID	SET	IndexID+1
	ENDM

***************************************************************
ProjEntry	MACRO	;name

	IFND	IndexID
IndexID	SET	0
	ENDC
		dc.l	Entry3\@-Entry0\@	;entry length
Entry0\@	dc.w	Entry2\@-Entry1\@	;filename length
Entry1\@	dc.b	'\1',0			;filename
		CNOP	0,2

Entry2\@	dc.l	TAGID_IndexID
		dc.l	IndexID
		dc.l	0		;mark end of taglist
Entry3\@

IndexID	SET	IndexID+1
	ENDM

**************************************************************************
* These various TYPES allow the project editor to supply a default
* icon, and to set the switcher up with appropriate defaults.
* These type are determined by the "File type", and the croutons "Function",
* the values (should) match those in Croutons.(h|i)

CrUD_Directory		EQU	' DIR'	;Directory icon (should never be used...)

CrUD_ANIMFX		EQU	'ANIM'	;ANIM FX (no video time)
CrUD_ILBMFX		EQU	'ILBM'	;ILBM FX (may loop)
CrUD_AlgoFX		EQU	'ALGO'	;Algorithmic FX
CrUD_ChromaFX		EQU	'CRFX'	;ChromaFX effect
CrUD_Video		EQU	'CLIP'	;Video Clip
CrUD_Audio		EQU	' AUD'	;Audio Clip
CrUD_Control		EQU	'CTRL'	;Sequence & Switcher Control crouton
CrUD_Project		EQU	'PROJ'	;Project File
CrUD_Frame		EQU	'FRAM'	;Frame store (may NOT (?) include alpha)
CrUD_Key		EQU	'KEYF'	;Frame store (may NOT NOT include alpha)
CrUD_Scroll		EQU	'SCRO'	;CG Scroll
CrUD_Crawl		EQU	'CRAW'	;CG Crawl
CrUD_Book		EQU	'BOOK'	;CG Book
CrUD_Image		EQU	'RGBA'	;upto 24 bit RGB with 8 bits alpha
CrUD_LWScene		EQU	'LWSC'	;Scene file
CrUD_LWObject		EQU	'LWOB'	;3D object
CrUD_LWSurface		EQU	'SURF'	;3D surface
CrUD_LWMotion		EQU	'LWMO'	;3D motion
CrUD_LWEnvelope		EQU	'LWEN'	;3D Envelope
CrUD_Font		EQU	'FONT'	;Postscript font
CrUD_EPS		EQU	'EPSF'	;Encapsulated Postscript file
CrUD_ARexx		EQU	'REXX'	;ARexx script * Miscellaneous
CrUD_Text		EQU	'TEXT'	;Simple ASCII Text file (docs)

CrUD_VideoANIM		EQU	'VIDA'	;Solid Amiga Animation (has video time)
CrUD_KeyedANIM		EQU	'KEYA'	;Keyed Amiga Animation (no video time)
CrUD_Main		EQU	'MAIN'	;Live video & Matte switcher sources
CrUD_FlyerStill		EQU	'STIL'	;4 field Flyer still

CrUD_Error		EQU	'ERR!'	;Can't load crouton	

CrUD_Unknown		EQU	'WHAT'	;Used for unknown data types
CrUD_Unseen		EQU	0	;Used yet-unexamined data types

***************************************************************
	IFD	CRAP6

	DEFTAGID	Version			;01	
	DEFTAGID	Revision		;02
	DEFTAGID	AAeffect		;03
	DEFTAGID	NonAAeffect		;04
	DEFTAGID	KillInterfaceNonAA	;05
	DEFTAGID	KillInterfaceAA		;06
	DEFTAGID	ButtonELHlogic		;07
	DEFTABLEID	CustomButtonELHlogic	;08
	DEFTAGID	NumberOfAnims		;09
	DEFTAGID	RequestFileName		;0a
	DEFTABLEID	AnimFiles		;0b
	DEFTAGID	Frames			;0c
	DEFTAGID	FieldSync		;0d
	DEFTAGID	VariableSpeeds		;0e
	DEFTAGID	ForcePlayForward	;0f
	DEFTAGID	ForcePlayReverse	;10
	DEFTAGID	LoopAnims		;11
	DEFTABLEID	AnimControl		;12
	DEFTAGID	AudioFastSamples	;13
	DEFTAGID	AudioMediumSamples	;14
	DEFTAGID	AudioSlowSamples	;15
	DEFTABLEID	AudioFiles		;16
	DEFTABLEID	AudioControl		;17
	DEFTABLEID	PauseTimes		;18
	DEFTABLEID	LatchColors		;19
	DEFTABLEID	TransparentColors	;1a
	DEFTABLEID	PaletteColors		;1b
	DEFTABLEID	Equations		;1c
	DEFTAGID	Encoder		        ;1d
	DEFTAGID	VerticalScroll		;1e
	DEFTAGID	ReverseTime		;1f
	DEFTAGID	ReverseButtLog		;20
	DEFTABLEID	ReverseCustomButtLog	;21
	DEFTAGID	KeyMode			;22
	DEFTAGID	MatteColor		;23
	DEFTAGID	CustomMatteColor 	;24
	DEFTAGID	BorderColor		;25
	DEFTAGID	CustomBorderColor	;26
	DEFTABLEID	LineNumbers		;27
	DEFTAGID	LineNumberPlane		;28
	DEFTAGID	ForceFreeze4		;29
	DEFTAGID	ForceFreeze8		;2a
	DEFTAGID	ForceLive		;2b
	DEFTAGID 	ForceLumKeyOn		;2c
	DEFTAGID 	ForceLumKeyOff		;2d
	DEFTAGID 	ForceLumKeyOnBlack	;2e
	DEFTAGID 	ForceLumKeyOnWhite	;2f
	DEFTAGID	BadDefaultFX		;30
	DEFTABLEID	LoadPictures		;31
	DEFTAGID	FadeInDuration		;32
	DEFTAGID	FadeOutDuration		;33
	DEFTAGID	DigitalFX		;34
	DEFTAGID	TimeMode		;35
	DEFTAGID	LUT			;36
	DEFTAGID	DigitalPairs		;37
	DEFTAGID	LatchAM			;38
	DEFTAGID	LatchBM			;39
	DEFTAGID	LatchIS			;3a
	DEFTAGID	HonorPreviewOverLay	;3b
	DEFTAGID	ForceDefaultMatte	;3c
	DEFTAGID	TurnAudioFilterOff	;3d
	DEFTAGID	AudioStartField		;3e
	DEFTAGID	NumAudioFields		;3f
	DEFTAGID	ISandClipPause		;40
	DEFTAGID	Interlaced		;41
	DEFTAGID	FirstFieldNTSCII	;42
	DEFTAGID	BounceILBM		;43
	DEFTABLEID	LatchRanges		;44
	DEFTABLEID	LatchList		;45
	DEFTABLEID	TransparentRanges	;46
	DEFTABLEID	TransparentList		;47
	DEFTAGID	Color0Transparent	;48
	DEFTAGID	AbortIfSlow		;49
	DEFTAGID	NumSkipFieldsAtEnd	;4a
	DEFTAGID	TBarDoesAuto		;4b
	DEFTAGID	DoNotStompSprite	;4c
	DEFTAGID	AbortLoopAtEnd		;4d
	DEFTAGID	NonAAremap		;4e
	DEFTAGID	100PercentWhiteMatte	;4f
	DEFTAGID	UseEffectColor		;50
	DEFTAGID	LoopCount		;51
	DEFTAGID	CroutonType		;52
	DEFTAGID	TimeLine		;53
	DEFTAGID	IndexID	   		;54
	DEFTAGID	FCountMode		;55
	DEFTAGID	VariableFCount  	;56
	DEFTAGID	SlowFCount		;57
	DEFTAGID	MedFCount		;58
	DEFTAGID	FastFCount		;59
	DEFTAGID	VariableFCount68000 	;5a
	DEFTAGID	SlowFCount68000	    	;5b
	DEFTAGID	MedFCount68000	    	;5c
	DEFTAGID	FastFCount68000	    	;5d
	DEFTAGID	NumFields		;5e
	DEFTAGID	StartTime		;5f
	DEFTABLEID	DescriptorList		;60
	DEFTABLEID	AboutList		;61
	DEFTABLEID	CommentList		;62
	DEFTAGID	AlgoFXtype		;63
	DEFTAGID	AlgoFXborder		;64		

	DEFTAGID	NumFramesSlow		;65
	DEFTAGID	NumFramesMedium		;66
	DEFTAGID	NumFramesFast		;67
	DEFTAGID	NumFramesVariable	;68
	DEFTABLEID	Page			;69
	DEFTAGID	Speed			;6a
	DEFTAGID	Delay			;6b
	DEFTAGID	Duration		;6c

	DEFTAGID	AudioAttack		;6d	;used to be RecStartPoint
	DEFTAGID	AudioDecay		;6e	;used to be RecEndPoint
	DEFTAGID	RecFields		;6f
	DEFTAGID	AudioOn			;70	;used to be RecChannel

	DEFTAGID	AudioStart		;71	;used to be ClipStartPoint
	DEFTAGID	AudioDuration		;72	;used to be ClipEndPoint
	DEFTAGID	ClipStartField		;73	
	DEFTAGID	FadeInVideo		;74
	DEFTAGID	MaxDuration		;75
	
	DEFTAGID	VideoSource		;76	
	DEFTAGID	LoadedSlices		;77

	DEFTABLEID	OriginalLocation	;78

	DEFTAGID	AudioVolume1		;79
	DEFTAGID	AudioVolume2		;7a
	DEFTAGID	AudioPan1		;7b
	DEFTAGID	AudioPan2		;7c

	DEFTAGID	PanelMode		;7d	
	DEFTAGID	ColorMode		;7e
	DEFTAGID	CycleMode		;7f
	DEFTAGID	DataMode		;80
	DEFTAGID	AdjustedVideoStart	;81
	DEFTAGID	AdjustedVideoDuration	;82

	DEFTAGID	Asynchronous		;83
	DEFTABLEID	CommandLine		;84

	DEFTABLEID	SMPTEtime		;85

	DEFTAGID	TBarPosition		;86

* NEW TAG DEFINITIONS GO HERE!!!!

	ENDC	;CRAP6
***********************************************************************

	ENDC	;TAGS_I
