


#ifdef TRASHBIN
    /* draw a test graph */

//    graph = init_graph( 50, 100, 200, 200, 35, 100, 200);

//    redraw_graph(rf_win->RPort ,graph);

//    insert_graph_point(graph, 20, 100);

//    redraw_graph(rf_win->RPort, graph);

//    insert_graph_point(graph, 1,25);
//    redraw_graph(rf_win->RPort, graph);

//    delete_graph_point(graph, 1);
//    redraw_graph(rf_win->RPort, graph);

//    delete_graph_point(graph,2);
//    redraw_graph(rf_win->RPort, graph);


//    insert_graph_point(graph, 20, 100);
//    redraw_graph(rf_win->RPort, graph);

//    move_graph_point( rf_win->RPort, graph, 3, 25, 75);



//    find_graph_points( graph, 25, &lower_index, &lower_delta, &higher_index,
//                        &higher_delta);

//    printf("lower_index = %d  lower_delta = %ld\n", lower_index, lower_delta);
//    printf("higher_index = %d  higher_delta = %ld\n", higher_index, higher_delta);



OLD INPUT FILE FORMAT, MAY WANT TO USE LATER



int read_control_file( char *filename, struct graph_struct **graph)
{


    FILE        *input_file;
    char        buff5[256], temp[50];
    char        *tokenpt;
    int         err;
    long int    temp_frame;
    double      temp_percent;

    int         translen;
    int         half_translen;

    int         i, num_keys;


    input_file = fopen(filename,"r");
    if (input_file == NULL)
    {
        printf("%s :No such file found\n",filename);
        return(ERROR);
    }





    fgets(buff5,255,input_file);
    tokenpt = strtok(buff5,",");
    strncpy(outfilename,tokenpt,49);

    tokenpt = strtok(NULL,",");
    outquality = atoi(tokenpt);
    tokenpt = strtok(NULL,",");
    matte = atoi(tokenpt);

    fgets(buff5,255,input_file);
    tokenpt = strtok(buff5,",");
    strncpy(afilename,tokenpt,49);
    tokenpt = strtok(NULL,",");
    acliptype = atoi(tokenpt);
    tokenpt = strtok(NULL,",");
//    aclipstart = atoi(tokenpt)/2;
    aclipstart = atoi(tokenpt);

printf("aclipstart = %d\n", aclipstart);

    tokenpt = strtok(NULL,",");
    acliptranslen = atoi(tokenpt)/2;

    /*!! attempt to open file and find its size, return if error */


    fgets(buff5,255,input_file);
    tokenpt = strtok(buff5,",");
    strncpy(bfilename,tokenpt,49);
    tokenpt = strtok(NULL,",");
    bcliptype = atoi(tokenpt);
    tokenpt = strtok(NULL,",");
//    bclipstart = atoi(tokenpt)/2;
    bclipstart = atoi(tokenpt);
    tokenpt = strtok(NULL,",");
    bcliptranslen = atoi(tokenpt)/2;

    /*!! attempt to open file and find its size, return if error */



    fgets(buff5,255,input_file);
    tokenpt = strtok(buff5,",");
    strncpy(comment,tokenpt,49);

    err = fscanf(input_file,"%s ",temp);
//    trans_len = atoi(temp)/2;
    trans_len = atoi(temp);



    /* now that we know transition lenght, init the the graph struct */

    *graph = init_graph( GRAPH_LEFT, GRAPH_TOP, GRAPH_WIDTH, GRAPH_HEIGHT,
                        GRAPH_XTICHEIGHT, GRAPH_YTICWIDTH,
                        (trans_len - 1), 100.0, max_points, 100, 10);

    if ( *graph == NULL)
    {
        printf("Error creating graph\n");
        return(ERROR);
    }

    err = fscanf(input_file,"%s ",temp);
    num_keys = atoi(temp);

    for (i=0;i<num_keys;i++)
    {
        fgets(buff5,255,input_file);
        tokenpt = strtok(buff5,",");
//        temp_frame = atol(tokenpt)/2;
        temp_frame = atol(tokenpt);
        tokenpt = strtok(NULL,",");
        temp_percent = atof(tokenpt);

//!! clip to bounds of graph, force to colorframe boundary


        if ( (append_graph_point(*graph, temp_frame, temp_percent, 0.0,
               0.0, 0.0, FALSE)) ==  ERROR)
        {
            printf("error appending point %d\n", i);
            return(ERROR);
        }


    }



    fclose (input_file);
    return(OK);
}



/* old graph file load routine */

int load_graph(struct graph_struct *graph)
{
    FILE                    *infile;
    char                    srcfile[512];
    unsigned long int       frame, last_frame = 0;
    double                  percent, tension, bias, cont;
    int                     linear;
    int                     i, num_points;
    char                    buff[512];
    int                     status;


    status = bb_filereq(rf_win, FILE_OPEN, "Select graph data file to load",
                               "prowave:graphs", NULL, srcfile, 512);

    if (status == FALSE)
    {
        printf("No file returned\n");
        return(ERROR);
    }

//    printf("Filename is %s\n", srcfile);

    if( (infile = fopen(srcfile,"r")) == NULL)
    {
        printf("Unable to open %s as an input file\n", srcfile);
        return(ERROR);
    }


    /* try to read the header (RFE1) */
    fscanf(infile, "%s", buff);
    if ( (strstr("RFE1",buff)) == NULL)
    {
        printf("File not a RenderFX RFE1 file\n");
        return(ERROR);
    }


    /* at this point, we probably have a valid file, go ahead and blank */
    /* the current graph */
    clear_graph_points(graph);



    /* get the number of points */
    fscanf(infile, "%d", &num_points);

    for( i=0; i<num_points; i++)
    {

        /* read the point (frame, percent, tension, bias, cont, linear) */
        if ( (fscanf(infile,"%ld %lf %lf %lf %lf %d", &frame, &percent,
                            &tension, &bias, &cont, &linear)) != 6 )
        {
printf("%uld %lf %lf %lf %lf %d\n", frame, percent, tension, bias, cont, linear);
            printf("Error reading data point %d from input file\n", i);
        }
        else
        {
            if( (i == 0) || (frame > last_frame) )
            {
                if ( (append_graph_point(graph, frame, percent, tension,
                        bias, cont, linear)) == ERROR)
                {
                    printf("error appending point %d\n", i);
                }
                last_frame = frame;
            }
        }
    }
    fclose(infile);
    return(OK);
}





#endif /* TRASHBIN */