/****************************************************************************
**                      PW Error Message Library Header
**
**  Header file for error_lib.  Contains defines and function
** prototypes
**
**
**
****************************************************************************/


/* make sure file is only included once */

#ifndef PW_ERROR_LIB_H

#define PW_ERROR_LIB_H


/*- message levels -*/
#define DEBUG_MSG       (0)
#define INFO_MSG        (1)
#define WARNING_MSG     (2)
#define ERROR_MSG       (3)


/*- variables -*/
extern char        err_msg_buf[1025];
extern int         err_msg_buff_size;
extern int         err_display_level;



/*-- function prototypes --*/

void log_message(int level, char *message);



#endif /* PW_ERROR_LIB_H */







