/*************************************************************************
**
**                           rfx_gadgets_ids.h
**
**  This file contains the Gadget IDs for the Render FX Gadgets
**
**
**
*************************************************************************/

/* only include if not alredy included */

#ifndef RFX_GADGET_ID_H

#define RFX_GADGET_ID_H




#define _A_LEFT_ID       (101)
#define _A_RIGHT_ID      (102)
#define _B_LEFT_ID       (103)
#define _B_RIGHT_ID      (104)

#define _LEN_LEFT_ID     (105)
#define _LEN_RIGHT_ID    (106)
#define _LEN_STRING_ID   (107)

#define _CREATE_ID       (108)  /* these are also mode values! */
#define _DELETE_ID       (109)
#define _DRAG_ID         (110)

#define _PREVIEW_ID      (111)
#define _CANCEL_ID       (112)
#define _RENDER_ID       (113)

#define _FRAME_RIGHT_ID    (114)
#define _FRAME_LEFT_ID     (115)

#define _PERCENT_STRING_ID  (116)
#define _FRAME_STRING_ID    (117)

#define _OK_ID              (118)
#define _CANCEL_1_ID        (119)

#define _TENSION_STRING_ID  (120)
#define _TENSION_LEFT_ID    (121)
#define _TENSION_RIGHT_ID   (122)

#define _CONT_STRING_ID  (123)
#define _CONT_LEFT_ID    (124)
#define _CONT_RIGHT_ID   (125)

#define _BIAS_STRING_ID  (126)
#define _BIAS_LEFT_ID    (127)
#define _BIAS_RIGHT_ID   (128)

#define _LINEAR_ID       (129)

#define _SHOW_ID         (130)

#define _LOAD_ID         (131)
#define _SAVE_ID         (132)

#define _VIEW_ID         (133)

#define _REALTIME_ID         (134)




#endif /* RFX_GADGET_ID_H */