#ifndef NEWTEK_DIB_H
#define NEWTEK_DIB_H
/*
 * $Id: dib.h 5.2 1995/08/02 16:59:12 pfrench Exp $
 *
 * $Source: n:/rcs/include/newtek/dib.h $
 *
 * $Log: dib.h $
 * Revision 5.2  1995/08/02 16:59:12  pfrench
 * Moved tools directories around.
 * Revision 5.1  1995/03/30 03:09:32  pfrench
 * Added attributes to share the toaster palette
 * Revision 5.0  1995/03/22 21:40:54  pfrench
 * Initial revision
 */

/*****************************************************************************
 *	Class:			DIBCLASS
 *	SuperClass:		ROOTCLASS
 *	Description:
 *
 *	New Methods:
 *
 *	Changed Methods:
 *
 *	Attributes:
 *
 *****************************************************************************
 *
 */

/**********************************************************/

/* Methods for DIB class objects
 */
enum
{	DIBM_Dummy = DIBCLASS_BASE,

	DIBM_RENDER,

	DIBM_LOAD,
	DIBM_LOAD_BM_CROUTON,
};

/* Method structs for my class objects
 */

/*
 * DIBM_RENDER
 */
struct opDIBRender
{	ULONG		MethodID;

	ULONG		dibr_dest_hdc;

	LONG		dibr_dest_x;
	LONG		dibr_dest_y;

	LONG		dibr_w;
	LONG		dibr_h;

	LONG		dibr_src_x;
	LONG		dibr_src_y;
};

#define ob_DIBRender(ob,hdc,dx,dy,w,h,sx,sy) \
	ob_DoMethod((ob),DIBM_RENDER,(hdc),(dx),(dy),(w),(h),(sx),(sy))

/*
 * DIBM_LOAD
 * DIBM_LOAD_BM_CROUTON
 */
struct opDIBLoad
{	ULONG		MethodID;
	APTR		dibl_fh;		/* stream to load from */
};


/* Attributes for DIB class objects
 */
enum
{	DIBA_Dummy = ((LONG)TAG_USER + DIBCLASS_BASE),

	DIBA_w,						/* (IG) Width in pixels */
					
	DIBA_h,						/* (IG) Height in pixels */

	DIBA_bpp,					/* (IG) bits per pixel */

	DIBA_numcolors,				/* (IG) colors actually used */

	DIBA_pixelbuf,				/* (G) pixel buffer */

	DIBA_UseBitMapInfo,			/* (IS) Use this BitMapInfo for rendering (for shared palettes) */
};


#endif /* NEWTEK_DIB_H */
