#ifndef NEWTEK_FRAME_H
#define NEWTEK_FRAME_H
/*
 * $Id: frame.h 5.1 1995/07/12 16:12:38 pfrench Exp $
 *
 * $Source: n:/rcs/include/newtek/frame.h $
 *
 * $Log: frame.h $
 * Revision 5.1  1995/07/12 16:12:38  pfrench
 * Added "fields" and pad to look like ByteMap
 * Revision 5.0  1995/07/10 15:24:28  pfrench
 * Initial revision
 */

/* These values subject to change!!! */
#define TOASTER_D2_WIDTH		752
#define TOASTER_D2_HEIGHT		240

struct Frame
{
	short			 fr_field_width;	/* Width of field, in pixels */
	short			 fr_field_height;	/* Height of field, in pixels */

	unsigned char	 fr_fields;			/* Number of Byte-Planes */
	unsigned char	 fr_pad[3];			/* Misc Flags, make sure they are cleared */

	unsigned char	*fr_d2_fld_1;		/* Field 1 Composite Data */

	unsigned char	*fr_d2_fld_2;		/* Field 2 Composite Data */

	unsigned char	*fr_d2_fld_3;		/* Field 3 Composite Data */

	unsigned char	*fr_d2_fld_4;		/* Field 4 Composite Data */
};

#endif /* NEWTEK_FRAME_H */
