#ifndef PROOF_CLASSBASE_H
#define PROOF_CLASSBASE_H TRUE
/*
 * $Id: classbase.h 5.3 1995/10/10 16:49:58 pfrench Exp $
 *
 * $Source: n:/rcs/include/proof/classbase.h $
 *
 * $Log: classbase.h $
 * Revision 5.3  1995/10/10 16:49:58  pfrench
 * Added msgport list
 * Revision 5.2  1995/10/10 16:48:24  pfrench
 * Added mutex to object
 * Revision 5.1  1995/07/10 22:36:58  pfrench
 * Moved proof includes to new directory.
 * Revision 5.0  1995/03/22 21:54:42  pfrench
 * Initial revision
 */

#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif

#ifndef PROOF_CLASSES_H
#include <proof/classes.h>
#endif

struct ClassBase
{
	APTR			 cb_allocator_ob;

	struct MinList	 cb_classes;

	/* The following should not even be read at all */
	struct Class	*cb_root_cl;		/* root class */

	APTR			 cb_orig_allocator_ob;
	struct Class	*cb_allocator_cl;
	struct Class	*cb_memory_cl;
	struct Class	*cb_null_cl;

	/* These are OS Dependant, do not use */
	APTR			 cb_mutex;
	struct MinList	 cb_msgports;
};

#endif /* PROOF_CLASSBASE_H */
