/* This is RenderFX PLUS calling script

written by Aussie, 1996 M.Holten

For use by Prowave and their customers  */

/* Lots of Stuff added by Bill @ Prowave */
/* Aug 26, 1997 - Added Undo */
/* Sept 15, 1997 - Audio Insert Added */
/* Oct 4, 1997 - Add Audio Enhanced */
/* Feb 14, 1999 - Added HQ6 Support */
/* Feb 21, 1999 - Added ChromaFX Support */
/* March 24, 1999 - Fixed Undo Support for Variable Length Effects */

call remlib('PROJECT_REXX_PORT')
call addlib('PROJECT_REXX_PORT',0)
call remlib('ToasterARexx.port')
call addlib('ToasterARexx.port',0)

if exists("ENV:OZ-PanicStop") then address command "delete ENV:OZ-PanicStop QUIET"

blackfile="Toaster:Effects/Control/Video Source Black"

/* -------------- set up all the nuts & bolts --------- */
call switcher(TOSW)

start_loc=croutonspot()
current_spot = start_loc
project_end = croutonsinproject()-1

padP=0 	/* This is padding time in fields before effect */
padN=0 	/* Padding time in fields after an effect */
fpath="" 	/* Path for saving to a selected location (not auto-save) */
did_one=0 /* counts each renderfx clip sequence */
qual=3 	/* default HQ-5 quality */
prg_mode=2	/* 1=start from effect  2=start from RFX Roadsign */
Rng_mode="00"   /* 1=One clip only  2=Whole Project till stop */
auto=0 	/* 1= Auto replace option on  0=off*/
orig=0	/* 1=Write to original file location  0=new selected path */


call set_view(2)
call req_open(" ","ClipFX","1999 Icecat Software","   Break on through to the other side    ")

/* ---------- get program mode: one clip or roadsigns ---------*/
do while (Rng_mode~=="01")&(Rng_mode~=="10")
   Rng_mode=req_buttons("Record Mode (pick one)","00","One Clip only","Search Project")
   if Rng_mode="CANCEL" then 
     do
       call req_close()
       quit()
     end
   end

call req_close()

if Rng_mode=="01" then Rng_mode=2
else if Rng_mode=="10" then do
   /* --------- One Clip Only: check selected is fx --------- */
   Rng_mode=1
   if current_spot<1 then do
      call req_tell("Sorry, Canceled","   To use the 'one clip only' mode"," select an FX or RFX crouton first")
      call quit()
      end
   call croutonpick(current_spot)
   fx_type=croutontype()
   fx_spot=current_spot

   if fx_type = 'CTRL' then do
      position1 = lastpos('/',croutonname())
      filename1 = upper(right(croutonname(),length(croutonname())-position1))
      if left(filename1,4)="RFX-" then do
         if right(filename1,3) = 'HQ5' then qual=3
         else if right(filename1,3) = 'STD' then qual=2
         else if right(filename1,3) = 'EXD' then qual=1
         else if right(filename1,3) = 'HQ6' then qual=4
         end
      else call quitc(0)
      end
   else do
      test= fxok()
      if test=2 then quitc(1)
      else if test=3 then quitc(2)
      else if test=0 then quitc(0)
      
      prg_mode=1
      /* -------- One Clip Only: quality mode ------------- */
      qual="000"
      do while (qual~=="1000")&(qual~=="0100")&(qual~=="0010")&(qual~=="0001")
         Qual=req_buttons("Record Quality", "0010","Extended (Fair)","Standard (Good)", "HQ-5 (Better)", "HQ-6 (Best)")
         if Qual="CANCEL" then quit()
         end
      if qual=="1000" then qual=1
      else if qual=="0100" then qual=2
      else if qual=="0010" then qual=3
      else if qual=="0001" then qual=4 
     end
   end



/* ------------ Get Options ----------- */
Opt=req_buttons("Options","110","Auto Replace in project","Save to original location","Add Audio to Clip")
if Opt="CANCEL" then quit()


if left(opt,1)=="1" then auto =1
if substr(opt,2,1)=="1" then orig=1
   else call SaveWhere()

value = 0
if right(opt,1=="1") then
   value = 1 


f_want=req_time("Extra padding at start?",0)
if f_want="CANCEL" then call quit()
call req_close()
fm=substr(f_want,4,2)
fs=substr(f_want,7,2)
ff=substr(f_want,10,2)
padP=((fm*1800)+(fs*30)+ff)*2
padPhold=padP

call req_open("ClipFX tip","-------------","If you plan to layer another effect to the end of this one,","  then perhaps add extra padding here to cover the next effect.  ")

f_want=req_time("Extra padding at end?",0)
if f_want="CANCEL" then call quit()
call req_close()
fm=substr(f_want,4,2)
fs=substr(f_want,7,2)
ff=substr(f_want,10,2)
padN=((fm*1800)+(fs*30)+ff)*2
padNhold=padN

call set_view(4)

/* --------  One Clip Only ----------- */
if Rng_mode=1 then do
   tot_clips=1
   tot_fields=1
   done_fields=1
   call RFXgo()
   if fx_cat=3 then tot_fields=padp+padn+n_dur
   else tot_fields=padp+padn+num
   done_fields=tot_fields
   test=req_tell("ClipFX ready","Render:" tot_clips "clip(s) " (tot_fields%2)" frames","Estimated time:" (tot_fields%60+1) "minute(s)  " )
   if test=0 then quit()
   call DoItNow()
   call quit0()
   end

go_mode=0
call ProjScan()

tot_fields=done_fields
tot_clips=done_clips
test=req_tell("ClipFX ready","Render: " tot_clips "clip(s) " (tot_fields%2)" frames","Estimated time: " (tot_fields%60+1) "minute(s)  " )
if test=0 then quit()
go_mode=1
call ProjScan()

quit0:
call req_close()
call set_view(2)
call req_error("ClipFX all done")
call remlib('PROJECT_REXX_PORT')
call remlib('ToasterARexx.port')
exit

quit:
call req_close()
call set_view(2)
call req_error("ClipFX canceled")
quit2:
call remlib('ToasterARexx.port')
call remlib('PROJECT_REXX_PORT')
exit

RFXgo:
   /* ---------------- get effect --------------- */
   padP=padPhold
   padN=padNhold
   visok=0
   visdur=0
   fxrev=0
   fxrev_spot=-1
   fxtbar=0
   fxtbar_spot=-1

/* ---- additions to Plus ----- */
   fxspeed=0
   fxspeed_spot=-1
   fx_spot=current_spot
   fx_cat=1

/* ------ if road signs, check whether clip or fx is next ---- */
   if prg_mode=2 then do
      fxfound=0
      do while (fxfound=0) & (visok<2) & (fx_spot<project_end)
        fx_spot=fx_spot+1
         croutonpick(fx_spot)
         fx_type=croutontype()
         if (fx_type="CLIP")|(fx_type="STIL")|(fx_type="FRAM")| (fx_type="MAIN") then do
            visok=visok+1
            visdur=croutongettag(duration)
            end
         else if fx_type = 'CTRL' then do
            fullname= croutonname()
            pos1 = lastpos('/',fullname)
            filename1 = upper(right(fullname,length(fullname)-pos1))

/* ---- Additions PLUS ---- */
            if filename1="OZFX-REV" then do
               fxrev=1
               fxrev_spot=fx_spot
               end
            else if filename1="OZFX-SPEED" then do
               test=CommentTest("OZFX-SPEED")
               if test= "NO" then test=NoteType("OZFX-SPEED 60",'W') 
                else test=NoteType("OZFX",'R')
               fxspeed=word(test,2)
               fxspeed_spot=fx_spot
               end
            else if filename1="OZFXO-TBAR" then do
               test=CommentTest("OZFXO-TBAR")
               if test= "NO" then test=NoteType("OZFXO-TBAR 50 1 1 60",'W') 
                else test=NoteType("OZFX",'R')
               tbarval=word(test,2)
               fx_in=word(test,3)
               fx_out=word(test,4)
               fx_delay=word(test,5)
               fxtbar_spot=fx_spot
               fx_cat=3
               end
            end
         else fxfound=fxok()
         end

      if fxfound=2 then quitc(1)
      else if fxfound=3 then quitc(2)
      else if (fxfound~=1) | (visok=2) then quitc(0)
      end
   p_spot=fx_spot
   n_spot=fx_spot
   call req_error("Preparing effect for ClipFX " fx_spot)
   croutonpick(fx_spot)
   fx_type=croutontype()
   num = croutongettag(numfields)
   if fxspeed_spot>-1 then num=fxspeed
num1=num
   num4 = trunc(num/4) 
   num=num4*4
   trimp=(num4%2)*4
   trimn=num-trimp
   if fx_cat=3 then do
      trimp=0
      trimn=0
      if visok>0 then padP=fx_delay+padPhold
      end
   else if visok>0 then padP=visdur+padPhold-trimp
   /* -------- Search backwards for previous clip --------- */
   found=0
   p_tn=0
   do while (p_spot>0) & (found=0)
      p_spot=p_spot-1
      croutonpick(p_spot)
      p_type=croutontype()
      if (p_type="FRAM")|(p_type="STIL")|(p_type="MAIN")|(p_type="KEYF") then do
         if (p_type="FRAM")|(p_type="KEYF") then p_tn=3
          else if (p_type="STIL") then p_tn=2
          else if (p_type="MAIN") then p_tn=4
         p_name=croutonname()
         p_start=0
         p_dur=croutongettag(Duration)
         p_full=p_dur

         if p_dur<(trimp+trimn) then do
            test= req_tell("Hmmm...","     Duration setting of previous","       clip is too short.","  Continue to fix; or Cancel")
            if test=0 then call quit()
            call croutonsettag(Duration,(trimp+trimn))
            p_full=p_dur
            end
         found=1
         end
      if (p_type="CLIP") then do
         p_name=croutonname()
         p_tn=1
         p_start=croutongettag(ClipStartField)
         p_dur=croutongettag(Duration)
         p_full=croutongettag(RecFields)

         if p_full<(num) then do
            call req_tell("Canceled","  It is impossible for previous video", "   clip to fit the selected effect.","  Use shorter effect or longer clip.")
            call quit()
            end
         if (p_full-p_start-p_dur)<(trimn) then do
            call req_tell("Canceled","   Settings for previous video clip","  will not fill second half of effect.","  Move previous video OUT to left.")
            call quit()
            end
         if fx_cat=1 then do
            if (p_start+p_dur)<trimp then do
               call req_tell("Canceled","   Settings for previous video clip","  will not fill first half of effect.","  Move previous video OUT to right.")
               call quit()
               end
            if (p_dur-trimp+p_start)<PadP then PadP=p_dur-trimp + p_start
            end
         found=1
         end
      end      

   if (found=0) then do
     call req_tell("Canceled","Previous visual was not found")
     call quit()
     end

    /* ------------ Search forwards for next clip ------------ */
   found=0
   n_tn=0

   do while (n_spot<=project_end) & (found=0)
      n_spot=n_spot+1
      croutonpick(n_spot)
      n_type=croutontype()
      if (n_type="FRAM")|(n_type="STIL")|(n_type="MAIN")|(n_type="KEYF") then do
         if (n_type="FRAM")|(n_type="KEYF") then n_tn=3
          else if (n_type="STIL") then n_tn=2
          else if (n_type="MAIN") then n_tn=4
         n_name=croutonname()
         n_start=0
         n_dur=croutongettag(Duration)
         n_full=n_dur
         if n_dur<(num) then do
            test= req_tell("Hmmm...","     Duration setting of following","       clip is too short.","  Continue to fix; or Cancel")
            if test=0 then call quit()
            call croutonsettag(Duration,(num))
            n_full=n_dur
            end
         found=1
         end
      if n_type="CLIP" then do
         n_tn=1
         found=1
         n_name=croutonname()
         n_start=croutongettag(ClipStartField)
         n_dur=croutongettag(Duration)
         n_full=croutongettag(RecFields)
/* ****** check that effect duration fits ****** */
         if n_full<num then do
            call req_tell("Canceled","  It is impossible for second video", "   clip to fit the selected effect.","  Use shorter effect or longer clip.")
            call quit()
            end
         if n_start<trimp then do
            test= req_tell("Alert","   Next video needs more IN time", "for effect.  Select Continue to fit,","            or cancel to quit.")
            if test=0 then call quit()
            n_dur=n_dur + n_start - trimp
            if n_dur<4 then n_dur=4
            n_start=trimp
            call croutonsettag(ClipStartField,n_start)
            call croutonsettag(Duration,n_dur)
            end
         if fx_cat=1 then do
            if n_dur<trimn then do
               call req_tell("Canceled","       Duration setting of next","  video clip is too short for effect.","  Use shorter effect or adjust clip.")
               call quit()
               end
            if (n_full-n_start-trimn)<PadN then PadN=n_full-n_start-trimn 
            end
         end
      end
   if (found=0) then do
      call req_tell("Canceled","Following visual was not found")
      call quit()
      end

   if (p_tn=3) | (n_tn=3) then do
      if (p_tn=3) then do
         Call Switcher(M001)
         Call Switcher(PDV2)
         Call Switcher(FMLD,p_name)
         Call Switcher(WAIT,30)
         end
       if (n_tn=3) then do
          Call Switcher(M001)
          Call Switcher(PDV1)
          Call Switcher(FMLD,n_name)
          Call Switcher(WAIT,30)
          end
      end

/* ---- Addition ---- */
   if fx_cat=3 then do
      if fx_delay > p_dur then do
         test= req_tell("Canceled, Delay is too long","Change delay setting on the","OZ-Paint control crouton")
         call quit()
         end
      if n_dur>(p_dur - fx_delay) then do
test= req_tell("Overlay is too long","   Pick Continue to fit it, or cancel")
if test=0 then quit()
         n_dur=(p_dur - fx_delay)
         call croutonsettag(duration,n_dur)
         end
      if n_dur<((fx_in=1)*(num*tbarval/100) +(fx_out=1)*(num*tbarval/100) + (fx_out=2)*(num-(num*tbarval/100))) then do
         call req_tell("Canceled, Effect is too long")
         call quit()
         end
      end

return






DoItNow:
/* Create file name here */

if lastpos('/',p_name,length(p_name)-1)~=0 then do
   filenam3=right(p_name,(length(p_name)-lastpos('/', p_name, length(p_name)-1)))
   newpath=left(p_name,(lastpos('/',p_name,length(p_name))-1))
   end
else do
   filenam3=right(p_name,(length(p_name)-lastpos(':', p_name, length(p_name)-1)))
   newpath=left(p_name,(lastpos(':',p_name,length(p_name))))
   end
call pragma("D",newpath)
newpath=pragma("D","RAM:")

if (right(newpath,1)~="/") & (right(newpath,1)~=":") then
   newpath=newpath||"/"
sm_name=left(filenam3,3)||"z.rfx"


if ((p_tn=1)|(p_tn=2)) & (orig=1) then newfile=newpath||sm_name
else do
   if fpath="" then call savewhere()
   newfile=fpath||sm_name
   end

counter=0
found=0
do while found=0
   counter=counter+1
   if counter<10 then ct="00"||counter
   else if counter<100 then ct="0"||counter
   else ct=counter   
   if ~exists(newfile||ct) then found=1
   end

/* XXX */
newfile=newfile||ct

/* ---------- render the effect, possibly in three parts ----- */
did_one=did_one+1
if padP>0 then do
   segnote=" Clip "||did_one||" of "||tot_clips||" (pre-effect)  "
   call prepad()
   call RecRFX()
   call PanicStop()
   end

segnote="  Clip "||did_one||" of "||tot_clips||" (effect)  "

call FX()
call RecRFX()
call PanicStop()

if padN>0 then do
   segnote="  Clip "||did_one||" of "||tot_clips||" (post-effect)  "
   call postpad()
   call RecRFX()
   call PanicStop()
   end


todo=((tot_fields-done_fields+30)%60)
 
if done_fields>=tot_fields then call req_open("Creating Icon...", (100*done_fields%tot_fields) "% complete")
else call req_open("Creating Icon...", (100*done_fields%tot_fields) "% complete","About " todo " minute(s) remaining")

call req_error(" ClipFX -- making icon")
call MakeIcon(newfile,padP+num%2)
call req_close()

/* ----------- AUTO - REPLACE OPTION --------- */
if auto="1" then do

   p2_dur=p_dur-trimp

/* ---- Addition ---- */
   if fx_cat=3 then do
      p2_dur=fx_delay
      num=n_dur
      end

   if (visok>0) & (p2_dur<=padP) then new_spot=p_spot
   else new_spot=n_spot-1

   /* Create Undo File */
   if fx_cat~=3 then do
      myfpath = newfile
      if lastpos('/',myfpath,length(myfpath)-1)~=0 then do
         filenam2=right(myfpath,(length(myfpath)-lastpos('/',myfpath,length(myfpath)-1)))
         path2=left(myfpath,(lastpos('/',myfpath,length(myfpath))-1))
         end
      else do
         filenam2=right(myfpath,(length(myfpath)-lastpos(':',myfpath,length(myfpath)-1)))
         path2=left(myfpath,(lastpos(':',myfpath,length(myfpath))))
         end
      undofilename = "prowave:undofx/"||filenam2||".undo"
      OPEN(myfile,undofilename,'WRITE')
      WRITELN(myfile,"0");

      croutonpick(fx_spot)
      WRITELN(myfile,croutonname())     
      myfcount = croutongettag(FCountMode)
      WRITELN(myfile,myfcount)
      if (myfcount = 2) then WRITELN(myfile,croutongettag(Duration))
      myfcount = croutongettag(numfields)
      SAY "This is the length "||myfcount  

      croutonpick(p_spot)
      WRITELN(myfile,croutongettag(Duration))
      WRITELN(myfile,croutongettag(AudioDuration))
      WRITELN(myfile,croutongettag(AudioDecay))
      WRITELN(myfile,croutongettag(AudioFadeFlags))

      croutonpick(n_spot)
      WRITELN(myfile,croutongettag(ClipStartField))
      WRITELN(myfile,croutongettag(Duration))
      WRITELN(myfile,croutongettag(AudioStart))
      WRITELN(myfile,croutongettag(AudioDuration))
      WRITELN(myfile,croutongettag(AudioAttack))
      WRITELN(myfile,croutongettag(AudioFadeFlags))
      CLOSE(myfile)
      end

   /* Lets Add the Audio */

   croutonpick(p_spot)
   one = croutongettag(AUDIOON)
   onev = croutongettag(clipstartfield) + croutongettag(Duration)
   onea = croutongettag(AudioStart) + croutongettag(AudioDuration)

   croutonpick(n_spot)
   two = croutongettag(AUDIOON)
   twov = croutongettag(clipstartfield)
   twoa = croutongettag(AudioStart)

   three = 0
   if one > 3 then three = 1
   if two > 3 then three = three + 1
   if three = 2 then do
      if onev > onea then three = 0   
      if twov < twoa then three = 0
      if onev+myfcount < onea then three = 0
      if twov-myfcount > twoa then three = 0
      end 

   if (three = 2) & (fx_cat ~= 3) then do
      if (value = 1) then do
         croutonpick(p_spot)
         OPEN(temp2,"env:flyaudio1.txt",'Write');
         WRITELN(temp2,croutonname()||",");
         WRITELN(temp2,"1");     
         fadeout = croutongettag(AudioFadeFlags)
         alength = onea/2-plugp1+2+padP
         if (fadeout = 2) | (fadeout = 3) then alength = myfcount/2+PadP
         afade = croutongettag(AudioDecay)
         if (afade > alength) then afade = alength 
         if (fadeout = 2) | (fadeout = 3) then do
            alength = myfcount/2
            afade = alength
            if (fadeout = 3) then croutonsettag(AudioFadeFlags,1)
            else croutonsettag(AudioFadeFlags,0)
            end

         croutonsettag(AudioDecay,0)
         WRITELN(temp2,croutonname()||".audio,"||plugp1-padP||","||alength||",1");
         CLOSE(temp2);
         address command "Prowave:FlyerStripAudio >CON: env:flyaudio1.txt" 
         croutonpick(n_spot)

         bstart = twoa/2
         blength = plugp2/2+padN
         bfade = croutongettag(AudioAttack)
         if (bfade > blength) then bfade = blength 
         bdelta = onea/2-plugp1
         fadein = croutongettag(AudioFadeFlags)
         if (fadein = 1) | (fadein = 3) then do
            blength = myfcount/2+padN
            bfade = myfcount/2
            bstart = croutongettag(AudioStart)/2-plugp2/2
            bdelta = 0
            if (fadein = 3) then croutonsettag(AudioFadeFlags,2)
            else croutonsettag(AudioFadeFlags,0)
            end
         croutonsettag(AudioAttack,0)

         OPEN(temp2,"env:flyaudio2.txt",'Write');
         WRITELN(temp2,croutonname()||",");
         WRITELN(temp2,"1");     
         WRITELN(temp2,croutonname()||".audio,"||bstart||","||blength||",1");
         CLOSE(temp2);
         address command "Prowave:FlyerStripAudio >CON: env:flyaudio2.txt" 
         OPEN(myfile,"env:keymix.txt",'Write')     
         WRITELN(myfile,newfile||".mixed,");
         WRITELN(myfile,"2");
         croutonpick(p_spot)
         WRITELN(myfile,croutonname()||".audio,0,"||alength||",0,"||croutongettag(AUDIOON)||","||croutongettag(AUDIOVOLUME1)||","||croutongettag(AUDIOVOLUME2)||","||croutongettag(AudioPan1)||","||croutongettag(AudioPan2)||",0,"||afade);
         croutonpick(n_spot)
         WRITELN(myfile,croutonname()||".audio,0,"||blength||","||bdelta||","||croutongettag(AUDIOON)||","||croutongettag(AUDIOVOLUME1)||","||croutongettag(AUDIOVOLUME2)||","||croutongettag(AudioPan1)||","||croutongettag(AudioPan2)||","||bfade||",0");
         CLOSE(myfile);
         address command  "prowave:keymixer env:keymix.txt"   
 /* Now lets insert the Audio */
         OPEN(myfile,"env:keyaudio.txt",'Write')     
         WRITELN(myfile,newfile||".A,");
         WRITELN(myfile,newfile||",0");
         WRITELN(myfile,newfile||".mixed,0");
         CLOSE(myfile);
         address command  "prowave:keysupport env:keyaudio.txt"   
         address command "delete "||newfile 
         address command "delete "||newfile||".A.prowave" 
         address command "delete "||newfile||".mixed" 
         croutonpick(p_spot)
         address command "delete "||croutonname()||".audio" 
         croutonpick(n_spot)
         address command "delete "||croutonname()||".audio" 
         address command "rename "||newfile||".A "||newfile
         call croutonpick(p_spot)
         call croutonsettag(AudioDuration,p2_dur)
         end 
      end

   /* --- Insert the new clip --- */
   croutonpick(new_spot)
   call croutonload(newfile,INSERT)
   call AddSpot(new_spot)
   new_spot=new_spot+1

   /* --- Remove old effect --- */
   call TrimSpot(fx_spot)

   /* --- Reset the new clip --- */
   call croutonpick(new_spot)
   call croutonsettag(clipstartfield,padP)
   call croutonsettag(duration,num)
   call croutonsettag(AudioStart,0)
   call croutonsettag(AudioDuration,num)

   /* --- Do we replace or reset previous clip --- */
   if (visok>0) & (p2_dur<=padP) then do
      call TrimSpot(p_spot)
      /* --- Reset the new clip --- */
      call croutonpick(new_spot)
      call croutonsettag(clipstartfield,(padP-p2_dur))
      call croutonsettag(duration,(num+p2_dur))
      end
   else do
      call croutonpick(p_spot)
      call croutonsettag(duration,p2_dur)
/* ---- Addition ---- */
      if fx_cat=3 then do
         if croutongettag(AudioOn)>0 then do
            pa_start=croutongettag(AudioStart)
            pa_dur=croutongettag(AudioDuration)
            new_p_out=p_start+p2_dur
            old_a_out=pa_start+pa_dur
            if (pa_start<new_p_out) & (old_a_out>(new_p_out+num)) then call croutonsettag(AudioDuration,(new_p_out+ num -pa_start))
            end
         end
      end         
   /* --- Reset the next clip --- */
   call croutonpick(n_spot)

   /* ---- Addition ---- */
   if fx_cat=3 then do
      call croutonload(p_name,INSERT)
      call croutonpick(n_spot)
      call croutondelete()
      call croutonpick(n_spot)
      call croutonsettag(clipstartfield,(p_start+fx_delay+n_dur+2))
      call croutonsettag(duration,(p_dur-fx_delay-n_dur))
      if croutongettag(AudioOn)>0 then do
         if (visok>0) & (p2_dur<=padP) then do
            call croutonsettag(AudioStart,p_start)
            call croutonsettag(AudioDuration,p_dur)
            end
         else do
            call croutonsettag(AudioStart,(p_start+fx_delay+n_dur+2))
            call croutonsettag(AudioDuration,(p_dur-fx_delay-n_dur))
            end
         end
      end
   else do
      n2_dur=n_dur-trimn
      if n2_dur<4 then do
         call TrimSpot(n_spot)
         end
      else do
         call croutonsettag(duration,n2_dur)
         if n_tn=1 then do
            n2_start=n_start+trimn
            call croutonsettag(clipstartfield,n2_start)
            if (value = 1) then do 
               call croutonsettag(AudioStart,n2_start)
               call croutonsettag(AudioDuration,n2_dur)
               end
            end
         end
      end

/* * are there any following audio clips etc locked to in point * * */ 
   

/* --- Remove roadsign --- */
   if prg_mode=2 then do
      call TrimSpot(current_spot)
      if fxrev_spot>-1 then do
         call TrimSpot(fxrev_spot)
         end
      if fxtbar_spot>-1 then do
         call TrimSpot(fxtbar_spot)
         end
/* ---- Addition ---- */
      if fxspeed_spot>-1 then do
         call TrimSpot(fxspeed_spot)
         end
      end
   end


CLOSE(myfile)
return




RecRFX:
   /* ----------------- call RenderFX to start ---------------- */
   call croutonpick(fx_spot) 
   call switcher(DOEN)
   call req_error(" ClipFX recording")
   address command "c:wait 2"
   address command "Prowave:renderfx ENV:clipfx.txt"
Return


Prepad:
   /* ------------ sets prepad recording ------------ */
   OPEN(myfile,"ENV:ClipFX.txt",'Write')     
   WRITELN(myfile,newfile||","||qual);

   if fx_cat=3 then WRITELN(myfile,p_name||","|| p_tn ||","||p_start/2 + fx_delay/2-padP%2||","||padP%2);

    else WRITELN(myfile,p_name||","|| p_tn ||","||p_start/2 + p_dur/2-trimp/2-padP%2||","||padP%2);
   WRITELN(myfile,n_name||","|| n_tn ||","||n_start/2||","||2);/* irrelevent */

   WRITELN(myfile,segnote||",0")
   WRITELN(myfile, padP%2);
   WRITELN(myfile,"2");
   WRITELN(myfile,"0,0");
   WRITELN(myfile,padP%2||",0");
   CLOSE(myfile)
return




FX:
   /* ---------------- Sets recording of effect ----------- */
   plugp1=0
   plugp2=0
   plugn1=0
   plugn2=0

if fx_cat=1 then do
   if p_tn=1 then do
      plugp1=p_start/2 + p_dur/2-trimp/2
      plugp2=num/2
      end
   else if p_tn=2 then plugp2=2

   if n_tn=1 then do
      plugn1=n_start/2-trimp/2
      plugn2=num/2
      end
   else if n_tn=2 then plugn2=2
   end

if fx_cat=3 then do /* tbar with delay */
   if p_tn=1 then do
      plugp1=p_start/2 + fx_delay/2  /* p_dur/2-trimp/2 */
      plugp2=n_dur/2
      end
   else if p_tn=2 then plugp2=2

   if n_tn=1 then do
      plugn1=n_start/2  /* -trimp/2 */
      plugn2=n_dur/2
      end
   else if n_tn=2 then plugn2=2
   end

call croutonpick(fx_spot) 
call switcher(DOEN) 

call switcher(TBAR,200)

billrev1 = Switcher(STAT,TBAR)

call switcher(TBAR,100)

billrev2 = Switcher(STAT,TBAR)

Switcher(TAKE)

if billrev1 = billrev2 then 
   billrev1 = 1
else
   billrev1 = 0

   OPEN(myfile,"ENV:ClipFX.txt",'Write')     
   WRITELN(myfile,newfile||","||qual||","||billrev1);

if (fxrev=1)&(fx_cat=1) then do
   WRITELN(myfile,n_name||","|| n_tn ||","|| plugn1||","||plugn2);
   WRITELN(myfile,p_name||","|| p_tn ||","||plugp1||","||plugp2);
   WRITELN(myfile,segnote||",0")
   WRITELN(myfile, num/2);
   WRITELN(myfile,"2");
   WRITELN(myfile,"0,100");
   WRITELN(myfile,(num/2)||",0");
   end
else if fx_cat=3 then do
   c2=n_dur
   tb1=1
   key=5
   if fx_in=1 then do
      c1=(num*tbarval/100)
      if fxrev=1 then do
         tb1=100
         c1=num-(num*tbarval/100)
         end
      end
   else do
      c1=1
      key=key-1
      end

   if fx_out=1 then do
      c2=n_dur-(num*tbarval/100)
      tb2=0
      end
   else if fx_out=2 then do
      c2=n_dur-(num-(num*tbarval/100))
      tb2=100
      end
   else do
      c2=n_dur
      tb2=tbarval
      key=key-1
      end

   if fxrev=0 then do
      WRITELN(myfile,p_name||","|| p_tn ||","||plugp1||","||plugp2);
      WRITELN(myfile,n_name||","|| n_tn ||","|| plugn1||","||plugn2);
      end
   else do
      WRITELN(myfile,n_name||","|| n_tn ||","|| plugn1||","||plugn2);
      WRITELN(myfile,p_name||","|| p_tn ||","||plugp1||","||plugp2);
      end
   WRITELN(myfile,segnote||",0")
   WRITELN(myfile, n_dur/2);
   WRITELN(myfile,key);
   WRITELN(myfile,"0,0");
   if fx_in~=0 then WRITELN(myfile,"1,"||tb1);
   WRITELN(myfile,(c1%2)||","||tbarval);
   WRITELN(myfile,(c2%2)||","||tbarval);
   if fx_out~= 0 then WRITELN(myfile,(n_dur/2)||","||tb2);

   end
else do
   WRITELN(myfile,p_name||","|| p_tn ||","||plugp1||","||plugp2);
   WRITELN(myfile,n_name||","|| n_tn ||","|| plugn1||","||plugn2);
   WRITELN(myfile,segnote||",0")
   WRITELN(myfile, num/2);
   WRITELN(myfile,"2");
   WRITELN(myfile,"0,0");
   WRITELN(myfile,(num/2)||",100");
   end
CLOSE(myfile)
return

PostPad:
   /* ----------  Sets recording of post effect-padding time -------*/
   OPEN(myfile,"ENV:ClipFX.txt",'Write')     
   WRITELN(myfile,newfile||","||qual);
   if fx_cat=3 then WRITELN(myfile,p_name||","|| p_tn ||","||p_start/2 +1 + fx_delay/2 + n_dur/2 ||","||padN%2);
   else WRITELN(myfile,n_name||","|| n_tn ||","||n_start/2+1+trimn/2 ||","||padN%2);
   WRITELN(myfile,p_name||","|| p_tn ||","||p_start/2+1||","||2);/* irrelevent */
   WRITELN(myfile,segnote||",0")
   WRITELN(myfile, padN%2);
   WRITELN(myfile,"2");
   WRITELN(myfile,"0,0");
   WRITELN(myfile,padN%2||",0");
   CLOSE(myfile)
return

FxOK:
   fx_name=upper(croutonname())
   if index(fx_name,'/OVERLAYS/')>0 then return 3
   if (fx_type="CRFX") then return 2
   if (fx_type="ALGO") | (fx_type="ANIM") | (fx_type="ILBM") then return 1
   if (fx_type="KEYF") | (fx_type="SCROL") | (fx_type="CRAWL") then return 0
return 0


SaveWhere:
call startfilereq("Select Flyer drive below to save clip to","FA0:","(No Filename needed)")

exit=1
do while exit=1
  fpath=queryfilereq()
  if fpath=0 then call quit()
  if fpath~="" then exit=0
  else address command "c:wait 1"
end

if lastpos('/',fpath,length(fpath)-1)~=0 then do
   filenam2=right(fpath,(length(fpath)-lastpos('/',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos('/',fpath,length(fpath))-1))
   end
else do
   filenam2=right(fpath,(length(fpath)-lastpos(':',fpath,length(fpath)-1)))
   path2=left(fpath,(lastpos(':',fpath,length(fpath))))
   end

call pragma("D",path2)
fpath=pragma("D","RAM:")

if (right(fpath,1)~="/") & (right(fpath,1)~=":") then
   fpath=fpath||"/"
return


TrimSpot:
arg sp
croutonpick(sp) 
call croutondelete()
project_end=project_end-1
if new_spot>=sp then new_spot=new_spot-1
if p_spot>=sp then p_spot=p_spot-1
if n_spot>=sp then n_spot=n_spot-1
if fx_spot>=sp then fx_spot=fx_spot-1
if fxrev_spot>=sp then fxrev_spot=fxrev_spot-1
if fxtbar_spot>=sp then fxtbar_spot=fxtbar_spot-1
if fxspeed_spot>=sp then fxspeed_spot=fxspeed_spot-1
if current_spot>=sp then current_spot=current_spot-1
return

AddSpot:
arg sp
croutonpick(sp) 
project_end=project_end+1
if new_spot>sp then new_spot=new_spot+1
if p_spot>sp then p_spot=p_spot+1
if n_spot>sp then n_spot=n_spot+1
if fx_spot>sp then fx_spot=fx_spot+1
if fxrev_spot>sp then fxrev_spot=fxrev_spot+1
if fxtbar_spot>sp then fxtbar_spot=fxtbar_spot+1
if fxspeed_spot>sp then fxspeed_spot=fxspeed_spot+1
if current_spot>sp then current_spot=current_spot+1
return

PanicStop:
if exists("ENV:OZ-PanicStop") then do
   address command "delete ENV:OZ-PanicStop QUIET"
   call req_tell('Abort Key Detected','   ClipFX has been canceled')
   call quit()
   end
return

quitc:
arg well
  if well=0 then call req_tell("ClipFX canceled","    Crouton" (fx_spot+1) "was not an effect")
  if well=1 then call req_tell("Sorry, Canceled","     ClipFX does not handle","             ChromaFX yet.")
  else if well=2 then call req_tell("Sorry, ClipFX does not","      handle Overlay effects yet.")
  call quit()
return        


ProjScan:
/* -------- Start Project scan --------- */

done_fields=0
done_clips=0
current_spot = 0
call req_error("Searching for RenderFX croutons")
stopfound=0
do while (current_spot < project_end-1)*(stopfound=0) /* must have fx and video anyway so skip last two */
   call PanicStop()
   call croutonpick(current_spot)
   if croutontype() = 'CTRL' then do
      position1 = lastpos('/',croutonname())
      filename1 = upper(right(croutonname(),length(croutonname())-position1))
      if filename1= 'STOP' then do
         stopfound=1
/*         call set_view(2)
         call req_error('RenderFX halted at Stop crouton')
         call quit2() */
         end
      if left(filename1,4)="RFX-" then do
         if right(filename1,3) = 'HQ5' then qual=3
         else if right(filename1,3) = 'STD' then qual=2
         else if right(filename1,3) = 'EXD' then qual=1
         call RFXgo()
         if fx_cat=3 then done_fields=done_fields+padp+padn+n_dur
         else done_fields=done_fields+padp+padn+num
         done_clips=done_clips+1

         if go_mode=1 then call DoItNow()
         end
      end
   current_spot = current_spot + 1
   end
return



CommentTest:
arg note
note=upper(note)
comment=croutongettag(CommentList)
if (datatype(comment)='NUM')|(comment='OK') then comment=''
test='NO'
if (length(comment)>1) & (note~='') then do
   wordcount=words(comment)
   icnt=wordcount
   iloop=1
   do while (iloop=1) & (icnt>0) /* works backwards */
      stword=upper(word(comment,icnt))
      icnt=icnt-1
      if note=upper(left(stword,length(note))) then test=stword
      if stword=note then test='YES'
      end
   end
return test      




NoteType:
begin
parse arg Notein, mode
/* mode=Read Write Append Kill(matching field)*/
notes= croutongettag(CommentList)
mode=upper(mode)
if (datatype(notes)='NUM')|(notes='OK') then notes=''
NoteInU=upper(NoteIn)
if (length(notes)>1)&(mode='K') then do
   wordcount=words(notes)
   icnt=wordcount
   iloop=1
   do while (iloop=1) & (icnt>0) /* works backwards */
      stword=upper(word(notes,icnt))
      if (stword=NoteInU) then do
         notes=delword(notes,icnt,1)
         call croutonsettag(CommentList,notes)
         end
      icnt=icnt-1
      end
   end


if upper(mode)='R' then Noteout=notes
if mode='W' then do
   Notes= NoteIn
   call croutonsettag(CommentList,Notes)
   end
else if mode='A' then do
   notes=trim(left(notes||' '||Notein,79))
   call croutonsettag(CommentList,notes)
   end
return Notes

